﻿import QtQuick 2.0
import QtQuick.Window 2.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtQuick.Window 2.0
import QtQuick.Dialogs 1.2
import QtGraphicalEffects 1.0

import FileIo 1.0
import WebRunPlatform 1.0
import "../js/query.js" as Query


Rectangle {
    id:chatItemid
    // width:getHeight()// parent.width
    width: parent.width

    height: Number(getHeight())
    /* height:(getHeight()>45)?
               getHeight():70*/
    property string chatName: ""//发送人姓名
    property string chatContents: ""//本条消息JSON体
    property string chatContents1: "" //表情转换后
    property string chatHead: ""//头像
    property string chatTime: ""//发送时间
    property string chatisopenfirereverfile:""//是否openfire直接发来的文件

    //  property string opentime: ""
    property int chatFlag: 0 //0:myself自己 1: other其他人
    property int chatIndex: 0//序号--费字段，无用
    property string chatFontType: ""
    property int chatFontSize: 0//字体大小-预计改字体使用，目前没用
    property string chatGifSource: ""//gif图原地址
    property bool chatBold: false//字体是否加粗
    property bool chatItalic: false//保留字体字段
    property bool chatUnderLine: false//字体是否有下划线
    property string chatMsgType: ""//本条消息类 0：文本消息 1：文件消息 2：图片消息 3：声音
    property bool bIsReceived: false//是否接受文件
    property bool issamefile: true//是否相同文件
    property string chatFileData: ""//文件大小
    property string chatFilePath: ""//文件路径
    property string chatVoiceTime: ""//声音时间
    property string oneselfUid: ""//自己uid
    property string otherUid: ""//其他uid,群聊中有@gsuboroom
    property string uuid: ""//uuid手机端，后台保存字段
    property string path:""//路径
    property double iReceived: 0.0//文件大小
    property var webPageObj: []//前端页面对象
    property string callback: ""//回调函数
    property bool callbackSender: false//回执发送人
    property string strip: ""//域名地址
    property string imgWidth:""//图像宽度
    property string imgHeight:""//图片高度
    property var faceinfo: [] //表情数据
   // property string index:""

    property bool   isReceivedAll1: false  //文件下载完成
    property int receiverFile1: 0 //文件下载字节数
    property string filenameStr:""  //本Chatitem 的文件名
    property string receiverFileName1: "" //正在下载的文件名

    property string filesizeStr: ""//文件大小字符串
    property int filesizeNum: 0//文件大小整数

    //property bool bIsMucRoomHandleMsg: false
    
    signal delChatitem(string index);
    //border.color: "red"
    //border.width:1
    color: "#EBF3F8"
    // color: "blue"
    FileIo {
        id:fileio
    }
    
    WebRunPlatform{
        id:webRun
    }
    MessageDialog {
        id: messageDialog
        title: "温馨提示"
        text: "该文件不存在，如果正在下载，请稍后再打开"
        onAccepted: {
            console.log("该文件不存在，如果正在下载，请稍后再打开")
            messageDialog.text = "该文件不存在，如果正在下载，请稍后再打开";
            messageDialog.close()
        }
        Component.onCompleted: visible = false
    }

    Item {
        id: chatImg1  //头像
        width: 40
        height: 40
        anchors.top: parent.top
        visible:
        {
            if(otherUid.indexOf("@gsrooms")>-1) //群聊没有头像
            {return false}
            else
            {return true}
        }
        anchors.topMargin:{
            if(isSameTime(chatTime))
            {
                return 10
            }
            else
            {
                return 50
            }
        }
        anchors.left: parent.left
        anchors.leftMargin: (chatFlag==0)?parent.width - 50:15

        BorderImage {
            id: chatImg
            source: chatHead
            anchors.fill:parent
            visible: true
        }
/*
        Rectangle{
            id:mask
            anchors.fill: chatImg
            radius: width/2.
        }
        //}
        OpacityMask {
            anchors.fill: chatImg
            source: chatImg
            maskSource: mask
        }
*/
        MouseArea{
            id:uerid
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor
            onClicked: {
                //  if(otherUid.indexOf("@gsbroom")<0)
                getuserinfos();
                var urlDetail;
                if(chatFlag == 0)
                    urlDetail = strip + "/sys/userDetails?uid=" + oneselfUid + "&lang=zh_CN"+ "&JSESSIONID1=" + jsessionid
                else
                    urlDetail = strip + "/sys/userDetails?uid=" + otherUid + "&lang=zh_CN"+ "&JSESSIONID1=" + jsessionid

                webRun._vNewWindows(urlDetail,"用户详情",false,strip);
                console.log("点击单聊窗口内的头像，打开个人信息页:", urlDetail)
            }
        }

    }

    Text {
        id: nameid  //姓名
        width: chatName.paintedWidth//chatImg1.width
        // clip: true
        height: 15
        visible:
        {
            if(otherUid.indexOf("@gsrooms")>-1)  //群聊才显示姓名
            {return true}
            else
            {return false}

        }
        anchors.top:parent.top

        anchors.topMargin: //---------------
        {
            if(isSameTime(chatTime))
            {
                return 10
            }
            else
            {
                return 40
            }

        }
        /* anchors.right:
           {
               if(chatFlag !== 0)
               {return parent.TopLeft}
               else
               {return chatImg1.right}
           }
           anchors.rightMargin:
           {if(chatFlag !== 0)
               {return 0}
               else
               {return 0}
           }*/
        anchors.left: (chatFlag==0)?parent.left:chatImg1.right

        anchors.leftMargin:
            if(otherUid.indexOf("@gsrooms")>-1){
                (chatFlag==0)?(parent.width-width-10):-40
            }
            else
            {
                (chatFlag==0)?(parent.width-width-60):10
            }

        // anchors.horizontalCenter: parent.horizontalCenter
        font.family: "微软雅黑"
        font.pixelSize:
        {
            if(otherUid.indexOf("@gsrooms")>-1)
            {return 14}
            else
            {return 9}
        }
        color:
        {
            //if(chatFlag !== 0)
            if(otherUid.indexOf("@gsrooms")>-1)
            {return "#575e66"}
            else
            {return "#9C9C9C"}
        }
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter

        text: chatName

        MouseArea{
            // id:uerid
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor
            onClicked: {
                //  if(otherUid.indexOf("@gsbroom")<0)
                getuserinfos();

                var urlDetail;
                if(chatFlag == 0)
                    urlDetail = strip + "/sys/userDetails?uid=" + oneselfUid + "&lang=zh_CN"+ "&JSESSIONID1=" + jsessionid
                else
                    urlDetail = strip + "/sys/userDetails?uid=" + userjid + "&lang=zh_CN"+ "&JSESSIONID1=" + jsessionid

                webRun._vNewWindows(urlDetail,"用户详情",false,strip);

                console.log("点击群聊窗口内的头像，打开个人信息页:", urlDetail)

            }
        }
    }

    Text {
        id: timeName  //时间
        text: changeMSecondToFullTime(chatTime)
        width: 180
        clip: true
        height: 30
        visible: isSameTime(chatTime)?false:true
        anchors.top: parent.top
        anchors.topMargin: 15
        anchors.horizontalCenter: parent.horizontalCenter
        font.family: "微软雅黑"
        font.pixelSize: 12
        color: "#9C9C9C"
        horizontalAlignment: Text.AlignHCenter
        verticalAlignment: Text.AlignVCenter
    }


    Text {
        id: hiddenText
        text: {
            if(chatMsgType === "0")//如果是文本显示文字，如果不是显示为空（""）
                return qsTr(chatContents);
            else
                return "";
        }

        visible: false
        anchors.top: parent.top
        font.family: "微软雅黑"
        font.weight: Font.Normal
        font.pointSize: 9
        font.wordSpacing: 1.0
   }


    Rectangle {
        id: showitem//消息内容、聊天内容
        width: {
            if(chatMsgType === "0")
            {
                // console.log("2221",contentstext.paintedWidth)
                //return (chatContents.length*15+20 > parent.width-150) ? (parent.width - 150) : chatContents.length*15+20
                if(hiddenText.width+20>parent.width-150)
                   return parent.width-150
                else
                   return hiddenText.width+20

            }
            else if(chatMsgType === "1")//文件显示默认宽度270
            {
                return 270;
            }
            else if(chatMsgType === "2")//图片显示默认宽度270--不合理需修改
            {
                return 270;
            }
            else if(chatMsgType === "3")//声音
            {
                var voice_width=70+chatVoiceTime*10
                if(voice_width>200)
                   voice_width=200
                return voice_width;
            }
        }

        height: {
            if(chatMsgType === "0")
            {
                return contents.height+15
            }
            else if(chatMsgType === "1")//文件显示默认高度75
            {
                return 70;
            }
            else if(chatMsgType === "2")//图片显示默认高度150--不合理需修改
            {
                /*var obj = eval('(' + chatContents + ')');
                      if("file" in obj )
                        return  Number(obj.file.file_height);//75;//contents.height+5;
                      else
                            return  Number(obj.data.file_height);//75;//contents.height+5;
                      }*/
                return 130;
            }
            else if(chatMsgType === "3") //声音
            {
                return 40;
            }
        }
        anchors.left://是本人，头像右边。不是本人,窗口左边

                     (chatFlag==0)?parent.left:chatImg1.right

        anchors.leftMargin://
                           if(otherUid.indexOf("@gsrooms")>-1){
                               (chatFlag==0)?(parent.width-width-10):-40
                           }
                           else
                           {
                               (chatFlag==0)?(parent.width-width-60):10
                           }

        anchors.top:
        {
            if(otherUid.indexOf("@gsrooms")>-1&&chatMsgType !="0")
                    {return nameid.bottom}  //群聊图片和文件,语音用相对定位
                else
                    {return parent.top}
        }
        anchors.topMargin:
        {
            //console.log("topMargin,根据内容类型 chatMsgType:",chatMsgType)
            //---------------------
            if(chatMsgType ==="0" )
            {
                if(isSameTime(chatTime))
                {
                    if(otherUid.indexOf("@gsrooms")>-1)
                       return 30;
                    else
                       return 10;
                }
                else
                {
                    if(otherUid.indexOf("@gsrooms")>-1)
                       return 60;
                    else
                       return 50;
                }
            }
            else //非文本消息。
            {
                if(otherUid.indexOf("@gsrooms")>-1) //群聊，图片等，采用与 nameid 相对定位
                {
                    return 10
                }
                else //单聊，图片等
                {
                    if(isSameTime(chatTime)) //与上一条在一分钟内
                        return 20
                    else
                        return 50;
                }

            }

        }

        border.width:0
        border.color: (chatFlag == 0)?"#bcbfc4":"#dee0e3"
        radius: 3
        color:
        {   if(chatMsgType === "2")
            {
                return  "#EBF3F8"
            }
            else
            {
                (chatFlag == 0)?"#cce4fc":"#dee0e3"
            }
        }


        TextEdit {
            id: contents    //聊天内容文字
            text: {

                chatContents1=facetopath(chatContents)
                if(chatMsgType === "0")//如果是文本显示文字，如果不是显示为空（""）
                    return qsTr(chatContents1);
                else
                    return "";
            }
            onLinkActivated: Qt.openUrlExternally(chatContents)

            anchors.left: parent.left
            anchors.leftMargin: 10
            anchors.right: parent.right
            anchors.rightMargin: 10

            // color: "#333333"
            font.family: "微软雅黑"
            font.weight: Font.Normal
            font.pointSize: 9
            font.wordSpacing: 1.0
            wrapMode: TextEdit.Wrap
            //lineHeight: 5+contents.font.pixelSize
            //lineHeightMode: Text.FixedHeight
            //smooth: true
            //renderType: Text.NativeRendering
            //horizontalAlignment: Qt.AlignHCenter
            verticalAlignment: TextEdit.AlignBottom  //Qt.AlignVCenter
            textFormat: TextEdit.RichText
            anchors.verticalCenter: parent.verticalCenter

            focus: true
            activeFocusOnPress: true
            selectByMouse: true //是否可以选择文本
            selectedTextColor: "white" //设置选择文本的字体颜色
            selectionColor: "#0078d7"  //"#cce4fc":"#dee0e3"
            mouseSelectionMode: TextEdit.SelectCharacters

            //cursorVisible: true
            //Keys.enabled: true;
            smooth: true
        }


        Image{

            id:imagechat
            fillMode:Image.PreserveAspectFit //Image.TileVertically
            height: 170
            width: 270
            //paintedHeight:170
            //paintedWidth:270
            cache : false
            clip:true
            visible: if(chatMsgType === "2")//当为图片时，显示该图片预览地址
                     {
                         return true;
                     }
                     else
                     {
                         return false;
                     }
            horizontalAlignment:
            {
                if(chatFlag==0)
                {
                    return Image.AlignRight
                }
                else
                {
                    return Image.AlignLeft
                }
            }
            //  verticalAlignment: Image.AlignTop

            source://:path
            {
                if(chatMsgType === "2")
                {
                    //console.log("该信息为图片传递参数:",chatContents)

                    var obj = eval('(' + chatContents + ')');//eval

                    if("file" in obj )
                    {

                        var downurl= obj.file.file_url;
                        /*if(a==="")
                                    {
                                        console.log("obj.file.file_url为空时",chatFilePath)

                                         return "file:///"+chatFilePath;
                                    }

                                    else{*/
                        var strhttp=fileio.readIniFile("login", "dnsip")
                        //console.log("图片预览地址11111:",strhttp+"/xs?"+downurl)
                        //  return strip+"/xs?"+a;

                        // console.log("b==",b)
                        downurl=decodeURIComponent(downurl);
                        return strhttp+"/xs?"+downurl;
                        //  }
                    }
                    else if("data" in obj )
                    {
                        var downurl= obj.data.file_url;
                        /*  if(a===""){

                                         console.log("obj.data.file_url为空时",chatFilePath)
                                       // return "file:///"+"chatFilePath";
                                     return  "file:///"+chatFilePath;
                                    }
                                    else
                                    {*/
                        //console.log("图片预览地址1111:",downurl)
                        var strhttp=fileio.readIniFile("login", "dnsip")
                        //  return strip+"/xs?"+a;
                        downurl=decodeURIComponent(downurl);

                        return strhttp+"/xs?"+downurl;
                        //   }
                    }
                    else
                    {
                        var downurl= obj.file_url;
                        /*  if(a===""){

                                         console.log("obj.data.file_url为空时",chatFilePath)
                                       // return "file:///"+"chatFilePath";
                                     return  "file:///"+chatFilePath;
                                    }
                                    else
                                    {*/
                        //console.log("图片预览地址22222:",downurl)
                        var strhttp=fileio.readIniFile("login", "dnsip")
                        //  return strip+"/xs?"+a;
                        downurl=decodeURIComponent(downurl);

                        return strhttp+"/xs?"+downurl;
                    }

                }
                return ""

            }

        }

        MouseArea{
            id:rightmouse;
            anchors.fill: parent;
            acceptedButtons: Qt.RightButton |Qt.LeftButton;
            hoverEnabled: true;

            onClicked: {
                if (mouse.button == Qt.RightButton)
                {
                    if(chatMsgType ==="0"||chatMsgType === "1"||chatMsgType === "2")
                    {
                        rightmenu.popup();
                    }
                }

                if(chatMsgType === "0")
                   contents.forceActiveFocus();

            }

            Menu{
                id:rightmenu
                MenuItem
                {
                    visible:
                    {
                        if(chatMsgType != "1")
                            return false;

                        if(chatFlag == 0)
                            return false; //自己发的没有另存为

                        var obj = eval('(' + chatContents + ')'); // eval

                        if("file" in obj) //历史消息
                        {
                            issamefile = fileio.findfilepathissame(obj.file.file_name,obj.time,obj.uuid);
                            //console.log("对象为file,历史消息,查找目录文件结果",issamefile)
                        }
                        else //openfire消息
                        {
                            issamefile = fileio.findfilepathissame(obj.data.file_name,obj.send_time,obj.uuid);
                            //console.log("对象为data,openfire消息,查找目录文件结果",issamefile)
                        }

                        if(issamefile)  //已经下载的,不显示另存为,意味着显示:下载文件
                            return true;
                        else
                            return false;
                    }


                    text: qsTr( "另存为")
                    onTriggered:
                    {
                        console.log("右键另存为，文件名:", chatContents);
                        var obj = eval('(' + chatContents + ')');  //eval gaobo

                        if("file" in obj)
                        {
                            var filename1 = obj.file.file_name;
                        }
                        else
                        {
                            var filename1 = obj.data.file_name;
                        }

                        var filename2=fileio.readiniRevfilenotes(filename1,"",obj.uuid)

                        if(filename2!="")//接收记录中找到该文件
                        {
                            var filePath = filename2;
                        }
                        else
                        {
                            var filePath = chatFilePath+filename1;
                        }

                        console.log("另存为，文件路径:", filePath);
                        var filename = fileio.saveFile(filePath,chatTime)

                    }
                }

                MenuItem {
                    text: qsTr("复制")
                    visible:(chatFilePath.length<=0)
                    // enabled: true
                    onTriggered: {
                        if(contents.selectedText=="")
                           contents.selectAll();

                        contents.copy()

                        contents.select(contents.cursorPosition,contents.cursorPosition)
                    }
                }

                MenuItem
                {
                    text: qsTr( "删除")
                    onTriggered:
                    {
                        delChatitem(index);
                    }
                }

            }
        }

        Rectangle {
            id: fileRect
            anchors.left: parent.left
            anchors.leftMargin: 5
            anchors.right: parent.right
            anchors.rightMargin: 5
            visible: {
                if(chatMsgType === "1")
                {
                    return true;
                }
                else
                {
                    return false;
                }


            }
            Image {
                id: iconrect   //文件类型图标
                width: 40
                height: 40
                anchors.right: parent.right
                anchors.rightMargin: 10
                anchors.top: parent.top
                anchors.topMargin: 13
                visible: {
                    if(chatMsgType === "1")//当为文件时才显示
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                source: {
                    if(chatMsgType === "1")         //文件
                    {

                        var obj = eval('(' + chatContents + ')');
                        if("file" in obj )
                           filenameStr=obj.file.file_name;
                        else
                           filenameStr=obj.data.file_name;

                        var filenameStrExt=filenameStr.substring(filenameStr.lastIndexOf(".")+1)

                        switch(filenameStrExt.toLowerCase())
                        {
                        case "xls":
                        case "xlsx":
                            filenameStrExt="xls"
                            break
                        case "ppt":
                        case "pptx":
                            filenameStrExt="ppt"
                            break
                        case "doc":
                        case "docx":
                            filenameStrExt="doc"
                            break

                        case "apk":
                            filenameStrExt="apk"
                            break
                        case "csv":
                            filenameStrExt="csv"
                            break
                        case "dwg":
                            filenameStrExt="dwg"
                            break
                        case "eml":
                            filenameStrExt="eml"
                            break
                        case "docx":
                            filenameStrExt="ppt"
                            break
                        case "docx":
                            filenameStrExt="ppt"
                            break
                        case "exe":
                            filenameStrExt="exe"
                            break
                        case "html":
                        case "htm":
                            filenameStrExt="html"
                            break
                        case "keynote":
                            filenameStrExt="keynote"
                            break
                        case "mp3":
                        case "wav":
                        case "midi":
                        case "flac":
                        case "aac":
                        case "wma":
                            filenameStrExt="mp3"
                            break
                        case "numbers":
                            filenameStrExt="numbers"
                            break
                        case "pdf":
                            filenameStrExt="pdf"
                            break
                        case "jpg":
                        case "png":
                        case "tif":
                        case "tiff":
                        case "bmp":
                        case "psd":
                        case "ico":
                        case "pcx":
                        case "ai":
                        case "jpeg":
                            filenameStrExt="pic"
                            break
                        case "rtf":
                            filenameStrExt="rtf"
                            break
                        case "txt":
                            filenameStrExt="txt"
                            break
                        case "wmv":
                        case "avi":
                        case "mpeg":
                        case "mp4":
                        case "mpg":
                        case "3gp":
                            filenameStrExt="wmv"
                            break
                        case "xmind":
                            filenameStrExt="xmind"
                            break
                        case "zip":
                        case "rar":
                        case "7z":
                        case "gz":
                        case "cab":
                        case "iso":
                        case "tar":
                        case "jar":
                            filenameStrExt="zip"
                            break
                        default:
                            filenameStrExt="default"
                            break


                        }

                        return "qrc:/resource/images/filetype/"+filenameStrExt+".png";
                    }
                    else if(chatMsgType === "2")    //图片
                    {
                        return "qrc:/resource/images/im/chatpicture.png";
                    }
                    else
                    {
                        return "qrc:/resource/images/im/voice.png";
                    }
                }
            }

            Text {
                id: fielname
                height: 15
                width:  45
                anchors.top: parent.top
                anchors.topMargin: 15
                anchors.left: parent.left
                anchors.leftMargin: 8
                anchors.right: parent.right
                anchors.rightMargin: 8
                //anchors.horizontalCenter: parent.horizontalCenter  //gaobo wait
                elide: Text.ElideNone

                wrapMode:  Text.WrapAnywhere
                horizontalAlignment: Qt.AlignLeft
                smooth:true        //是平滑
                verticalAlignment: Qt.AlignVCenter
                font.family: "微软雅黑"
                font.pixelSize: 13
                color: "#222222"
                //clip:  true
                visible: {
                    if(chatMsgType === "1") //为文件时才显示
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }
                }
                text: {
                    if(chatMsgType === "1" )
                    {
                        //console.log("文件-json内容:",chatContents)

                        var obj = eval('(' + chatContents + ')');

                        if((otherUid.indexOf("@gsrooms")>-1) && ("file" in obj ) )
                        {
                            //    console.log("1")
                            var a = obj.file.file_name;

                            filenameStr=obj.file.file_name;

                            if(obj.file.file_name.length>18)
                            {
                                // obj.file.file_name = obj.file.file_name.left(5)+"....."+obj.file.file_name.right(4);

                                return  obj.file.file_name.substring(0,8)+"....."+obj.file.file_name.substring((obj.file.file_name.length-8),obj.file.file_name.length);

                                //return obj.file.file_name.left(5)+"....."+obj.file.file_name.right(4)
                            }
                            // if(obj.file.file_name.len)
                            return obj.file.file_name;
                        }

                        else if("data" in obj)
                        {
                            //   console.log("2")\\
                            var a = obj.data.file_name;
                            filenameStr=obj.data.file_name;
                            if(obj.data.file_name.length>18)
                            {
                                //obj.data.file_name = obj.data.file_name.left(5)+"....."+obj.data.file_name.right(4);

                                return  obj.data.file_name.substring(0,8)+"....."+obj.data.file_name.substring((obj.data.file_name.length-8),obj.data.file_name.length);
                            }
                            return obj.data.file_name;
                        }
                        else
                        {
                            if("file" in obj )
                            {
                                var a =  obj.file.file_name;
                                filenameStr=obj.file.file_name;

                                if(obj.file.file_name.length>18)
                                {
                                    //  obj.file.file_name = obj.file.file_name.left(5)+"....."+obj.file.file_name.right(4);

                                    return  obj.file.file_name.substring(0,8)+"....."+obj.file.file_name.substring((obj.file.file_name.length-8),obj.file.file_name.length);
                                    //return obj.file.file_name.left(5)+"....."+obj.file.file_name.right(4);

                                }
                                return obj.file.file_name;
                            }

                            else
                            {
                                var a =  obj.file_name;
                                filenameStr=obj.file_name;
                                if(obj.file_name.length>18)
                                {
                                    //obj.file_name = obj.file_name.left(5)+"....."+obj.file_name.right(4);

                                    return  obj.file_name.substring(0,8)+"....."+obj.file_name.substring((obj.file_name.length-8),obj.file_name.length);

                                    //return obj.file_name.left(5)+"....."+obj.file_name.right(4);

                                }
                                return obj.file_name;
                                //  return obj.file_name;
                            }
                        }
                    }
                    else
                    {
                        //  return "位置文件0.1";
                        //console.log("不是文件")
                        return ""
                    }
                }
            }


            Text {
                id: filesize
                height: 15
                anchors.top: fielname.bottom
                anchors.topMargin: 10
                anchors.left: parent.left
                anchors.leftMargin: 9
                anchors.right: parent.right
                anchors.rightMargin: 9
                visible:// bIsReceived?true:false
                        if(chatMsgType == "1")//为文件时才显示
                        {
                            return  true;
                        }
                        else
                        {
                            return false;
                        }
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                font.family: "微软雅黑"
                font.pixelSize: 13
                color: "#6b6166"
                text: {
                    if(chatMsgType === "1" || chatMsgType === "2")
                    {
                        //console.log("chatContents__file_size__",chatContents)

                        var obj = eval('(' + chatContents + ')');  //eval

                        var obj1;

                        if(("file" in obj ))
                        {
                            // console.log("1")
                            obj1 = obj.file;
                            var  iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                            if(iReceived/1024>1)
                            {
                                return (iReceived/1024).toFixed(2)+"MB"
                            }
                            else if (iReceived<1)
                            {
                                return (iReceived).toFixed(2) +"KB"
                            }
                            else
                            {
                                return iReceived.toFixed(2) +"KB"
                            }

                            //return obj1.file_size;
                        }
                        else if("data" in obj)
                        {
                            //  console.log("2")
                            obj1 = obj.data

                            if(obj1.file_size.endsWith("B"))
                               return obj1.file_size


                            var  iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                            if(iReceived/1024>1)
                            {
                                return (iReceived/1024).toFixed(2)+"MB"
                            }
                            else if (iReceived<1)
                            {
                                return (iReceived).toFixed(2) +"KB"
                            }
                            else
                            {
                                return iReceived +"KB"
                            }
                            // return obj1.file_size;
                        }
                        else
                        {
                            //  console.log("3")
                            if("file" in obj )
                            {
                                obj1 = obj.file;
                                // var iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                                var  iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                                if(iReceived/1024>1)
                                {
                                    return (iReceived/1024).toFixed(2)+"MB"
                                }
                                else if (iReceived<1)
                                {
                                    return (iReceived).toFixed(2) +"KB"
                                }
                                else
                                {
                                    return iReceived.toFixed(2) +"KB"
                                }
                                // r
                                // return obj1.file_size;
                                //return obj.file.file_size;
                            }

                            else
                            {
                                obj1 = obj.data
                                //var iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                                var  iReceived = Number(obj1.file_size.substr(0,obj1.file_size.length));
                                if(iReceived/1024>1)
                                {
                                    return (iReceived/1024).toFixed(2)+"MB"
                                }
                                else if (iReceived<1)
                                {
                                    return (iReceived).toFixed(2) +"KB"
                                }
                                else
                                {
                                    return iReceived.toFixed(2) +"KB"
                                }
                                // return obj1.file_size;
                                //   return obj.data.file_size;
                            }

                        }
                    }
                    else
                    {
                        return "";
                    }
                }
            }

            Text {
                id: openfile
                height: 15
                anchors.top: fielname.bottom
                anchors.topMargin: 10
                anchors.left: parent.left
                anchors.leftMargin: 74
                //anchors.right: parent.right  //gaobo wait
                anchors.rightMargin: 64
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                font.family: "微软雅黑"
                font.pixelSize: 13
                color: "#0099FF"

                visible:
                    if(chatMsgType === "1")//文件才显示
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }


                text:
                {
                    if(chatMsgType != "1")
                        return "";

                    if(chatFlag == 0)
                        return ("打开文件夹");

                    var obj = eval('(' + chatContents + ')'); // eval


                    if("file" in obj)  //历史消息
                    {
                        issamefile = fileio.findfilepathissame(obj.file.file_name,obj.time,obj.uuid);
                        //console.log("对象为file，历史消息,查找目录文件结果",issamefile)

                        filesizeStr =  obj.file.file_size;
                        filesizeNum=countfilesize(filesizeStr)
                    }
                    else //openfire 消息
                    {
                        issamefile = fileio.findfilepathissame(obj.data.file_name,obj.send_time,obj.uuid);
                        //console.log("对象为data,openfire消息,查找目录文件结果",issamefile)

                        filesizeStr =  obj.data.file_size;
                        filesizeNum=countfilesize(filesizeStr)

                        //Openfire消息的文件,小于2M则自动下载,显示进度条
                        if(filesizeNum<=2*1024*1024)
                        {
                            if(!isReceivedAll1 && !issamefile) //第一次触发时配合下载显示进度条
                            {
                                console.log("Openfire消息的文件,小于2M自动下载,启动进度条");
                                receiverFileName1=obj.data.file_name;
                                isReceivedAll1=false;

                                progressBar1.visible=true;
                                timer1.start();
                            }
                        }
                    }

                    if(issamefile)//已经下载的,不显示另存为,意味着显示:下载文件
                    {
                        return ("打开文件夹");
                    }
                    else
                    {
                        return ("下载文件");
                    }

                }



                //  visible: bIsReceived?true:false

                MouseArea {
                    id: mouse_opendir
                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onEntered:
                    {
                        openfile.color ="#16b0e9";
                    }
                    onExited:
                    {
                        openfile.color="#0099FF";
                    }

                    onClicked: {
                        if(openfile.text=="打开文件夹")
                        {
                            console.log("打开文件夹,chatContents: ",chatContents)

                            var obj = eval('(' + chatContents + ')'); //eval gaobo

                            //自己发的,打开文件夹
                            if(chatFlag == 0)
                            {
                                //如果是自己：查询本地记录文件。如果有打开对应文件，如果没有提示文件没找到
                                var strfindnotepath;
                                var strsendtime ;
                                if("file" in obj )
                                {
                                    console.log("自己发的文件-历史消息",obj.file.file_name)


                                    if("sendTime"in obj.file)
                                    {
                                        strsendtime = obj.file.sendTime
                                    }
                                    else
                                    {
                                        // strsendtime = obj.time
                                        if("time" in obj)strsendtime = obj.time
                                        if("send_time" in obj)strsendtime = obj.send_time

                                    }


                                    strfindnotepath = fileio.readiniSendfilenotes(obj.file.file_name,strsendtime)
                                    if(strfindnotepath!="")
                                    {
                                        downLoadManager.startSendfileExe(strfindnotepath,true) //打开文件夹

                                    }
                                    else
                                    {
                                        messageDialog.text = "文件不存在"
                                        messageDialog.visible = true;

                                    }
                                }
                                else
                                {
                                    console.log("自己发的文件-openfire消息",obj.data.file_name)

                                    if("sendTime"in obj.data)
                                    {
                                        strsendtime = obj.data.sendTime
                                    }
                                    else
                                    {
                                        strsendtime = obj.time
                                        if("time" in obj)strsendtime = obj.time
                                        if("send_time" in obj)strsendtime = obj.send_time

                                    }

                                    strfindnotepath = fileio.readiniSendfilenotes(obj.data.file_name,strsendtime)
                                    if(strfindnotepath!="")
                                    {
                                        downLoadManager.startSendfileExe(strfindnotepath,true) //打开文件夹
                                    }
                                    else
                                    {
                                        messageDialog.text = "文件不存在"
                                        messageDialog.visible = true;
                                    }
                                }
                            }
                            else //别人发的,打开文件夹
                            {
                                if(chatMsgType === "1")
                                {
                                    console.log("别人发的,打开文件夹",chatFlag, downLoadManager.strGetFilePath("1")+fielname.text)
                                    if("file" in obj )
                                    {
                                        downLoadManager.startExe("explorer.exe", downLoadManager.strGetFilePath("1")+obj.file.file_name,chatTime,true,obj.uuid)//打开文件夹
                                    }
                                    else
                                    {
                                        downLoadManager.startExe("explorer.exe", downLoadManager.strGetFilePath("1")+obj.data.file_name,chatTime,true,obj.uuid)//打开文件夹
                                    }
                                }

                            }

                            return;
                        }

                        //单击,还未下载
                        if(openfile.text== "下载文件")
                        {
                            openfile.text= "打开文件夹"
                            filesaveas.text= "另存为"

                            var obj = eval('(' + chatContents + ')');//eval  gaobo
                            var loginAddressFile = fileio.getLoginAddress();
                            var strpath =  downLoadManager.getDownloadPath(chatTime);
                            console.log("本条消息路径为:",strpath,chatTime);
                            if("file" in obj )
                            {

                                console.log("点击聊天内容窗口历史记录的下载文件1");
                                receiverFileName1=obj.file.file_name;
                                isReceivedAll1=false;

                                progressBar1.visible=true;
                                timer1.start();

                                downLoadManager.downloadFile(loginAddressFile+"/xs?"+decodeURIComponent(obj.file.file_url), obj.file.file_name, "1",chatTime,jid,obj.uuid);
                                var sendtext = "文件："+obj.file.file_name +" 正在下载中，请稍候。";
                                //appendSendData(sendtext, 0, "0", "", "",jid,"0");

                            }
                            else
                            {
                                console.log("点击聊天内容窗口的下载文件2---来自openfire的消息");
                                receiverFileName1=obj.data.file_name;
                                isReceivedAll1=false;

                                progressBar1.visible=true;
                                timer1.start();

                                downLoadManager.downloadFile(loginAddressFile+"/xs?"+decodeURIComponent(obj.data.file_url), obj.data.file_name, "1",chatTime,jid,obj.uuid);
                                var sendtext1 = "文件："+obj.data.file_name +" 正在下载中，请稍候。";
                                //appendSendData(sendtext1, 0, "0", "", "",jid,"0");
                            }

                            //单击下载文件给出回执
                            uuid = obj.uuid +  receiverFileName1;
                            if(!fileio.readCallBackIniFile(uuid) && otherUid.indexOf("@gsrooms")<=-1) //群聊无回执
                            {
                                var str_ = "对方已经通过PC端在"+ fileio.getCurrTimestr()+"接收文件: "+receiverFileName1+"  (" + filesize.text+")" ;
                                var _suuid = Query.uuid()
                                //console.log("发送openfire回执消息参数",str_,strOid + "pq"+jid + "@gsubo","",false,jid,mainwindow.oneselfName,_suuid)
                                //singleChat.sendMsg(0, str_, strOid + "pq"+jid + "@gsubo","",false,mainwindow.oneselfName,_suuid)
                                //console.log("聊天显示界面的str==",str_,"stroid==",strOid)
                                fileio.writeCallBackIniFile(uuid,1)

                                var MessageKey =strOid + "pq";

                                var parm = [];
                                parm[0] = 1;
                                parm[1] = userjid;
                                parm[2] = jid;
                                parm[3] = str_;
                                parm[4] = "text";
                                parm[5] = userjid + "@gsubo"
                                parm[6] = jid + "@gsubo"
                                parm[7] = getTime();
                                parm[8] = _suuid;
                                parm[9] = 0;

                                var parm1 = [];
                                parm1[0] = 5;
                                parm1[1] = userjid + "@gsubo"
                                parm1[2] = jid + "@gsubo"
                                parm1[3] = getTime();
                                parm1[4] = 0;

                                var strServer = loginAddressFile + "/im/putMessage?flag=" + parm[0] +"&from_uid=" +
                                        parm[1] +"&to_uid=" + parm[2] + "&content=" + parm[3] + "&type=" + parm[4] +
                                        "&of_from=" +MessageKey+ parm[5] + "&of_to=" +MessageKey+ parm[6] + "&stime=" + parm[7]  + "&atime=" + parm[7]*1000+ "&uuid=" +
                                        parm[8] + "&msg_type=" + parm[9] + "&charset=utf-8"

                                console.log("单击下载回执 "+strServer);
                                //chatMessageToServer.sendMsgServer(jessonid, strServer.toString())
                                Query.sendMessage(strServer,parm,str_,strOid + "pq",sendMsgResult2,sendMsgerror2);
                            }
                            else
                            {
                                 console.log("找到之前的回执记录,不再发送回执")
                            }

                        }
                    }//单击事件
                }//MouseArea

            }//下载/打开文件夹链接

            Text {
                id: filesaveas
                height: 15
                anchors.top: fielname.bottom
                anchors.topMargin: 10
                anchors.left: openfile.left
                anchors.leftMargin: 74
                anchors.right: parent.right  //gaobo wait
                anchors.rightMargin: 64
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                font.family: "微软雅黑"
                font.pixelSize: 13
                color: "#0099FF"

                visible:

                    if(chatMsgType === "1")//为文件时才显示
                    {
                        return true;
                    }
                    else
                    {
                        return false;
                    }

                text:
                {
                    if(chatMsgType != "1")
                        return ("");

                    if(chatFlag == 0)
                        return (""); //自己发的没有另存为

                    var obj = eval('(' + chatContents + ')'); // eval

                    if("file" in obj) //历史消息
                    {
                        issamefile = fileio.findfilepathissame(obj.file.file_name,obj.time,obj.uuid);
                        console.log("对象为file,历史消息,查找目录文件结果",issamefile)
                    }
                    else //openfire消息
                    {
                        issamefile = fileio.findfilepathissame(obj.data.file_name,obj.send_time,obj.uuid);
                        console.log("对象为data,openfire消息,查找目录文件结果",issamefile)
                    }

                    if(issamefile)  //已经下载的,不显示另存为,意味着显示:下载文件
                        return ("另存为");
                    else
                        return ("");

                }

                MouseArea {
                    id: mouse_saveas
                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onEntered:
                    {
                        filesaveas.color ="#16b0e9";
                    }
                    onExited:
                    {
                        filesaveas.color="#0099FF";
                    }

                    onClicked: {
                        if(filesaveas.text=="另存为")
                        {
                            console.log("点击文件名下方 另存为")
                            var obj = eval('(' + chatContents + ')');  //eval gaobo

                            if("file" in obj)
                            {
                                var filename1 = obj.file.file_name;
                            }
                            else
                            {
                                var filename1 = obj.data.file_name;
                            }

                            var filename2=fileio.readiniRevfilenotes(filename1,"",obj.uuid)

                            if(filename2!="")//接收记录中找到该文件
                            {
                                var filePath = filename2;
                            }
                            else
                            {
                                var filePath = chatFilePath+filename1;
                            }

                            console.log("另存为，文件路径:", filePath);
                            var filename = fileio.saveFile(filePath,chatTime)
                        }


                    }


                }

            }

            //下载文件进度条
            ProgressBar {
                id: progressBar1
                anchors.top: filesize.bottom
                anchors.topMargin: 11
                anchors.left: parent.left
                anchors.leftMargin: 0
                anchors.right: parent.right
                anchors.rightMargin: 0
                height: 3
                minimumValue: 0;
                maximumValue: 100;
                value: 0;

                //visible: receiverFile1>0 ? true : false
                visible: false

                style: ProgressBarStyle {
                    background: Rectangle {
                        width: parent.width
                        height: parent.height
                        radius: 3
                        border.width: 1
                        border.color: "#3c9fea"
                    }
                    progress: Rectangle {
                        radius: 3
                        color: "#3c9fea"
                    }
                }

                Timer{
                    id: timer1;
                    interval: 100;
                    repeat: true;
                    running: false;
                    onTriggered:
                    {
                        if(otherUid.indexOf("@gsrooms")<=-1) //单聊
                        {
                            isReceivedAll1=chatwindow.isReceivedAll;
                            receiverFile1=chatwindow.receiverFile;
                        }
                        else
                        {
                            isReceivedAll1=groupchatwindow.isReceivedAll;
                            receiverFile1=groupchatwindow.receiverFile;
                        }

                        console.log("进度条,receiverFile1:", receiverFile1," isReceivedAll1:",isReceivedAll1);
                        if(receiverFile1!=0 && receiverFileName1==filenameStr)
                        {
                            console.log("进度条,下载文件名:", receiverFileName1," 本地文件名:",filenameStr);
                            if(isReceivedAll1)
                            {
                                console.log("进度条:下载完毕,隐藏进度条")
                                parent.value=100;
                                parent.visible=false;
                                timer1.stop();
                                receiverFile1=0;
                                parent.value=0;
                            }
                            else
                            {
                                console.log("进度条:百分比 ", receiverFile1/filesizeNum);
                                parent.value = receiverFile1/filesizeNum * 100;
                            }
                        }
                    }

                }

            }


        }

        Item {
            id: voicerect

            anchors.left: parent.left
            anchors.leftMargin: 5
            anchors.right: parent.right
            anchors.rightMargin: 5
            height: parent.height

            visible: {
                if(chatMsgType === "3")
                {
                    console.log("显示音频文件")
                    return true;
                }
                else
                {
                    return false;
                }
            }

            Image {
                id: voiceImg
                width: 30
                height: 30
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.right: (chatFlag == 0) ? parent.right:undefined
                anchors.left: (chatFlag == 1) ? parent.left:undefined
                anchors.rightMargin: (chatFlag == 0) ? 0 : 30
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 5
                source: (chatFlag == 0) ? "qrc:/resource/images/im/voice/send.png" : "qrc:/resource/images/im/voice/received.png";

                SequentialAnimation {
                    id:voiceanimation
                    //loops: Animation.Infinite
                    loops: 5
                    alwaysRunToEnd:true
                    PropertyAnimation {
                        target: voiceImg;
                        property: "source";
                        to: (chatFlag == 0) ? "qrc:/resource/images/im/voice/send1.png" : "qrc:/resource/images/im/voice/received1.png"
                        duration: 250
                    }
                    PropertyAnimation {
                        target: voiceImg;
                        property: "source";
                        to: (chatFlag == 0) ? "qrc:/resource/images/im/voice/send2.png" : "qrc:/resource/images/im/voice/received2.png"
                        duration: 250
                    }
                    PropertyAnimation {
                        target: voiceImg;
                        property: "source";
                        to: (chatFlag == 0) ? "qrc:/resource/images/im/voice/send3.png" : "qrc:/resource/images/im/voice/received3.png"
                        duration: 250
                    }
                    PropertyAnimation {
                        target: voiceImg;
                        property: "source";
                        to: (chatFlag == 0) ? "qrc:/resource/images/im/voice/send.png" : "qrc:/resource/images/im/voice/received.png";
                        duration: 250
                    }
                }

                Timer{
                    id: timer_voice;
                    interval: 250;
                    repeat: true;
                    running: false;
                    onTriggered:
                    {

                        if(otherUid.indexOf("@gsrooms")<=-1) //单聊
                        {
                            if(chatwindow.receiverFileName!=receiverFileName1)
                            {
                                voiceanimation.stop()
                                console.log("点击了其它语音,停止播放动画");
                            }
                        }
                        else
                        {
                            if(groupchatwindow.receiverFileName!=receiverFileName1)
                            {
                                voiceanimation.stop()
                                console.log("群点击了其它语音,停止播放动画");
                            }
                        }

                        if(!voiceanimation.running)
                        {
                           timer_voice.stop()
                           console.log("动画停止后,停止定时器");
                        }

                    }
                }



//                MouseArea {
//                    id:_chatFilePath
//                    cursorShape: Qt.PointingHandCursor
//                    anchors.fill: parent

//                    onClicked: {
//                        voiceanimation.running = true
//                        chatVoiceMessage.playVoice(chatFilePath);
//                    }
//                }

            } //voiceImg

            Text {
                id: voicetimetext
                height: 30
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.right: (chatFlag == 0) ? voiceImg.left : undefined
                anchors.rightMargin: (chatFlag == 0) ? 10 : undefined
                anchors.left: (chatFlag == 1) ? voiceImg.right : undefined
                anchors.leftMargin: (chatFlag == 1) ? 10 : undefined

                font.family: "微软雅黑"
                font.pixelSize: 14
                color: "#80888f"
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
                text: chatVoiceTime+"\""
            }

        }

        //!聊天单个信息的item双击事件
        MouseArea {
            id: redownload_
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor
            onDoubleClicked: {
                //双击还没下载的文件
                if(openfile.text== "下载文件")
                {
                    openfile.text= "打开文件夹"
                    filesaveas.text= "另存为"
                    if(chatMsgType === "1")
                    {
                        var obj =eval('(' + chatContents + ')'); //eval gaobo
                        var loginAddressFile = fileio.getLoginAddress();
                        var strpath =  downLoadManager.getDownloadPath(chatTime);
                        console.log("本条消息路径为:",strpath);
                        if("file" in obj )
                        {
                            console.log("双击聊天内容窗口历史消息的下载文件1");
                            receiverFileName1=obj.file.file_name;
                            isReceivedAll1=false;

                            progressBar1.visible=true;
                            timer1.start();
                            downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.file.file_url, obj.file.file_name, "1",chatTime,jid,obj.uuid);

                            var sendtext = "文件："+obj.file.file_name +" 正在下载中，请稍候。";
                            //appendSendData(sendtext, 0, "0", "", "",jid,"0");
                        }
                        else
                        {
                            console.log("双击聊天内容窗口的下载文件2---来自openfire的消息");
                            receiverFileName1=obj.data.file_name;
                            isReceivedAll1=false;

                            progressBar1.visible=true;
                            timer1.start();
                            downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.data.file_url, obj.data.file_name, "1",chatTime,jid,obj.uuid);
                            var sendtext1 = "文件："+obj.data.file_name +" 正在下载中，请稍候。";
                            //appendSendData(sendtext1, 0, "0", "", "",jid,"0");

                        }

                        //下载别人发的,发送回执
                        uuid = obj.uuid +  receiverFileName1; //lingshi
                        console.log("聊天对话框中的uuid",uuid)

                        if(!fileio.readCallBackIniFile(uuid) && otherUid.indexOf("@gsrooms")<=-1)//群聊无回执
                        {
                            var str_ = "对方已经通过PC端在"+ fileio.getCurrTimestr()+"接收文件: "+receiverFileName1+"  (" + filesize.text+")" ;
                            var _suuid = Query.uuid()
                            //console.log("发送openfire回执消息参数",str_,strOid + "pq"+jid + "@gsubo","",false,jid,mainwindow.oneselfName,_suuid)
                            //singleChat.sendMsg(0, str_, strOid + "pq"+jid + "@gsubo","",false,mainwindow.oneselfName,_suuid)
                            fileio.writeCallBackIniFile(uuid,1)

                            var MessageKey =strOid + "pq";

                            var parm = [];
                            parm[0] = 1;
                            parm[1] = userjid;
                            parm[2] = jid;
                            parm[3] = str_;
                            parm[4] = "text";
                            parm[5] = userjid + "@gsubo"
                            parm[6] = jid + "@gsubo"
                            parm[7] = getTime();
                            parm[8] = _suuid;
                            parm[9] = 0;

                            var parm1 = [];
                            parm1[0] = 5;
                            parm1[1] = userjid + "@gsubo"
                            parm1[2] = jid + "@gsubo"
                            parm1[3] = getTime();
                            parm1[4] = 0;

                            var strServer = loginAddressFile + "/im/putMessage?flag=" + parm[0] +"&from_uid=" +
                                    parm[1] +"&to_uid=" + parm[2] + "&content=" + parm[3] + "&type=" + parm[4] +
                                    "&of_from=" +MessageKey+ parm[5] + "&of_to=" +MessageKey+ parm[6] + "&stime=" + parm[7]  + "&atime=" + parm[7]*1000+ "&uuid=" +
                                    parm[8] + "&msg_type=" + parm[9] + "&charset=utf-8"

                            console.log("双击下载回执 "+strServer);
                            //chatMessageToServer.sendMsgServer(jessonid, strServer.toString())
                            Query.sendMessage(strServer,parm,str_,strOid + "pq",sendMsgResult2,sendMsgerror2);
                        }

                    }//if(chatMsgType === "1")

                    return
                }

                //双击自己发的文件
                if(chatMsgType === "1")
                {
                    if(chatFlag == 0)
                    {
                        //如果是自己：查询本地记录文件。如果有打开对应文件，如果没有提示文件没找到
                        var obj = eval('(' + chatContents + ')');//eval gaobo
                        var strfindnotepath;
                        var strsendtime;
                        if("file" in obj )
                        {

                            if("sendTime"in obj.file)
                            {
                                console.log("strsendtime1",strsendtime,obj.file.sendTime);
                                strsendtime = obj.file.sendTime
                            }
                            else
                            {
                                if("time" in obj)strsendtime = obj.time
                                if("send_time" in obj)strsendtime = obj.send_time
                            }

                            console.log("strsendtime",strsendtime);
                            strfindnotepath = fileio.readiniSendfilenotes(obj.file.file_name,strsendtime)
                            if(strfindnotepath!="")
                            {
                                downLoadManager.startSendfileExe(strfindnotepath,false) //打开文件
                            }
                            else
                            {
                                messageDialog.text = "文件不存在"
                                messageDialog.visible = true;

                            }
                        }
                        else
                        {
                            console.log("本条消息路径为:自己发的openfire消息");
                            if("sendTime"in obj.data)
                            {
                                strsendtime = obj.data.sendTime
                            }
                            else
                            {
                                if("time" in obj)strsendtime = obj.time
                                if("send_time" in obj)strsendtime = obj.send_time
                            }

                            strfindnotepath = fileio.readiniSendfilenotes(obj.data.file_name,strsendtime)
                            if(strfindnotepath!="")
                            {
                                downLoadManager.startSendfileExe(strfindnotepath,false) //打开文件
                            }
                            else
                            {
                                messageDialog.text = "文件不存在"
                                messageDialog.visible = true;
                            }
                        }
                        return;
                    }
                }


                //双击已下载的别人发的文件、图片、语音
                var obj = eval('(' + chatContents + ')');
                var obj1;

                if(("file" in obj ))
                {
                    obj1 = obj.file;

                }
                else if("data" in obj)
                {
                    obj1 = obj.data
                }

                if(chatMsgType === "1")//文件
                {
                    console.log("双击已下载的别人发的文件，参数chatTime为",chatTime)
                    if(!fileio.findfilepathissame(obj1.file_name,chatTime,obj.uuid))
                        messageDialog.visible = true;
                    else
                        downLoadManager.startExe("explorer.exe", chatFilePath+obj1.file_name,chatTime,false,obj.uuid)  //打开文件
                }
                else if(chatMsgType === "2")//图片
                {
                    console.log("类型为图片，chatTime为",chatTime,"chatContents为",chatContents)
                    var obj = eval('(' + chatContents + ')'); //eval gaobo

                    if("file" in obj )
                    {
                        //    console.log("1")
                        var a= obj.file.file_url;
                        var b=fileio.readIniFile("login", "dnsip")
                        imgWidth=obj.file.file_width
                        imgHeight=obj.file.file_height
                        if( imgWidth > 424)
                        {
                            imgWidth = Number(obj.file.file_width) + 40;
                        }
                        else
                        {
                            imgWidth = 424;
                        }

                        if((imgHeight+100)  >= 372 &&(imgHeight+100)<Screen.desktopAvailableHeight)
                        {
                            imgHeight =  Number(imgHeight)+100
                        }
                        else
                        {
                            imgHeight = 800;
                        }
                        //  return strip+"/xs?"+a;
                        console.log("聊天微缩图的数据1",imgWidth,imgHeight)
                        creatImagePreviewObj(b+"/xs?"+a,  Number(imgWidth), Number(imgHeight))
                    }
                    else if("data" in obj)
                    {
                        var a= obj.data.file_url;
                        var b=fileio.readIniFile("login", "dnsip")
                        console.log("a=====",a)
                        a=decodeURIComponent(a);
                        imgWidth= Number(obj.data.file_width)
                        imgHeight= Number(obj.data.file_height)
                        if( imgWidth > 424)
                        {
                            imgWidth = Number(obj.data.file_width) + 40;
                        }
                        else
                        {
                            imgWidth = 424;
                        }

                        if((imgHeight+100)  >= 372 && (imgHeight+100)<Screen.desktopAvailableHeight)
                        {
                            imgHeight =  Number(imgHeight)+100
                        }
                        else
                        {
                            imgHeight = 800;
                        }
                        console.log("聊天微缩图的数据2",imgWidth,imgHeight)
                        creatImagePreviewObj(b+"/xs?"+a,  Number(imgWidth), Number(imgHeight))
                    }
                    else
                    {
                        var a= obj.file_url;
                        var b=fileio.readIniFile("login", "dnsip")
                        console.log("a=====",a)
                        a=decodeURIComponent(a);
                        imgWidth= Number(obj.file_width)
                        imgHeight= Number(obj.file_height)
                        if( imgWidth > 424)
                        {
                            imgWidth = Number(obj.file_width) + 40;
                        }
                        else
                        {
                            imgWidth = 424;
                        }

                        if((imgHeight+100)  >= 372 && (imgHeight+100)<Screen.desktopAvailableHeight)
                        {
                            imgHeight =  Number(imgHeight)+100
                        }
                        else
                        {
                            imgHeight = 800;
                        }
                        console.log("聊天微缩图的数据2",imgWidth,imgHeight)
                        creatImagePreviewObj(b+"/xs?"+a,  Number(imgWidth), Number(imgHeight))
                    }

                }
                else if(chatMsgType === "3")//音频双击下载,播放
                {

                    if(voiceanimation.running)
                    {
                        voiceanimation.stop()
                        fileio.stopmusic()

                    }
                    else
                    {

                        var loginAddressFile = fileio.getLoginAddress();

                        if("data" in obj)
                        {
                            var voice_file_url=obj.data.file_url
                            var voice_time=obj.data.voice_time
                        }
                        else
                        {
                            var voice_file_url=obj.file.file_url
                            var voice_time=obj.file.voice_time
                        }

                        if(typeof(obj.uuid) != "undefined")
                            receiverFileName1=obj.uuid+".aac"
                        else
                            receiverFileName1=obj.send_time+".aac"

                        if(otherUid.indexOf("@gsrooms")<=-1) //单聊
                            chatwindow.receiverFileName=receiverFileName1
                        else
                            groupchatwindow.receiverFileName=receiverFileName1
                        console.log("类型为音频，文件名 ",receiverFileName1)

                        downLoadManager.downloadFile(loginAddressFile+"/xs?"+voice_file_url, receiverFileName1, "3",chatTime,jid,obj.uuid);  //参数为3表示语音

                        voiceanimation.loops= Number(voice_time)+1
                        voiceanimation.start()
                        timer_voice.start()
                    }

                }

            }//双击事件
        }
        Component.onCompleted: {

        }
    }

    Item {
        id: waiteanimation
        width: 40
        height: 40
        anchors.top: parent.bottom
        anchors.topMargin:17
        anchors.left: (chatFlag == 0) ? showitem.left : showitem.right
        anchors.leftMargin: (chatFlag == 0) ? -45 : 5
        //visible: (chatMsgType === "3" && chatFileData != "1.0") ? true :false
        visible:false

        AnimatedImage {
            id: animation
            anchors.top: parent.top
            anchors.topMargin: 10
            anchors.left: parent.left
            anchors.leftMargin: 10
            source:"qrc:/resource/images/im/waiteanimation.gif"
        }
    }

    property Component windowComponent: Window {
        id: webwindow
        property string strTitle: ""
        property WebEngineView webView: webView_
        property int webWidth: 0
        property int webHeight: 0
        x: (Screen.desktopAvailableWidth - webWidth)/2
        y: (Screen.desktopAvailableHeight - webHeight)/2

        width: webWidth
        height: webHeight

        visible: true

        title: strTitle

        WebEngineView {
            id: webView_
            anchors.top: parent.top
            anchors.topMargin: 1
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom

            onNewViewRequested: function(request) {
                var newWindow = windowComponent.createObject(window.parent
                                                             , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                                                                 , "webHeight": (Screen.desktopAvailableHeight)*0.8
                                                                 , "strTitle": ""});
                request.openIn(newWindow.webView);
                newWindow.strTitle = newWindow.webView.title


            }

            onWindowCloseRequested: {
                webwindow.close();
            }

        }
        Component.onCompleted: {

        }
    }
    function progressparams()
    {
        console.log("progressint");

    }
    function downLoadreslt()
    {
        console.log("strReslt");
    }

    function countfilesize(strFileSize)
    {
        if(strFileSize.endsWith("MB"))
        {
            //console.log("文件大小为 M____",typeof strFileSize.substr(0,strFileSize.length-1),strFileSize.substr(0,strFileSize.length-1));
            //console.log("ChatItem 文件大小为 MB____",strFileSize.substr(0,strFileSize.length-2));
            //return Number(strFileSize.substr(0,strFileSize.length-1)) * 1024 *1024;
            return Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
        }
        else if(strFileSize.endsWith("KB"))
        {
            //console.log("文件大小为 KB____",typeof strFileSize.substr(0,strFileSize.length-2),strFileSize.substr(0,strFileSize.length-2));
            //console.log("ChatItem 文件大小为 KB____",strFileSize.substr(0,strFileSize.length-2));
            return Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
        }
        else
        {
            //console.log("文件大小为 null__未知大小",typeof strFileSize.substr(0,strFileSize.length-1),strFileSize.substr(0,strFileSize.length-1));
            //console.log("ChatItem 文件大小按 KB 处理",strFileSize);
            //return Number(strFileSize.substr(0,strFileSize.length-1));
            return Number(strFileSize) * 1024;
        }
    }


    function getHeight()
    {
        var iHeight;
        //  var iweight;
        if(chatMsgType === "0" && isSameTime(chatTime))
        {
            //console.log("时间相同,发送文字的高度:",contents.height)  //gaobo wait
            iHeight =  contents.height+40;
        }
        else if(chatMsgType === "0" && !isSameTime(chatTime))
        {
            //console.log("时间不相同,发送文字的高度:",contents.height)  //gaobo wait
            iHeight =  contents.height+80;
        }
        else if(chatMsgType === "1"  && !isSameTime(chatTime)) //|| chatMsgType === "2"
        {
            iHeight = 130;
        }
        else if(chatMsgType === "1" )
        {
            iHeight =110
        }
        else if(chatMsgType==="2" && isSameTime(chatTime))
        {
            var obj = eval('(' + chatContents + ')'); //eval gaobo
            // iweight=obj.file.file_weight;
            if("file" in obj )
            {
                // iHeight=obj.file.file_height;
                if(iHeight<100)
                {
                    return 190;
                }
                else{
                    console.log("iHeight====1===",iHeight)
                    return 220;//Number(iHeight)+20
                }

            }
            else
            {

                //   iHeight=obj.data.file_height;
                if(iHeight<100)
                {
                    return 190;
                }
                else{
                    console.log("iHeight====2===",iHeight)
                    return 220;//return Number(iHeight)+20
                }

            }

        }
        else if(chatMsgType==="2" && !isSameTime(chatTime))
        {
            var obj = eval('(' + chatContents + ')');  //eval
            // iweight=obj.file.file_weight;
            if("file" in obj )
            {
                iHeight=obj.file.file_height;
                if(iHeight<100)
                {
                    return 190;
                }
                else{
                    //console.log("发送图片的高度，时间不相同",iHeight)

                    //console.log("iHeight====3===",iHeight)
                    return 220;//190Number(iHeight)+20
                }

                // return Number(iHeight)+30
            }
            else if(chatMsgType==="2")
            {


                //iHeight=obj.data.file_height;
                if(iHeight<100)
                {
                    return 190;
                }
                else{
                    console.log("iHeight====4===",iHeight)
                    return 220;//190Number(iHeight)+20
                }

                //iHeight=obj.data.file_height;
                //  return Number(iHeight)+20;
                /*  else
                {
                   return 270;
                }*/

            }

            // return 110
        }
        else if(chatMsgType === "3")
        {
            iHeight = 120;
        }

        return iHeight;
    }

    function filterImg(str)
    {
        for(var i=0;i<tmpModel.count;i++)
        {
            var curTitle=tmpModel.get(i).title2;
            var curPath = "<img src="+"\""+tmpModel.get(i).path+"\" "+ "width=\"24\" height=\"24\"\" />";
            var reg = new RegExp(curTitle, "ig");
            str = str.replace(reg, curPath);
        }
        var orgStr =str.replace(/<<(.+?)>>/gi,"&lt;&lt;$1&gt;&gt;");
        orgStr.replace(/'/gi,"&#39;")
        return orgStr;
    }

    //change msecond to "year-month-date hour:minute" by feifei
    function changeMSecondToFullTime(msecond,iType)
    {

        if(msecond.length==10)
            msecond*=1000;
        //console.log("msecond=",msecond)
        var date = new Date((msecond - 0)+ 8*3600);
        var dateArray = [date.getFullYear(),date.getMonth()+1,date.getDate(),date.getHours(),date.getMinutes(), date.getSeconds()];
        for(var i=0;i<dateArray.length;i++){
            if(dateArray[i]<10){
                dateArray[i] = "0" + dateArray[i];
            }
        }


        var currentWeek = new Date().getDay();
        var currentDate = new Date().getDate();
        var str = "";
        var week = date.getDay();
        switch (week) {
        case 0 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 1 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 2 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 3 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 4 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 5 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        case 6 :
            if(currentDate == date.getDate())
            {
                str += "今天"
            }
            else if(currentDate == date.getDate() - 1)
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            else
            {
                str += dateArray[0] + "/"+ dateArray[1] +"/" + dateArray[2] + "/"
            }
            break;
        }

        var now =str + " "+ dateArray[3]+ ":" + dateArray[4]+ ":" + dateArray[5];
        return now
    }

    function getFormatData(msecond,iType)
    {
        var dates = new Date((msecond - 0)+ 8*3600);
        if(iType === 0)
        {
            return dates.getUTCFullYear().toString();
        }
        else if(iType === 1)
        {
            return dates.getMonth().toString();
        }
        else if(iType === 2)
        {
            return dates.getDate().toString();
        }
        else if(iType === 3)
        {
            return dates.getHours().toString();
        }
        else if(iType === 4)
        {
            return dates.getMinutes().toString();
        }
    }

    function isSameTime(str)
    {
        if(str != 0)
        {
            return false;
        }
        else
        {
            return true;
        }
    }

    function stopPlay()
    {
        voiceanimation.running = false
    }

    function creatWebObj(text, url, pageId) {
        var component = Qt.createComponent("../common/CustomWebView.qml");

        var obj;
        if (component.status === Component.Ready)
        {

            for(var i = 0; i < webPageObj.length; ++i)
            {
                if(webPageObj[i].pageid  == pageId)
                {
                    return;
                }
            }

            obj = component.createObject(window.parent, {"nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                             , "titletext": text
                                             , "visible": true
                                             , "pageid": pageId
                                             , "weburl": url});

        }

        if(obj === null)
        {

        }
        else
        {
            obj.deleteitem.connect(deleteUserInfoObj)
            webPageObj.push(obj)
        }
    }

    function deleteUserInfoObj(pageid)
    {

        for(var i = 0; i < webPageObj.length; ++i)
        {
            if(webPageObj[i].pageid === pageid)
            {
                webPageObj[i].deleteitem.disconnect(chatItemid.deleteUserInfoObj)
                webPageObj[i].destroy()
                console.log("销毁消息。itemid号:", pageid)
            }
        }
    }


    function showCallBackMsg(isShow)
    {
        //    callbackSender.visible = isShow;
        //    callbackSender.visible = isShow;
    }

    function getuserinfos()
    {
        oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")
        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")
        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")
        }

        //   strOid = fileio.readIniFile("login", "companyoid")
        strOid = window.companyoid
    }

    function faceDataLoad()
    {
        //qq face
        //faceinfo.push(new Array("[微笑]", "emotion_weixiao_gif.gif"));
        faceinfo.push(new Array("[微笑]", "emotion_weixiao_gif.gif"));
        faceinfo.push(new Array("[撇嘴]", "emotion_biezui_gif.gif"));
        faceinfo.push(new Array("[色]", "emotion_se_gif.gif"));
        faceinfo.push(new Array("[发呆]", "emotion_fadai_gif.gif"));
        faceinfo.push(new Array("[得意]", "emotion_deyi_gif.gif"));
        faceinfo.push(new Array("[流泪]", "emotion_liulei_gif.gif"));
        faceinfo.push(new Array("[害羞]", "emotion_haixiu_gif.gif"));
        faceinfo.push(new Array("[闭嘴]", "emotion_bizui_gif.gif"));
        faceinfo.push(new Array("[睡]", "emotion_shui_gif.gif"));
        faceinfo.push(new Array("[大哭]", "emotion_daku_gif.gif"));
        faceinfo.push(new Array("[尴尬]", "emotion_ganga_gif.gif"));
        faceinfo.push(new Array("[发怒]", "emotion_fanu_gif.gif"));
        faceinfo.push(new Array("[调皮]", "emotion_tiaopi_gif.gif"));
        faceinfo.push(new Array("[呲牙]", "emotion_ciya_gif.gif"));
        faceinfo.push(new Array("[惊讶]", "emotion_jingya_gif.gif"));
        faceinfo.push(new Array("[难过]", "emotion_nanguo_gif.gif"));
        faceinfo.push(new Array("[酷]", "emotion_ku_gif.gif"));
        faceinfo.push(new Array("[冷汗]", "emotion_lenghan_gif.gif"));
        faceinfo.push(new Array("[抓狂]", "emotion_zhuakuang_gif.gif"));
        faceinfo.push(new Array("[吐]", "emotion_tu_gif.gif"));
        faceinfo.push(new Array("[偷笑]", "emotion_touxiao_gif.gif"));
        faceinfo.push(new Array("[可爱]", "emotion_keai_gif.gif"));
        faceinfo.push(new Array("[白眼]", "emotion_baiyan_gif.gif"));
        faceinfo.push(new Array("[傲慢]", "emotion_aoman_gif.gif"));
        faceinfo.push(new Array("[饥饿]", "emotion_jie_gif.gif"));
        faceinfo.push(new Array("[困]", "emotion_kun_gif.gif"));
        faceinfo.push(new Array("[惊恐]", "emotion_jingkong_gif.gif"));
        faceinfo.push(new Array("[流汗]", "emotion_liuhan_gif.gif"));
        faceinfo.push(new Array("[憨笑]", "emotion_hanxiao_gif.gif"));
        faceinfo.push(new Array("[大兵]", "emotion_dabing_gif.gif"));
        faceinfo.push(new Array("[奋斗]", "emotion_fendou_gif.gif"));
        faceinfo.push(new Array("[咒骂]", "emotion_zouma_gif.gif"));
        faceinfo.push(new Array("[疑问]", "emotion_yiwen_gif.gif"));
        faceinfo.push(new Array("[嘘]", "emotion_xu_gif.gif"));
        faceinfo.push(new Array("[晕]", "emotion_yun_gif.gif"));
        faceinfo.push(new Array("[折磨]", "emotion_fakuang_gif.gif"));
        faceinfo.push(new Array("[衰]", "emotion_shuai_gif.gif"));
        faceinfo.push(new Array("[骷髅]", "emotion_kulou_gif.gif"));
        faceinfo.push(new Array("[敲打]", "emotion_qiaoda_gif.gif"));
        faceinfo.push(new Array("[再见]", "emotion_zaijian_gif.gif"));
        faceinfo.push(new Array("[擦汗]", "emotion_cahan_gif.gif"));
        faceinfo.push(new Array("[抠鼻]", "emotion_koubi_gif.gif"));
        faceinfo.push(new Array("[鼓掌]", "emotion_guzhang_gif.gif"));
        faceinfo.push(new Array("[糗大了]", "emotion_qiudale_gif.gif"));
        faceinfo.push(new Array("[坏笑]", "emotion_huaixiao_gif.gif"));
        faceinfo.push(new Array("[左哼哼]", "emotion_zuohengheng_gif.gif"));
        faceinfo.push(new Array("[右哼哼]", "emotion_youhengheng_gif.gif"));
        faceinfo.push(new Array("[哈欠]", "emotion_haqian_gif.gif"));
        faceinfo.push(new Array("[鄙视]", "emotion_bishi_gif.gif"));
        faceinfo.push(new Array("[委屈]", "emotion_weiqu_gif.gif"));
        faceinfo.push(new Array("[快哭了]", "emotion_kuaikule_gif.gif"));
        faceinfo.push(new Array("[阴险]", "emotion_yingxian_gif.gif"));
        faceinfo.push(new Array("[亲亲]", "emotion_qinqin_gif.gif"));
        faceinfo.push(new Array("[吓]", "emotion_xia_gif.gif"));
        faceinfo.push(new Array("[可怜]", "emotion_kelian_gif.gif"));
        faceinfo.push(new Array("[菜刀]", "emotion_caidao_gif.gif"));
        faceinfo.push(new Array("[西瓜]", "emotion_xigua_gif.gif"));
        faceinfo.push(new Array("[啤酒]", "emotion_pijiu_gif.gif"));
        faceinfo.push(new Array("[篮球]", "emotion_lanqiu_gif.gif"));
        faceinfo.push(new Array("[乒乓]", "emotion_pingpang_gif.gif"));
        faceinfo.push(new Array("[咖啡]", "emotion_kafei_gif.gif"));
        faceinfo.push(new Array("[饭]", "emotion_fan_gif.gif"));
        faceinfo.push(new Array("[猪头]", "emotion_zhutou_gif.gif"));
        faceinfo.push(new Array("[玫瑰]", "emotion_meigui_gif.gif"));
        faceinfo.push(new Array("[凋谢]", "emotion_diaoxie_gif.gif"));
        faceinfo.push(new Array("[示爱]", "emotion_shiai_gif.gif"));
        faceinfo.push(new Array("[爱心]", "emotion_aixin_gif.gif"));
        faceinfo.push(new Array("[心碎]", "emotion_xinsui_gif.gif"));
        faceinfo.push(new Array("[蛋糕]", "emotion_dangao_gif.gif"));
        faceinfo.push(new Array("[闪电]", "emotion_shandian_gif.gif"));
        faceinfo.push(new Array("[炸弹]", "emotion_zhadan_gif.gif"));
        faceinfo.push(new Array("[刀]", "emotion_dao_gif.gif"));
        faceinfo.push(new Array("[足球]", "emotion_zhuqiu_gif.gif"));
        faceinfo.push(new Array("[瓢虫]", "emotion_pachong_gif.gif"));
        faceinfo.push(new Array("[便便]", "emotion_bianbian_gif.gif"));
        faceinfo.push(new Array("[月亮]", "emotion_yueliang_gif.gif"));
        faceinfo.push(new Array("[太阳]", "emotion_taiyang_gif.gif"));
        faceinfo.push(new Array("[礼物]", "emotion_liwu_gif.gif"));
        faceinfo.push(new Array("[拥抱]", "emotion_baobao_gif.gif"));
        faceinfo.push(new Array("[强]", "emotion_qiang_gif.gif"));
        faceinfo.push(new Array("[弱]", "emotion_ruo_gif.gif"));
        faceinfo.push(new Array("[握手]", "emotion_woshou_gif.gif"));
        faceinfo.push(new Array("[胜利]", "emotion_shengli_gif.gif"));
        faceinfo.push(new Array("[抱拳]", "emotion_baoquan_gif.gif"));
        faceinfo.push(new Array("[勾引]", "emotion_gouying_gif.gif"));
        faceinfo.push(new Array("[拳头]", "emotion_quantou_gif.gif"));
        faceinfo.push(new Array("[差劲]", "emotion_chajing_gif.gif"));
        faceinfo.push(new Array("[爱你]", "emotion_aini_gif.gif"));
        faceinfo.push(new Array("[NO]", "emotion_no_gif.gif"));
        faceinfo.push(new Array("[OK]", "emotion_ok_gif.gif"));
        faceinfo.push(new Array("[爱情]", "emotion_aiqing_gif.gif"));
        faceinfo.push(new Array("[飞吻]", "emotion_feiwen_gif.gif"));
        faceinfo.push(new Array("[跳跳]", "emotion_tiaotiao_gif.gif"));
        faceinfo.push(new Array("[发抖]", "emotion_fadou_gif.gif"));
        faceinfo.push(new Array("[怄火]", "emotion_ouhuo_gif.gif"));
        faceinfo.push(new Array("[转圈]", "emotion_zhuanquan_gif.gif"));
        faceinfo.push(new Array("[磕头]", "emotion_ketou_gif.gif"));
        faceinfo.push(new Array("[回头]", "emotion_huitou_gif.gif"));
        faceinfo.push(new Array("[跳绳]", "emotion_tiaosheng_gif.gif"));
        faceinfo.push(new Array("[挥手]", "emotion_huishou_gif.gif"));
        faceinfo.push(new Array("[激动]", "emotion_jidong_gif.gif"));
        faceinfo.push(new Array("[街舞]", "emotion_jiewu_gif.gif"));
        faceinfo.push(new Array("[献吻]", "emotion_xianwen_gif.gif"));
        faceinfo.push(new Array("[左太极]", "emotion_zuotaiji_gif.gif"));
        faceinfo.push(new Array("[右太极]", "emotion_youtaiji_gif.gif"));
        faceinfo.push(new Array("[双喜]", "emotion_shuangxi_gif.gif"));
        faceinfo.push(new Array("[鞭炮]", "emotion_bianpao_gif.gif"));
        faceinfo.push(new Array("[灯笼]", "emotion_denglong_gif.gif"));
        faceinfo.push(new Array("[发财]", "emotion_facai_gif.gif"));
        faceinfo.push(new Array("[K歌]", "emotion_kge_gif.gif"));
        faceinfo.push(new Array("[购物]", "emotion_gouwu_gif.gif"));
        faceinfo.push(new Array("[邮件]", "emotion_youjian_gif.gif"));
        faceinfo.push(new Array("[帅]", "emotion_dashuai_gif.gif"));
        faceinfo.push(new Array("[喝彩]", "emotion_hecai_gif.gif"));
        faceinfo.push(new Array("[祈祷]", "emotion_qidao_gif.gif"));
        faceinfo.push(new Array("[爆筋]", "emotion_baojing_gif.gif"));
        faceinfo.push(new Array("[棒棒糖]", "emotion_bangbangtang_gif.gif"));
        faceinfo.push(new Array("[喝奶]", "emotion_henai_gif.gif"));
        faceinfo.push(new Array("[下面]", "emotion_xiamian_gif.gif"));
        faceinfo.push(new Array("[香蕉]", "emotion_xiangjiao_gif.gif"));
        faceinfo.push(new Array("[飞机]", "emotion_feiji_gif.gif"));
        faceinfo.push(new Array("[开车]", "emotion_kaiche_gif.gif"));
        faceinfo.push(new Array("[左车头]", "emotion_zuochetou_gif.gif"));
        faceinfo.push(new Array("[车厢]", "emotion_chexiang_gif.gif"));
        faceinfo.push(new Array("[右车头]", "emotion_youchexiang_gif.gif"));
        faceinfo.push(new Array("[多云]", "emotion_duoyun_gif.gif"));
        faceinfo.push(new Array("[下雨]", "emotion_xiayu_gif.gif"));
        faceinfo.push(new Array("[钞票]", "emotion_chaopiao_gif.gif"));
        faceinfo.push(new Array("[熊猫]", "emotion_xiongmao_gif.gif"));
        faceinfo.push(new Array("[灯泡]", "emotion_dengpao_gif.gif"));
        faceinfo.push(new Array("[风车]", "emotion_fengche_gif.gif"));
        faceinfo.push(new Array("[闹钟]", "emotion_naozhong_gif.gif"));
        faceinfo.push(new Array("[打伞]", "emotion_dashan_gif.gif"));
        faceinfo.push(new Array("[彩球]", "emotion_caiqiu_gif.gif"));
        faceinfo.push(new Array("[钻戒]", "emotion_zhuanjie_gif.gif"));
        faceinfo.push(new Array("[沙发]", "emotion_shafa_gif.gif"));
        faceinfo.push(new Array("[纸巾]", "emotion_zhijing_gif.gif"));
        faceinfo.push(new Array("[药]", "emotion_yao_gif.gif"));
        faceinfo.push(new Array("[手枪]", "emotion_shouqiang_gif.gif"));
        faceinfo.push(new Array("[青蛙]", "emotion_qingwa_gif.gif"));

        //sina face
        faceinfo.push(new Array("[sina呵呵]","sina_emo_0.png"));
        faceinfo.push(new Array("[sina嘻嘻]","sina_emo_1.png"));
        faceinfo.push(new Array("[sina哈哈]","sina_emo_2.png"));
        faceinfo.push(new Array("[sina爱你]","sina_emo_3.png"));
        faceinfo.push(new Array("[sina挖鼻屎]","sina_emo_4.png"));
        faceinfo.push(new Array("[sina汗]","sina_emo_5.png"));
        faceinfo.push(new Array("[sina晕]","sina_emo_6.png"));
        faceinfo.push(new Array("[sina吃惊]","sina_emo_7.png"));
        faceinfo.push(new Array("[sina泪]","sina_emo_8.png"));
        faceinfo.push(new Array("[sina馋嘴]","sina_emo_9.png"));
        faceinfo.push(new Array("[sina抓狂]","sina_emo_10.png"));
        faceinfo.push(new Array("[sina哼]","sina_emo_11.png"));
        faceinfo.push(new Array("[sina可爱]","sina_emo_12.png"));
        faceinfo.push(new Array("[sina怒]","sina_emo_13.png"));
        faceinfo.push(new Array("[sina害羞]","sina_emo_14.png"));
        faceinfo.push(new Array("[sina打哈欠]","sina_emo_15.png"));
        faceinfo.push(new Array("[sina钱]","sina_emo_16.png"));
        faceinfo.push(new Array("[sina懒得理你]","sina_emo_17.png"));
        faceinfo.push(new Array("[sina酷]","sina_emo_18.png"));
        faceinfo.push(new Array("[sina衰]","sina_emo_19.png"));
        faceinfo.push(new Array("[sina闭嘴]","sina_emo_20.png"));
        faceinfo.push(new Array("[sina鄙视]","sina_emo_21.png"));
        faceinfo.push(new Array("[sina花心]","sina_emo_22.png"));
        faceinfo.push(new Array("[sina鼓掌]","sina_emo_23.png"));
        faceinfo.push(new Array("[sina悲伤]","sina_emo_24.png"));
        faceinfo.push(new Array("[sina思考]","sina_emo_25.png"));
        faceinfo.push(new Array("[sina生病]","sina_emo_26.png"));
        faceinfo.push(new Array("[sina亲亲]","sina_emo_27.png"));
        faceinfo.push(new Array("[sina怒骂]","sina_emo_28.png"));
        faceinfo.push(new Array("[sina太开心]","sina_emo_29.png"));
        faceinfo.push(new Array("[sina偷笑]","sina_emo_30.png"));
        faceinfo.push(new Array("[sina右哼哼]","sina_emo_31.png"));
        faceinfo.push(new Array("[sina左哼哼]","sina_emo_32.png"));
        faceinfo.push(new Array("[sina嘘]","sina_emo_33.png"));
        faceinfo.push(new Array("[sina委屈]","sina_emo_34.png"));
        faceinfo.push(new Array("[sina吐]","sina_emo_35.png"));
        faceinfo.push(new Array("[sina可怜]","sina_emo_36.png"));
        faceinfo.push(new Array("[sina挤眼]","sina_emo_37.png"));
        faceinfo.push(new Array("[sina失望]","sina_emo_38.png"));
        faceinfo.push(new Array("[sina疑问]","sina_emo_39.png"));
        faceinfo.push(new Array("[sina困]","sina_emo_40.png"));
        faceinfo.push(new Array("[sina拜拜]","sina_emo_41.png"));
        faceinfo.push(new Array("[sina黑线]","sina_emo_42.png"));
        faceinfo.push(new Array("[sina阴险]","sina_emo_43.png"));
        faceinfo.push(new Array("[sina互粉]","sina_emo_44.png"));
        faceinfo.push(new Array("[sina睡觉]","sina_emo_45.png"));
        faceinfo.push(new Array("[sina抱抱]","sina_emo_46.png"));
        faceinfo.push(new Array("[sina心]","sina_emo_47.png"));
        faceinfo.push(new Array("[sina伤心]","sina_emo_48.png"));
        faceinfo.push(new Array("[sina猪头]","sina_emo_49.png"));
        faceinfo.push(new Array("[sina熊猫]","sina_emo_50.png"));
        faceinfo.push(new Array("[sina兔子]","sina_emo_51.png"));
        faceinfo.push(new Array("[sina赞]","sina_emo_52.png"));
        faceinfo.push(new Array("[sinagood]","sina_emo_53.png"));
        faceinfo.push(new Array("[sina耶]","sina_emo_54.png"));
        faceinfo.push(new Array("[sina弱]","sina_emo_55.png"));
        faceinfo.push(new Array("[sina不要]","sina_emo_56.png"));
        faceinfo.push(new Array("[sinaok]","sina_emo_57.png"));
        faceinfo.push(new Array("[sina来]","sina_emo_58.png"));
        faceinfo.push(new Array("[sina威武]","sina_emo_59.png"));
        faceinfo.push(new Array("[sina蛋糕]","sina_emo_60.png"));
        faceinfo.push(new Array("[sina蜡烛]","sina_emo_61.png"));
        faceinfo.push(new Array("[sina草泥马]","sina_emo_62.png"));
        faceinfo.push(new Array("[sina浮云]","sina_emo_63.png"));
        faceinfo.push(new Array("[sina给力]","sina_emo_64.png"));
        faceinfo.push(new Array("[sina围观]","sina_emo_65.png"));
        faceinfo.push(new Array("[sina奥特曼]","sina_emo_66.png"));
        faceinfo.push(new Array("[sina囧]","sina_emo_67.png"));
        faceinfo.push(new Array("[sina礼物]","sina_emo_68.png"));
        faceinfo.push(new Array("[sina神马]","sina_emo_69.png"));

    }

    function facetopath(content)
    {
        if(faceinfo.length==0)
           faceDataLoad() // 加载表情数组数据

        for(var i=0;i<faceinfo.length;i++)
        {
            //content=content.replace(/\[微笑\]/g, "<img width=22 valign=bottom src=qrc:/resource/images/im/face/all/emotion_weixiao_gif.gif>")
            //console.log("faceinfo:",faceinfo[i][0]);
            var str=faceinfo[i][0].replace("[","\\[");
            str=str.replace("]","\\]");
            var reg=new RegExp(str,"g");
            content=content.replace(reg, "<img width=22 valign=bottom src=qrc:/resource/images/im/face/all/"+faceinfo[i][1]+">")
        }
        return content;
    }



    /* function returnimagepath(shotfilepath,userjid)
    {
         var strfile = shotfilepath;
         imagechat.source="file:///"+strfile
         console.log("imagechat.source==",imagechat.source)
         // console.log("strfile===ljx",shotfilepath)
         //"file:///"+strfile
         //if(jid!=userjid)return;
         //  getuserinfos()

   }*/
    Component.onCompleted: {
        chatVoiceMessage.playVoiceFinished.connect(stopPlay)

        //  screenshot.finishPixmap.connect(returnimagepath)
        // console.log("onCompleted::::",chatName)
        // console.log("onCompleted::::",oneselfUid)
        // console.log("onCompleted::::",otherUid)
        // console.log("onCompleted::::",uuid)
        //sconsole.log("callback::::",uuid)

    }
}
