﻿import QtQuick.Window 2.2
import QtQuick.Layouts 1.1
import QtQuick.XmlListModel 2.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtGraphicalEffects 1.0
import Qt.labs.platform 1.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import QtQuick 2.0
import QtQuick 2.7

Window {
    id: groupUserwindow
    width: 279
    height: 315
    opacity: 1.0
    title:"人员信息"

    x: ((Screen.desktopAvailableWidth - 598)/2) + (20*count)
    y: ((Screen.desktopAvailableHeight - 522)/2)+(60*count)

    flags: Qt.Window | Qt.FramelessWindowHint
    property bool bPressed: true

    property int count: 0
    property string vatar : "";
    property string userName : "";
    property string userId : "";
    property string userIden :"";
    property string sexIco  :"";
    property string phoneNum :"";
    property string department  :"";

    signal deleteitem()

    MouseArea { //为窗口添加鼠标事件
                id:mouse
                anchors.fill: parent
                acceptedButtons: Qt.LeftButton //只处理鼠标左键
                property point clickPos: "0,0"
                width: 283
                anchors.rightMargin: 0
                anchors.bottomMargin: 0
                anchors.leftMargin: 2
                anchors.topMargin: 0
                onPressed: { //接收鼠标按下事件
                    clickPos  = Qt.point(mouse.x,mouse.y)
                    bPressed = true
                }

                onReleased: {
                    bPressed = false;
                }

                onPositionChanged: { //鼠标按下后改变位置
                    //鼠标偏移量
                    if(bPressed)
                    {
                        var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)

                        //如果mainwindow继承自QWidget,用setPos
                        groupUserwindow.setX(groupUserwindow.x+delta.x)
                        groupUserwindow.setY(groupUserwindow.y+delta.y)
                    }
                }
            }

    Rectangle{
               id:trc
                   anchors.top: parent.top
                   anchors.topMargin: 2
            Image {
                id: image_vavtar
                anchors.top: parent.top
                anchors.topMargin: 2
                anchors.left: parent.left
                anchors.leftMargin: 2
                x: 28
                y: 15
                width: 58
                height: 50
                source: vatar
            }

            Text {
                id: text_username
                x: 82
                y: 12
                width: 37
                height: 12
                text: userName
                font.pixelSize: 12
            }

            Text {
                id: text_userIden
                x: 82
                y: 30
                width: 91
                height: 12
                text: userIden
                font.pixelSize: 12
            }

            Text {
                id: text_12
                x: 28
                y: 79
                width: 91
                height: 15
                text: qsTr("手机:")
                opacity: 0.9
                font.pixelSize: 12
            }

            Text {
                id: text_13
                x: 28
                y: 128
                width: 91
                height: 15
                text: qsTr("部门:")
                opacity: 0.9
                font.pixelSize: 12
            }

            Text {
                id: text_phoneNum
                x: 39
                y: 100
                width: 109
                height: 15
                text: phoneNum
                font.pixelSize: 12
            }

            Text {
                id: text_depatment
                x: 39
                y: 149
                width: 109
                height: 15
                text: department
                font.pixelSize: 12
            }

            Button {
                id: button_sendmsg
                x: 28
                y: 198
                width: 226
                height: 23
                text: qsTr("发消息")
            }

            Button {
                id: button_velue
                x: 28
                y: 241
                width: 226
                height: 23
                text: qsTr("语音通话")
            }

            Button {
                id: button_close
                anchors.top:parent.top
                x: 252
                y: 0
                width: 28
                height: 24
                text: qsTr("X")

                onClicked: {
                    groupUserwindow.deleteitem()
                }
            }
    }

           Image {
               id: image_ico
               anchors.top: image_vavtar.top
               anchors.left: image_vavtar.left
               anchors.leftMargin: 2
               x:118
               y: 11
               width: 21
               height: 18
               source: sexIco
           }

    Component.onCompleted: {
       //   console.log("username:",vatar);
       //    console.log("username:",userName );
       //    console.log("username:",userId );
       //    console.log("username:",userIden );
       //    console.log("username:",sexIco  );
       //    console.log("username:",phoneNum );
       //    console.log("username:",department);

        }

}
