﻿import QtQuick 2.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import GetClientversion 1.0
import "../common"
import "../setting"
import "../interface"
import "../js/query.js" as Query

Rectangle {
    id: login
    visible: true
    color: "#2772CD"
    focus: true
    property string url: ""
    property string port: ""
    property string userName: ""
    property string userPasswd: ""
    property var items: []
    property int oaoutnet: -1
    property var networksetobj: null
    property var setobj: null
    property var    mesageObj: null

    property var versionmesageObj: null

    property alias loginingid: logining.visible
    property alias logininfoid: logininfor.visible
    property alias loginbtnid: loginbtn.visible
    property alias cancelbtnid: cancelbtn.visible
    property alias rememberpasswdid: rememberpasswd.visible
    property alias autologinid: autologin.visible
    property alias loginingiconid: loginingicon.visible


    signal loginSuccess(string userjson)
    function usertoClientversion(clientdownurl,clientversion)
     {
         console.log("用户确认了升级---------------");

         versionmesageObj.sigSure.disconnect(usertoClientversion)
         getclientversion.openIpdatapress(strip+clientversion,clientdownurl);

             versionmesageObj.deleteitem();
             versionmesageObj.close();
             versionmesageObj=NULL;
         //versionmesageObj.vi
         //  quit();
         //Qt.quit();

     }
     function userNotoClientversion(clientdownurl,clientversion)
     {
        // versionmesageObj.sigSure.disconnect(usertoClientversion)
         //getclientversion.openIpdatapress(clientdownurl,clientversion);
         console.log("用户取消了升级---------------");


         var oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
          if(oaoutnet === "0") //内网登录
          {
              strip = fileio.readIniFile("login", "oainnet")
              if(strip === "http://"|| strip === "")
              {
                  creatMessageObj("请输入网址!", "creatSetObj");

                // creatSetObj();
                  return;
              }
          }
          else if(oaoutnet === "1")//外网登录
          {
              strip = fileio.readIniFile("login", "oaoutnet")
              if(strip === "http://"|| strip === "")
              {
                  creatMessageObj("请输入网址!", "creatSetObj");

                   //    creatSetObj();
                   return;
              }
          }
          else if(oaoutnet === "2")//测试地址
          {
              strip = fileio.readIniFile("login", "oatestnet")
              if(strip === "http://" || strip === "")
              {
                  creatMessageObj("请输入网址!", "creatSetObj");

                 // creatSetObj();
                   return;
              }
          }
          if(rememberpasswd.checkedState)
          {
              fileio.writeIniFile("login", "xoabang", fileio.textEncode(userpasswd.text,"X"))
          }
          else
          {
              fileio.writeIniFile("login", "xoabang", "")
          }

          fileio.writeIniFile("login", "username", username.text)

          fileio.writeIniFile("login", "autologin", autologin.checkedState)
          fileio.writeIniFile("login", "remembPasswd", rememberpasswd.checkedState)

          loginingicon.visible = true
          rememberpasswd.visible = false
          autologin.visible = false
         // login.loginSuccess(userpasswd.text)

     }
    function getClientversionsuessed(clientversion,clientdownurl)
    {


                if(Number(clientversion.substring(0,4)) >Number( fileio.readIniFile("def", "autologinMode").substring(0,4)))
                  {
                    //  getclientversion.openIpdatapress(clientversion,clientdownurl);
                    //  console.log(clientversion)
                      var versionMsgcomponent = Qt.createComponent("VersionMessagebox.qml");
                     //  console.log(fileio.readIniFile("def", "autologinMode"))
                          if (versionMsgcomponent.status === Component.Ready)
                          {
                              if(versionmesageObj === null)
                              {
                                  console.log("进入了弹窗界面2")

                                   console.log("进入了弹窗界面3")
                                   versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                     , "messageText":"升级到"+clientversion
                                                                     , "version": clientversion
                                                                          ,"versionDownurl":clientdownurl});
                               }
                              if(versionmesageObj === null)
                              {
                              }
                              else
                              {
                                  versionmesageObj.sigSure.connect(usertoClientversion)
                                  versionmesageObj.sigCancel.connect(userNotoClientversion)
                              }

                      }
                          else
                          {
                         //     console.log(component.error)

                          }

                  }
                  else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                          &&Number(clientversion.substring(5,7)) >Number( fileio.readIniFile("def", "autologinMode").substring(5,7)))
                  {
                      //console.log(clientversion)
                      var versionMsgcomponent = Qt.createComponent("VersionMessagebox.qml");
                     //  console.log(fileio.readIniFile("def", "autologinMode"))
                          if (versionMsgcomponent.status === Component.Ready)
                          {
                              if(versionmesageObj === null)
                              {
                                 // console.log("进入了弹窗界面2")

                                 //  console.log("进入了弹窗界面3")
                                   versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                     , "messageText":"升级到"+clientversion
                                                                     , "version": clientversion
                                                                          ,"versionDownurl":clientdownurl});
                               }
                              if(versionmesageObj === null)
                              {
                              }
                              else
                              {

                                  versionmesageObj.sigSure.connect(usertoClientversion)
                                  versionmesageObj.sigCancel.connect(userNotoClientversion)
                              }

                      }
                          else
                          {
                             // console.log(component.error)

                          }

                  }
                  else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                          &&Number(clientversion.substring(5,7))===Number( fileio.readIniFile("def", "autologinMode").substring(5,7))
                          &&Number(clientversion.substring(8,10))>Number( fileio.readIniFile("def", "autologinMode").substring(8,10)))
                  {
                     // console.log(clientversion)
                      var versionMsgcomponent = Qt.createComponent("VersionMessagebox.qml");
                     //  console.log(fileio.readIniFile("def", "autologinMode"))
                          if (versionMsgcomponent.status === Component.Ready)
                          {
                              if(versionmesageObj === null)
                              {
                                 // console.log("进入了弹窗界面2")

                                  // console.log("进入了弹窗界面3")
                                   versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                     , "messageText":"升级到"+clientversion
                                                                     , "version": clientversion
                                                                          ,"versionDownurl":clientdownurl});
                               }
                              if(versionmesageObj === null)
                              {
                              }
                              else
                              {

                                  versionmesageObj.sigSure.connect(usertoClientversion)
                                  versionmesageObj.sigCancel.connect(userNotoClientversion)
                              }

                      }
                          else
                          {
                             // console.log(component.error)

                          }

                  }
                  else if(Number(clientversion.substring(0,4)) ===Number( fileio.readIniFile("def", "autologinMode").substring(0,4))
                          &&Number(clientversion.substring(5,7))===Number( fileio.readIniFile("def", "autologinMode").substring(5,7))
                          &&Number(clientversion.substring(8,10))===Number( fileio.readIniFile("def", "autologinMode").substring(8,10))
                          &&Number(clientversion.substring(11,12))>Number( fileio.readIniFile("def", "autologinMode").substring(11,12)))
                  {
                     // console.log(clientversion)
                      var versionMsgcomponent = Qt.createComponent("VersionMessagebox.qml");
                       //console.log(fileio.readIniFile("def", "autologinMode"))
                          if (versionMsgcomponent.status === Component.Ready)
                          {
                              if(versionmesageObj === null)
                              {
                                //  console.log("进入了弹窗界面2")

                                //   console.log("进入了弹窗界面3")
                                   versionmesageObj = versionMsgcomponent.createObject(window.parent, { "visible": true
                                                                     , "messageText":"升级到"+clientversion
                                                                     , "version": clientversion
                                                                          ,"versionDownurl":clientdownurl});
                               }
                              if(versionmesageObj === null)
                              {

                              }
                              else
                              {

                                  versionmesageObj.sigSure.connect(usertoClientversion)
                                  versionmesageObj.sigCancel.connect(userNotoClientversion)
                              }

                      }
                          else
                          {
                           //   console.log(component.error)

                          }

                  }
                  else
                  {

                      //login.loginSuccess(userpasswd.text)
                      userNotoClientversion();
                  }
     }

    function getClientversionerr(){
                     //login.loginSuccess(userpasswd.text)
        userNotoClientversion();
    }

    function creatMessageObj(contexText, parm) {
        var component = Qt.createComponent("../main/MessageDailog.qml");

        if (component.status === Component.Ready)
        {
            if(mesageObj === null)
            {
                mesageObj = component.createObject(window.parent, { "visible": true
                                                       , "messageText":contexText
                                                       , "pageId": parm});
            }
        }
        if(mesageObj === null)
        {
        }
        else
        {
            //mesageObj.deleteitem.connect(mainbottomOperating.deleteMessageObj)
            mesageObj.sigSure.connect(setLoginAgin)
            mesageObj.sigCancel.connect(deleteMessageObj)
        }


    }
    function setLoginAgin()
    {
        creatSetObj();
        mesageObj.sigCancel.disconnect(deleteMessageObj)
         mesageObj.sigSure.disconnect(deleteMessageObj)

        mesageObj.destroy()
        mesageObj = null
        //console.log("destroyR342", "没有输入zu'zh组织--提醒框")
    }
    function deleteMessageObj()
    {
       // mesageObj.deleteitem.disconnect(deleteMessageObj)
       // mesageObj.sigSure.disconnect(messageOperate)
        mesageObj.sigCancel.disconnect(deleteMessageObj)
        mesageObj.sigSure.disconnect(deleteMessageObj)

        mesageObj.destroy()
        mesageObj = null
       // console.log("destroyR342", "没有输入zu'zh组织--提醒框")
    }

    function getuserinfo()
    {
        oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")
        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")
        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")
        }
        userName = username.text
        userPasswd = userpasswd.text

    }

    function logintranslator()  {
        username.placeholderText = qsTr("请输入用户名");
        userpasswd.placeholderText = qsTr("密码");
        rememberpasswd.rememberpasswdtext = qsTr("记住密码");
        autologin.autologintext = qsTr("自动登录");

    }

    function saveLoginClicked(passwd)
    {
        //console.log("strPasswd", passwd)
        username.text = fileio.readIniFile("login", "username")
        userpasswd.text = passwd

        autologin.checkedState = fileio.readIniFile("login", "autologin")
        rememberpasswd.checkedState = fileio.readIniFile("login", "remembPasswd")

    }

    FileIo {
        id:fileio
    }
   GetClientversion
   {
    id:getclientversion
   }


    Image {
        id: centerbkg
        anchors.top: parent.top
        anchors.left: parent.left
        anchors.right: parent.right
        height: 350//300  350
        //source: "qrc:/resource/images/login/login_logo.png"

        ControlButton {
            id: setting
            anchors.top: parent.top
            anchors.right: min.left
            width: 28
            height: 28
            normalImage: "qrc:/resource/images/main/maintop/set.png"
            hoverImage: "qrc:/resource/images/main/maintop/setHovered.png"
            onClicked: {
                creatSetObj()
            }
        }

        ControlButton {
            id:min
            anchors.top: parent.top
            anchors.right: close.left
            width: 28
            height: 28
            normalImage: "qrc:/resource/images/main/maintop/min.png"
            hoverImage: "qrc:/resource/images/main/maintop/minHover.png"
            onClicked: {
                window.flags = Qt.Window | Qt.FramelessWindowHint | Qt.WindowStaysOnTopHint
                window.showMinimized()
            }
        }


        ControlButton {
            id:close
            anchors.top: parent.top
            anchors.right: parent.right
            width: 28
            height: 28
            normalImage: "qrc:/resource/images/main/maintop/close.png"
            hoverImage: "qrc:/resource/images/main/maintop/closeHover.png"
            onClicked: {
                loginWebServer.quitThread();

                /*while (!stoped){
                  emit sendhandledata();
                  qDebug() << "-------------- handle is running -------------";
                  msleep(SLEEP_TIME);
                 }
                 stoped = false;*/
                Qt.quit();
            }
        }
    }


    Item {
        id: loginingicon
        anchors.top: parent.top
        anchors.topMargin: 310
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        height: 200
        visible: false

        BorderImage {
            anchors.top: parent.top
            anchors.topMargin: 5
            anchors.left: parent.left
            anchors.leftMargin: (login.width - 80)/2
            width: animation.width ; height:animation.height

            AnimatedImage {id: animation; source:"qrc:/resource/images/login/load.gif"}
        }

    }

    Item {
        id: logininfor
        anchors.top: parent.top
        anchors.topMargin: 263
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        height: 120


        Rectangle {
            id: userinputback
            anchors.top: parent.top
            anchors.topMargin: 10
            anchors.left: parent.left
            anchors.right: parent.right
            border.width: 1
            height: 40
            border.color: "#9BC0EC"
            color: "#5d99e2"
            radius: 5

            Image {
                id: usericon
                anchors.left: parent.left
                anchors.leftMargin: 18
                anchors.top: parent.top
                anchors.topMargin: 9
                width: 22
                height: 22
                source: "qrc:/resource/images/login/person.png"
            }





            TextField {
                id:username
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                anchors.left: usericon.right
                anchors.leftMargin: 20
                anchors.right: parent.right
                anchors.rightMargin: 3
             // inputMethodHints: Qt.ImhHiddenText
                font.pixelSize: 16
                font.family: "微软雅黑"
                font.bold: false
                placeholderText: qsTr("请输入用户名")
                //!屏蔽鼠标右键出现的查看源码的界面
                         MouseArea
                           {
                               id:_mainMouse3
                               anchors.fill: parent
                               hoverEnabled: false
                               focus: false
                               acceptedButtons: Qt.RightButton
                               cursorShape: Qt.PointingHandCursor
                               onClicked:
                               {
                                   console.log("_mainMouse onClicked",webeng.url)
                               }
                               onDoubleClicked:
                               {
                                   console.log("_mainMouse onDoubleClicked",webeng.url)
                               }
                           }

                           Component.onCompleted: {
                               //webChannel.registerObject("interface", inter);
                           }
                style: TextFieldStyle {
                    placeholderTextColor : "#C8D9F3"
                    textColor : "white"
                    background: Rectangle {
                        color: "#5d99e2"
                        border.color: "#5d99e2"
                        border.width: 1
                    }
                }
            }
        }


        Rectangle{
            id: passwdbkg
            anchors.top: userinputback.bottom
            anchors.topMargin: 15
            anchors.left: parent.left
            anchors.right: parent.right
            border.width: 1
            height: 40
            border.color: "#9BC0EC"
            color: "#5d99e2"
            radius: 5

            Image {
                id: passwdicon
                anchors.left: parent.left
                anchors.leftMargin: 18
                anchors.top: parent.top
                anchors.topMargin: 9
                width: 22
                height: 22
                source: "qrc:/resource/images/login/passwd.png"
            }

            TextField {
                id:userpasswd
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                anchors.left: passwdicon.right
                anchors.leftMargin: 23
                anchors.right: parent.right
                anchors.rightMargin: 3
                echoMode: TextInput.Password
                inputMethodHints: Qt.ImhHiddenText
                font.pixelSize: 16
                font.family: "微软雅黑"
                font.bold: false
                placeholderText: qsTr("请输入密码")
                //!屏蔽鼠标右键出现的查看源码的界面
                           MouseArea
                           {
                               id:_mainMouse2
                               anchors.fill: parent
                               hoverEnabled: false
                               focus: false
                               acceptedButtons: Qt.RightButton
                               cursorShape: Qt.PointingHandCursor
                               onClicked:
                               {
                                   console.log("_mainMouse onClicked",webeng.url)
                               }
                               onDoubleClicked:
                               {
                                   console.log("_mainMouse onDoubleClicked",webeng.url)
                               }
                           }

                           Component.onCompleted: {
                               //webChannel.registerObject("interface", inter);
                           }
                style: TextFieldStyle {
                    placeholderTextColor : "#C8D9F3"
                    textColor : "white"
                    background: Rectangle {
                        color: "#5d99e2"
                        border.color: "#5d99e2"
                        border.width: 1
                    }
                }

            }

        }
    }

    CheckBox {
        id: rememberpasswd
        property string rememberpasswdtext: qsTr("记住密码")
        width: 80
        height: 20
        anchors.left: parent.left
        anchors.leftMargin: 34
        anchors.top: logininfor.bottom
        style: CheckBoxStyle {

            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: normal
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: checked
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
                Text {
                    id: keeppassword
                    anchors.left: parent.left
                    anchors.leftMargin: 28
                    anchors.top: parent.top
                    anchors.topMargin: 0
                    text: rememberpasswd.rememberpasswdtext
                    verticalAlignment: Qt.AlignVCenter
                    color: "#eff5fb"
                    font.family: "微软雅黑"
                }
            }
        }

        checkedState: fileio.readIniFile("login", "remembPasswd")

        onClicked: {

        }
    }

    CheckBox {
        id: autologin
        property string autologintext: qsTr("自动登录")
        width: 80
        height: 20
        anchors.right: parent.right
        anchors.rightMargin: 30
        anchors.top: logininfor.bottom
        style: CheckBoxStyle {
            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: autonormal
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: autochecked
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
                Text {
                    id: autologon
                    anchors.left: parent.left
                    anchors.leftMargin: 28
                    anchors.top: parent.top
                    anchors.topMargin: 0
                    verticalAlignment: Qt.AlignVCenter
                    text: autologin.autologintext
                    color: "#eff5fb"
                    font.family: "微软雅黑"
                }
            }
        }
        checkedState: fileio.readIniFile("login", "autologin")

        onClicked: {
            fileio.writeIniFile("login", "autologin", autologin.checkedState)
        }
    }

    Image {
        id: logining
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.leftMargin: 116.5
        anchors.rightMargin: 116.5
        anchors.bottom: cancelbtn.top
        anchors.bottomMargin: 20
        width: 67
        height: 17
        visible: false
        source: "qrc:/resource/images/login/login_process.png"
    }

    LoginButton {
        id: loginbtn
        anchors.top: logininfor.bottom
        anchors.topMargin: 70
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        normalImage: "qrc:/resource/images/login/login_btn.png"
        hoverImage: "qrc:/resource/images/login/login_btn_Hover.png"

        MouseArea{
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor

            onClicked: {

                var oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
                 if(oaoutnet === "0") //内网登录
                 {
                     strip = fileio.readIniFile("login", "oainnet")
                     if(strip === "http://"||strip === "")
                     {
                         creatMessageObj("请输入网址!", "creatSetObj");

                       // creatSetObj();
                         return;
                     }
                 }
                 else if(oaoutnet === "1")//外网登录
                 {
                     strip = fileio.readIniFile("login", "oaoutnet")
                     if(strip === "http://"||strip === "")
                     {
                         creatMessageObj("请输入网址!", "creatSetObj");

                          //    creatSetObj();
                          return;
                     }
                 }
                 else if(oaoutnet === "2"||strip === "")//测试地址
                 {
                     strip = fileio.readIniFile("login", "oatestnet")
                     if(strip === "http://"|| strip === "")
                     {
                         creatMessageObj("请输入网址!", "creatSetObj");

                        // creatSetObj();
                          return;
                     }
                 }
                 //fileio.writeIniFile()
                 if(rememberpasswd.checkedState)
                 {
                     //fileio.writeIniFile("login", "passwd", userpasswd.text)
                     fileio.writeIniFile("login", "xoabang", fileio.textEncode(userpasswd.text,"X"))
                 }

                 fileio.writeIniFile("login", "username",  username.text)
                 loginingicon.visible = true
                 rememberpasswd.visible = false
                 autologin.visible = false
                 getclientversion.getClientversionfromSever(strip+"/sys/getAPPMessage")
                 login.loginSuccess(userpasswd.text)
             // window.getClientversion(strip+"/sys/getAPPMessage")

            }
        }
 }

    LoginButton{
        id:cancelbtn
        visible: false
        anchors.top: logininfor.bottom
        anchors.topMargin: 70
        anchors.left: parent.left
        anchors.leftMargin: 15
        anchors.right: parent.right
        anchors.rightMargin: 15
        normalImage: "qrc:/resource/images/login/login_cancel.png"
        hoverImage: "qrc:/resource/images/login/login_cancel_hover.png"
        onClicked: {
            loginWebServer.quitThread();
            logininfor.visible = true
            loginbtn.visible = true
            cancelbtn.visible = false
            logining.visible = false
            loginingicon.visible = false
            rememberpasswd.visible = true
            autologin.visible = true
        }
    }


    Text{
        anchors.right: parent.right

        anchors.rightMargin: 25

        anchors.bottom: parent.bottom
        anchors.bottomMargin: 15
        height: 30
        width: 50
        color: "#eff5fb"
        font.pixelSize: 13
        font.family: "微软雅黑"
        text: qsTr("网络和登录")
        MouseArea{
            anchors.fill: parent
            cursorShape: Qt.PointingHandCursor

            onClicked: {
                //creatNetObj()
                //settingwindow.visibility = Window.Minimized
                 creatSetObj()

            }
        }
    }

//    function creatNetObj() {
//        var component = Qt.createComponent("../setting/NetworkSetting.qml");

//        if (component.status === Component.Ready)
//        {
//            if(networksetobj === null)
//            {
//                networksetobj = component.createObject(window.parent, {
//                                                           "visible": true
//                                                       });
//            }
//            else
//              {
//                networksetobj.show();
//            }
//        }
//        if(networksetobj === null)
//        {

//        }
//        else
//        {
//            networksetobj.deleteitem.connect(login.deletenetObj)
//            networksetobj.setValue()
//        }
//    }

//    function deletenetObj()
//    {
//        networksetobj.deleteitem.disconnect(login.deletenetObj)
//        networksetobj.destroy()
//        networksetobj = null
//        console.log("destroy23341234", "netview")
//    }

    function creatSetObj() {
        //var component = Qt.createComponent("qrc:/resource/setting/Setting.qml");  以前的qrc路径调用qml用法
        var component = Qt.createComponent("../setting/Setting.qml"); //Setting

        console.log("open setting.qml")

        if (component.status === Component.Ready)
        {
            if(setobj === null)
            {
                setobj = component.createObject(window.parent, { "visible": true});
            }
        }
        if(setobj === null)
        {
            console.log("open failed")

        }
        else
        {

            setobj.setValue()
            setobj.deleteitem.connect(login.deletesetObj)
            setobj.saveLoginClicked.connect(login.saveLoginClicked)

        }
    }

    function deletesetObj()
    {
        setobj.deleteitem.disconnect(login.deletesetObj)
        setobj.saveLoginClicked.disconnect(login.saveLoginClicked)

        setobj.destroy()
        setobj = null
        console.log("退出设置界面")
    }

    function loginLogo(strip,op)//设置登录界面logo，请求logo地址后回调函数
    {
        console.log("登录界面logo地址",strip )

        if(op==1)
           centerbkg.source=strip
        else
           centerbkg.source="qrc:/resource/images/login/login_logo.png"
    }

    function setLoginLogo() //设置登录界面logo
    {
        var strip = fileio.readIniFile("login", "dnsip")

         //console.log("logo地址dnsip",strip )

        if(strip!="")
        {
            strip=strip + "/img/app/login_logo.png"
            Query.queryLoginLogo(strip, loginLogo)
        }
        else
            centerbkg.source="qrc:/resource/images/login/login_logo.png"
    }

    Keys.onReturnPressed:
    {
        if(rememberpasswd.checked)
        {
            //fileio.writeIniFile("login", "passwd", userpasswd.text)
            fileio.writeIniFile("login", "xoabang", fileio.textEncode(userpasswd.text,"X"))
        }

        fileio.writeIniFile("login", "username", username.text)

        fileio.writeIniFile("login", "autologin", autologin.checkedState)

        loginingicon.visible = true
        rememberpasswd.visible = false
        autologin.visible = false

        login.loginSuccess(userpasswd.text)
    }



    Component.onCompleted: {

        username.text = fileio.readIniFile("login", "username")
        //userpasswd.text = fileio.readIniFile("login", "passwd")

         var xoabang= fileio.readIniFile("login", "xoabang")
         userpasswd.text=fileio.textDecode(xoabang,"X");

        translator.languageChanged.connect(logintranslator)
        //getclientversion.sigGetVersionSuccess.connect(getClientversionsuessed)
        //2018-11-9 修改
        //getclientversion.sigGetVersionErr().connect(getClientversionerr)原始代码
        getclientversion.sigGetVersionErr.connect(getClientversionerr)//修改后代码-信号绑定格式错误，日志中出现connect函数不识别错误Cannot call method 'connect' of undefined
        setLoginLogo()
    }
}

