﻿import QtQuick 2.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import "../interface"

Rectangle {
    id:mainpanel
    property alias weburl : webeng.url

    function getuserid()
    {

    }

    FileIo {
        id: fileio
    }

    Interface {
        id:inter
    }

    WebChannel {
        id: webChannel
    }


    WebEngineView {
        id:webeng
        anchors.fill: parent
        webChannel: webChannel

        smooth: true
        onNewViewRequested: request.openIn(webeng)
    }

    Component.onCompleted: { webChannel.registerObject("interface", inter);
    }

}
