﻿import QtQuick 2.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import WebRunPlatform 1.0
import WebIEPlatform 1.0

import "../interface"

Rectangle {
    property alias weburl: webeng.url
    color: "#E5E5E5"

    
    WebRunPlatform{
        id:webRun
    }
    WebIEPlatform
    {
        id:iewebrun
    }
    Interface {
        id:inter

        onGetDataSignal: {
            console.log("前端参数.msg1:", msg1)
            console.log("前端参数.msg2", msg2)
            console.log("前端参数.msg3", msg3)
            
            
            if(msg3 === "web_url")
            {
                if(msg1 == "undefined")
                {
                    return;
                }
                
                
             //  console.log("url", strip + msg1 + "?lang=zh_CN")
             //  var firstWindow = windowComponent.createObject(window.parent
             //                                                 ,{"webWidth":window.webWidth
             //                                                 , "webHeight": window.webHeight
             //                                                 , "strTitle": msg2});
             //  firstWindow.webView.url = strip + msg1 + "?lang=zh_CN"
                
              //webRun._vNewWindows(strip + msg1 + "?lang=zh_CN",msg2,true,strip)
                //Qt.openUrlExternally(strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                //iewebrun._vNewWindows_IE(strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,msg2);
                iewebrun._vNewWindows_XOAbrowser(strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,msg2,true);
                //iewebrun._vNewWindows((strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,true,strip);
            }
            else if(msg3 === "SEND_MSG")
            {
                jid = msg1

                var obj1 = eval('(' + msg2 + ')');//eval gaobo

                username = obj1.username;
                userprivname = obj1.userprivname;

                if(obj1.mobilNo == "")
                {
                   mobilNo = " "
                }
                else
                {
                    mobilNo = obj1.mobilNo
                }
                
                if(obj1.sex ==="0") //! 男
                {
                    creatObj(obj1.username, obj1.userprivname, obj1.sex, jid, mobilNo,true, "","qrc:/resource/images/main/maincenter/man.png")

               console.log("creat chat userid",msg1,"username",msg2,"sex0", sex)
                }
                     else
                {

                    creatObj(obj1.username, obj1.userprivname, obj1.sex, jid, mobilNo,true, "","qrc:/resource/images/main/maincenter/woman.png")

                console.log("creat chat userid",msg1,"username",msg2,"sex1", sex)
                }
                console.log("creat chat userid",msg1,"username",msg2,"sex", sex)
            }
        }

    }

    WebChannel {
        id: webChannel
    }

    WebEngineView {
        id:webeng
        anchors.fill: parent
        webChannel: webChannel

        smooth: true
        onNewViewRequested: function(request) {
            var newWindow = windowComponent.createObject(window.parent
                                                         , {"webWidth":window.webWidth
                                                         , "webHeight": window.webHeight
                                                         , "strTitle": ""});
            request.openIn(newWindow.webView);
            newWindow.strTitle = newWindow.webView.title
        }

        onWindowCloseRequested: {
            webeng.close();
        }
    }

    MouseArea
    {
        id:_searchWeb
        anchors.fill: parent
        hoverEnabled: false
        focus: false
        acceptedButtons: Qt.RightButton
        cursorShape: Qt.ArrowCursor
        onClicked:
        {
            console.log("_mainMouse onClicked")
        }
        onDoubleClicked:
        {
            console.log("_mainMouse onDoubleClicked")
        }
    }

    Component.onCompleted: {
       webChannel.registerObject("interface", inter);
    }
}
