﻿//***** 主界面 *****//

import QtQuick 2.0
import QtQuick.Layouts 1.3
import QtWebEngine 1.5
import QtWebChannel 1.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import QtQuick.Window 2.2
import QtQuick.Dialogs 1.1
import WebRunPlatform 1.0
import WebIEPlatform 1.0
import LoginWebServer 1.0
import "../js/query.js" as Query
import "../interface"
import "../common"
import "../chat"
import "../signalWeb"

Rectangle {
    id: mainwindow
    property alias t_mainbottomoperating: mainbottomoperating
    property alias weburl: mainpanel.weburl
    property string userId: ""
    property string userjid: ""
    property bool flag: false
    property string username: ""//username, userprivname, usersex, jid, usermobileno, bshow,strStaus,ImgSoure
    property int msgCount //gaobo wait
    property string jid: ""
    property string userprivname: ""
    property string sex: ""
    property string mobilNo:""
    property string birthday: ""
    property var chatviewobj: []
    property string jsessionid: ""
    property var webobj: null
    property string strImIp: ""
    property string strImPort: ""
    property string oneselfName:""
    property string zZorfriends:""
    property bool isOpen: false
    property var list: []
    property int messageCount: 0
    property string titleName: ""
    property var childWebObj: []
    property var messageUUidlist: []
    property string strSignatureIcon: ""
    property string _Maincompanyoid: "" //!企业id
    property string _MainUrl: "" //!
    property string strStatus: ""
    property var douyin: []
    property var qunMessage: []
    property bool isAlreadyRead: false
    property bool isAlreadyRead_tem: false
    property string _gjid:"";
    property string _guser:"";
    property string _gusername:"";
    property int topCount: 0
    property string _createroomuserid:""
    property bool isWindowedge:false
    property string strImage;
    property string strUsername;
    property string strUID;
    property int imReloginCount:0;
    property string hrmenu: ""
    property int smsTotalCount: 0;

    color: "#278ADD"
    property int msgtimerNum: 0
    signal maxClicked()
    signal minClicked()
    signal closeClicked()
    signal userOnlineStatus(bool flags)


    FileIo {
        id: fileio
    }

    LoginWebServer {
        id: loginWebServer
    }

    WebRunPlatform{
            id:webRun
        }
    WebIEPlatform
    {
        id:iewebrun
    }


        MouseArea { //为窗口添加鼠标事件
            id:mouse
            anchors.fill: mainwindow
            acceptedButtons: Qt.LeftButton//只处理鼠标左键
            hoverEnabled:true
           // drag.active : true
            property point clickPos: "0,0"

           onCanceled: {
              console.log("onCanceled")
             }
            onEntered:
            {
                //console.log("onEntered")
                if(isWindowedge&&isWindowsHide)
                {
                    console.log("进入111")
                    isWindowsHide =false
                    window.y = 0
                    window.height=_mainwindowh;
                    // console.log(" window.y  ",  window.y)
                    // console.log("_mainwindowh--  ", _mainwindowh)
                    // console.log("ainwindow.height--  ", window.height)
                    window.flags = Qt.FramelessWindowHint | Qt.Window |Qt.Tool|Qt.WindowStaysOnTopHint
                    window.visible=true

                }

            }

            onExited:
             {
                window.flags = Qt.FramelessWindowHint | Qt.Window |Qt.Tool
                // console.log("onExited")
               /* if(window.y === 5&& !isWindowsHide)
                {
                    isWindowsHide = true;
                     window.y =-1
                                        //console.log("!isWindowsHide", window.y)
                    window.height= 2
                }*/

                if( window.y<5)
                {     // console.log("进入222")
                    if(isWindowedge&&isWindowsHide===false)
                    {
                        //   console.log("进入333")
                        isWindowedge = true;
                        window.y =-1

                        window.height= 5
                        isWindowsHide =true
                        /*window.flags = Qt.FramelessWindowHint | Qt.Window
                    window.visible=false*/
                        console.log("!onExited", window.y)
                    }
                }
                else
                {
                    //console.log("进入4444")
                    isWindowedge = false;
                    isWindowsHide = false;
                }
            }


            onPressed: { //接收鼠标按下事件
                clickPos  = Qt.point(mouse.x,mouse.y)
                bPressed = true

            }

            onReleased: {
                clickPos =Qt.point(mouse.x,mouse.y)
                bPressed = false;

                if( window.y<5)
                {     // console.log("进入222")
                    if(isWindowedge&&isWindowsHide===false)
                    {
                        //   console.log("进入333")
                        isWindowedge = true;
                        window.y =-1

                        window.height= 5
                        isWindowsHide =true
                        /*window.flags = Qt.FramelessWindowHint | Qt.Window
                       window.visible=false*/
                       console.log("!onExited", window.y)
                    }
                }


                //记录窗口位置
                console.log("mouse onReleased 记录窗口位置", window.x,window.y)
                fileio.writeIniFile("login", "windowX", window.x)
                fileio.writeIniFile("login", "windowY", window.y)


            }

            onPositionChanged: { //鼠标按下后改变位置
                //鼠标偏移量

                if(bPressed )// && !isWindowsHide
                {
                    var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                    var posx=window.x+delta.x
                    var posy=window.y+delta.y

                    if(posx>0 && posx<5000 && posy>0 && posy<5000)
                    {
                      window.setX(posx)
                      window.setY(posy)
                      //console.log("x---  ", posx,"   y---",posy)
                    }

                }
                else if(isWindowsHide===false&&isWindowedge===false)
                {
                    if( window.y<5)
                    {
                        //console.log("移动中隐藏窗口")

                        isWindowedge = true;
                        window.y =-1
                        window.height= 5
                        isWindowsHide =true
                    }
                    else
                    {
                        //console.log("大于5 ----")
                        isWindowedge = false;
                    }
                }

     }
    Component.onCompleted: {

        //console.log("transData初始化","-------------------");
        transData._sig_trigger.connect(addRoomgroup);
        var b1= conversationList.sigReplyMessage.connect(getList)
        var b2= chatGetUserInfo.sigReplyMessage.connect(__callBack)

        var b3= talkRoomIntface._sig_appendGroudMsg.connect(_appendGroudMsg)
        var b4= talkRoomIntface._sig_cteatGroudObj.connect(_cteatopGroudObj)

        loginServer.sigGetConReason.connect(imLoginSucess)//的管理成功后开始加入群

        //addRoomgroup()
        webRun._sig_close.connect(quest);
        loginWebServer.sigReplyMessage.connect(loginCallback);

        hrmenu = fileio.readIniFile("login", "hrmenu") //获取人力资源按钮是否显示

    }

    MainTopOperating {
            id: maintopoperating
            width: mainwindow.width
            jid:jid
            height: 124
            anchors.top:parent.top


            onMaxclicked: {
                mainwindow.maxClicked()
            }

            onMinclicked: {
                if(chattooltip.visible)chattooltip.visible=false
                mainwindow.minClicked()
            }

            onCloseclicked: {
                mainwindow.closeClicked()
            }

            onSkinclicked: {

            }
        }


    //搜索框
    Rectangle {
        id: mainsearch
        anchors.top: maintopoperating.bottom
        anchors.left: parent.left
        anchors.leftMargin: 0
        width: mainwindow.width
        height: 31
        color: "#2472b4"

        property alias text: input.text
        property alias placeHoldText: placeHold.text

        Image {
            id: searchicon
            anchors.right: parent.right
            anchors.rightMargin: 7
            anchors.top: parent.top
            anchors.topMargin: 4
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 4
            visible: true
            height: 23
            width: 23
            source: "qrc:/resource/images/main/maincenter/search.png"
        }

        TextInput {
            id: input
            anchors.top: parent.top
            anchors.topMargin: 0
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 0
            anchors.left: parent.left
            anchors.leftMargin: 6
            anchors.right: parent.right
            anchors.rightMargin: 9
            horizontalAlignment: TextInput.AlignLeft
            verticalAlignment: TextInput.AlignVCenter
            font.pixelSize: 12
            color: "black"
            font.family: "微软雅黑"
            clip: true

            Text {
                id: placeHold

                font: input.font
                text: qsTr("搜索: 用户、应用");
                color: "white"
                opacity: !input.activeFocus && !search.visible
                Behavior on opacity{
                    NumberAnimation{ duration: 300 }
                }
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 10
                anchors.bottom: parent.bottom
                anchors.right: parent.right
                verticalAlignment: TextInput.AlignVCenter
            }
            onTextChanged: {
                var url;
                if(input.text != "")
                {
                    url = strip + "/spirit/searchBox?search="+ input.text;
                    search.weburl = url;
                    input.focus = true
                }
                else
                {
                    url = strip + "/spirit/searchBox?search="+ " ";
                    search.weburl = url;
                    input.focus = true
                }
                console.log("搜索地址",url)
            }

            onActiveFocusChanged: {
                if(input.activeFocus)
                {
                    searchicon.visible = false
                    deleteicon.visible = true
                    search.visible = true
                    var url = strip + "/spirit/searchBox?search="+ input.text;
                    search.weburl = url;
                    mainsearch.color = "#FFFFFF"
                    mainsearch.anchors.leftMargin= 2
                    mainsearch.width= mainwindow.width-4
                    //search.color = "#E5E5E5"
                    //line.height = 1
                }
            }

            Image {
                id: deleteicon
                anchors.right: parent.right
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                visible: false
                source: "qrc:/resource/images/main/maincenter/searchdelete.png"

                MouseArea{
                    anchors.fill: parent
                    hoverEnabled: true

                    onEntered: {
                        deleteicon.source = "qrc:/resource/images/main/maincenter/searchdelete_hover.png"
                    }
                    onExited: {
                        deleteicon.source = "qrc:/resource/images/main/maincenter/searchdelete.png"
                    }

                    onClicked: {
                        input.clear()
                        input.focus = false
                        searchicon.visible = true
                        deleteicon.visible = false
                        search.visible = false
                        search.weburl = ""
                        mainsearch.color = "#2472b4"
                        mainsearch.anchors.leftMargin= 0
                        mainsearch.width= mainwindow.width
                        //line.height = 0
                    }

                }
            }
        }
    }

    Rectangle{
        id: line
        anchors.top: mainsearch.bottom
        anchors.topMargin: 0
        width: mainsearch.width
        height: 1

        color: "#278ADD"
    }

    MainSearch {
        id: search
        x: 2
        y: mainsearch.y + 32
        z: 1
        width: mainsearch.width-4
        height: mainpanel.height + 3
        visible: false

        Behavior on visible {
            NumberAnimation {
                duration: 300
            }
        }
    }

    Rectangle {
        id: mainpanel
        width: mainwindow.width
        anchors.top: line.bottom
        anchors.left: parent.left
        anchors.leftMargin: 2
        anchors.right: parent.right
        anchors.rightMargin: 2
        anchors.bottom: mainbottomoperating.top
        property alias weburl : webeng.url

        ExclusiveGroup {
            id: exclusive
        }

        Loader {id: pageLoader}

        TabButton {
            id: apply
            anchors.top: parent.top
            anchors.left: parent.left
            width: mainpanel.width/3
            height: 40
            normalSource: "qrc:/resource/images/main/maincenter/apply.png"
            checkeSource: "qrc:/resource/images/main/maincenter/apply_selected.png"
            checkable: true
            checked: true
            exclusiveGroup: exclusive
            textContent: qsTr("应用")
            iconWidth: 24
            iconHeight: 24
            visible: true
            onClicked: {
                setVisible(0)
                //2018-12-21由于输出密码，暂定去掉这条日志
              //  console.log("应用界面url地址:", webeng.url)
            }
        }

        TabButton {
            id: conversation
            anchors.top: parent.top
            anchors.left: apply.right
            width: mainpanel.width/3
            height: 40
            normalSource: "qrc:/resource/images/main/maincenter/conversation.png"
            checkeSource: "qrc:/resource/images/main/maincenter/conversation_selected.png"
            checkable: true
            checked: false
            exclusiveGroup: exclusive
            textContent: qsTr("会话")
            iconWidth: 24
            iconHeight: 24
            visible: true
            onClicked: {
                setVisible(1)
            }
        }

        TabButton {
            id: tissue
            anchors.top: parent.top
            anchors.left: conversation.right
            width: mainpanel.width/3
            height: 40
            //normalSource: "qrc:/resource/images/组织默认.png"
            //checkeSource: "qrc:/resource/images/组织选中.png"
            normalSource: "qrc:/resource/images/main/maincenter/tissue.png"
            checkeSource: "qrc:/resource/images/main/maincenter/tissue_selected.png"
            checkable: true
            checked: false
            exclusiveGroup: exclusive
            textContent:
                if(zZorfriends == "0")
                {
                    console.log("组织好友参数为1 设置组织面板标签为好友",zZorfriends);
                    return qsTr("组织")
                }
            else
                {
                    console.log("组织好友参数不为1 设置组织面板标签为组织",zZorfriends);
                     return qsTr("好友")
                }
            iconWidth: 26
            iconHeight: 24
            visible: true
            onClicked: {
                setVisible(2)
                // webeng1.update();

                if(!isOpen)
                {
                  //
                    //!取消点击刷新
                    //console.debug(webeng1.data());
                    if(zZorfriends == "1")
                    {
                        webeng1.url = strip + "/spirit/getFriendList?JSESSIONID1="+jsessionid
                       console.log("好友界面地址：",webeng1.url);


                    }
                    else
                    {
                        webeng1.url = strip + "/spirit/zz?JSESSIONID1="+jsessionid
                        console.log("组织界面地址：",webeng1.url);

                    }


                }
                else
                {
                     webeng1.runJavaScript("initdept()", function(initdept) { console.log("result"); });
                }
             isOpen = true;

            }
        }

        Rectangle {
            id: applyRect
            anchors.top: parent.top
            anchors.topMargin: 40
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            color: "#FFFFFF"
            visible: true

            Interface {
                id:inter

                onGetDataSignal: {
                    //userOnlineStatus(true)

                    if(msg3 === "web_url")
                    {
                        //console.log("msg1:__"+msg1)
                        // console.log("msg2:__"+ msg2)
                        // console.log("msg3:__"+ msg3)
                        if(msg1.substring(0,7)==="http://")
                        {
                            //Qt.openUrlExternally( msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                            //iewebrun._vNewWindows((msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,true,strip);
                            console.log("内置XOA浏览器打开外部地址:", msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                            //iewebrun._vNewWindows_IE((msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2);
                            iewebrun._vNewWindows_XOAbrowser((msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,true);
                        }
                        else
                        {
                            //console.log(strip + msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                            // Qt.openUrlExternally(strip + msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                            //iewebrun._vNewWindows((strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,true,strip);

                            //iewebrun._vNewWindows_IE((strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2);
                            iewebrun._vNewWindows_XOAbrowser((strip +msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,true);   //XOA 浏览器
                            console.log("内置XOA浏览器打开OA模块地址:", strip + msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                        }

                        //     var firstWindow = windowComponent.createObject(window.parent
                        //                                                    ,{"webWidth":(Screen.desktopAvailableWidth)*0.8
                        //                                                        , "webHeight": (Screen.desktopAvailableHeight)*0.8
                        //                                                        , "strTitle": msg2});
                        //     firstWindow.webView.url = strip + msg1 +"?lang=zh_CN" ;//"C:/Users/ admin/Desktop/1.html"//;


                        //应用界面
                       // console.log("应用界面: ",strip + msg1 +"?lang=zh_CN" )
                        //webRun._vNewWindows(strip + msg1 +"?lang=zh_CN","应用界面",true,strip);

                        //   console.log("LLLLLL",firstWindow.webView.title);
                    }
                    else if(msg3 === "userId")
                    {
                        console.log("应用页面传来登录成功后传来参数:",msg1,msg2,msg3,"将登录界面隐藏，显示主界面")
                        //console.log()
                       // userOnlineStatus(true)
                    }
                }
            }

            WebChannel {
                id: webChannel
            }

            WebEngineView {
                id:webeng
                anchors.fill: parent
                webChannel: webChannel
                visible: true
                smooth: true

                onNewViewRequested:
                {
                    console.log(" 内置webkit浏览器打开地址: ",request.url)
                    webRun._vNewWindows(request.url)
                }

                onJavaScriptDialogRequested:
                {
                    console.log("内置浏览器打开地址:1",request.url)
                    request.accepted = true;
                    request.dialogAccept(request.defaultFileName);
                }

                onFileDialogRequested:
                {
                    console.log("内置浏览器打开地址:2 ",request.url)
                    request.accepted = true;
                    request.dialogAccept(request.defaultFileName);
                }

                onAuthenticationDialogRequested:
                {
                    console.log("内置浏览器打开地址:3 ",request.url)
                    request.accepted = true;
                    request.accepted = request.dialogAccept("","");
                }
            }


            //!屏蔽鼠标右键出现的查看源码的界面
            MouseArea
            {
                id:_mainMouse
                anchors.fill: parent
                hoverEnabled: false
                focus: false
                acceptedButtons: Qt.RightButton
                cursorShape: Qt.PointingHandCursor
                onClicked:
                {
                    console.log("_mainMouse onClicked",webeng.url)
                }
                onDoubleClicked:
                {
                    console.log("_mainMouse onDoubleClicked",webeng.url)
                }

            }

            Component.onCompleted: {
                webChannel.registerObject("interface", inter);
            }


        }
        Messagecs{

            id:messagecs
            visible: false
        }

      /*  MessageDialog {
            id: messageDialog
            width: 250
            height: 170
            title: "提示"
            text: "账号或密码错误，请重新输入！"
            icon: StandardIcon.Information
            onAccepted: {
                console.log("qqqqqqqqqqqqqqqqqqqqq");
                messageDialog.visible = false
                //取消登录
                login.logininfoid = true
                login.loginbtnid = true
                login.cancelbtnid = false
                login.loginingid = false
                login.loginingiconid = false
                login.rememberpasswdid = true
                login.autologinid = true
            }

            //Component.onCompleted: visible = true
        }*/

        Rectangle {
                            id: conversationRect
                            anchors.top: parent.top
                            anchors.topMargin: 40
                            anchors.bottom: parent.bottom
                            anchors.left: parent.left
                            anchors.right: parent.right
                            color: "#F8F8F8"
                            visible: false
                            Rectangle{
                                id: line1
                                anchors.top: groupmanagerid.bottom
                                anchors.topMargin: -1

                                width: parent.width
                                height: 1.5

                                color: "#E8E8E8"
                            }
                            //管理群按钮
                            Rectangle {
                                id: groupmanagerid

                                anchors.top: parent.top
                                anchors.topMargin: 0
                                anchors.right: parent.right
                                anchors.rightMargin:100

                                height: 26.6
                                border.width: 1
                                border.color: "#176dc6"
                                radius: 5
                                color: "#176dc6"
                                //Button.color: "#F8F8F8"

                                        Button {
                                            id: textgroupmanagerid
                                            checkable: true
                                            checked: false

                                            style: ButtonStyle {
                                                background: Rectangle {
                                                    anchors.top: parent.top
                                                    anchors.topMargin: 10.5
                                                    anchors.right: parent.right
                                                    anchors.rightMargin: -60
                                                    width: 30
                                                    height: 30
                                                    //border.width: control.activeFocus ? 2 : 1
                                                    //border.color: "#888"
                                                   // radius: 60
                                        //normalSource: "qrc:/resource/images/管理群.png"
                                        //checkeSource: "qrc:/resource/images/点击1.png"
                                        //checkable: true
                                        //checked: false
                                        //exclusiveGroup: exclusive

                                                    Text{
                                                        id:groupmanageridtext
                                                        text: qsTr("管理群")
                                                        font.pixelSize: 13
                                                        anchors.centerIn: parent
                                                        font.family: "微软雅黑"
                                                        color: "#176dc6"

                                                    }
                                                    Rectangle {
                                                         anchors.top: parent.top
                                                         anchors.topMargin: -7
                                                         anchors.right: parent.right
                                                         anchors.rightMargin: 48

                                                 Image {

                                                     id: image2

                                                     width: 20

                                                     height: 22

                                                     source: "qrc:/resource/images/管理群.png"


                                                     MouseArea{
                                                         id:groupmanager
                                                         anchors.fill: parent
                                                         //enabled: edit.text.length?true:false
                                                         hoverEnabled: true
                                                         cursorShape: Qt.PointingHandCursor
                                                         onEntered: {//鼠标离开信号
                                                                         console.log("Entered")
                                                                     }

                                                                     onExited: {//鼠标进入信号
                                                                         console.log("Exited")
                                                                     }
                                                                     onClicked: {

                                                                         console.log("打开管理群窗口地址:",strip + "/spirit/managegroupchat")
                                                                         webRun._vNewWindows(strip + "/spirit/managegroupchat?JSESSIONID1=" + jsessionid,"管理群组",false)

                                                                         // Qt.openUrlExternally(strip + "/spirit/managegroupchat"+"&JSESSIONID1=" + jsessionid)
                                                                        }
                                                                   }
                                                             }
                                                        }

                                                    MouseArea{
                                                        id:groupmanager1
                                                        anchors.fill: groupmanageridtext
                                                        //enabled: edit.text.length?true:false
                                                        hoverEnabled: true
                                                        cursorShape: Qt.PointingHandCursor
                                                        onEntered: {//鼠标离开信号
                                                                        console.log("鼠标进入主界面");

                                                                    }

                                                                    onExited: {//鼠标进入信号
                                                                        console.log("鼠标离开主界面");

                                                                    }


                                                        onClicked: {

                                                            console.log("打开管理群窗口页面地址:",strip + "/spirit/managegroupchat")

                                                             webRun._vNewWindows(strip + "/spirit/managegroupchat?JSESSIONID1=" + jsessionid,"管理群组",false)
                                                             //Qt.openUrlExternally(strip + "/spirit/managegroupchat?"+"&JSESSIONID1=" + jsessionid)
                                                            //var  paramurl = strip + "/spirit/managegroupchat?";
                                                            //Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)

                                                            //192.168.0.210:8080/spirit/managegroupchat

                                                        }
                                                    }
                                                }
                                            }

                                        visible: true
                            }
                }

                            //创建群按钮
                            Rectangle {
                                id: groupmanageridcj

                                anchors.top: parent.top
                                anchors.topMargin: 0
                                anchors.right: groupmanagerid.left
                                anchors.rightMargin:75

                                height: 26.6
                                border.width: 1
                                border.color: "#176dc6"
                                radius: 5
                                color: "#176dc6"

                                Button {
                                    id: textgroupmanageridcj
                                    checkable: true
                                    checked: false

                                    style: ButtonStyle {
                                        background: Rectangle {
                                            anchors.top: parent.top
                                            anchors.topMargin: 10.5
                                            anchors.right: parent.right
                                            anchors.rightMargin: -60
                                            width: 30
                                            height: 30

                                            Text{
                                                id:groupmanageridcjtext
                                                text: qsTr("新建群")
                                                font.pixelSize: 13
                                                anchors.centerIn: parent
                                                font.family: "微软雅黑"
                                                color: "#176dc6"

                                            }
                                            Rectangle {
                                                 anchors.top: parent.top
                                                 anchors.topMargin: -7
                                                 anchors.right: parent.right
                                                 anchors.rightMargin: 48

                                         Image {

                                             id: image3

                                             width: 20

                                             height: 22

                                             source: "qrc:/resource/images/新建群.png"


                                             MouseArea{
                                                 id:groupmanagercj
                                                 anchors.fill: parent
                                                 //enabled: edit.text.length?true:false
                                                 hoverEnabled: true
                                                 cursorShape: Qt.PointingHandCursor
                                                 onEntered: {//鼠标离开信号
                                                                 console.log("Entered")
                                                             }

                                                             onExited: {//鼠标进入信号
                                                                 console.log("Exited")
                                                             }
                                                             onClicked: {

                                                                 console.log("打开新建群窗口地址：",strip + "/spirit/managegroupchat?add=1")
                                                                 webRun._vNewWindows(strip + "/spirit/managegroupchat?add=1&JSESSIONID1=" +  jsessionid,"新建群组",false)//managegroupchat?add=1
                                                                 // Qt.openUrlExternally(strip + "/spirit/managegroupchat?add=1"+"&JSESSIONID1=" + jsessionid)
                                                                }
                                                           }
                                                     }
                                                }

                                            MouseArea{
                                                id:groupmanagercj1
                                                anchors.fill: groupmanageridcjtext
                                                //enabled: edit.text.length?true:false
                                                hoverEnabled: true
                                                cursorShape: Qt.PointingHandCursor
                                                onEntered: {//鼠标离开信号
                                                                console.log("鼠标进入");

                                                            }

                                                            onExited: {//鼠标进入信号
                                                                console.log("鼠标离开");

                                                            }


                                                onClicked: {

                                                    console.log("打开新建群窗口地址:",strip + "/spirit/managegroupchat?add=1")
                                                    webRun._vNewWindows(strip + "/spirit/managegroupchat?add=1&JSESSIONID1=" +  jsessionid,"新建群组",false)//managegroupchat?add=1
                                                    //Qt.openUrlExternally(strip + "/spirit/managegroupchat?add=1"+"&JSESSIONID1=" + jsessionid)
                                                    //var  paramurl = strip + "/spirit/managegroupchat?add=1";
                                                    //Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)

                                                    //192.168.0.210:8080/spirit/managegroupchat
                                                    //打开创建群窗口

                                                }
                                            }
                                        }
                                    }

                                visible: true
                    }
                }

                            ListModel {
                                id: conversationModel  //会话列表
                            }
                            ListView {
                                id: conversationListview
                                anchors.fill: parent
                                anchors.top: groupmanagerid.bottom
                                anchors.topMargin: 27.1
                                width: parent.width
                                //height: (parent.height-95)-conversationListview.height  待处理 gaobo
                                height: (parent.height-95)
                                focus: true
                                spacing:0
                                clip: true
                                model: conversationModel                             
                                //snapMode: ListView.Conversation  //gaobo 待处理 ListView.SnapOneItem ListView.NoSnap


                                delegate: ConversationItem {
                                    strJid: strUserJid
                                    strType: strUserType
                                    strPrivName: privName
                                    strSex: userSex
                                    strMobileNo: mobileNo
                                    strIconImage: iconImage
                                    strUserName: userName
                                    strUserTime: userTime
                                    strUserText: userText
                                    messageCount: msgCount
                                    strUserStatus: strStatus
                                    strlistid: dele_strlistid
                                    //topnum: topnum1
                                    msgtype: msgtype
                                    groudimg: groudimg
                                    groudmsglist: groudmsglist

                    //会话列表右键删除
                    onSigRightMenu:
                    {
                        // console.log("onSigRightMenu_index__",conversationModel.get(index).jid);


                        if(conversationModel.get(index).strUserJid.indexOf("@gsrooms.gsubo")>0)
                        {
                            console.log("删除(群)用户:",strip+ "/im/getOutPerson?&delete_uid="+userjid+"&room_id="+conversationModel.get(index).strUserJid + "&opt=1") // /im/getOutPerson   参数: room_id   delete_uid(要删除的人uid)    opt=1
                            webRun._slot_request(strip+ "/im/getOutPerson?&delete_uid="+userjid+"&room_id="+conversationModel.get(index).strUserJid + "&opt=1",mainwindow.jsessionid);
                            deleteObj(conversationModel.get(index).strUserJid);
                        }
                        else
                        {
                            console.log("删除聊天记录:",strip+ "/im/delChatList?&listId="+conversationModel.get(index).dele_strlistid) // /im/getOutPerson   参数: room_id   delete_uid(要删除的人uid)    opt=1
                            webRun._slot_request(strip+ "/im/delChatList?&listId="+conversationModel.get(index).dele_strlistid,mainwindow.jsessionid);
                        }
                        conversationModel.remove(index,1);
                        conversationListview.update();
                        // Query.deleteTalkList(strip,conversationModel.get(index).dele_strlistid,deleteTalkListCallback())
                    }

                    //会话列表点击打开
                    onSigClicked:
                    {
                       // if(getChatObjVisible(conversationModel.get(index).strUserJid))return;

                        messageCount = 0;
                        if(getObjIsCreate(conversationModel.get(index).strUserJid) && !getChatObjVisible(conversationModel.get(index).strUserJid))
                        {
                            setObjVisible(conversationModel.get(index).strUserJid, false);

                        }
                       // else if(getObjIsCreate(conversationModel.get(index).strUserJid) && getChatObjVisible(conversationModel.get(index).strUserJid))


                        //区分打开的是群聊、单聊
                        if(conversationModel.get(index).msgtype == "1" ) //!群聊消息
                        {

                            creatGroupObj(conversationModel.get(index).userName, conversationModel.get(index).privName, conversationModel.get(index).userSex, conversationModel.get(index).strUserJid,
                                         conversationModel.get(index).mobileNo, true, conversationModel.get(index).strUserStatus,conversationModel.get(index).groudimg,"")

                       // chattooltip.deleteOneItem(conversationModel.get(index).strUserJid)
                        }
                        else   //!单聊聊消息
                        {

                            //chattooltip.itemClicked(conversationModel.get(index).strUserJid,conversationModel.get(index).userName)
                            creatObj(conversationModel.get(index).userName, conversationModel.get(index).privName, conversationModel.get(index).userSex, conversationModel.get(index).strUserJid,
                                     conversationModel.get(index).mobileNo, true, conversationModel.get(index).strStatus,conversationModel.get(index).iconImage);
                            //currentIndex = index
                            //chattooltip.itemClicked(conversationModel.get(index).strUserJid)
                            //deleteOneItem(string jid)//消息闪烁处理
                            //deleteAllItem()


                        }
                        if(taryMsgdataMap.containsKey("'" + conversationModel.get(index).strUserJid.toString() + "'"))
                        {
                         chattooltip. itemClicked(conversationModel.get(index).strUserJid,conversationModel.get(index).userName)
                        }
                    }


                    //右键菜单置顶
                    onSigMaktopMenu: //string index, bool top
                    {
                        if(top)
                        {
                            console.log("onSigMaktopMenu_index__","置顶",conversationModel.get(index).dele_strlistid);
                            conversationModel.move(index,0,1);
                            conversationListview.update();
                        }
                        else
                        {
                            console.log("onSigMaktopMenu_index__","取消置顶",conversationModel.get(index).dele_strlistid);
                            conversationModel.move(index,conversationModel.get(index).topnum1,1);
                            conversationListview.update();
                        }
                    }

                }

                currentIndex: 0

                Rectangle{
                    id: bkg
                    anchors.top: parent.top
                    anchors.topMargin: 100
                    anchors.left: parent.left
                    anchors.leftMargin: (parent.width -147)/2 - 10
                    width: 147
                    height: 140
                    color: "#F8F8F8"
                    visible: false
                    Image {
                        id: infoimage
                        anchors.top: parent.top
                        anchors.left: parent.left
                        source: "qrc:/resource/images/main/maincenter/info.png"
                    }

                    Text {
                        id: infoText
                        anchors.top: infoimage.bottom
                        anchors.topMargin: 15
                        anchors.left: parent.left
                        anchors.leftMargin: (parent.width - infoText.contentWidth)/2
                        font.family: "微软雅黑"
                        font.pixelSize: 12
                        color: "#999999"
                        text: qsTr("太低调了，一条信息都木有~")
                    }
                }
            }

        }

        Rectangle {
            id: tissueRect
            anchors.top: parent.top
            anchors.topMargin: 40
            anchors.bottom: parent.bottom
            anchors.left: parent.left
            anchors.right: parent.right
            color: "#FFFFFF"
            visible: false

            Interface {
                id:inter1

                onGetDataSignal: {

                    if(msg3 === "SEND_MSG")
                    {
                       // console.log("_SEND_MSG_msg1: ",msg1)
                       // console.log("_SEND_MSG_msg2: ",msg2)
                       // console.log("_SEND_MSG_msg3: ",msg3)
                        if(msg1 =="addFrineds")
                        {
                            console.log("添加好友操作，默认webkit浏览器添加好友页面，地址: ",strip+msg2+"?&JSESSIONID1=" + jsessionid)
                            //Qt.openUrlExternally(strip+msg1+"?&JSESSIONID1=" + jsessionid)

                            //iewebrun._vNewWindows((strip+msg2+"?&JSESSIONID1=" + jsessionid).toString(),msg2,true,strip);

                            //iewebrun._vNewWindows_IE((msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2);
                            iewebrun._vNewWindows_XOAbrowser((msg1 +"?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),msg2,false);
                            return;
                        }
                        jid = msg1;

                        var obj1 = eval('(' + msg2 + ')');//eval gaobo

                        username = obj1.uname;
                        userprivname = obj1.userPrivName;
                        sex = obj1.sex
                        mobilNo = obj1.mobilNo
                        var  avatar    = obj1.avatar;
                        //  console.log("_SEND_MSG_SEND_MSG_obj1: ",obj1)
                        //  console.log("_SEND_MSG_username: ",username)
                        //  console.log("_SEND_MSG_userprivname: ",userprivname)
                        //  console.log("_SEND_MSG_sex: ",sex)
                        //  console.log("_SEND_MSG_mobilNo: ",mobilNo)
                        //  console.log("_SEND_MSG_vavtar: ", obj1.avatar)
                        //  console.log("_SEND_MSG_myStatu: ", obj1.myStatus)
                        if(username !== "")
                        {
                            if(avatar !== "0" && avatar !== "1" && avatar !== "" && avatar !== null)
                                creatObj(obj1.uname, obj1.userPrivName, obj1.sex, jid, mobilNo,true, obj1.myStatus,strip+avatar)
                            else  if(sex === "1")
                                creatObj(obj1.uname, obj1.userPrivName, obj1.sex, jid, mobilNo,true, obj1.myStatus,"qrc:/resource/images/main/maincenter/woman.png")
                            else
                                creatObj(obj1.uname, obj1.userPrivName, obj1.sex, jid, mobilNo,true, obj1.myStatus,"qrc:/resource/images/main/maincenter/man.png")

                        }
                        else
                        {
                            console.log("页面传来错误的 = \"\"")
                        }

                    }
                }
            }

            WebChannel {
                id: webChannel1
            }

            WebEngineView {
                id:webeng1
                anchors.fill: parent
                webChannel: webChannel1
                visible: true
                smooth: true
                onNewViewRequested:function(request)
                {
                  //  console.log("_webeng1-onNewViewRequested 地址是：",request.url)

                        webRun._vNewWindows(request.url)

                }

                onJavaScriptDialogRequested:
                {
                   // console.log(" _webeng1-onJavaScriptDialogRequested 地址：",request.url)
                    request.accepted = true;
                    request.dialogAccept(request.defaultFileName);
                }

                onFileDialogRequested:
                {
                   // console.log("_webeng1-onFileDialogRequested 地址",request.url)
                    request.accepted = true;
                    request.dialogAccept(request.defaultFileName);
                }

                onAuthenticationDialogRequested:
                {
                   // console.log("_webeng1-onAuthenticationDialogRequested 地址",request.url)
                    request.accepted = true;
                    request.accepted = request.dialogAccept("","");
                }


            }

            //!屏蔽鼠标右键出现的查看源码的界面
            MouseArea
            {
                id:_mainMousezz
                anchors.fill: parent
                hoverEnabled: false
                focus: false
                acceptedButtons: Qt.RightButton
                cursorShape: Qt.PointingHandCursor
                onClicked:
                {
                    console.log("_mainMouse onClicked")
                }
                onDoubleClicked:
                {
                    console.log("_mainMouse onDoubleClicked")
                }
            }

            Component.onCompleted: {
                webChannel1.registerObject("interface", inter1);
            }
        }
    }

    property Component windowComponent: Window {
        id: webwindow
        property string strTitle: ""
        property WebEngineView webView: webView
        property int webWidth: 0
        property int webHeight: 0
        property string pageFlags: ""

        width: webWidth
        height: webHeight

        onClosing: {
            if(pageFlags === "email" || pageFlags === "seralarms")
            {
                //console.log("email+seralarms");
               // Query.query(strip, userId, jsessionid,parsedata)//userjid, window.companyoid,parsedata)
               // console.log("email+seralarms");
            }

            // destroyed();
        }

        visible: true
        title: strTitle


        WebEngineView {
            id:   _SignalWebEngine
            enabled: true;
            url:strip
            anchors.top: parent.top
            anchors.topMargin: 1
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom

            onNewViewRequested: function(request) {

                //   var newWindow = windowComponent.createObject(window.parent
                //                                                , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                //                                                    , "webHeight": (Screen.desktopAvailableHeight)*0.8
                //                                                    , "strTitle": qsTr("精灵导航")});
                //
                //   request.openIn(newWindow.webView_);
                //   request.openIn(_SignalWebEngine);
                //   newWindow.strTitle = qsTr("精灵导航")

                console.log("精灵导航_SignalWebEngine: ", request.url)
                var  paramurl = strip + "/main?lang=zh_CN";
               //Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)

                //iewebrun._vNewWindows_IE(paramurl+"&JSESSIONID1=" + jsessionid,"精灵导航");
                iewebrun._vNewWindows_XOAbrowser(paramurl+"&JSESSIONID1=" + jsessionid,"精灵导航",true);

                //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"精灵导航",true,strip);
                //webRun._vNewWindows(request.url,"精灵导航",true,strip)
                //QDesktopServices::openUrl(url("http://www.baidu.com"));
                //Qt.openUrlExternally("http://www.baidu.com")
                //webRun._vNewWindows("http://www.baidu.com","精灵导航",true,strip)
            }
            onLinkHovered:
            {
                _MainUrl = hoveredUrl.toString();
                console.log("_MainUrl:"+_MainUrl)
            }

            onWindowCloseRequested: {
                console.log("onWindowCloseRequested:")
                webwindow.close();
            }
        }


        //!屏蔽鼠标右键出现的查看源码的界面
        MouseArea
        {
            id:_mainMousein
            anchors.fill: parent
            hoverEnabled: false
            focus: false
            acceptedButtons: Qt.RightButton
            cursorShape: Qt.PointingHandCursor
            onClicked:
            {
                console.log("_mainMouse onClicked")
            }
            onDoubleClicked:
            {
                console.log("_mainMouse onDoubleClicked")
            }
        }

        Component.onCompleted: {

        }
    }

    Timer {
        id: timeremailseralarms
        interval: 120000;//120秒获取一次事务提醒
        running: false //是否开启定时，默认是false
        repeat: true
        triggeredOnStart: true // 是否开启定时就触发onTriggered
        onTriggered: {
            //console.log("开启定时器timeremailseralarms，获取事务提醒")

            Query.query(strip, userId, jsessionid, parsedata,parsedataerror)
        }
    }

    Timer {
        id: timerReadstat
        interval: 2000;//设置定时器时间
        repeat: true //是否重复定时,默认为false
        running: true //是否开启定时，默认是false
        triggeredOnStart: true // 是否开启定时就触发onTriggered
        onTriggered: {
            //console.log("Query.query")

            if(webRun._slot_returnStat())
            {
                console.log("Query.query",strip, userId, companyoid, parsedata)
                //Query.query(strip, userId, jsessionid, parsedata)
                webRun._slot_setStat(false)
            }
        }
    }
    MainBottomOperating {
            id: mainbottomoperating
            anchors.bottom: parent.bottom
            width: mainwindow.width
            height: 36


        }
        }
        function loginWebServerErr(errorcode,errormsg)
        {
            console.log("OA登录接口返回失败，返回数据：",errorcode,errormsg);

           // messageDialog.text ="
          //"+errormsg+"！！！      "+"
//messageDialog.text = " "+errormsg+"！！！     "+"";
            if(errormsg==="undefined")
            {
                messagecs.messageText = " 网络异常!     "+""
                messagecs.visible=true
                return
            }
           messagecs.messageText = " "+errormsg+"!     "+"";
//messageDialog.visible=true
            messagecs.visible=true
            //登录失败，根据后台返回的错误码进行提示
            /*if(errorcode === 1020)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+", 用户名或密码错误 "

                       }
                       else if(errorcode===100040)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+",密码或用户名错误超过3次，请等待10分钟后再重试"
                       }

                       else if(errorcode === 1030)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+", 用户权限表数据缺失 "
                       }
                       else if(errorcode === 1040)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+", 服务器session创建失败 "
                       }
                       else if(errorcode === 1050)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+", 用户名或用户不存在 "
                       }
                       else if(errorcode === 1060)
                       {
                           messageDialog.text = "登录失败: 错误代码 "+errorcode+", 用户禁止登录 "
                       }*/

           // messageDialog.visible = true
        }
    function getUserInfo(userInfo)
    {
        //console.log('登录接口返回数据：', userInfo)  //gaobo wait
        console.log('登录接口返回数据,暂不显示:')

        var obj = eval('(' + userInfo + ')'); //gaobo

        jsessionid = obj.msg

        userjid  = obj.object.uid;
        maintopoperating.jid = obj.object.uid;
        maintopoperating.userName = obj.object.userName

        oneselfName = obj.object.userName

        if(fileio.readIniFile("login", "companyoid")==""||fileio.readIniFile("login", "companyoid")==null)
        {


            if(obj.object.companyId!=""||obj.object.companyId!=null)
            {
            console.log("默认组织， 服务器返回companyId值为： ","",obj.object.companyId)
              window.companyoid = obj.object.companyId//获取服务器的企业ID
            }          
            else
            {
                 console.log("服务器companyId字段值为空","设置默认1001",obj.object.companyId)
                window.companyoid = "1001";
            }
        }
        else
        {
             console.log("window.companyoid 取配置文件值：",fileio.readIniFile("login", "companyoid"))
           window.companyoid =fileio.readIniFile("login", "companyoid")
        }

        titleName = obj.object.para.paraValue
        maintopoperating.titleName = titleName
        sex = obj.object.sex
        if(userInfo.indexOf("isFriends")>-1)
         {
            zZorfriends = obj.object.isFriends;
             console.log("组织和好友参数设置为",zZorfriends,obj.object.isFriends)

         }
        // zZorfriends = obj.object.isFriends;
        //  console.log("zZorfriends2",zZorfriends,obj.object.isFriends)


      // console.log('avatar_______2_', obj.object.avatar);
      //  console.log('avatar_______3_', strip);

        var  img = obj.object.avatar;

        if(img !== "" && img !== "0" && img !== null && img !== " " )
        {
            console.log('头像图片地址:', strip +  "/img/user/"+img);
            maintopoperating.headimg =strip +  "/img/user/"+img;
        }
        else  if(sex === "0") //boy.png'
        {
            maintopoperating.headimg = "qrc:/resource/images/main/maintop/manhead.png"
            console.log('头像图片地址:', maintopoperating.headimg);
        }
        else if(sex === "1")//girl.png'
        {
            maintopoperating.headimg = "qrc:/resource/images/main/maintop/womanhead.png"
            console.log('头像图片地址:',  maintopoperating.headimg);
        }

        //console.log('头像图片地址:',  maintopoperating.headimg);
        //    talkRoom.addRoomItem("jid",roomitem);

        if(obj.object.myStatus != "")
        {
            console.log('个性签名数据：', obj.object.myStatus)

            var strSignatureText = obj.object.myStatus.split("/");

            console.log('', strSignatureText)

            if(strSignatureText.length < 2)
            {
                maintopoperating.signatureText = strSignatureText[0]
                strSignatureIcon = ""
                maintopoperating.signatureIcon = ""
            }
            else
            {
                maintopoperating.signatureText = strSignatureText[0]
                strSignatureIcon = strSignatureText[1]
                maintopoperating.signatureIcon = strSignatureText[1]
            }
        }

        console.log("个人信息数据：",obj.object.uid, obj.object.userName, obj.object.myStatus)
        trayIconUpdate.updateTrayIconTips(strusername+" "+obj.object.userName)  //更新任务托盘图标提示为 用户名 姓名
        window.strusername2=obj.object.userName

        //请求当前用户的相关数据

        userId = obj.object.userId;

      //  timer.running = true

        //判断后台返回的关于IM的ip和端口
        if(obj.object.gimPort == ""||obj.object.gimPort ==null)
        {
            console.log('接口数据IM的ip和端口为空，默认设置5222', obj.object.gimPort)
            strImPort = "5222";
        }
        else
        {
            console.log('接口数据IM的ip的端口不为空，设置为：', obj.object.gimPort)
            strImPort = obj.object.gimPort;
        }
        //strImIp = obj.object.gimIp
        //strImIp = "192.168.0.21"
        if(obj.object.gimHost == ""||obj.object.gimHost ==null)
        {
            //通过解析域名获取ip
            var valueIP = fileio.getDNSFromFile()
            console.log("自动获得 Openfire IP地址:",valueIP)

            var ret = fileio.checkIP(valueIP)
            //console.log("检查IP",ret)

            if(ret == 0)
            {
                strImIp = valueIP
                console.log("IP可以直接使用:",valueIP)
                //register.registerToServer(userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
                //loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);

                //console.log("openfire登录参数为:",userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid); //gaobo wait
            }
            else
            {
                var value = fileio.getIPFromDNS()
                // fileio.sigDomainResolutionOpenfire.connect(imDomainResolutionSeussed)

                strImIp = value

                //register.registerToServer(userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
                //loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);

                console.log("解析域名获取IP:",value,ret)
            }
        }
        else
        {
            strImIp = obj.object.gimHost
            strImPort = obj.object.gimPort
            console.log("使用后台配置的 Openfire IP地址",strImIp)

           // register.registerToServer(userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
           // loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);
        }


       register.registerToServer(userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
       loginServer.loginSeverfunction(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);

        var MessageKey = _Maincompanyoid + "pq";

        //会话列表接口地址
        conversationList.getConversationList(obj.msg,strip + "/im/getImList?of_from="+MessageKey+ userjid + "@gsubo")

        console.log("调用接口：获取会话列表数据接口地址:", strip + "/im/getImList?of_from=" +MessageKey+ userjid + "@gsubo",obj.msg) //gaobo wait
        //console.log("调用接口：获取会话列表数据，地址暂不显示:");
        //Query.query(strip, obj.object.userId, window.jsessionid,parsedata)
    }

    function ispirit()
    {
        if(!isLoginSuccessful)
        {
            return;
        }

        // var firstWindow = windowComponent.createObject(window.parent
        //                                                ,{"webWidth":window.webWidth
        //                                                    , "webHeight": window.height
        //                                                    , "strTitle": qsTr("精灵导航")});
        // firstWindow.webView.url = strip + "/main?lang=zh_CN";

        //精灵导航
        console.log("点击进入精灵导航按钮地址: ", strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
        //webRun._vNewWindows(strip + "/main?lang=zh_CN","精灵导航",true,strip)
        // Qt.openUrlExternally(paramurl+"&JSESSIONID1=" + jsessionid)
        //iewebrun._vNewWindows_IE(paramurl+"&JSESSIONID1=" + jsessionid,"精灵导航");
        var  paramurl = strip + "/main?lang=zh_CN";
        iewebrun._vNewWindows_XOAbrowser(paramurl+"&JSESSIONID1=" + jsessionid,"精灵导航",true);

        //iewebrun._vNewWindows((paramurl+"&JSESSIONID1=" + jsessionid).toString(),"精灵导航",true,strip);
        //Qt.openUrlExternally("http://www.baidu.com")

    }

    function switchUser()
    {
        if(!isLoginSuccessful)
        {
            loginServer.startExe("./ispirit_xoa","switchUser")
            app_quit()
            return;
        }
        mainbottomoperating.creatMessageObj("确定要切换用户吗?", "switchUser")

    }

    function about()
    {
        mainbottomoperating.creatAboutObj();
    }

    function relogin()
    {
        if(!isLoginSuccessful)
        {

            loginServer.startExe("./ispirit_xoa","")
            app_quit()
            return;
        }
        mainbottomoperating.creatMessageObj("确定要重新登录吗?", "relogin");
    }


    function main_quit()
    {
        console.log("退出，Mainwindow.main_quit()");

        if(!isLoginSuccessful)
        {
            console.log("没有登录成功就退出了，Mainwindow.main_quit()");
            app_quit()
            return;
        }
        mainbottomoperating.creatMessageObj("确定要退出吗?", "main_quit")
    }



    function app_quit()
    {
        console.log("退出应用程序 app_quit()");
        imAgainlogin.destroy()
        loginServer.logoutServer();
        Qt.exit(0);
        iewebrun._vNewWindows_IE_quit()
    }

    function formatDate(timespan)
    {

        var dateTime = new Date(timespan * 1000);
        var year = dateTime.getFullYear();
        var month = dateTime.getMonth() + 1;
        var day = dateTime.getDate();
        var hour = dateTime.getHours();
        var minute = dateTime.getMinutes();
        //当前时间
        var now = Date.parse(new Date());  //typescript转换写法
        var milliseconds = 0;
        var timeSpanStr;
        //计算时间差
        milliseconds = (now / 1000) - timespan;

        //一分钟以内
        if (milliseconds <= 60) {
            timeSpanStr = '刚刚';
        }
        //大于一分钟小于一小时
        else if (60 < milliseconds && milliseconds <= 60 * 60) {
            timeSpanStr = Math.ceil((milliseconds / (60))) + '分钟前';
        }
        //大于一小时小于等于一天
        else if (60 * 60 < milliseconds && milliseconds <= 60 * 60 * 24) {
            timeSpanStr = Math.ceil(milliseconds / (60 * 60)) + '小时前';
        }
        //大于一天小于等于15天
        else if (60 * 60 * 24 < milliseconds && milliseconds <= 60 * 60 * 24 * 30) {
            timeSpanStr = Math.ceil(milliseconds / (60 * 60 * 24)) + '天前';
        }
        //大于一个月小于一年
        else if (60 * 60 * 24 * 30 < milliseconds && milliseconds <= 60 * 60 * 24 * 30 * 12){
            timeSpanStr = Math.ceil(milliseconds / (60 * 60 * 24 * 30)) + '个月前';
        }
        //超过一年显示
        else {
            timeSpanStr = year + '年' + month + '月' + day + '日 ' + hour + ':' + minute;
        }
        return timeSpanStr;
    }

    //会话列表添加一条数据
    function appendData(strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)
    {
        // console.log("appendData(strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)")
        // console.log("appendData(","strIcon:"+strIcon, "strUserName:"+strUserName, "strUserText:"+strUserText, "strUserTime:"+strUserTime, "strJid:"+strJid, "strType:"+strType,"listID:"+listID,"myStatus:"+myStatus,"msgtype:"+msgtype,"groudimg:"+groudimg,"msglist:"+msglist)

        //  console.log("conversationModel appendData__strIcon_______"+strIcon, typeof strIcon)
        //  console.log("conversationModel appendData__strUserName___"+strUserName, typeof strUserName)
        //  console.log("conversationModel appendData__strUserText___"+strUserText, typeof strUserText)
        //  console.log("conversationModel appendData__strUserTime___"+strUserTime, typeof strUserTime)
        //  console.log("conversationModel appendData__strJid________"+strJid, typeof strJid)
        //  console.log("conversationModel appendData__strType_______"+strType , typeof strType)
        //  console.log("conversationModel appendData__listID________"+listID , typeof listID)
        //  console.log("conversationModel appendData__myStatus______"+myStatus , typeof myStatus)
        //  console.log("conversationModel appendData__msgtype_______"+msgtype , typeof msgtype)
        //  console.log("conversationModel appendData__msglist_______",strJid, msglist , typeof msglist)
        //  console.log("conversationModel appendData__msglist_______",JSON.stringify(msglist))

        //      var obj = JSON.parse(str); var _sstr = JSON.stringify(obj)var obj1 = JSON.parse(strTemMsg)

        console.log("会话列表 appendData");

        for(var len = 0 ; len < conversationModel.count; len++ )
        {
            if(conversationModel.get(len).strUserJid  == strJid)
            {
                console.log(" appendData id已经存在",strJid,strUserName,strUserText)
                return
            }
            //else
                //console.log(" 会话列表 appendData id",conversationModel.get(len).strUserJid)
        }

        console.log("会话列表增加条目，JID:",strJid,"姓名",strUserName,"最后聊天",strUserText)

        if(strUserText.indexOf("对方已经通过PC端在")>-1)
           strUserText="已下载:"+strUserText.substr(strUserText.indexOf(" "))

        conversationModel.append({"iconImage": groudimg,
                                     "userName":strUserName,
                                     "userText":strUserText,
                                     "strUserJid" : strJid,
                                     "strUserType" : strType,
                                     "userTime": formatDate(strUserTime),
                                     "mobileNo": "",
                                     "userSex": "",
                                     "privName": "",
                                     "dele_strlistid": listID,
                                     "myStatus": myStatus,
                                     "msgtype": msgtype,
                                     "groudimg": groudimg,
                                     "groudmsglist": msglist,
                                 })

        conversationListview.update();
        conversationModel.move(conversationModel.count-1,0,1);
    }

    function insertData(strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)
    {
        console.log("insertData(strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)")
        console.log("insertData",strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)

        for(var len = 0 ; len < conversationModel.count; len++ )
        {
            if(conversationModel.get(len).strUserJid  == strJid)
            {
                console.log("insertData id已经存在",strJid)
                // return
            }
        }


        //  console.log("conversationModel insertData__strIcon_______"+strIcon, typeof strIcon)
        //  console.log("conversationModel insertData__strUserName___"+strUserName, typeof strUserName)
        //  console.log("conversationModel insertData__strUserText___"+strUserText, typeof strUserText)
        //  console.log("conversationModel insertData__strUserTime___"+strUserTime, typeof strUserTime)
        //  console.log("conversationModel insertData__strJid________"+strJid, typeof strJid)
        //  console.log("conversationModel insertData__strType_______"+strType , typeof strType)
        //  console.log("conversationModel insertData__listID________"+listID , typeof listID)
        //  console.log("conversationModel insertData__myStatus______"+myStatus , typeof myStatus)
        //  console.log("conversationModel insertData__msgtype_______"+msgtype , typeof msgtype)
        //  console.log("conversationModel insertData__msglist_______"+msglist , typeof msglist)

        conversationModel.insert(0,
                                 {"iconImage": groudimg,
                                     "userName":strUserName,
                                     "userText":strUserText,
                                     "strUserJid" : strJid,
                                     "strUserType" : strType,
                                     "userTime": formatDate(strUserTime),
                                     "mobileNo": "",
                                     "userSex": "",
                                     "privName": "",
                                     "dele_strlistid": listID,
                                     "myStatus": myStatus,
                                     "msgtype": msgtype,
                                     "groudimg": groudimg,
                                     "groudmsglist": msglist,
                                 })

        conversationListview.update();
    }

    function setVisible(index)
    {
        if(index == 0)
        {
            applyRect.visible = true;
            conversationRect.visible = false
            tissueRect.visible = false
        }
        else if(index == 1)
        {
            applyRect.visible = false;
            conversationRect.visible = true
            tissueRect.visible = false
        }
        else if(index == 2)
        {
            applyRect.visible = false;
            conversationRect.visible = false
            tissueRect.visible = true
        }
    }
function loginserverresult(result)
{
    //console.log("事务提醒接口返回结果认证信息已过期，重新登录接口返回:",result)
    var obj = eval('(' + result + ')');//eval gaobo
    if(obj.flag)
    {
        jsessionid = obj.msg
         console.log("重新登录成功。jsessionid：",obj.msg)
    }
}
function loginserverErrorresult(result)
{
    console.log("重新获取jsessionid失败。不处理，会在下次获取事务提醒时进行再次请求")
}


//自动重新登录
function loginCallback(userjson)
{

    var obj = eval('(' + userjson + ')');
    if("flag" in obj )
    {
        if(obj.flag)
        {

          jsessionid = obj.msg
          console.log("重新登录成功，获取了新的 jsessionid:",jsessionid)

          //var url =strip +"/spirit/login?company="+companyoid+"&USERNAME=" + encodeURIComponent(strusername) + "&PASSWORD=" + encodeURIComponent(strpasswd)
          //weburl = strip + "/logOut?name=" + encodeURIComponent(strusername) + "&userAgent=pc"
          //var url =strip +"/spirit/main?company="+companyoid+"&USERNAME=" + encodeURIComponent(strusername) + "&PASSWORD=" + encodeURIComponent(strpasswd) + "&JSESSIONID1=" +jsessionid
          //console.log("主面板重新登录:",url)
          //weburl = url;
          //loginWebServer.deleteSeseions();

          logoutWebServer.logoutServer(strip + "/logOut?name="+ username +"&userAgent=pc", jsessionid,"3");
        }
    }
}

//解析用户数据信息
function parsedataerror(errorlogin)
{
    console.log("服务器返回状态!=200，可能服务器已经停止")
    return;
}

function parsedata(strdata)
{
    if(strdata.indexOf("403页面")>-1 || strdata.indexOf("重新登录")>-1)
    {
        var url = strip + "/login?loginId=" + companyoid +"&userAgent=pc" + "&username=" + strusername + "&password=" + encodeURIComponent(strpasswd)
                +"&clientVersion=" + fileio.readIniFile("def", "autologinMode")+"&clientType=pc"
        console.log("parsedata 403页面,重新登录")
        //Query.loginserver(url,loginserverresult,loginserverErrorresult)
        loginWebServer.loginWebServer(url);

        return;
    }

    var obj = eval("(" + strdata + ")");//eval gaobo
    // console.log("mianwindow_parsedata()___", strdata);
    maintopoperating.setInfo(obj.data.emailCount, obj.data.totalCount,obj.data.totalCount);
    /* obj.data.map.email.count+
                                 obj.data.map.schedule.count+
                                 obj.data.map.document.count+
                                 obj.data.map.publicFile.count+
                                 obj.data.map.diary.count+
                                 obj.data.map.news.count+
                                 obj.data.map.vote.count+
                                 obj.data.map.meeting.count+
                                 obj.data.map.notify.count+
                                 obj.data.map.supervision.count+
                                 obj.data.map.workflow.count+
                                 obj.data.map.calendar.count
                                 )*/

    console.log("事务提醒接口返回 邮件数量:  提醒总数量: ",obj.data.emailCount, obj.data.totalCount);

    /* if(obj.data.emailCount!==0)
          {
             fileio.warningtone();
            if(taryMsgdataMap.isEmpty())
            {
                console.log("b 2·");
                taryMsgdataMap.put("'" + "/email/index?" +"'", obj.data.emailCount);
            }
            else
            {
                console.log("b 3·");
                if(taryMsgdataMap.containsKey("'" + "/email/index?" + "'"))
                {
                      taryMsgdataMap.put("'" + "/email/index?" + "'" ,  obj.data.emailCount)
                }
                else
                {
                    console.log("b 4·");
                    taryMsgdataMap.put("'" + "/email/index?" + "'", obj.data.emailCount)
                }

            }
           // mainwindow.modifyUserInfo(_sGuid, taryMsgdataMap.get("'" + _sGuid + "'"))
            _msgtimer.running = true;
                    //taryMsgdataMap.put("'" + "/email/index?" + "'" ,  obj.data.email.toString())
          chattooltip.appendData("/email/index?", "您有新的邮件", 4, taryMsgdataMap.get("'" + "/email/index?" + "'"));
                    //chattooltip.show()
        }
        else
        {
            taryMsgdataMap.remove("'" + "/email/index?" + "'")
            chattooltip.removeAtIndexasname("'" + "/email/index?" + "'");
            if(taryMsgdataMap.length===0)
            {
                _msgtimer.running = false;
                chattooltip.hide()
            }

        }*/
    if(obj.data.totalCount==0)
    {
        //console.log("MainWindow:当事务提醒为零时，清除图标闪烁事务提醒条目1",chattooltip.getModelCount())
        taryMsgdataMap.remove("'" + "/sms/index?" + "'")
        //taryMsgdataMap.clear();
        //chattooltip.removeAtIndexasname("'" + "/sms/index?"  + "'");
        chattooltip.removeAtIndexasname("/sms/index?");
        //chattooltip.removeAtIndex(); //gaobo
        //console.log("MainWindow:当事务提醒为零时。清除图标闪烁事务提醒条目2",chattooltip.getModelCount(),taryMsgdataMap.length)
        //if(chattooltip.getModelCount()== 0)
        if(chattooltip.getModelCount() == 0)
        {
            //console.log("MainWindow:当事务提醒为零时，清除图标闪烁事务提醒条目3")
            _msgtimer.running = false;
            chattooltip.visible = false;
            chattooltip.hide();
            taryMsgdataMap.clear();
            trayIconUpdate.updateTrayIcon(":/resource/logo.ico")
            chattooltip.hide();
            return
        }

    }
    else

    {

        if(fileio.readIniFile("IM","newmsgSound") != "false")
        {
            fileio.warningtone();
            console.log("事务提醒，播放声音");
        }

        if(taryMsgdataMap.isEmpty())
        {

            //console.log("b 2·");
            taryMsgdataMap.put("'" + "/sms/index?" + "'", obj.data.totalCount);
        }
        else if( obj.data.totalCount>smsTotalCount || msgtimerNum%10==0)
        {
            //console.log("b 3·");
            if(taryMsgdataMap.containsKey("'" + "/sms/index?" + "'"))
            {
                taryMsgdataMap.remove("'" + "/sms/index?" + "'")
                taryMsgdataMap.put("'" + "/sms/index?" + "'" ,  obj.data.totalCount)
            }
            else
            {
                taryMsgdataMap.put("'"  + "/sms/index?" +  "'",  obj.data.totalCount)
            }

        }
        // mainwindow.modifyUserInfo(_sGuid, taryMsgdataMap.get("'" + _sGuid + "'"))
        _msgtimer.running = true;
        //taryMsgdataMap.put("'" + "/sms/index?" + "'" ,  obj.data.smsDo.toString())
        chattooltip.appendData("/sms/index?", "您有新的事务提醒", 5, taryMsgdataMap.get("'" + "/sms/index?" + "'"));
        console.log("chattooltip.appendData 事务提醒");

        if(fileio.readIniFile("Seralarms","newSeralarmsMode") != "false" || chattooltip.visible==true)
        {

            chattooltip.height = 35 + chattooltip.getModelCount()*50
            chattooltip.x = screenwidth - 80 - 220;//screenwidth - 80 - 220
            chattooltip.y = screenheight - chattooltip.height

            chattooltip.hide();
            chattooltip.show();
            return;
        }
    }
    smsTotalCount=obj.data.totalCount
    msgtimerNum++
}

//根据jid删除聊天窗口
function deleteObj(jid)
{
    //console.log("destroy chatobj_:"+jid,chatviewobj.length)
    //console.log(" B0 ")
    for(var i = 0; i <  chatviewobj.length; ++i)
    {
        //  console.log("destroy chatobj_:"+jid,chatviewobj[i].jid,i)

        // console.log(" B1 ")
        if(jid === chatviewobj[i].jid)
        {
            //console.log("destroy chatobj_:"+jid , chatviewobj[i].jid)
            //console.log(" B2 ")
            chatviewobj[i].deleteitem.disconnect(mainwindow.deleteObj)
            //chatviewobj[i].getfileurl.disconnect(chatTransferFile.sigReplyMessage)
            //chatviewobj[i].sender.disconnect(chatTransferFile.sigSendFileData)
            //chatviewobj[i].receiver.disconnect(downLoadManager.signalDownloadProcess)
            //chatviewobj[i].appendMessagAeLoginingData.disconnect(chatMessageFromServer.sigReplyMessage)
            //chatviewobj[i].__callBack.disconnect(chatGetUserInfo.sigReplyMessage)
            // console.log(" B3 ")
            chatviewobj[i].appendConverList.disconnect(mainwindow.modifyConversationModel)
            // console.log(" B4 ")
            chatviewobj[i].destroy()
            //console.log(" B5 ")
            chatviewobj.splice(i, 1)
            //console.log(" B6 ")
        }
        //  console.log(" B7 ")
    }
    // console.log(" B8 ")
}


//创建单聊窗口
function creatObj(username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure)
{
    var component = Qt.createComponent("../chat/ChatView.qml");

    var obj;

    //console.log(usersex);

    if (component.status === Component.Ready)
    {
        console.log("创建单聊窗口对象:", username, userprivname, usersex, jid, usermobileno, bshow,strStaus,ImgSoure)

        for(var i = 0; i < chatviewobj.length; ++i)
        {
            if(chatviewobj[i].jid == jid)
            {
                conversationModel.set(i, {"visibility": Window.Windowed})
                // console.log("visibility.length()::",i+1 );
                chatviewobj[i].showNormal();
                //console.log("创建聊天窗口对象_返回_::");
                return true;
            }
            else if(i+1>=chatviewobj.length)
            {
                //console.log("chatviewobj.length()::",i+1 )
            }
        }
        conversationListview.update();
        obj = component.createObject(window.parent, {"jid": jid     //聊天对象jid
                                         , "chatusername": username
                                         , "userjid": userjid       //自己jid
                                         , "jessonid": jsessionid
                                         , "chatuserprivname": userprivname
                                         , "chatsex":usersex
                                         , "visible":bshow
                                         , "sex":sex
                                         , "moblieNo": usermobileno
                                         , "loginusername": oneselfName
                                         , "inputFocus": true
                                         , "strStaus" :strStaus
                                         , "avatar" : ImgSoure
                                         , "count" : chatviewobj.length
                                         , "strOid" :_Maincompanyoid
                                         , "selfvavtar" :maintopoperating.headimg
                                     });
    }
    else
    {
        console.log("创建单聊窗口时,Component 对象不可用，错误是：",component.errorString());
    }

    if(obj === null)
    {
        console.log("创建单聊窗口时,obj为空");
    }
    else
    {
        obj.deleteitem.connect(mainwindow.deleteObj)
        obj.appendConverList.connect(mainwindow.modifyConversationModel)
        chatviewobj.push(obj);
    }
    return false;

}

//创建群聊窗口
function creatGroupObj(username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure,creatObj,groudmsglist)
{
    /* username:群组名称（不为空）
        userprivname：群成员名称(空)
        usersex：性别（空）
        jid：聊天对象jid（openfire房间号）（不为空）
        usermobileno：用户手机号（空）
        bshow：是否显示（true）
        strStaus：字符状态(空)
        ImgSoure：http://192.168.0.18/img/im/groupchat.png
        creatObj： （空）
        groudmsglist：（空）*/
    var component = Qt.createComponent("../chat/GroupChatView.qml");
    var obj;

    if (component.status === Component.Ready)
    {
        console.log("创建群聊窗口对象:", username, userprivname, usersex, jid, usermobileno, bshow, strStaus,ImgSoure) //groudmsglist

        for(var i = 0; i < chatviewobj.length; ++i)
        {
            if(chatviewobj[i].jid == jid)
            {
                //  console.log("true::",true )
                chatviewobj[i].show();
                return true;
            }
            else if(i+1>=chatviewobj.length)
            {
                // console.log("chatviewobj.length()::",i+1 )
            }
        }

        obj = component.createObject(window.parent,{"roomId": jid     //聊天对象jid
                                         , "groupId": jid
                                         , "jid": jid
                                         , "jid": jid
                                         , "oneselfJid": userjid     //!自己jid
                                         , "oneselfName":oneselfName //!自己名称
                                         , "groupName": username
                                         , "chatuserprivname": userprivname
                                         , "jessonid": jsessionid
                                         , "visible":bshow
                                         , "inputFocus": true
                                         , "strStaus" :strStaus
                                         , "avatar" : ImgSoure
                                         , "count" : chatviewobj.length
                                         , "strOid" :_Maincompanyoid
                                         , "groudmsglist" :groudmsglist
                                         , "strOid" :_Maincompanyoid
                                         , "selfvavtar" :maintopoperating.headimg
                                     });

        //console.log("obj",obj )
    }
    else
    {
        console.log("创建群聊窗口时,Component 对象不可用，错误是：",component.errorString());
    }

    if(obj === null)
    {
        console.log("创建群聊窗口时,obj 为空");
    }
    else
    {
        obj.deleteitem.connect(mainwindow.deleteObj)
        obj.appendConverList.connect(mainwindow.modifyConversationModel)
        obj._room_changeGroupName.connect(mainwindow.setGroupName)

        chatviewobj.push(obj);
        // console.log("_______chatviewobj_____",chatviewobj.length);
    }

    return false;
}

//创建web窗口对象
function creatWebObj(text, url) {
    var component = Qt.createComponent("../common/CustomWebView.qml");

    console.log("weburl______________",url)
    if (component.status === Component.Ready)
    {
        if(webobj === null)
        {
            webobj = component.createObject(window.parent, {
                                                //"viewwidth": (Screen.desktopAvailableHeight)*0.8
                                                //, "viewheight": (Screen.desktopAvailableHeight)*0.8
                                                "nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                                , "titletext": text
                                                , "visible": true
                                                , "weburl": url});
        }
    }
    if(webobj === null)
    {

    }
    else
    {
        webobj.sendWebUrl.connect(mainwindow.getWebChildUrl)
        webobj.deleteitem.connect(mainwindow.deleteWebObj)
    }
}

//销毁所有聊天窗口对象
function destroyallobject()
{
    console.log("chatviewobj.length", chatviewobj.length)
    for(var i = 0; i < chatviewobj.length; i++)
    {
        if(chatviewobj[i] == null)
        {
            return;
        }

        chatviewobj[i].destroy();
        chatviewobj.shift()
    }
}

//销毁web网页对象
function deleteWebObj()
{
    if(webobj == null)
    {
        return;
    }
    webobj.sendWebUrl.disconnect(mainwindow.getWebChildUrl)
    webobj.deleteitem.disconnect(mainwindow.deleteWebObj)
    webobj.destroy()
    webobj = null
}

function creatChildWebObj(text, url) {
    var component = Qt.createComponent("../common/CustomWebView.qml");

    var webChildObj;
    if (component.status === Component.Ready)
    {
        for(var i = 0; i < childWebObj.length; ++i)
        {
            if(childWebObj[i].weburl == url)
            {
                return true;
            }
        }

        webChildObj = component.createObject(window.parent, {
                                                 "nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                                 , "titletext": text
                                                 , "visible": true
                                                 , "weburl": url
                                                 , "pageid": url});

    }
    if(webChildObj === null)
    {

    }
    else
    {
        webChildObj.sendWebUrl.connect(mainwindow.getWebChildUrl)
        webChildObj.deleteitem.connect(mainwindow.deleteChildWebObj)

        childWebObj.push(webChildObj)
    }
    return false;
}

function deleteChildWebObj(url)
{
    console.log("kkkk_ deleteChildWebObj", jid)
    for(var i = 0; i <  childWebObj.length; ++i)
    {
        if(url == childWebObj[i].weburl)
        {
            // console.log("destroy chatobj")
            childWebObj[i].sendWebUrl.connect(mainwindow.getWebChildUrl)
            childWebObj[i].deleteitem.connect(mainwindow.deleteChildWebObj)
            childWebObj[i].destroy()
            //childWebObj[i].splice(i, 1)
        }
    }
}

function getWebChildUrl(msg1, msg2, msg3)
{
    creatChildWebObj(msg2,strip+msg1)
}

//根据jid显示聊天窗口
function showObj(chatjid,chatname)
{
    for(var i = 0; i < chatviewobj.length; ++i)
    {
        if(chatviewobj[i].jid === chatjid)
        {
            chatviewobj[i].visible = true;
            //console.log("..chaungkou ..",chatviewobj[i].visible);
            return;
        }

    }

    if(chatjid.indexOf("@gsrooms")>-1) //群聊
    {
        //creatObj(chatjid,chatjid,chatjid,chatjid,false,"qrc:/resource/images/im/45.png");
        //mainwindow.creatObj (chatname, "", userjid, chatjid,"", true,"","qrc:/resource/images/im/45.png");
        console.log("创建新的群聊窗口")
        mainwindow.creatGroupObj(chatname, "", "",chatjid ,"", true,"","qrc:/resource/images/im/45.png","","");

            /* username:群组名称（不为空）
                userprivname：群成员名称(空)
                usersex：性别（空）
                jid：聊天对象jid（openfire房间号）（不为空）
                usermobileno：用户手机号（空）
                bshow：是否显示（true）
                strStaus：字符状态(空)
                ImgSoure：http://192.168.0.18/img/im/groupchat.png
                creatObj： （空）
                groudmsglist：（空）*/
    }

    else
    {
        console.log("创建新的单聊窗口")
        // creatObj(chatjid,chatjid,userjid,chatjid,false,chatjid,"","");

        mainwindow.creatObj (chatname, "", userjid, chatjid,"", true,"","");
    }



}

//追加单聊聊天消息
function appendMsg(chatjid, strMsg)
{

    // console.log("追加聊天消息。",strMsg,chatjid)

    for(var i = 0; i < chatviewobj.length; ++i)
    {
        console.log("追加聊天消息。111111",strMsg,chatjid,chatviewobj[i].jid)
        if(chatviewobj[i].jid == chatjid)
        {
            console.log("追加接收聊天消息。。。。",strMsg)
            if(chatviewobj[i].visible ==true)
            {
                chatviewobj[i].appendReceiveData(strMsg, 1, "","");
            }
        }
    }
}

//获取聊天窗口是否显示
function getChatObjVisible(chatjid)
{
    for(var i = 0; i < chatviewobj.length; ++i)
    {
        // console.log("getChatObjVisible:",chatviewobj[i].jid , chatjid)
        if(chatviewobj[i].jid == chatjid)
        {
            // console.log("getChatObjVisible:")
            //  Qt.FlatCap(chatviewobj[i], True)
            return chatviewobj[i].visible;
        }
    }
    return false;
}

//获取聊天对象是否创建
function getObjIsCreate(chatjid)
{
    var jid;
    if(typeof chatjid === "string")
    {
        jid = chatjid.toString();
        // console.log(typeof chatjid,"chatjid_");
    }
    else
    {
        jid = chatjid;
        // console.log(typeof jid,"jid_");
    }

    for(var i = 0; i < chatviewobj.length; ++i)
    {
        //  console.log(typeof chatviewobj[i].jid,chatviewobj[i].jid);
        //  console.log(typeof jid,jid);
        //  console.log(typeof chatjid,chatjid);

        if(chatviewobj[i].jid == jid)
        {
            console.log("此窗口已存在,激活到最前面,chatjid:",chatjid,"窗口状态",chatviewobj[i].visibility);
            if(chatviewobj[i].visibility  !=Window.Maximized) //不是最大化
               chatviewobj[i].show();
            chatviewobj[i].requestActivate();
            return true;
        }
    }
    // console.log("不存在,",typeof chatjid,chatjid);
    return false;
}

function setObjVisible(chatjid, visible)
{
    for(var i = 0; i < chatviewobj.length; ++i)
    {
        if(chatviewobj[i].jid == chatjid)
        {
            chatviewobj[i].visible = visible
        }
    }
}

//设置用户信息
function setUserInfo(chatjid, username, userPrivName, sex, iCount, mobleNo,strStaus,avatar)
{

    //console.log("setUserInfo:chatjid, username, userPrivName, sex, iCount, mobleNo,strStaus,avatar");
    //  console.log("setUserInfo:",chatjid, username, userPrivName, sex, iCount, mobleNo,strStaus,avatar);
    var ook = false;

    for(var i = 0; i < chatviewobj.length; ++i)
    {
        if(chatviewobj[i].jid == chatjid)
        {
            chatviewobj[i].chatusername = username
            chatviewobj[i].chatuserprivname = userPrivName
            chatviewobj[i].chatsex = sex
            chatviewobj[i].moblieNo = mobleNo
            chatviewobj[i].itemCount += iCount
            chatviewobj[i].strStaus = strStaus
            chatviewobj[i].avatar = avatar
            //chatviewobj[i].iconImage = avatar

            //![qgz]填充没有头像的chatitem
            chatviewobj[i].setChatViewIco(chatjid,avatar);
            ook = true;

        }
        //chatviewobj.update();
    }

    for(var len =0; len <conversationModel.count;len++)
    {

        if(conversationModel.get(len).strJid == chatjid)
        {

            if(conversationModel.get(len).userName !== username)
                conversationModel.setProperty(len, "userName", username)

            if(conversationModel.get(len).strPrivName !== userPrivName)
                conversationModel.setProperty(len, "strPrivName", userPrivName)

            if(conversationModel.get(len).userSex !== sex)
                conversationModel.setProperty(len, "userSex", sex)

            conversationModel.setProperty(len, "msgCount", parseInt(iCount))

            if(conversationModel.get(len).mobileNo !== mobleNo)
                conversationModel.setProperty(len, "mobileNo", mobleNo)

            if(conversationModel.get(len).strStatus !== strStaus)
                conversationModel.setProperty(len, "strStatus", strStaus)

            if(conversationModel.get(len).iconImage !== avatar)
                conversationModel.setProperty(len, "iconImage", avatar)

        }
    }


    //   console.log("douyin[le]",douyin[0]);

    for(var le =0; le<douyin.length;le++)
    {

        //  console.log("setUserInfo——————————:",conversationModel.get(le).strUserJid);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).strUserType);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).privName);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).userSex);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).mobileNo);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).iconImage);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).userText);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).msgCount);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).strStatus);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).dele_strlistid);
        //  console.log("setUserInfo——————————:",conversationModel.get(le).userName);


        if(douyin[le] == conversationModel.get(le).strUserJid && conversationModel.get(le).userText == "抖屏")
        {
            creatObj(conversationModel.get(le).userName, conversationModel.get(le).privName, conversationModel.get(le).userSex, conversationModel.get(le).strUserJid,
                     conversationModel.get(le).mobileNo, true, conversationModel.get(le).strStatus,conversationModel.get(le).iconImage);
            douyin = [];
        }
    }
}

function modifyUserInfo(chatjid, iCount)
{
    for(var i = 0; i < chatviewobj.length; ++i)
    {
        if(chatviewobj[i].jid == chatjid)
        {
            chatviewobj[i].itemCount += iCount
        }
    }
}

function getList(conversaList)//获取会话列表，设置头像 2019.12.30.1
{

    conversationModel.clear()

    //console.log("调用接口：获取会话列表数据接口数据:"    ,conversaList) //gaobo wait
    console.log("调用接口：获取会话列表数据接口数据,暂不显示:")

    if(conversaList == "")
    {
        //console.log("会话列表null,返回追加会话列表");
        bkg.visible = true
        return;
    }

    var obj = eval('(' + conversaList + ')');//eval gaobo
    list = conversaList

    if(obj.length == 0)
    {
        bkg.visible = true
    }

    for(var i = obj.length-1 ; i >= 0; --i)
    {

        // 注释群聊
        // if(obj[i].msg_type === "1")continue;
        //appendData(strIcon, strUserName, strUserText, strUserTime, strJid, strType,listID,myStatus,msgtype,groudimg,msglist)

        var strURL= "";

        if(obj[i].msg_type == "1") //群聊
        {
            //  console.log("会话列表,  发送人:",obj[i].formUserName,"发送ID:",obj[i].from_uid,"接收人:",obj[i].toUserName,"接收ID:",obj[i].from_uid," 本地ID:",userjid,obj[i].groupMessage);
            var temmsg;
            if("groupMessage" in obj[i])
            {
                temmsg = JSON.stringify(obj[i].groupMessage);
            }
            else
            {
                temmsg =  obj[i].content;
            }
            //console.log("会话列表,  发送人:",temmsg);
            if(obj[i].type!="file")
            {
                appendData("", obj[i].toUserName, obj[i].content, obj[i].time, obj[i].to_uid, obj[i].type,obj[i].list_id,obj[i].myStatus,obj[i].msg_type, "qrc:/resource/images/im/45.png",temmsg);
            }
            else
            {
                appendData("", obj[i].toUserName, obj[i].file.file_name, obj[i].time, obj[i].to_uid, obj[i].type,obj[i].list_id,obj[i].myStatus,obj[i].msg_type, "qrc:/resource/images/im/45.png",temmsg);
            }

        }
        else //单聊
        {
            //strURL =  strip + "/user/findUserByuid?uid=" + obj[i].to_uid+"&msg_type="+ obj[i].msg_type;

             if(obj[i].from_uid == userjid) //自己发给别人或自己的
             {
                 strUsername=obj[i].toUserName;
                 strUID=obj[i].to_uid;
             }
             else  //别人发给自己的
             {
                 strUsername=obj[i].formUserName;
                 strUID=obj[i].from_uid;
             }

            if(obj[i].photo=="0")
               strImage="qrc:/resource/images/im/chatman (2).png";
            else if(obj[i].photo=="1")
               strImage="qrc:/resource/images/im/chatwoman (2).png";
            else
               strImage=strip + "/img/user/"+obj[i].photo;

            console.log("会话列表 toUserName",obj[i].toUserName,"photo",obj[i].photo,"strImage:",strImage);

            if(obj[i].type=="file")
                 obj[i].content= obj[i].file.file_name;

            //appendData("",obj[i].toUserName, obj[i].content, obj[i].time, obj[i].to_uid, obj[i].type,obj[i].list_id,obj[i].myStatus,obj[i].msg_type, "qrc:/resource/images/main/maincenter/man.png","qrc:/resource/images/main/maincenter/man.png");//strip+ obj[i].photo
            appendData("",strUsername, obj[i].content, obj[i].time,strUID, obj[i].type,obj[i].list_id,obj[i].myStatus,obj[i].msg_type, strImage,"");
        }


        if(obj[i].msg_type !== "1")
        {
            //console.log("查询个人消息接口地址:",strURL,"传入session:",mainwindow.jsessionid); //gaobo wait

            //2019-12-24 不再单独获取单聊头像
            //chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 2);
        }
        else //群聊
        {
            var jid  =  obj[i].of_to;
            var user  =  obj[i].of_from.split("@")[0];
            var username  = user.split("pq")[0]+"pq"+userjid+"@gsubo";

            qunMessage.push(jid +"**"+user +"**"+username)
            // console.log("会话列表群信息-",qunMessage.length,jid +"**"+user +"**"+username);

            isAlreadyRead_tem = true;
            _gjid =jid
            _guser=user
            _gusername=username
            //talkRoomIntface._bAddGroudRoom(jid,username);  //立即加群 2019-11-05

            // talkRoomIntface._vWriteGroudMsg(username,jid)
        }
    }

    if(isAlreadyRead_tem)
    {
        //console.log("群信息  qunMessage.push  isAlreadyRead_tem:");
        isAlreadyRead = true;
    }
    else
    {
        //console.log("群信息  qunMessage.push ！ isAlreadyRead_tem:");
    }
    // Query.query(strip, userId, jsessionid,parsedata)
    console.log("登录成功，开启定时器获取事务提醒");
    timeremailseralarms.start();
    timeremailseralarms.running = true;

}

//收到查询的用户信息，更新会话列表信息
function __callBack(userjson, flags) {

    console.log("会话列表查询个人消息接口返回数据:", userjson);  //gaobo wait
    //console.log("查询用户信息接口:");

    //console.log("__callBack_flags_", flags);
    if(flags ===  3) //群聊联系人
        return

    var  obj = eval('(' + userjson + ')');//eval gaobo
    var  img = obj.object.avatar;
    var  sex = obj.object.sex;

    //   console.log("__callBack_userjson_", obj.object.sex);

    if(flags === 2)
    {
        console.log("查询用户信息_flags == 2,为会话列表查询", obj.object.userName ,typeof obj.object.userName )
        //  console.log("_main_weindos_收到查询的用户信息_flags == 2_.userPrivName", obj.object.userPrivName,typeof obj.object.userPrivName )
        //  console.log("_main_weindos_收到查询的用户信息_flags == 2_.sex", obj.object.sex ,typeof obj.object.sex)
        //  console.log("_main_weindos_收到查询的用户信息_flags == 2_.mobilNo",obj.object.mobilNo ,typeof obj.object.mobilNo)
        //  console.log("_main_weindos_收到查询的用户信息_flags == 2.ico",obj.object.avatar  ,typeof obj.object.avatar)
        for(var i = 0; i < conversationModel.count; ++i)
        {


            if(obj.object == null)//
            {
                // console.log("kkk!==111222 ",img);
                //  conversationModel.setProperty(i, "iconImage", "qrc:/resource/images/main/maincenter/man.png")
                continue ;
            }

            if(conversationModel.get(i).strUserJid == obj.object.uid)
            {
                // console.log("__callBack",obj.object.userName,obj.object.sex, obj.object.mobilNo + "",obj.object.userPrivName)
                conversationModel.setProperty(i, "userName", obj.object.userName)

                if(img !== "0" && img !== "1" && img !== "" && img !== null)
                {

                    console.log("加载会话列表头像1:",img);
                    //img=img.substr(0,img.indexOf("."))+"s"+img.substr(img.indexOf("."));
                    //console.log("加载会话列表头像2:",img);
                    conversationModel.setProperty(i, "iconImage", strip +  "/img/user/"+img)
                }
                else
                {
                    //console.log("kkk!==22333333 ",sex);
                    conversationModel.setProperty(i, "iconImage", "qrc:/resource/images/main/maincenter/man.png")
                    if(sex === "0") //boy.png'
                    {
                        //console.log("kkk!==22 ",sex);
                        conversationModel.setProperty(i, "iconImage", "qrc:/resource/images/main/maincenter/man.png")
                    }
                    else if(sex === "1")//girl.png'
                    {
                        //console.log("kkk!==33 ",sex);
                        conversationModel.setProperty(i, "iconImage", "qrc:/resource/images/main/maincenter/woman.png")
                    }
                }

                conversationModel.setProperty(i, "mobileNo", obj.object.mobilNo)
                conversationModel.setProperty(i, "userSex", obj.object.sex)
                conversationModel.setProperty(i, "privName", obj.object.userPrivName)
                conversationModel.setProperty(i, "strStatus", obj.object.myStatus)
            }
            else
            {
                //   console.log("__callBack",conversationModel.get(i).strUserJid, typeof conversationModel.get(i).strUserJid, ":",obj.object.userPrivName ,typeof obj.object.userPrivName)
            }

        }

        //   console.log("obj.userName", obj.object.userName,"obj.userPrivName", obj.object.userPrivName, "obj.sex", obj.object.sex)
    }
    else   if(flags === 1)
    {
        console.log("查询用户信息_flags == 1,为会话列表查询", obj.object.userName ,typeof obj.object.userName )
        //  console.log("_main_weindos_收到查询的用户信息_flags == 1_.userPrivName", obj.object.userPrivName,typeof obj.object.userPrivName )
        //  console.log("_main_weindos_收到查询的用户信息_flags == 1_.sex", obj.object.sex ,typeof obj.object.sex)
        //  console.log("_main_weindos_收到查询的用户信息_flags == 1_.mobilNo",obj.object.mobilNo ,typeof obj.object.mobilNo)
        //  console.log("_main_weindos_收到查询的用户信息_flags == 1.ico",obj.object.avatar  ,typeof obj.object.avatar)

        for(var i2 = 0; i2 < conversationModel.count; ++i2)
        {
            if(obj.object == null)
            {
                continue ;
            }

            //    console.log("conversationModel.strJid_ 循环", conversationModel.get(i2).strUserJid,typeof  conversationModel.get(i2).strUserJid," : ", obj.object.uid, typeof obj.object.uid)

            if(conversationModel.get(i2).strUserJid ==  obj.object.uid)
            {
                // console.log("kkk",obj.object.userName,obj.object.sex, obj.object.mobilNo + "",obj.object.userPrivName)
                conversationModel.setProperty(i2, "userName", obj.object.userName)

                //  console.log("__callBack_userjson_", obj.object.sex);


                if( img !=="0" && img !=="1"  &&  img !== null && img !== "")
                {
                    console.log("个人头像地址 ",strip +  "/img/user/"+img);
                    //  console.log("kkk!== ",strip +  "/img/user/"+img);
                    conversationModel.setProperty(i2, "iconImage", strip +  "/img/user/"+img)
                }
                else  if(sex === "0") //boy.png'
                {
                    conversationModel.setProperty(i2, "iconImage", "qrc:/resource/images/main/maincenter/man.png")
                }
                else if(sex === "1")//girl.png'
                {
                    conversationModel.setProperty(i2, "iconImage", "qrc:/resource/images/main/maincenter/woman.png")
                }
                else
                {
                    conversationModel.setProperty(i2, "iconImage", "qrc:/resource/images/main/maincenter/man.png")
                    //console.log("kkkkkk",img);
                }

                conversationModel.setProperty(i2, "mobileNo", obj.object.mobilNo)
                conversationModel.setProperty(i2, "userSex", obj.object.sex)
                conversationModel.setProperty(i2, "privName", obj.object.userPrivName)
                conversationModel.setProperty(i2, "strStatus", obj.object.myStatus)

            }
        }

        // console.log("obj.userName", obj.object.userName,"obj.userPrivName", obj.object.userPrivName, "obj.sex", obj.object.sex)
    }
    else
    {
        console.log("个人查询接口返回错误", flags)
    }

}

//!删除会话列表回调
function deleteTalkListCallback(userjson)
{
    console.log(userjson);
}

//更新会话列表
function modifyConversationModel( chatText, chatTime, chatuserjid, chatType,mystauts,uuid)
{
    bkg.visible = false
    var showendbel  = false;
    var _bshow = false;
    console.log("会话列表添加一条",chatText, chatTime, chatuserjid, chatType);

    for(var i = 0; i < conversationModel.count; i++)
    {

        //    console.log("modifyConversationModel___",conversationModel.get(i).strUserJid , chatuserjid);
        if(conversationModel.get(i).strUserJid == chatuserjid)
        {
           console.log("会话列表已经存在的 chatuserjid: ", chatuserjid)

            //console.log("modifyConversationModel_chatText: strUserJid == chatuserjid", chatText)
            // console.log("modifyConversationModel_chatTime: ",  chatTime )
            // console.log("modifyConversationModel_chatuserjid: ", chatuserjid)
            // console.log("modifyConversationModel_chatType: ", chatType)
            // console.log("modifyConversationModel_strStatus: ", mystauts)
            // console.log("modifyConversationModel_uuid: ", uuid)
            // console.log("modifyConversationModel_chatText: ", conversationModel.get(i).strUserJid)

            if(!mainwindow.getChatObjVisible())
            {
                messageCount += 1;
                conversationModel.setProperty(i, "msgCount", messageCount)
            }

            if(typeof chatuserjid == "Number" )
            {
                chatuserjid = chatuserjid.toString();
            }


            conversationModel.setProperty(i, "strUserJid", chatuserjid.toString())
            conversationModel.setProperty(i, "userText", chatText)
            conversationModel.setProperty(i, "strUserType", chatType.toString())
            conversationModel.setProperty(i, "userTime", formatDate(chatTime))
            conversationModel.setProperty(i, "strStatus", mystauts)
            //conversationModel.setProperty(i, "strStatus", mystauts)

            _bshow = true;

            //2018-11-14修改。修改实时消息过来时将会话列表中的群名修改成实时消息中的groupname字段群名
            /*
            if(typeof chatuserjid =="string" )
            {
                if(chatuserjid.indexOf("@gsrooms")>-1)
                {
                    conversationModel.setProperty(i, "userName", mystauts) //gaobo 打开
                    console.log("实时消息群里修改名 userName: ", mystauts)
                }
            }*/


            conversationListview.update();
            if(i!=0)
               conversationModel.move(i,0,1);

            douyin.push(chatuserjid.toString())

            //console.log(" douyin.push", chatuserjid.toString());
            return;
        }

    }

    var strURL= strip + "/user/findUserByuid?uid=" + chatuserjid
    // console.log("输出《《《《:",strURL)

    /*if(chatuserjid.indexOf("@gsrooms")>-1)原来代码
if(chatText.indexOf("@gsrooms")>-1)//新改
{*/
    if(typeof chatuserjid =="string" )
    {
        console.log("新来群聊（会话列表中没有）")
        if(chatuserjid.indexOf("@gsrooms")>-1)
        {
            insertData("qrc:/resource/images/im/45.png", mystauts, chatText, chatTime, chatuserjid, chatType,"","","1","qrc:/resource/images/im/45.png","");
        }
        else
        {
            insertData("qrc:/resource/images/main/maintop/manhead.png", mystauts, chatText, chatTime, chatuserjid.toString(), chatType,"","","0","qrc:/resource/images/main/maintop/manhead.png","");
        }
    }
    else
    {
        console.log("新来单聊（会话列表中没有）")
        insertData("qrc:/resource/images/main/maintop/manhead.png", mystauts, chatText, chatTime, chatuserjid.toString(), chatType,"","","0","qrc:/resource/images/main/maintop/manhead.png","");
    }
    /*}
else
{
    if(typeof chatuserjid =="string" )
    {
         console.log("群聊")
        insertData("qrc:/resource/images/im/45.png", mystauts, chatText, chatTime, chatuserjid, chatType,"","","1","qrc:/resource/images/im/45.png","");
    }
    else
    {
        console.log("单聊")
        insertData("qrc:/resource/images/im/45.png", mystauts, chatText, chatTime, chatuserjid.toString(), chatType,"","","0","qrc:/resource/images/im/45.png","");
    }
}*/


    //  if(!mainwindow.getChatObjVisible())
    //  {        //    }
    messageCount += 1;
    //  console.log("第三处消息，，",messageCount)
    conversationModel.setProperty(i, "msgCount", messageCount)
    chatGetUserInfo.getUserInfo(mainwindow.jsessionid, strURL, 2);
}

function setGroupName(roomid,name)
{
    // console.log("setGroupName__",roomid);
    // console.log("setGroupName__",name);

    for(var i = 0; i < conversationModel.count; ++i)
    {
        // console.log("setGroupName_strUserJid_",conversationModel.get(i).strUserJid);
        // console.log("setGroupName_strUserName_",conversationModel.get(i).userName);
        // console.log("setGroupName_privName_",conversationModel.get(i).privName);
        // console.log("");
        if(conversationModel.get(i).strUserJid == roomid)
        {
            conversationModel.setProperty(i, "userName", name)
            // conversationListview.update();
            conversationModel.move(i,0,1);
            conversationListview.update();

            return;
        }
    }
}

function _appendGroudMsg(name, nike)
{

    console.log("------------_appendGroudMsg  群消息",name, nike);
    var group = nike.split("/");
    var groupid =group[0]; //群的id
    var personid =group[1]; //个人id
    var sendpersonid =group[2]; //发送人id
    var msgUuid =group[4]; //消息id
    var _bGreb = false;
    //var strsendmsg =  name.replace(/\n/g,"") //gaobo
    var strsendmsg = name.replace(/\n/g,"\\\\n").replace(/\r/g,"\\\\r");


    /* if(sendpersonid.indexOf("pq")<0)
        {
            sendpersonid = _Maincompanyoid +"pq"+sendpersonid+"@gsubo";
        }

        if(personid.indexOf("@")<0)
        {
            personid = personid +"@gsubo";
        }*/
    //console.log("群消息",strsendmsg, nike);

    //gaobo 2019-11-13  去掉
    //if(sendpersonid === personid)
      //  return;


    //console.log("_appendGroudMsg_nike:",sendpersonid);
    //console.log("_appendGroudMsg_nike:",personid);

    // console.log("_appendGroudMsg_nike:",nike,name,chatviewobj.length ,personid,sendpersonid,_Maincompanyoid+"pq"+ userjid)

    // console.log("_appendGroudMsg_groupid:群的id",groupid)
    //  console.log("_appendGroudMsg_personid:个人id",personid)

    // console.log("_appendGroudMsg_name:",name)
    // var component = Qt.createComponent("../chat/ChatView.qml");
    //console.log("群消息",strsendmsg, nike);
    var obj =eval("("+strsendmsg+")");//eval gaobo
    //console.log("群消息",strsendmsg, nike);

    var groupdata  = obj.data;
    //console.log("_appendGroudMsg_数据:",groupdata)
    var grouptime = obj.send_time;
    // console.log("_appendGroudMsg_时间:",grouptime)
    var groupname = obj.groupname;
    // console.log("_appendGroudMsg_时间:",groupname)
    var type =obj.type;
    // console.log("_appendGroudMsg_类型:",type,conversationModel.count)


    for(var i = 0; i < chatviewobj.length; ++i)
    {
        console.log("_appendGroudMsg_时间:",chatviewobj[i].jid,groupid)
        if(chatviewobj[i].jid === groupid)
        {
            _bGreb=true;
            console.log("_appendGroudMsg,窗口显示一条群消息");
            chatviewobj[i].appendReceiveData(nike+"@@!!@@**@@"+strsendmsg, 1, "");
            return;
        }
    }
    //obj1.data, obj1.send_time, chatuserjid, obj1.type,"",obj1.uuid
    //  modifyConversationModel(groupdata,grouptime,personid,type,msgUuid);

    /* gaobo 2019-11-13去掉
    if((typeof groupdata == "string"))
    {
        if(groupdata.indexOf("邀请")>0 && groupdata.indexOf("加入群聊")>0 )
        {
            if(groupdata.length>16)
                groupdata = groupdata.substring(2,12)
            else
                groupdata = groupdata.substring(2,groupdata.length-4)
        }
    }*/



    //  console.log("_appendGroudMsg_类型:",groupdata.length)
    /*
    for(var len = 0; len < conversationModel.count; ++len)
    {

        if(conversationModel.get(len).strUserJid == groupid)
        {
            if(!mainwindow.getChatObjVisible())
            {
                messageCount += 1;
                //    console.log("msgCount:",messageCount);
                conversationModel.setProperty(len, "msgCount", messageCount)
            }

            conversationModel.setProperty(len, "userText", groupdata)
            conversationModel.setProperty(len, "strUserType", type)
            conversationModel.setProperty(len, "userTime", formatDate(grouptime))
            conversationModel.setProperty(len, "userName", groupname)
            conversationModel.setProperty(len, "msgtype", "1")
            conversationModel.move(len,0,1);
            conversationListview.update();
        }
        else
        {
            //conversationModel.append()
            appendData("qrc:/resource/images/im/45.png",groupname,groupdata,formatDate(grouptime), groupid,"1","","","1","qrc:/resource/images/im/45.png","")  //马大哈把 nike 写成 "nike"
            // appendData("qrc:/resource/images/im/45.png",name,nike, groupnumbername, nike,"1","","","1","qrc:/resource/images/im/45.png","")
            conversationListview.update();
            conversationModel.move(conversationModel.count-1,0,1);
        }
    }
*/

    // console.log("1·");

    if(_bGreb)
    {

        //   console.log("2·");
    }
    else
    {
        //  console.log("3·");
        if(mainwindow.getChatObjVisible(groupid))
        {
            //     console.log("4·");
            console.log("聊天窗口已显示");
        }
        else
        {
            // console.log("5·");
            // if(dataMap.isEmpty())
            // {
            //     console.log("6·");
            //     dataMap.put("'" + userJid + "'", "1");
            // }
            // else
            // {
            //     console.log("7·");
            //     if(dataMap.containsKey("'" + userJid + "'"))
            //     {
            //         console.log("8·");
            //         var data = dataMap.get("'" + userJid + "'" );
            //
            //         dataMap.remove("'" + userJid + "'")
            //
            //         var data1 = Number(data) + 1;
            //
            //         dataMap.put("'" + userJid + "'" ,  data1.toString() )
            //     }
            //     else
            //     {
            //         console.log("9·");
            //         dataMap.put("'" + userJid + "'", "1")
            //     }
            //
            //     console.log("10·");
            // }

            // console.log("mmm2",nike.split("/")[0], userJid, dataMap.get("'" + userJid + "'"))
            // console.log("112·",nike.split("/")[0],dataMap.get("'" + userJid + "'"));
            // chattooltip.modifyData(nike.split("/")[0], dataMap.get("'" + userJid + "'"));
            // mainwindow.modifyUserInfo(nike.split("/")[0], dataMap.get("'" + userJid + "'"))
            // _msgtimer.running = true;
        }

    }
}
function _cteatopGroudObj(strStartTime,nike, name,groupnumbername)
{
    // console.log("创建群参数：",strStartTime)
    //console.log("创建群参数：",nike)
    console.log("创建群参数：",strStartTime,nike, name,groupnumbername)
    // console.log("创建群参数：",groupnumbername)
    var requestString =strip+ "/im/insertRoom?&name="+name +"&set_uid="+userjid+ "&set_of="+window.companyoid+"pq"+userjid+"@gsubo"+"&member_uid="+strStartTime+userjid+","+"&stime="+groupnumbername+"&room_of="+nike;
    // console.log("============================",requestString,jsessionid) //
    //im/insertRoom   参数: name (房间名称)  set_uid  (创建人uid) set_of  (创建人openfireid) member_uid  (房间成员uid串，用逗号分隔) stime 创建时间) room_of (房间openfireid)

    //creatGroupObj(jid,"","",objJson.qroom,objJson.qroom,true,"","http://192.168.0.18/img/im/groupchat.png","","");
    /* username:群组名称（不为空）
         userprivname：群成员名称(空)
         usersex：性别（空）
         jid：聊天对象jid（openfire房间号）（不为空）
         usermobileno：用户手机号（空）
         bshow：是否显示（true）
         strStaus：字符状态(空)
         ImgSoure：http://192.168.0.18/img/im/groupchat.png
         creatObj： （空）
         groudmsglist：（空）*/
    //creatGroupObj(name,"","",nike,"",true,"","qrc:/resource/images/im/45.png","","");
    appendData("qrc:/resource/images/im/45.png",name,nike, groupnumbername, nike,"1","","","1","qrc:/resource/images/im/45.png","")
    //_appendGroudMsg(nike,"");
    webRun._slot_request(requestString,jsessionid);
}


function _cteatGroudObj( nike,name,jid,groupname)
{
    //  console.log("_cteatGroudObj_nike:",nike,name)
    if(jid==="")
    {
        var group = nike.split("/");
        var groupid =group[0]; //群的id
        var personid =group[1]; //个人id
        var sendpersonid =group[2]; //发送人id
        var msgUuid =group[4]; //消息id
        var _bGreb = false;


        //  console.log("_cteatGroudObj_groupid:群的id",groupid)
        //  console.log("_cteatGroudObj_personid:个人id",personid)

        // console.log("_cteatGroudObj_name:",name)
        // var component = Qt.createComponent("../chat/ChatView.qml");

        var obj = eval('(' + name + ')');//eval
        var groupdata  = obj.data;
        //  console.log("_cteatGroudObj_数据:",groupdata)
        var grouptime = obj.send_time;
        //    console.log("_cteatGroudObj_时间:",grouptime)
        var type =obj.type;
        //    console.log("_cteatGroudObj_类型:",type)

        //   if(groupdata.indexOf("邀请")>0 && groupdata.indexOf("加入群聊")>0 )
        //   {
        //       if(groupdata.length>16)
        //           groupdata = groupdata.substring(2,12)
        //       else
        //           groupdata = groupdata.substring(2,groupdata.length-4)
        //   }


        //console.log("_cteatGroudObj_类型:",groupdata.length)
        // appendData("", obj[i].toUserName, obj[i].content, obj[i].time, obj[i].to_uid, obj[i].type,obj[i].list_id,obj[i].myStatus,obj[i].msg_type, strip+ obj[i].photo,obj[i].groupMessage );
        appendData("qrc:/resource/images/main/maintop/manhead.png",groupdata,groupdata, grouptime, groupid,type,"","","1","qrc:/resource/images/im/45.png","")
    }
    else
    {
        //    console.log(nike,"name----",name,"jid-----",jid);
        /*nike---
              */
        var objJson = eval('('+ name + ')');//eval
        //console.log("qname--------------",objJson.qname);//群组名称
        //console.log("uid--------------",objJson.quid);//群组成员uid(用，分开的)
        //console.log("quname",objJson.quname);//群组成员名字(用，分开的)

        var _suuid =Query.uuid()

        //console.log("qroom--------",objJson.qroom);
        //console.log("qtime-----",objJson.qtime);

        //  var strpostdata = "{name:\""+jid+"\",set_uid:\""+ userId +"\",set_of:\""+ userId+"\",\member_uid:\""+name+"\",stime:\"\",room_of:\""+nike+"\"}"
        //Query.postRequsetseverurl(strip+ "/im/insertRoom",strpostdata,postseverCreateGroupCallback,postseverCreateGroupCallbackError)
        // console.log("requestString----------------",strip+ "/im/insertRoom?&name="+jid +"&set_uid="+userjid+ "&set_of="+window.companyoid+"pq"+userjid+"&member_uid="+userId+"&stime="+stime+"&room_of="+name)
        // var requestString =strip+ "/im/insertRoom?&name="+jid +"&set_uid="+userjid+ "&set_of="+window.companyoid+"pq"+userjid+"&member_uid="+_createroomuserid+userjid+"&stime="+stime+"&room_of="+name;
        // console.log("============================",requestString,jsessionid)
        //im/insertRoom   参数: name (房间名称)  set_uid  (创建人uid) set_of  (创建人openfireid) member_uid  (房间成员uid串，用逗号分隔) stime 创建时间) room_of (房间openfireid)
        //  webRun._slot_request(requestString,jsessionid);
        //var strtime = new Date().toString() ;
        //  var strRoomjid = strtime +"@gsrooms.gsubo"
        //console.log("创建群房间号是：",strRoomjid)
        // talkRoomIntface.CreateGroupRoom(objJson.qname,objJson.quid,objJson.quname,oneselfName);
        //  creatGroupObj(jid,"","",objJson.qroom,objJson.qroom,true,"","http://192.168.0.18/img/im/groupchat.png","","");
        /* username:群组名称（不为空）
             userprivname：群成员名称(空)
             usersex：性别（空）
             jid：聊天对象jid（openfire房间号）（不为空）
             usermobileno：用户手机号（空）
             bshow：是否显示（true）
             strStaus：字符状态(空)
             ImgSoure：http://192.168.0.18/img/im/groupchat.png
             creatObj： （空）
             groudmsglist：（空）*/

        //  appendData("qrc:/resource/images/main/maintop/manhead.png",jid,"", objJson.qtime, objJson.qroom,type,"","","1","qrc:/resource/images/im/45.png","")
        if(objJson.qname=="")
        {
            talkRoomIntface.CreateGroupRoom(objJson.quname,objJson.quid,objJson.quname,oneselfName,_suuid);
        }
        else
        {
            talkRoomIntface.CreateGroupRoom(objJson.qname,objJson.quid,objJson.quname,oneselfName,_suuid);
        }


        // appendData("qrc:/resource/images/main/maintop/manhead.png",jid,"", objJson.qtime, objJson.qroom,type,"","","1","qrc:/resource/images/im/45.png","")
        //   talkRoomIntface.CreateGroupRoom(objJson.quname,objJson.quid,objJson.quname,oneselfName,_suuid);


        // appendData("qrc:/resource/images/main/maintop/manhead.png",jid,"", objJson.qtime, objJson.qroom,type,"","","1","qrc:/resource/images/im/45.png","")


    }
}
//消息回执函数
function callbackmsg(jid,msg)
{
    var stm = (msg);

    //       messageUUidlist.push(stm)

    for(var i = 0; i < chatviewobj.length; ++i)
    {
        if(chatviewobj[i].jid === jid)
        {
            chatviewobj[i].insetCallbcklist(msg);
        }
    }
}

Timer {
    id: alreadReadtimer;
    interval: 300;//设置定时器时间
    repeat: true //是否重复定时,默认为false
    running: true //是否开启定时，默认是false
    triggeredOnStart: true // 是否开启定时就触发onTriggered

    onTriggered:
    {
        if(isAlreadyRead)
        {
            isAlreadyRead = false;
            addroommsgInit()
            alreadReadtimer.stop();
            //  console.log("Timer  qunMessage.push  onTriggered:",isAlreadyRead);

            //loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);

        }
        else{
            //     isAlreadyRead = true;
            //  alreadReadtimer.start();
            //console.log("Timer  qunMessage.push  onTriggered:",isAlreadyRead);

            //    loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);
            //     alreadReadtimer.start();

            //  addroom()
        }
    }

}
Timer {
    id: imAgainlogin;
    interval: 60000;//设置IM重连定时器时间
    repeat: true //是否重复定时,默认为false
    running: false //是否开启定时，默认是false
    triggeredOnStart: true // 是否开启定时就触发onTriggered

    onTriggered:
    {

        if(imReloginCount%2==0)
        {
            console.log("定时器执行，重新登录IM服务器",userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
            // register.registerToServer(userjid, "123456", "gsubo",strImIp, strImPort, window.companyoid)
            loginServer.loginSeverfunction(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);
            mainbottomoperating.addReconnectionNum();
        }

        imReloginCount++;
    }

}
//2018-11-20添加点击闪烁图标
function cleartopseralarms()
{
    maintopoperating.cleartopseralarms()
}
function imLoginSucess(msg)
{

    console.log("imLoginSucess___",msg)

    if(msg === "即时通讯服务连接失败")
    {
        //alreadReadtimer.start();
        //loginServer.loginSever(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);
        isAlreadyRead = false;
        if(!imAgainlogin.running)
        {
            console.log("im掉线，开启定时器重新登录服务器")
            imAgainlogin.start();
        }
        else
        {
            console.log("im掉线，但定时器进行中")
        }
    }
    else
    {

        //isAlreadyRead = true;

        alreadReadtimer.start();
        //alreadReadtimer.start();
        // addroom()
        // isAlreadyRead = true;

        console.log("im成功，关闭重新登录服务器定时器")
        imAgainlogin.stop();


    }
}

//! 初始化群聊响应
function addroommsgInit()
{
    return;
    // talkRoomIntface._bAddGroudRoom("0000000000000@gsrooms.gsubo",_Maincompanyoid+"pq"+userjid+"@gsubo");//!为了启动监听
    // console.log("群信息quanbu:addroom",_Maincompanyoid+"pq"+userjid+"@gsubo");

    for(var len=0;len <qunMessage.length;len++ )
    {

        // console.log("群信息quanbu:",qunMessage.length, qunMessage[len]);
        var jid  =  qunMessage[len].split("**")[0];
        var user  =  qunMessage[len].split("**")[1];
        var username  =  qunMessage[len].split("**")[2];

        console.log("初始化群聊响应，群信息:",jid,user,username);
        talkRoomIntface._bAddGroudRoom(jid,username);
        //talkRoomIntface._vWriteGroudMsg(username,jid)

    }
}


function addRoomgroup(p3,p2,p1)
{


    console.log("addRoomgroup 增加或删除人员接口");
    console.log("进入房间p1",p1);
    console.log("进入房间p2",p2);
    console.log("进入房间p3",p3);

    if(p3.indexOf("quaddname")>-1)  //增加或删除人员接口
    {
        //  console.log("quaddname","-----------------------------------",p3);

        var objJson = eval('('+ p3 + ')');//eval
        setGroupName(objJson.room_id,objJson.qname);
        var _suuid = Query.uuid()
        talkRoomIntface._vAddGroudUser(objJson.quadd,objJson.quaddname,objJson.room_id,objJson.qname,oneselfName,_suuid);
        talkRoomIntface._vDelGroudUser(objJson.qudelete,objJson.qudeletename,objJson.room_id,objJson.qname,oneselfName,_suuid);

        webRun._slot_request(strip+ "/im/updateRoomName?&room_name="+objJson.qname+"&room_id="+ objJson.room_id,mainwindow.jsessionid);
    }
    else if(p3.indexOf("clickRoomNameWeb")>-1)  //修改群名接口
    {
        var objJson = eval('('+ p3 + ')');//eval
        if(getObjIsCreate(objJson.room_id))
        {
            showObj(objJson.room_id,objJson.qname);
        }
        else
        {
            //待添加表里没有的群
            // _cteatGroudObj(p1,p3,objJson.qname);
            creatGroupObj(objJson.rname,"","",objJson.room_id,"",true,"","qrc:/resource/images/im/45.png","","");
            appendData("qrc:/resource/images/im/45.png",objJson.rname,"", "", userjid,"1","","","1","qrc:/resource/images/im/45.png","")
        }
    }
    else if(p3.indexOf("recoverRoom")>-1) //恢复群接口
    {
        //{\"recoverRoom\":1,\"room_id\":\"1527761564975@gsrooms.gsubo\",\"rname\":\"李华、王丽\"}"
    }
    else if(p3.indexOf("dismissRoom")>-1)  //解散群接口
    {
        //"{\"dismissRoom\":1,\"room_id\":\"1527821183230@gsrooms.gsubo\",\"rname\":\"金黎平、王海\"}"
    }
    else   //新建群接口
    {
        // //if(p1=="1")
        // {
        //     talkRoomIntface._bAddGroudRoom{"qname":"任天涯654321 ","quid":"251,"};
        // }

        if(p1 == "ADD_GROUPUSER_LIST")return;  //群增加人员
        var objJson = eval('('+ p3 + ')');//eval
        console.log("name--------------",objJson.qname);

        // console.log("uid--------------",objJson.quid);
        if(objJson.qname=="")
        {
            _createroomuserid = objJson.quid;
            _cteatGroudObj(p1,p3,objJson.quname);
        }
        else
        {
            _createroomuserid = objJson.quid;
            _cteatGroudObj(p1,p3,objJson.qname);
        }

    }

    /* if( talkRoomIntface._bAddGroudRoom("",objJson.quid,objJson.qname))
     {
           console.log("AddGroudRoom--------------suessed",objJson.quid);
           username:群组名称（不为空）
           userprivname：群成员名称(空)
           usersex：性别（空）
           jid：聊天对象jid（openfire房间号）（不为空）
           usermobileno：用户手机号（空）
           bshow：是否显示（true）
           strStaus：字符状态(空)
           ImgSoure：http://192.168.0.18/img/im/groupchat.png
           creatObj： （空）
           groudmsglist：（空）


     }
     else
     {
      console.log("AddGroudRoom--------------fail",objJson.quid);
     }   */
    /*
          *
          * 创建作者:   杨 胜
          * 创建日期:   2017-5-22 上午10:41:07
          * 方法介绍:   创建房间
          * 参数说明:   @param name         房间名称
          * 参数说明:   @param set_uid      创建人uid
          * 参数说明:   @param set_of       创建人openfireid
          * 参数说明:   @param member_uid   房间成员uid串，用逗号分隔
          * 参数说明:   @param stime        创建时间
          * 参数说明:   @param room_of      房间openfireid
          * 参数说明:   @return
          * @return     Status  返回状态
          */

    /*var  name       = "1111";
       var  set_uid    = "192";
       var  set_of     = "luweihua@gsroom";
       var  member_uid = "192";
       var  stime      = "1521956578";
       var  room_of    = "luweihua@gsroom";*/

    //console.log("进入：",strip+ "/im/insertRoom?&name="+name +"&set_uid="+set_uid+ "&set_of="+set_of+"&member_uid="+member_uid+"&stime="+stime+"&room_of="+room_of,jessonid)
    var  name       = "";
    var  set_uid    = "";
    var  set_of     = "";
    var  member_uid = "";
    var  stime      = "";
    var  room_of    = "";
    // console.log("出来：",strip+ "/im/insertRoom?&name="+name +"&set_uid="+set_uid+ "&set_of="+set_of+"&member_uid="+member_uid+"&stime="+stime+"&room_of="+room_of,jessonid)
    /*   var requestString =strip+ "/im/insertRoom?&name="+name +"&set_uid="+set_uid+ "&set_of="+set_of+"&member_uid="+member_uid+"&stime="+stime+"&room_of="+room_of;
        console.log(requestString,jsessionid) //  /im/insertRoom   参数: name (房间名称)  set_uid  (创建人uid) set_of  (创建人openfireid) member_uid  (房间成员uid串，用逗号分隔) stime 创建时间) room_of (房间openfireid)
        webRun._slot_request(requestString,jsessionid);*/
}

function deleteRoom(roomid,name) //   /im/getOutPerson   参数: room_id
{
    // console.log("删除群:",strip+ "/im/getOutPerson?&room_id="+ groupId+"&opt=1",jessonid) //  /im/getOutPerson   参数: room_id    opt=1
    webRun._slot_request(strip+ "/im/getOutPerson?&room_id="+ groupId+"&opt=1",jessonid);
}


//!请求事务数量
function quest()
{
    //console.log("quest");
    //Query.query(strip, userjid, jsessionid,parsedata)
}
function isJSON(str) {
    if (typeof str == 'string') {
        try {
            var obj=JSON.parse(str);
            if(typeof obj == 'object' && obj ){
                return true;
            }else{
                return false;
            }

        } catch(e) {
            console.log('error：'+str+'!!!'+e);
            return false;
        }
    }
    console.log('It is not a string!')
}
function imDomainResolutionSeussed(value)
{
    // console.log(value);
    strImIp = value
    // console.log(userjid, "123456", "gsubo", strImIp, strImPort,  window.companyoid);


}

}

