﻿import QtQuick 2.2
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.4
//import WebIEPlatform 1.0
import FileIo 1.0
import QtQuick.Window 2.2
import QtQuick.Dialogs 1.0
import Qt.labs.platform 1.1

Item {

    property string usersavepath: "" //文件保存路径


    function selfdomView_transfer()
    {
        seldommaintext.text = qsTr("主界面" );
        loginsavebtn.text = qsTr("保存");
        logincancelbtn.text = qsTr("取消");
    }

    Component.onCompleted:
    {
        if(fileio.readIniFile("IM","newmsgMode") != "true")
        {
            newmsgdialogModecheckbox.checked = false
            // fileio.writeIniFile("IM","newmsgMode","true");
        }
        else
        {
            newmsgdialogModecheckbox.checked = true
            //fileio.writeIniFile("IM","newmsgMode","false");
        }

        if(fileio.readIniFile("Seralarms","newSeralarmsMode") != "false")
        {
            newSeralarmsModecheckbox.checked = true
            //fileio.writeIniFile("Seralarms","newSeralarmsMode","true");
        }
        else
        {
            newSeralarmsModecheckbox.checked = false
            // fileio.writeIniFile("Seralarms","newSeralarmsMode","false");
        }

        if(fileio.readIniFile("IM","newmsgSound") != "false")
        {
            newmsgSoundcheckbox.checked = true
            //fileio.writeIniFile("IM","newSeralarmsMode","true");
        }
        else
        {
            newmsgSoundcheckbox.checked = false
            // fileio.writeIniFile("IM","newSeralarmsMode","false");
        }

        translator.languageChanged.connect(selfdomView_transfer)
        //translator.languageChanged.connect(selfdomView_transfer)
    }
    FileIo {
        id: fileio

    }
    /*
    WebIEPlatform
    {
        id:iewebrun
    }*/

    Text {
        id: websettext
        width: 48
        height: 26
        anchors.bottom:newSeralarmsModecheckbox.top
        anchors.bottomMargin: 25
        anchors.left: parent.left
        anchors.leftMargin: 40

        font.pixelSize: 15
        font.family: "微软雅黑"
        //font.bold: true
        color: "#1874CD"
        verticalAlignment: Qt.AlignVCenter
        //Sources: "qrc:/resource/images/login/persionicon.png"
        text: qsTr("个性设置")
    }
    Image {
        id: websettexticon
        width: 22
        height: 22
        source: "qrc:/resource/images/login/persionicon.png"
        anchors.bottom:websettext.bottom
        anchors.bottomMargin: 5
        anchors.right:  websettext.left
        anchors.leftMargin: 5
        visible: true

    }


/*

    CheckBox {
        id: useiewenmodecheckbox
        width: 23
        height: 23
        anchors.left: parent.left
        anchors.leftMargin: 60
        anchors.top: parent.top
        anchors.topMargin: 60//45

        //  exclusiveGroup: exclusive
        style: CheckBoxStyle {

            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16

                Image {
                    id: autonormal1
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: autochecked1
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
            }
        }
        onClicked: {
            //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
            if(useiewenmodecheckbox.checked)
            {
                userieSilentModecheckbox.enabled = true
                if(fileio.readIniFile("Iemodeconfig", "ieSilentMode") != "false")
                {
                    //iEweb.setopenIemode(true);

                    userieSilentModecheckbox.checked = false
                    // useiewenmodecheckbox.checkedState = true;
                }
                else
                {

                    userieSilentModecheckbox.checked = true
                    //useiewenmodecheckbox.checkedState = true;
                    //iEweb.setopenIemode(false);
                }
            }
            else
            {
                userieSilentModecheckbox.checked = false
                userieSilentModecheckbox.enabled = false
            }
        }
    }

    Rectangle {
        id:rectback
        width: 320
        height: 60
        anchors.left: useiewenmodecheckbox.left
        anchors.leftMargin: 30
        anchors.top:parent.top
        anchors.topMargin:45//30
        // radius: 3
        border.color: "#dbdbdb"
        border.width: 0
        //visible: false

        Rectangle{
            id: outnetnamebkg
            width: 318
            height: 58
            color: "#ffffff"
            anchors.top: rectback.top
            anchors.topMargin: 1
            anchors.left: rectback.left
            anchors.leftMargin: 1
            Text {
                id: outnetname
                // anchors.centerIn: outnetnamebkg

                anchors.verticalCenter: outnetnamebkg.verticalCenter
                font.pixelSize: 14
                color: "#999999"
                font.family: "微软雅黑"
                //wrapMode: Text.WordWrap
                text:qsTr("默认使用内置浏览器打开页面")

            }
        }

        Component.onCompleted:
        {
            if(fileio.readIniFile("Iemodeconfig", "openwebmode") != "false")
            {
                //iEweb.setopenIemode(true);
                // console.log("进入设置界面。设置IE使用页面1")
                useiewenmodecheckbox.checked = true
                // useiewenmodecheckbox.checkedState = true;
            }
            else
            {
                //  console.log("进入设置界面。设置IE使用页面2")
                useiewenmodecheckbox.checked = true
                //useiewenmodecheckbox.checkedState = true;
                //iEweb.setopenIemode(false);
            }
            if(fileio.readIniFile("Iemodeconfig", "ieSilentMode") != "false")
            {
                //iEweb.setopenIemode(true);

                userieSilentModecheckbox.checked = false
                // useiewenmodecheckbox.checkedState = true;
            }
            else
            {

                userieSilentModecheckbox.checked = true
                //useiewenmodecheckbox.checkedState = true;
                //iEweb.setopenIemode(false);
            }
            translator.languageChanged.connect(selfdomView_transfer)
            //translator.languageChanged.connect(selfdomView_transfer)
        }
    }
    CheckBox {
        id: userieSilentModecheckbox
        width: 23
        height: 23
        anchors.left: parent.left
        anchors.leftMargin: 60
        anchors.top: useiewenmodecheckbox.bottom
        anchors.topMargin: 50
        checked:true
        // exclusiveGroup: exclusive
        style: CheckBoxStyle {
            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: userieSilentModeautonormal1
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: userieSilentModeautochecked1
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
            }
        }
        onClicked: {
            //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
        }
    }

    Rectangle {
        id:userieSilentModerectback
        width: 320
        height: 20
        anchors.left: userieSilentModecheckbox.left
        anchors.leftMargin: 30
        anchors.top:rectback.bottom
        anchors.topMargin:30
        radius: 3
        border.color: "#dbdbdb"
        border.width: 0
        //visible: false
        Rectangle{
            id: userieSilentModeoutnetnamebkg
            width: 318
            height: 18
            color: "#ffffff"
            anchors.top: userieSilentModerectback.top
            anchors.topMargin: 1
            anchors.left: userieSilentModerectback.left
            anchors.leftMargin: 1
            Text {
                id: userieSilentModeoutnetname
                // anchors.centerIn: userieSilentModeoutnetnamebkg.left
                anchors.verticalCenter: userieSilentModeoutnetnamebkg.verticalCenter
                font.pixelSize: 14
                color: "#999999"
                font.family: "微软雅黑"
                //wrapMode: Text.WordWrap
                text:qsTr("如需加载IE浏览器时，采用非静默模式(可以自动安装IE插件)")

            }
        }

        Component.onCompleted:
        {
            if(fileio.readIniFile("Iemodeconfig", "ieSilentMode") != "false")
            {
                //iEweb.setopenIemode(true);
                // console.log("进入设置界面。设置IE使用页面1")
                userieSilentModecheckbox.checked = false
                // useiewenmodecheckbox.checkedState = true;
            }
            else
            {
                // console.log("进入设置界面。设置IE使用页面2")
                userieSilentModecheckbox.checked = true
                //useiewenmodecheckbox.checkedState = true;
                //iEweb.setopenIemode(false);
            }


            if(fileio.readIniFile("Iemodeconfig", "ieSilentMode") != "false")
            {
                //iEweb.setopenIemode(true);
                //  console.log("进入设置界面。设置IE使用页面1")
                userieSilentModecheckbox.checked = false
                // useiewenmodecheckbox.checkedState = true;
            }
            else
            {
                //  console.log("进入设置界面。设置IE使用页面2")
                userieSilentModecheckbox.checked = true
                //useiewenmodecheckbox.checkedState = true;
                //iEweb.setopenIemode(false);
            }
            translator.languageChanged.connect(selfdomView_transfer)
            //translator.languageChanged.connect(selfdomView_transfer)
        }
    }
*/


    CheckBox {
        id: newSeralarmsModecheckbox//
        width: 23
        height: 23
        anchors.left: parent.left
        anchors.leftMargin: 60

        anchors.top: parent.top //userieSilentModecheckbox.bottom
        anchors.topMargin: 60
        // exclusiveGroup: exclusive
        style: CheckBoxStyle {
            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: newmsgdialogModeautonormal1
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: newmsgdialogModeautochecked1
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
            }
        }
        onClicked: {
            //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
        }
    }

    Rectangle {
        id:newmsgdialogModerectback
        width: 320
        height: 20
        anchors.left: newmsgdialogModecheckbox.left
        anchors.leftMargin: 30
        anchors.top:parent.top
        anchors.topMargin:60
        radius: 3
        border.color: "#dbdbdb"
        border.width: 0
        //visible: false
        Rectangle{
            id: newmsgdialogModeoutnetnamebkg
            width: 318
            height: 18
            color: "#ffffff"

            anchors.topMargin: 1

            anchors.leftMargin: 1
            Text {
                id: newmsgdialogModeoutnetname
                // anchors.centerIn: userieSilentModeoutnetnamebkg.left

                font.pixelSize: 14
                color: "#333333"
                font.family: "微软雅黑"
                //wrapMode: Text.WordWrap
                text:qsTr("收到事务提醒消息时自动弹出消息提示窗")

            }
        }


        Component.onCompleted:
        {
        }
    }
    CheckBox {
        id: newmsgdialogModecheckbox//
        width: 23
        height: 23
        anchors.left: parent.left
        anchors.leftMargin: 60
        anchors.top: newSeralarmsModecheckbox.bottom
        anchors.topMargin: 50
        // exclusiveGroup: exclusive
        style: CheckBoxStyle {
            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: newSeralarmsModeautonormal1
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: newSeralarmsModeautochecked1
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
            }
        }
        onClicked: {

            //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
        }
    }


    Rectangle {
        id:newSeralarmsModerectback
        width: 320
        height: 20
        anchors.left: newSeralarmsModecheckbox.left
        anchors.leftMargin: 30
        anchors.top:newmsgdialogModerectback.bottom
        anchors.topMargin:53
        radius: 3
        border.color: "#dbdbdb"
        border.width: 0
        //visible: false
        Rectangle{
            id: newSeralarmsModeoutnetnamebkg
            width: 318
            height: 18
            color: "#ffffff"

            anchors.topMargin: 1

            anchors.leftMargin: 1
            Text {
                id: newSeralarmsModeoutnetname
                // anchors.centerIn: userieSilentModeoutnetnamebkg.left

                font.pixelSize: 14
                color: "#333333"
                font.family: "微软雅黑"
                //wrapMode: Text.WordWrap
                text:qsTr("收到聊天消息时自动弹出消息提示窗")//收到聊天提醒消息时自动弹出消息提示窗

            }
        }

        Component.onCompleted:
        {
        }
    }

    CheckBox {
        id: newmsgSoundcheckbox//消息提示音
        width: 23
        height: 23
        anchors.left: parent.left
        anchors.leftMargin: 60
        anchors.top: newmsgdialogModecheckbox.bottom
        anchors.topMargin: 50
        // exclusiveGroup: exclusive
        style: CheckBoxStyle {
            indicator: Item {
                implicitWidth: 16
                implicitHeight: 16
                Image {
                    id: newmsgSoundcheckboxImg
                    anchors.fill: parent
                    source: "qrc:/resource/images/login/checkbox.png"
                }

                Image {
                    id: newmsgSoundcheckboxImgChecked
                    anchors.fill: parent
                    visible: control.checked
                    source: "qrc:/resource/images/login/checkbox_hover.png"
                }
            }
        }
        onClicked: {

            //   fileio.writeIniFile("login", "useroutnetlogin", 1) outnetcheckbox fileio.writeIniFile("login", "useroutnetlogin", 0)innetcheckbox
        }
    }

    Rectangle {
        id:newmsgSoundRect
        width: 320
        height: 20
        anchors.left: newSeralarmsModecheckbox.left
        anchors.leftMargin: 30
        anchors.top:newSeralarmsModerectback.bottom
        anchors.topMargin:53
        radius: 3
        border.color: "#dbdbdb"
        border.width: 0
        //visible: false
        Rectangle{
            id: newmsgSoundRectBkg
            width: 318
            height: 18
            color: "#ffffff"

            anchors.topMargin: 1

            anchors.leftMargin: 1
            Text {
                id: newmsgSoundRectName

                font.pixelSize: 14
                color: "#333333"
                font.family: "微软雅黑"
                //wrapMode: Text.WordWrap
                text:qsTr("消息提示音（修改后需重新登录后生效）")

            }
        }

        Component.onCompleted:
        {
        }
    }


    Text {
        id: savepathtext
        width: 100
        height: 25

        anchors.top:newmsgSoundcheckbox.bottom
        anchors.topMargin: 50
        anchors.left: parent.left
        anchors.leftMargin: 55

        font.pixelSize: 14
        font.family: "微软雅黑"
        font.bold: false
        color: "#000000"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("文件保存路径")
    }


    FolderDialog {
           id: fileDialog
           title: qsTr("选择路径")

           //nameFilters: ["Photo Files", "Image Files (*.jpg *.png *.gif *.bmp *.ico)", "*.*"]
           onAccepted: {
               //格式为 file:///D:/QTWORK/ispirit_xoa/debug

               usersavepath=String(folder)

               usersavepath=usersavepath.replace("file:///","")
               savepath.text = usersavepath
           }
       }

    TextField {
        id: savepath
        width: 270
        height: 25
        anchors.top:newmsgSoundcheckbox.bottom
        anchors.topMargin: 50
        anchors.left: savepathtext.right
        anchors.leftMargin: 0

        font.pixelSize: 14
        verticalAlignment: Qt.AlignVCenter
        font.family: "微软雅黑"
        style: TextFieldStyle {

            textColor: "#666666"
            background: Rectangle {
                border.color: "#dbdbdb"
                border.width: 1
                radius: 3
            }
        }
    }

    Button {
        id: filechoose
        width: 50
        height: 25
        anchors.top:newmsgSoundcheckbox.bottom
        anchors.topMargin: 50
        anchors.left: savepath.right
        anchors.leftMargin: 5
        style:ButtonStyle {
            background: Rectangle {
                border.color: control.hovered ? "#0075c4" : "#ccc"
                border.width: 1
                radius: 3
                color: control.hovered ? "#278ADD" : "#EEEEEE"
            }

            label: Text{
                text:qsTr("选择")
                font.pixelSize: 12
                font.family: "微软雅黑"
                color: control.hovered ?"#FFFFFF" :"#333333"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }

        }
        onClicked: {
            fileDialog.open()

        }
    }

    Text {
        id: savepathtext2
        width: 200
        height: 25

        anchors.top:savepathtext.bottom
        anchors.topMargin: 10
        anchors.left: parent.left
        anchors.leftMargin: 55

        font.pixelSize: 14
        font.family: "微软雅黑"
        font.bold: false
        color: "#999999"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("存储接收的文件、图片，默认保存目录：文档\\ispirit_xoa\\Cache\\file")
    }

    Button {
        id: loginsavebtn
        width: 70
        height: 30
        anchors.right: logincancelbtn.left
        anchors.rightMargin: 15
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 30
        style:ButtonStyle {
            background: Rectangle {
                border.color: control.hovered ? "#0075c4" : "#ccc"
                border.width: 1
                radius: 3
                color: control.hovered ? "#278ADD" : "#EEEEEE"
            }

            label: Text{
                text:qsTr("保存")
                font.pixelSize: 12
                font.family: "微软雅黑"
                color: control.hovered ?"#FFFFFF" :"#333333"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }
        onClicked: {

            if(newmsgdialogModecheckbox.checked)
            {
                fileio.writeIniFile("IM","newmsgMode","true");
            }
            else
            {
                fileio.writeIniFile("IM","newmsgMode","false");
            }

            if(newSeralarmsModecheckbox.checked)
            {
                fileio.writeIniFile("Seralarms","newSeralarmsMode","true");
            }
            else
            {
                fileio.writeIniFile("Seralarms","newSeralarmsMode","false");
            }

            if(newmsgSoundcheckbox.checked)
            {
                fileio.writeIniFile("IM","newmsgSound","true");
            }
            else
            {
                fileio.writeIniFile("IM","newmsgSound","false");
            }


            fileio.writeIniFile("openfiledialog", "savepath", savepath.text)

            deleteitem();
        }
    }

    Button {
        id: logincancelbtn
        width: 70
        height: 30
        anchors.right: parent.right
        anchors.rightMargin: 20
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 30
        style:ButtonStyle {
            background: Rectangle {
                border.color: control.hovered ? "#0075c4" : "#ccc"
                border.width: 1
                radius: 3
                color: control.hovered ? "#278ADD" : "#EEEEEE"
            }

            label: Text{
                text:qsTr("取消")
                font.pixelSize: 12
                font.family: "微软雅黑"
                color: control.hovered ?"#FFFFFF" :"#333333"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }

        }
        onClicked: {
            deleteitem();
        }
    }

}
