﻿import QtQuick 2.0

Rectangle {
    id:bkg
    width: 220
    height: 50
    property string chatJid: ""
    property string chatHead: ""
    property string chatName: ""
    property string chatInfoNum: ""
    color: "#ffffff"

    signal itemClicked(string jid)
    signal itemEnter(bool isShow)

    BorderImage {
        id: headicon
        width: 36
        height: 36
        anchors.top: parent.top
        anchors.topMargin: 7
        anchors.left: parent.left
        anchors.leftMargin: 10//14
        source: chatHead
    }

    Text {
        id: username
        height: 30
        anchors.left: headicon.right
        anchors.leftMargin: 10//15
        anchors.right: infonumbkg.left
        anchors.rightMargin: 10
        anchors.top: parent.top
        anchors.topMargin: 10
        color: "#000000"
        font.pixelSize: 14
        font.family: "微软雅黑"
        verticalAlignment: Qt.AlignVCenter
        horizontalAlignment: Qt.AlignLeft
        text: chatName

    }

    Rectangle {
        id: infonumbkg
        width: 40
        height: 20
        anchors.top:parent.top
        anchors.topMargin: 16
        anchors.right: parent.right
        anchors.rightMargin: 5
        radius: 20/2
        //opacity: 0
        color: "#ffffff"
        Text {
            id: infonum
            anchors.centerIn: parent
            color: "#f9493a"//#f9493a
            font.pixelSize: 16
            font.family: "微软雅黑"
            font.bold: true
            text: chatInfoNum
        }
    }

    MouseArea{
        anchors.fill: parent
        hoverEnabled: true

        onEntered: {
            bkg.color = "#F0F1F3"
            infonumbkg.color = "#F0F1F3"
            itemEnter(true)
        }

        onExited: {
            bkg.color = "#FFFFFF"
            infonumbkg.color = "#FFFFFF"
            itemEnter(false)
        }

        onClicked: {
            itemClicked(chatJid)
        }
    }
}
