﻿import QtQuick 2.7
import QtQuick.Window 2.2
import QtQuick.Layouts 1.1
import QtQuick.XmlListModel 2.0
import QtQuick.Controls 1.4
import QtQuick.Controls.Styles 1.4
import QtGraphicalEffects 1.0
import Qt.labs.platform 1.0
import QtWebEngine 1.5
import QtWebChannel 1.0
import FileIo 1.0
import WebRunPlatform 1.0
import QtQuick.Dialogs 1.3
import WebIEPlatform 1.0
//import DropArea 1.0
import "../interface"

import "../common"
import "../main"
import "../chat"
import "../js/query.js" as Query

Window {
    id: chatwindow    //单聊
    width: 598//1400//598
    height: 522
    minimumWidth: width
    minimumHeight: height
    //   maximumWidth:Window.Maximized
    //   maximumHeight: Screen.desktopAvailableHeight
    visible: true
    flags: Qt.Window | Qt.FramelessWindowHint|Qt.NoDropShadowWindowHint//|Qt.DragLinkCursor

    title:chatusername

    x: ((Screen.desktopAvailableWidth - 598)/2) + (20*count)
    y: ((Screen.desktopAvailableHeight - 522)/2)+(60*count)
    //Accessible:true
    // DropShadow:true
    opacity: 1.0

    //1:对方  0:自己
    property int count: 0
    property XmlListModel tmpModel;
    property string userjid //自己jid
    property string atContents: ""
    property string chatgifsource: ""
    property string gifname: ""
    property string jid     //聊天对象jid
    property string chatusername: ""
    property string chatvoicetime:""
    property string chatuserprivname: ""
    property string groupbumenname:""
    property string chatsex: ""

    property string chatname1: ""
    property string chattime1: ""
    property string openfolder: ""

    property bool   bPressed: false
    property string jessonid: ""
    property string oaoutnet: ""
    property string strip: ""
    property string strport: ""
    property string strOid: ""
    property string sex: ""
    property string moblieNo: ""
    property double iReceived: 0.0  //文件大小,字节
    property int    itemCount: 0
    property int    iCurrentIndex: 0
    property bool   isReceivedAll: false  //下载完成
    property bool   isSendAll: false  //上传完成

    property string receiverFileName: "" //正在下载的文件名
    property int    receiverFile:0 //文件接收到字节
    property string fileUploadUuid: "" //上传文件生成的Uuid
    property int    voiceTimePast:0 //语音录制时间,每秒加1
    property string strMsg: ""
    property bool   inputFocus: false

    property bool   bflag: false
    property int    elapseTime: 0
    property string loginusername: ""
    property bool   keyflag: false
    property bool   bCompleteSearceh: false
    property int    pageNumber: 1
    property bool   isSearch: false
    property bool   isCtrlDown: false
    property var    imagePreviewObj: null
    property var    mesageObj: null
    property string strStaus: ""
    property string avatar: ""
    property string signature: ""
    property string signatureIMG: ""
    property string selfvavtar: ""
    property string _Command: ""
    property string lastMsgTime:"" //最后一次定时拉取时间
    property string appendDataUuid:"" //自己发送的消息的Uuid串，用于判断是否定时拉取后显示，避免重复

    property bool   akeyflag:false
    property bool   ckeyflag:false
    property bool   skeyflag:false
    property bool   callbackmsg:false
    property var    callbackmsgList: []
    property bool   reb: false
    property int    ddcount: 0
    property string chatisopenfirereverfile1:"0"
    //2018-11-5修改图片格式只支持".jpg",".png" , ".gif", ".jpeg",".bmp"五种
    property var imgformat1: [".jpg",".png", ".gif", ".jpeg", ".bmp"]
    //".psd",".pcx", ".tiff",  ".tga", ".exif", ".fpx", ".svg" ,  ".cdr", ".pcd", ".dxf", ".ufo", ".eps"
    //, ".ai", ".hdri", ".raw", ".wmf", ".lic", ".fli", ".flc", ".emf"
    property var imgformat2: [".JPG",".PNG", ".GIF", ".JPEG", ".BMP"]
    //".PSD",, ".PCX", ".TIFF" ".TGA", ".EXIF", ".FPX", ".SVG",
    // ,  ".CDR", ".PCD", ".DXF", ".UFO", ".EPS"
    // , ".AI", ".HDRI", ".RAW", ".WMF", ".LIC", ".FLI", ".FLC", ".EMF"

    signal deleteitem(string userjid)
    signal appendConverList(string chatText, string chatTime, string chatuserjid, string chatType,string mystauts);

    WebIEPlatform
    {
        id:iewebrun
    }


    MessageDialog {
        id: messageDialogGsubo
        title: "版权信息"
        text: "北京高速波软件有限公司 版权所有，官网8OA.cn ，作者高波，QQ 11201403"
    }

    /*   Rectangle{ //组合键

        Keys.onPressed: {


         console.log("event.key----22222222222222222",event.key);
            if (event.key === Qt.Key_Alt) { //alt键
                akeyflag=true;
                //event.accepted = true;
                console.log("主体框 组合键 Key_Alt",akeyflag);
            }

            if (event.key === Qt.Key_C && akeyflag)  //alt + c 键
            {
                console.log("主体框 组合键 alt + c ",akeyflag);

               // chatwindow.deleteitem(jid);
                chatwindow.close();
            }

            if(event.key === Qt.Key_Escape)//esc键
            {
                console.log("主体框 组合键 esc键",akeyflag);
              //  chatwindow.deleteitem(jid);
                chatwindow.close()
            }

        }
        Keys.onReleased: {
            akeyflag=false;
            console.log("主体框 组合键 onReleased",akeyflag);
        }

    }*/

    /* MouseArea { //为窗口添加鼠标事件
        id:mouse
       // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"
        cursorShape: Qt.SizeFDiagCursor;
        height: 8
        width: 8
        anchors.left:parent.left
        anchors.leftMargin: 0
        anchors.top:  parent.top
        anchors.topMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                chatwindow.setX(chatwindow.x+delta.x)
                chatwindow.setY(chatwindow.y+delta.y)
                chatwindow.setWidth(chatwindow.width-delta.x);
                chatwindow.setHeight(chatwindow.height-delta.y);
            }
        }
 }*/


    /* MouseArea { //为窗口添加鼠标事件
           id:mouse
          // anchors.fill: parent
           acceptedButtons: Qt.LeftButton //只处理鼠标左键
           property point clickPos: "0,0"
           cursorShape: Qt.SizeFDiagCursor;
           height: 8
           width: 8
           anchors.left:parent.left
           anchors.leftMargin: 0
           anchors.top:  parent.top
           anchors.topMargin: 0
           onPressed: { //接收鼠标按下事件
               clickPos  = Qt.point(mouse.x,mouse.y)
               bPressed = true

           }

           onReleased: {
               bPressed = false;
           }

           onPositionChanged: { //鼠标按下后改变位置
               //鼠标偏移量
               if(bPressed)
               {
                   var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                   //如果mainwindow继承自QWidget,用setPos
                   chatwindow.setX(chatwindow.x+delta.x)
                   chatwindow.setY(chatwindow.y+delta.y)
                   chatwindow.setWidth(chatwindow.width-delta.x);
                   chatwindow.setHeight(chatwindow.height-delta.y);
               }
           }
    }*/
    /* MouseArea { //为窗口添加鼠标事件
           id:mouse
          // anchors.fill: parent
           acceptedButtons: Qt.LeftButton //只处理鼠标左键
           property point clickPos: "0,0"
           cursorShape: Qt.SizeFDiagCursor;
           height: 8
           width: 8
           anchors.left:parent.left
           anchors.leftMargin: 0
           anchors.top:  parent.top
           anchors.topMargin: 0
           onPressed: { //接收鼠标按下事件
               clickPos  = Qt.point(mouse.x,mouse.y)
               bPressed = true

           }

           onReleased: {
               bPressed = false;
           }

           onPositionChanged: { //鼠标按下后改变位置
               //鼠标偏移量
               if(bPressed)
               {
                   var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                   //如果mainwindow继承自QWidget,用setPos
                   chatwindow.setX(chatwindow.x+delta.x)
                   chatwindow.setY(chatwindow.y+delta.y)
                   chatwindow.setWidth(chatwindow.width-delta.x);
                   chatwindow.setHeight(chatwindow.height-delta.y);
               }
           }
    }*/


    MouseArea { //为窗口添加鼠标事件
        id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeFDiagCursor;
        height: 8
        width: 8
        anchors.left:parent.left
        anchors.leftMargin: 0
        anchors.top:  parent.top
        anchors.topMargin: 0

        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量

            if(bPressed)
            {
                var delta = Qt.point(mouse.x+clickPos.x, mouse.y+clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                chatwindow.setX(chatwindow.x+delta.x)
                chatwindow.setY(chatwindow.y+delta.y)
                chatwindow.setWidth(chatwindow.width-delta.x);
                chatwindow.setHeight(chatwindow.height-delta.y);
            }

        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeHorCursor;
        height: parent.height//8
        width: 8
        anchors.right:parent.right
        anchors.rightMargin: 0
        // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos

                // chatwindow.setX(chatwindow.x+delta.x)
                // chatwindow.setY(chatwindow.y+delta.y)
                chatwindow.setWidth(chatwindow.width+delta.x);
                // chatwindow.setHeight(chatwindow.height-delta.y);
            }
        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeVerCursor;
        height: 8
        width: 8
        anchors.top:parent.top
        anchors.topMargin: 0
        anchors.right:  parent.right
        anchors.rightMargin: 4
        anchors.left: parent.left
        anchors.leftMargin: 4
        //anchors.bottom: parent.bottom
        //anchors.bottomMargin: 4
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y+clickPos.y)
                //如果mainwindow继承自QWidget,用setPos

                // chatwindow.setX(chatwindow.x+delta.x)
                chatwindow.setY(chatwindow.y+delta.y)
                //chatwindow.setWidth(chatwindow.width+delta.x);
                chatwindow.setHeight(chatwindow.height-delta.y);
            }
        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeFDiagCursor;
        height: 8
        width: 8
        anchors.right:parent.right
        anchors.rightMargin: 0
        //  anchors.left: parent
        //  anchors.leftMargin: 8
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos

                // chatwindow.setX(chatwindow.x+delta.x)
                // chatwindow.setY(chatwindow.y+delta.y)
                chatwindow.setWidth(chatwindow.width+delta.x);
                chatwindow.setHeight(chatwindow.height+delta.y);
            }
        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeVerCursor;
        height: 8
        width: 8
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 0
        //  anchors.left: parent
        //  anchors.leftMargin: 8
        anchors.right: parent.right
        anchors.rightMargin: 8
        anchors.left: parent.left
        anchors.leftMargin: 8
        // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos

                // chatwindow.setX(chatwindow.x+delta.x)
                // chatwindow.setY(chatwindow.y+delta.y)
                // chatwindow.setWidth(chatwindow.width+delta.x);
                chatwindow.setHeight(chatwindow.height+delta.y);
            }
        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeBDiagCursor;
        height: 8
        width: 8
        //anchors.right:parent.right
        // anchors.rightMargin: 0
        anchors.left: parent.left
        anchors.leftMargin: 0
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x+clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos
                chatwindow.setX(chatwindow.x+delta.x)
                // chatwindow.setY(chatwindow.y+delta.y)
                chatwindow.setWidth(chatwindow.width-delta.x);
                chatwindow.setHeight(chatwindow.height+delta.y);
            }
        }
    }
    MouseArea { //为窗口添加鼠标事件
        //id:mouse
        // anchors.fill: parent
        acceptedButtons: Qt.LeftButton //只处理鼠标左键
        property point clickPos: "0,0"

        cursorShape: Qt.SizeHorCursor;
        height: 8
        width: 8
        //anchors.right:parent.right
        // anchors.rightMargin: 0
        anchors.left: parent.left
        anchors.leftMargin: 0
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 4
        anchors.top: parent.top
        anchors.topMargin: 4
        // anchors.bottom:  parent.bottom
        //  anchors.bottomMargin: 0
        onPressed: { //接收鼠标按下事件
            clickPos  = Qt.point(mouse.x,mouse.y)
            bPressed = true

        }

        onReleased: {
            bPressed = false;
        }

        onPositionChanged: { //鼠标按下后改变位置
            //鼠标偏移量
            if(bPressed)
            {
                var delta = Qt.point(mouse.x+clickPos.x, mouse.y-clickPos.y)
                //如果mainwindow继承自QWidget,用setPos

                chatwindow.setX(chatwindow.x+mouse.x)
                //   chatwindow.setY(chatwindow.y)
                chatwindow.setWidth(chatwindow.width-delta.x);
                //chatwindow.setHeight(chatwindow.height-delta.y);
            }
        }
    }



    FileIo {
        id: fileio

    }

    WebRunPlatform{
        id:webRun
    }

    Rectangle{   //聊天窗口
        anchors.fill: parent
        //border.color:"#D8DCE0"
        border.color:"#278ADD"  //聊天窗口边框
        border.width: 1
        id:ace
        anchors.right: parent.right
        anchors.rightMargin: 0
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 0
        anchors.left:parent.left
        anchors.leftMargin: 0


        XmlListModel {
            id: xmlModel
            source:"ybemxml_new.xml"
            query: "/ybdb/img/item"
            XmlRole { name: "title"; query: "title/string()" }
            XmlRole { name: "path"; query: "path/string()" }

            XmlRole { name: "title2"; query: "title2/string()" }
            Component.onCompleted: {
                tmpModel = xmlModel;
            }
        }
        Rectangle {
            id: title
            height: 74
            anchors.top: parent.top
            anchors.topMargin: 1
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            anchors.bottomMargin: 1

            border.width: 1
            //border.color: "#D8DCE0"
            border.color: "#CCCCCC"
            MouseArea { //为窗口添加鼠标事件
                // id:mouse
                anchors.fill: parent
                acceptedButtons: Qt.LeftButton //只处理鼠标左键
                property point clickPos: "0,0"

                onPressed: { //接收鼠标按下事件
                    clickPos  = Qt.point(mouse.x,mouse.y)
                    bPressed = true

                }

                onReleased: {
                    bPressed = false;
                }

                onPositionChanged: { //鼠标按下后改变位置
                    //鼠标偏移量
                    if(bPressed)
                    {
                        var delta = Qt.point(mouse.x-clickPos.x, mouse.y-clickPos.y)
                        //如果mainwindow继承自QWidget,用setPos
                        chatwindow.setX(chatwindow.x+delta.x)
                        chatwindow.setY(chatwindow.y+delta.y)
                        // chatwindow.setWidth(chatwindow.width-delta.x);
                        //chatwindow.setHeight(chatwindow.height-delta.y);
                    }
                }
            }

            LinearGradient {
                anchors.left: parent.left
                anchors.right: parent.right
                height: 73;
                gradient: Gradient {
                    GradientStop{ position: 0.0; color: "#EBF3F8";}
                    GradientStop{ position: 1.0; color: "#EBF3F8";}
                }
                start: Qt.point(0, 0);
                end: Qt.point(0, 73);
            }

            //头像
            Item{
                id: userimage
                width: 45
                height: 45
                anchors.left: parent.left
                anchors.leftMargin: 16
                anchors.top: parent.top
                anchors.topMargin: 15

                BorderImage {
                    id: userimage1
                    anchors.fill: parent
                    visible: true
                    source: {
                        if(avatar !== "0" && avatar !== "1" && avatar !== "" && avatar !== null)
                        {
                            return avatar;
                        }
                        if(chatsex === "0")
                        {
                            return "qrc:/resource/images/im/chatman (2).png"
                        }
                        else
                        {
                            return "qrc:/resource/images/im/chatwoman (2).png"
                        }
                    }
                }
                /*
                Rectangle{
                    id:mask
                    anchors.fill: userimage1
                    radius: width/2.
                }
                OpacityMask {
                    anchors.fill: userimage1
                    source: userimage1
                    maskSource: mask
                }*/

                MouseArea{
                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onClicked: {

                        // var secondWindow = windowComponent.createObject(window.parent
                        //                                                 , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                        //                                                     , "webHeight": (Screen.desktopAvailableHeight)*0.8
                        //                                                     , "strTitle": qsTr("用户详情")});
                        // secondWindow.webView.url = strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"

                        //用户详情
                        // webRun._vNewWindows(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN","用户详情",false)
                        //iewebrun._vNewWindows_IE(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" +jsessionid,"用户详情");
                        iewebrun._vNewWindows_XOAbrowser(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" +jsessionid,"用户详情",false);   //XOA 浏览器


                        //Qt.openUrlExternally(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                        console.log("聊天窗口点击了头像。显示用户详情页面地址 :",strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                    }
                }

            }

            //用户名
            Text {
                id: username
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 15;
                    }
                    else
                    {
                        return 25;
                    }
                }

                anchors.left: userimage.right
                anchors.leftMargin: 10
                font.pixelSize: 17
                font.bold: true
                font.family: "微软雅黑"
                color: "#111111"
                text: chatusername

                MouseArea{
                    anchors.fill: parent

                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onClicked: {

                        // var secondWindow = windowComponent.createObject(window.parent
                        //                                                 , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                        //                                                     , "webHeight": (Screen.desktopAvailableHeight)*0.8
                        //                                                     , "strTitle": qsTr("用户详情")});
                        // secondWindow.webView.url = strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"

                        //用户详情

                        //webRun._vNewWindows(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN","用户详情",false,strip);//2018-11-15修改，strip地址已带，不需要穿进去
                        //webRun._vNewWindows(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN","用户详情",false,"");
                        //iewebrun._vNewWindows_IE(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" +jsessionid,"用户详情");
                        iewebrun._vNewWindows_XOAbrowser(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" +jsessionid,"用户详情",false);   //XOA 浏览器

                        //Qt.openUrlExternally(strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                        console.log("聊天窗口点击了头像。显示用户详情cbatview地址 :",strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                    }
                }

            }

            //手机ico
            Image {
                id: phoneicon
                width: 16
                height: 16
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left: username.right
                anchors.leftMargin: 10
                source: "qrc:/resource/images/im/phoneicon.png"
                visible: {
                    if(moblieNo === "")
                    {
                        return false
                    }
                    else
                    {
                        return true
                    }
                }
            }

            //电话
            Text {
                id: phone
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left: phoneicon.right
                anchors.leftMargin: 5
                font.pixelSize: 12
                color: "#111111"
                font.family: "微软雅黑"
                visible: {
                    if(moblieNo === "")
                    {
                        return false
                    }
                    else
                    {
                        return true
                    }
                }
                text: {
                    return moblieNo
                }
            }

            Rectangle{
                id: line
                width: 1
                height: 16
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left:phone.right
                anchors.leftMargin: 6
                visible: {
                    if(moblieNo === "")
                    {
                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }

                color: "#ADB6BD"
            }

            Image {
                id: positionicon
                width: 16
                height: 16
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left:
                    if(moblieNo === "")
                    {
                        return username.right
                    }
                    else
                    {
                        return line.right
                    }

                anchors.leftMargin:
                {
                    if(moblieNo === "")
                    {
                        return 10
                    }
                    else
                    {
                        return 6
                    }
                }

                source: "qrc:/resource/images/im/positionicon.png"
            }

            //职位
            Text {
                id: position
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left: positionicon.right
                anchors.leftMargin: 5
                font.wordSpacing: 1.0
                font.family: "微软雅黑"
                font.pixelSize: 12
                font.weight: Font.Normal
                renderType: Text.NativeRendering
                smooth: true
                color: "#9c9c9c"
                text: chatuserprivname
            }
            Rectangle{
                id: linetwo
                width: 1
                height: 16
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left:position.right
                anchors.leftMargin:
                {
                    if(moblieNo === "")
                    {
                        return 9;
                    }
                    else
                    {
                        return 24;
                    }
                }
                /*visible: {
                    if(moblieNo === "")
                    {
                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }*/

                color: "#ADB6BD"
            }
            Image {
                id: positionicontwo
                width: 16
                height: 16
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left:
                    if(moblieNo === "")
                    {
                        return position.right
                    }
                    else
                    {
                        return linetwo.right
                    }

                anchors.leftMargin:
                {
                    if(moblieNo === "")
                    {
                        return 12
                    }
                    else
                    {
                        return 6
                    }
                }

                source: "qrc:/resource/images/im/department.png"
            }

            //部门
            Text {
                id: department
                anchors.top: parent.top
                anchors.topMargin: {
                    if(strStaus !== "")
                    {
                        return 19;
                    }
                    else
                    {
                        return 29;
                    }
                }

                anchors.left:  positionicontwo.right
                anchors.leftMargin: 5
                font.wordSpacing: 1.0
                font.family: "微软雅黑"
                font.pixelSize: 12
                font.weight: Font.Normal
                renderType: Text.NativeRendering
                smooth: true
                color: "#9c9c9c"
                text:groupbumenname
            }

            //个性签名拖=图片
            Image {
                id: statusIcon
                anchors.top: username.bottom
                anchors.topMargin: 3
                anchors.left: userimage.right
                anchors.leftMargin: 10
                visible: {
                    if(strStaus === "")
                    {
                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }
                source:
                {
                    if(strStaus !== "")
                    {
                        var strTem = strStaus.split("/");
                        console.log("个性签名图片:"+strTem[1])
                        return  "qrc:/resource/images/main/common/" + strTem[1];
                    }
                    else
                    {
                        console.log("个性签名图像为空")
                        return "";
                    }

                }
            }

            //个性签名
            Text {
                anchors.top: username.bottom
                anchors.topMargin: 2
                anchors.left: statusIcon.right
                anchors.leftMargin: 10
                color: "#9c9c9c"
                font.pixelSize: 12
                font.family: "微软雅黑"
                visible: {
                    if(strStaus === "")
                    {
                        return false;
                    }
                    else
                    {
                        return true;
                    }
                }
                text:{
                    if(strStaus !== "")
                    {
                        var strTem = strStaus.split("/");
                        //console.log("strStaus_username_",strStaus);
                        console.log("个性签名具体内容:",strTem);
                        return strTem[0];
                    }
                    else
                    {
                        return "";
                    }
                }
            }

            //打开文件对话框
            FileDialog {

                id: fileDialog

                visible: false
                selectExisting: true
                selectFolder: false
                selectMultiple: true
                folder:
                {
                    //console.log("文件对话框打开默认路径为：",fileio.readinifilepath())

                    return fileio.readinifilepath()//shortcuts.home
                }

                onAccepted: {


                    //上传文件，打开文件对话框
                    getuserinfos()
                    // var strfile = fileDialog.currentFile.toString().split("///");
                    //var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
                    var str = fileio.findfilepathUseRegExp(fileDialog.fileUrls)
                    console.log("文件对话框选择路径为",str)
                    if(str!= "")
                    {
                        var strfilepath;
                        var strlist = str.toString().split("---");
                        console.log("文件对话框选择个数:",strlist.length)
                        for(var i = 0;i<strlist.length-1;i++)
                        {
                            strfilepath= strlist[i]
                            strfilepath = decodeURIComponent(strfilepath) //文件地址???
                            console.log("本次上传文件路径为", strfilepath)
                            var tempFile = strfilepath.toString().split("/");
                            //  console.log("tempFile====",tempFile)
                            // console.log("strfile", tempFile,strfilepath.toString(),tempFile[tempFile.length - 1])
                            var MessageKey =strOid + "pq";
                            // console.log("MessageKey======",MessageKey)
                            var strUrl;
                            var _sUuid =Query.uuid();

                            fileUploadUuid=_sUuid; //记录此次上传的uuid
                            //  if(strFileType == "1") file
                            //   if(strFileType == "2") img
                            //   if(strFileType == "3")voice

                            var  s1 =strfilepath;
                            var  s2 =downLoadManager.strGetFilePath("2");
                            var  s3 =s2+tempFile[tempFile.length - 1];

                            //fileio.copyFile(s1,s3,s2)
                            console.log(strfilepath)
                            fileio.writeinifilepath(strfilepath)
                            if(findimg(strfilepath) == 1)
                            {
                                if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                {
                                    appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                    var strMessage1 = "{\"type\":\"file\",\"data\":";
                                    strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                    strMessage1 += ",\"send_time\":\"";
                                    strMessage1 += getTime() ;
                                    strMessage1 += "\",\"uuid\":\"";
                                    strMessage1 +=_sUuid;
                                    strMessage1 += "\",\"callback\":\"";
                                    strMessage1 +="1" ;
                                    strMessage1 += "\"}";
                                    strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                            + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                            + "&msg_type=0&charset=utf-8";
                                    if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                    {
                                        //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                        var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                        appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                    }
                                    console.log("长传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                                    edit.text = "";
                                    return ;
                                }

                                appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
                                var strMessage = "{\"type\":\"img\",\"data\":";
                                strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                strMessage += ",\"send_time\":\"";
                                strMessage += getTime() ;
                                strMessage += "\",\"uuid\":\"";
                                strMessage +=_sUuid;
                                strMessage += "\",\"callback\":\"";
                                strMessage +="1" ;
                                strMessage += "\"}";

                                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                        + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                        + "&msg_type=0&charset=utf-8"

                                //chatTransferFile.setStrJessionId(jessonid)
                                //chatTransferFile.setServerAddr(strUrl);
                                //chatTransferFile.setPostFilePath(strfile[1]);
                                if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                {
                                    // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")

                                }


                                console.log("上传文件地址为:",  strUrl,strfilepath,jessonid,jid)

                            }
                            else
                            {
                                appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                var strMessage1 = "{\"type\":\"file\",\"data\":";
                                strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                strMessage1 += ",\"send_time\":\"";
                                strMessage1 += getTime() ;
                                strMessage1 += "\",\"uuid\":\"";
                                strMessage1 +=_sUuid;
                                strMessage1 += "\",\"callback\":\"";
                                strMessage1 +="1" ;
                                strMessage1 += "\"}";
                                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                        + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                        + "&msg_type=0&charset=utf-8";
                                if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                {
                                    //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                    var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                    appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                }
                                console.log("上传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                            }

                            filebtn1.checked = 0
                        }

                    }
                }

                onRejected: {

                    filebtn1.checked = 0
                }

                Component.onCompleted: {
                    visible = false
                }

            }
            //nameFilters: [ "(*.jpg *.png *.bmp *.gif *.jpeg)" ]

            //打开图片对话框
            FileDialog {

                id: pictureDialog

                visible: false
                nameFilters: [ "(*.jpg *.png *.bmp *.gif *.jpeg)" ]
                selectExisting: true
                selectFolder: false
                selectMultiple: true
                onAccepted: {


                    getuserinfos()
                    // var strfile = fileDialog.currentFile.toString().split("///");
                    //var strfile = fileDialog.currentFile.toString().replace(/^(file:\/{3})/,"");
                    var str = fileio.findfilepathUseRegExp(pictureDialog.fileUrls)
                    console.log("图片对话框选择详细路径",str)
                    if(str!= "")
                    {
                        var strfilepath;
                        var strlist = str.toString().split("---");
                        console.log("strlist====",strlist,strlist.length)
                        for(var i = 0;i<strlist.length-1;i++)
                        {
                            //strfilepath= strlist[i]
                            strfilepath = decodeURIComponent(strlist[i]) //文件地址???
                            console.log("本次上传图片对话框文件路径", strfilepath)

                            var tempFile = strfilepath.toString().split("/");
                            //   console.log("tempFile====",tempFile)
                            // console.log("strfile", tempFile,strfilepath.toString(),tempFile[tempFile.length - 1])
                            var MessageKey =strOid + "pq";
                            //   console.log("MessageKey======",MessageKey)
                            var strUrl;
                            var _sUuid =Query.uuid();
                            fileUploadUuid=_sUuid; //记录此次上传的uuid
                            //  if(strFileType == "1") file
                            //   if(strFileType == "2") img
                            //   if(strFileType == "3")voice

                            var  s1 =strfilepath;
                            var  s2 =downLoadManager.strGetFilePath("2");
                            var  s3 =s2+tempFile[tempFile.length - 1];
                            fileio.writeinifilepath(strfilepath)

                            fileio.copyFile(s1,s3,s2)

                            if(findimg(strfilepath) == 1)
                            {
                                console.log(fileio.getfilesize(strfilepath))
                                if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                {
                                    appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                    var strMessage1 = "{\"type\":\"file\",\"data\":";
                                    strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                    strMessage1 += ",\"send_time\":\"";
                                    strMessage1 += getTime() ;
                                    strMessage1 += "\",\"uuid\":\"";
                                    strMessage1 +=_sUuid;
                                    strMessage1 += "\",\"callback\":\"";
                                    strMessage1 +="1" ;
                                    strMessage1 += "\"}";
                                    strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                            + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                            + "&msg_type=0&charset=utf-8";
                                    if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                    {
                                        //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                        var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                        appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                    }
                                    console.log("长传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                                    edit.text = "";
                                    return ;
                                }
                                appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
                                var strMessage = "{\"type\":\"img\",\"data\":";
                                strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                strMessage += ",\"send_time\":\"";
                                strMessage += getTime() ;
                                strMessage += "\",\"uuid\":\"";
                                strMessage +=_sUuid;
                                strMessage += "\",\"callback\":\"";
                                strMessage +="1" ;
                                strMessage += "\"}";

                                strUrl =strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                        + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                        + "&msg_type=0&charset=utf-8"

                                //chatTransferFile.setStrJessionId(jessonid)
                                //chatTransferFile.setServerAddr(strUrl);
                                //chatTransferFile.setPostFilePath(strfile[1]);
                                if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                {
                                    // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                }


                                console.log("本次图片上传地址:",  strUrl)

                            }

                            picturebtn.checked = 0
                        }

                    }
                }

                onRejected: {
                    picturebtn.checked = 0
                }

                Component.onCompleted: {

                }

            }

            //最小化按钮
            ControlButton {
                id: min
                anchors.top: parent.top
                anchors.right: max.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMin.png"
                hoverImage: "qrc:/resource/images/im/chatMin_hovered.png"
                onClicked: {
                    chatwindow.visibility = Window.Minimized
                }
            }

            //最大化按钮
            ControlButton {
                id: max
                anchors.top: parent.top
                anchors.right: close.left
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatMax.png"
                hoverImage: "qrc:/resource/images/im/chatMax_hovered.png"

                onClicked: {
                    if(chatwindow.visibility == Window.Maximized)
                    {
                        chatwindow.visibility = Window.Windowed
                    }
                    else
                    {
                        chatwindow.visibility = Window.Maximized
                    }
                }
            }

            //关闭按钮
            ControlButton {
                id: close
                anchors.top: parent.top
                anchors.right: parent.right
                width: 28
                height: 28
                normalImage: "qrc:/resource/images/im/chatClose.png"
                hoverImage: "qrc:/resource/images/im/chatClose_hovered.png"
                onClicked:{
                    voiceRect.visible = false
                    voicetimer.stop();
                    voice.checked = 0
                    voiceicon_timer.stop();
                    voiceprogressbar.value = 0;
                    voiceTimePast=0
                    chatVoiceMessage.stopRecorder(false);
                    elapseTime = 0;

                    chatwindow.deleteitem(jid);
                    chatwindow.destroy()
                }
            }
        }


        ListModel{
            id:chatModel
        }

        //聊天内容窗口
        Rectangle{
            id:viewRect
            anchors.top: title.bottom
            anchors.bottom: grayline.top
            anchors.bottomMargin: 0
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right:parent.right
            anchors.rightMargin: 1
            color: "#EBF3F8"

            ScrollView
            {
                width: parent.width
                anchors.top: parent.top
                height: parent.height//32 27   10

                style: ScrollViewStyle {
                    handle: Item{
                        implicitWidth: 7
                        Rectangle {
                            //color: "#B0B0B0"
                            color: "#85C6F2" //滚动条颜色
                            anchors.fill: parent
                            visible: true
                            radius: 3
                        }
                    }
                    decrementControl:Image {
                        width:7
                        height: 7
                        source: "qrc:/resource/images/im/uparrow.png"
                    }
                    incrementControl:Image {
                        width: 7
                        height: 7
                        source: "qrc:/resource/images/im/downarrow.png"
                    }
                    scrollBarBackground: Rectangle {
                        implicitWidth: 7
                        color: "#EBF3F8"

                    }
                }

                ListView{
                    id:chatView
                    width: parent.width
                    anchors.top: parent.top
                    anchors.bottom: parent.bottom
                    anchors.bottomMargin: 0
                    spacing:0
                    orientation:  ListView.Vertical
                    model:chatModel

                    delegate: ChatItem{
                        chatName: chatname1
                        chatContents: chatcontents1
                        chatFlag: chatflag1
                        chatHead: chathead1
                        chatisopenfirereverfile:chatisopenfirereverfile1
                        chatTime: chattime1
                        chatIndex: index
                        chatGifSource: chatgifsource
                        chatMsgType: chatmsgtype
                        chatFileData: chatfiledata
                        bIsReceived: bisreceived
                        chatFilePath: chatfilepath
                        chatVoiceTime: chatvoicetime
                        strip: strip
                        isReceivedAll1:isReceivedAll
                        receiverFile1:receiverFile
                        receiverFileName1:receiverFileName


                        oneselfUid: userjid
                        otherUid: jid
                        uuid: uuid
                        callback:callback


                        onDelChatitem:{
                            //! 下一步 提交删除接口
                            getuserinfos();
                            Query.deleteChatItem(strip,chatModel.get(index).uuid,jsessionid)
                            console.log("删除聊天index strip uuid:",index,strip,chatModel.get(index).uuid);
                            chatModel.remove(index,1)
                        }
                    }

                    clip:true
                    MouseArea{
                        id:mouse1
                        anchors.fill: parent
                        propagateComposedEvents: true

                        onClicked:
                        {
                            edit.focus = false
                            mouse.accepted = false
                        }

                        onEntered: {
                            //mouse.accepted = false
                        }

                        onExited: {
                            //.accepted = false
                        }
                    }
                }
            }
        }

        //消息记录
        Rectangle {
            id: messagelogingrect
            width: 300
            anchors.top: title.bottom
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 1
            anchors.right: parent.right
            anchors.rightMargin: 1
            visible: false
            color: "#F3F6F9"
            border.width: 1
            border.color: "#cccccc"

            Interface {
                id:inter
                onGetDataSignal: {

                    console.log("网页端传来参数SEND_IMG_URL_________", msg1,"__", msg2,"__",  msg3)
                    //  Qt.openUrlExternally(msg1)
                    if(msg3 === "send_ts")
                    {
                        //!show
                        alert(msg2)
                        return;
                    }

                    if(msg3 === "SEND_IMG_URL")
                    {
                        var obj = eval('(' + msg1 + ')');//eval  gaobo

                        console.log("网页端传来图片地址参数SEND_IMG_URL", obj.file_url, obj.file_width,  obj.file_height)

                        var imgWidth = 0;
                        var imgHeight = 0;

                        var temWidth = obj.file_width;
                        var temHeight = obj.file_height;

                        if( temWidth > 424)
                        {
                            imgWidth = Number(obj.file_width) + 40;
                        }
                        else
                        {
                            imgWidth = 424;
                        }

                        if((temHeight+100)  >= 372)
                        {
                            imgHeight =  Number(temHeight)+100
                        }
                        else
                        {
                            imgHeight = 372;
                        }

                        console.log("网页端传来图片地址后，打开地址SEND_IMG_URL参数:", strip+"/xs?"+obj.file_url, imgWidth,  imgHeight)
                        creatImagePreviewObj(strip+"/xs?"+ obj.file_url,  Number(imgWidth), Number(imgHeight))


                    }
                    else if(msg3 === "SEND_MESSAGE_URL") //单聊消息记录中点击文件
                    {
                        console.log("单聊消息记录中点击文件");

                        var obj = eval('(' + msg1 + ')');//eval gaobo
                        var loginAddressFile = fileio.getLoginAddress();

                        //downLoadManager.startExploreExe("explorer.exe", strFileName, obj.file_url);
                        if(!fileio.findfilepathissame(obj.file_name,obj.time,obj.uuid))
                        {
                            var sendtext = "文件："+obj.file_name +" 正在下载中，请下载完毕后再双击打开。";

                            //单聊消息记录里的文件下载
                            receiverFileName="消息记录下载文件";
                            downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.file_url, obj.file_name, "1",obj.time,jid,obj.uuid);
                            appendSendData(sendtext, 0, "0", "", "",jid,"0");
                        }
                        else
                        {
                            //打开文件
                            downLoadManager.startExe("explorer.exe", downLoadManager.strGetFilePath("1")+obj.file_name,obj.time,false,obj.uuid) //打开文件
                        }

                    }
                    else if(msg3 === "send_ts")
                    {
                        creatMessageObj(msg2, "msg");
                    }
                }
            }

            WebChannel {
                id: webChannel
            }

            WebEngineView{
                id: messageWeb
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 1
                anchors.right: parent.right
                anchors.rightMargin: 1
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                smooth: true
                webChannel: webChannel

            }

            //!屏蔽鼠标右键出现的查看源码的界面
            MouseArea
            {
                id:_msgweb
                anchors.fill: parent
                hoverEnabled: false
                acceptedButtons: Qt.RightButton
                cursorShape: Qt.ArrowCursor
                onClicked:
                {
                    console.log("点击了鼠标右键。代码已屏蔽")
                }
                onDoubleClicked:
                {
                    console.log("双击了鼠标右键。代码已屏蔽")
                }
            }

            Component.onCompleted: {
                webChannel.registerObject("interface", inter);
            }
        }

        //表情区域
        Rectangle {
            id: iconrect
            z: 1
            width: 470
            height: 310
            x: toolbar.x
            y: toolbar.y - 310
            color: "#FFFFFF"
            visible: false

            ChatFace {
                id: faceitem
                anchors.top: parent.top
                anchors.topMargin: 5
                anchors.left: parent.left
                anchors.leftMargin: 10
                onSignalClickCurrentImg: {

                    chatgifsource = strPath

                    gifname = imgName

                    edit.text += "["+gifname+"]";
                    edit.cursorPosition = edit.text.length

                    //edit.text += "<img src ="+chatgifsource+">"

                    iconrect.visible = false
                    facebtn.checked = false
                }
            }
        }

        //语音区域
        Rectangle{
            id: voiceRect
            height: 28
            anchors.bottom: toolbar.top
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right:
            {
                if(messagelogingrect.visible)
                {
                    return messagelogingrect.left
                }
                else
                {
                    return parent.right
                }
            }

            anchors.rightMargin: 1
            color: "#EBF3F8"

            visible: false

            ProgressBar{
                id:voiceprogressbar
                anchors.fill: parent
                style: ProgressBarStyle {
                    background: Rectangle {
                        width: parent.width
                        height: parent.height
                        border.width: 1
                        border.color: "#CFD5DB"
                        color: "#EBF3F8"
                    }
                    progress: Rectangle {
                        radius: 4
                        color: "#BEE8FB"
                    }
                }

                Rectangle {
                    id: voiceicon

                    anchors.top: parent.top
                    anchors.topMargin: 10
                    anchors.left: parent.left
                    anchors.leftMargin: 10
                    width: 8; height: 8
                    radius: 4
                    color: "#79E09F"

                }

                Text {
                    id: voicetext
                    anchors.top: parent.top
                    anchors.bottom: parent.bottom
                    anchors.left: voiceicon.right
                    anchors.leftMargin: 10
                    font.family: "微软雅黑"
                    font.pixelSize: 12

                    verticalAlignment: Qt.AlignVCenter
                    text:qsTr("正在录音...");
                }

                Rectangle {
                    id: sendvoicebtn
                    width: 45
                    height: 22
                    radius: 3
                    anchors.top: parent.top
                    anchors.topMargin: 3
                    anchors.right: canclevoicebtn.left
                    anchors.rightMargin: 5
                    border.width: 1
                    border.color: "#069DD5"
                    color: "#069DD5"

                    Text {
                        anchors.fill: parent

                        font.family: "微软雅黑"
                        color: "#FFFFFF"
                        font.pixelSize: 12
                        horizontalAlignment: Qt.AlignHCenter
                        verticalAlignment: Qt.AlignVCenter
                        text: qsTr("发送")

                        MouseArea{
                            anchors.fill: parent

                            onClicked: {
                                sendvoice()
                            }
                        }
                    }
                }

                Rectangle {
                    id: canclevoicebtn
                    width: 45
                    height: 22
                    radius: 3
                    anchors.top: parent.top
                    anchors.topMargin: 3
                    anchors.right: parent.right
                    anchors.rightMargin: 5
                    border.width: 1
                    border.color: "#3290de"
                    color: "#069DD5"

                    Text {
                        anchors.fill: parent

                        font.family: "微软雅黑"
                        font.pixelSize: 12

                        horizontalAlignment: Qt.AlignHCenter
                        verticalAlignment: Qt.AlignVCenter
                        text: qsTr("取消")
                        color: "#FFFFFF"

                        MouseArea{
                            anchors.fill: parent

                            onClicked: {
                                cancelvoice()
                            }
                        }
                    }
                }
            }
        }

        //语音录制定时器
        Timer
        {
            id: voicetimer
            //interval: 1800;
            interval: 600; //0.6秒*100表示进度条总长60秒
            repeat: true
            onTriggered: {
                voiceprogressbar.value += 0.01

                //console.log("音频录制进度:", voiceprogressbar.value)
                if(voiceprogressbar.value == "1")
                {
                    sendvoice()
                }
            }
        }

        //录音图标和倒计时定时器
        Timer {
            id: voiceicon_timer
            interval: 1000;
            repeat: true
            onTriggered: {

                if(!bflag)
                {
                    voiceicon.color = "#54B904"
                    bflag = !bflag
                }
                else
                {
                    voiceicon.color = "#79E09F";
                    bflag = !bflag
                }

                voiceTimePast++
                var timeleft=parseInt(60-voiceTimePast)
                voicetext.text="正在录音,剩余"+timeleft+"秒"
            }
        }

        Rectangle {
            id: grayline
            height: 1
            anchors.bottom: toolbar.top
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right:
            {
                if(messagelogingrect.visible)
                {
                    return messagelogingrect.left
                }
                else
                {
                    return parent.right
                }
            }

            anchors.rightMargin: 0
            color: "#D8DCE0"
        }

        //聊天工具条
        Rectangle {
            id:  toolbar
            height: 30
            anchors.bottom: inputRect.top
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right:
            {
                if(messagelogingrect.visible)
                {
                    return messagelogingrect.left
                }
                else
                {
                    return parent.right
                }
            }

            anchors.rightMargin: 1
            //  border.width: 1
            //  border.color: "#D8DCE0"
            color: "red"//"#EBF3F8"
            //  LinearGradient {
            //  anchors.left: parent.left
            //  anchors.right: parent.right
            //  anchors.top: parent.top
            //  anchors.topMargin: 1
            //  height: 29;
            //  gradient: Gradient {
            //      GradientStop{ position: 0.0; color: "#EBF3F8";}
            //      GradientStop{ position: 1.0; color: "#EBF3F8";}
            //  }
            //  start: Qt.point(0, 1);
            //  end: Qt.point(0, 29);
            //            }

            //发表情
            CheckedIconButton {
                id: facebtn
                width: 22
                height: 22
                anchors.left: parent.left
                anchors.leftMargin: 8
                anchors.top: parent.top
                anchors.topMargin: 3
                checkable: true
                visible: true
                tooltip: qsTr("表情")
                normalIcon: "qrc:/resource/images/im/face.png"
                hoveredIcon: "qrc:/resource/images/im/face_hovered.png"
                checkedIcon: "qrc:/resource/images/im/face_hovered.png"

                onClicked: {
                    if(iconrect.visible)
                    {
                        iconrect.visible = false
                    }
                    else
                    {
                        iconrect.visible = true
                    }
                }
            }

            //发图片
            CheckedIconButton {
                id: picturebtn
                width: 22
                height: 22
                anchors.left: facebtn.right
                anchors.leftMargin: 12
                anchors.top: parent.top
                anchors.topMargin: 3
                checkable: true
                visible: true
                tooltip: qsTr("发送图片")
                normalIcon: "qrc:/resource/images/im/picture1.png"
                hoveredIcon: "qrc:/resource/images/im/picture1_hovered.png"
                checkedIcon: "qrc:/resource/images/im/picture1_hovered.png"
                onClicked: {
                    if(picturebtn.checked)
                    {
                        openfolder=fileio.readinifilepath();
                        openfolder=openfolder.substring(0,openfolder.lastIndexOf("/"))

                        pictureDialog.setFolder(openfolder)
                        pictureDialog.open()
                    }
                    else
                    {
                        pictureDialog.close()
                    }
                }
            }

            CheckedIconButton {
                id: filebtn1
                width: 22
                height: 22
                anchors.left: picturebtn.right
                anchors.leftMargin: 12
                anchors.top: parent.top
                anchors.topMargin: 3
                checkable: true
                visible: true
                tooltip: qsTr("发送文件")
                normalIcon: "qrc:/resource/images/im/file2.png"
                hoveredIcon: "qrc:/resource/images/im/file2_hovered.png"
                checkedIcon: "qrc:/resource/images/im/file2_hovered.png"
                onClicked: {
                    if(filebtn1.checked)
                    {

                        openfolder=fileio.readinifilepath();
                        openfolder=openfolder.substring(0,openfolder.lastIndexOf("/"))

                        fileDialog.setFolder(openfolder)

                        console.log("设置默认打开路径",openfolder);
                        fileDialog.open()
                    }
                    else
                    {
                        fileDialog.close()
                    }
                }
            }



            //截图
            CheckedIconButton {
                id: screenShotbtn
                width: 22
                height: 22
                anchors.left: filebtn1.right
                anchors.leftMargin: 12
                anchors.top: parent.top
                anchors.topMargin: 3
                checkable: true
                visible: true
                tooltip: qsTr("截图发送")
                normalIcon: "qrc:/resource/images/im/shotsreen_hovered.png"
                hoveredIcon: "qrc:/resource/images/im/shotsreen.png"
                checkedIcon: "qrc:/resource/images/im/shotsreen_hovered.png"
                onClicked: {
                    //var  paramurl = strip + "/email/index?lang=zh_CN";
                    //Qt.openUrlExternally(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid)
                    //webRun._vNewWindows(strip + "/email/addbox?uid="+jid+"&uname="+chatusername,jsessionid)
                    //console.log("(strip + "/email/addbox?uid="+jid+"&uname="+chatuserprivname,jsessionid)",id---------)
                    hide();
                    screenshot.startShot(jid);
                    console.log("聊天窗口点击截图按钮")
                }
            }


            //发语音
            CheckedIconButton {
                id: voice
                width: 22
                height: 22
                anchors.top: parent.top
                anchors.topMargin: 4
                anchors.left: screenShotbtn.right
                anchors.leftMargin: 12
                checkable: true
                visible: true
                tooltip: qsTr("发送语音")
                hoveredIcon: "qrc:/resource/images/im/voice_hovered.png"
                normalIcon: "qrc:/resource/images/im/voice.png"
                checkedIcon: "qrc:/resource/images/im/voice.png"
                onClicked: {

                    if(!voiceRect.visible)
                    {
                        voicetext.text="正在录音..."
                        voiceRect.visible = true

                        console.log("开始录制声音");
                        chatVoiceMessage.startRecorder(getTime())
                        voiceprogressbar.value=0
                        voiceTimePast=0
                        voicetimer.start();
                        voiceicon_timer.start();
                        elapseTime = getTime();
                    }
                    else
                    {
                        cancelvoice()
                    }
                }
            }


            //抖屏
            CheckedIconButton {
                id: shaking
                width: 22
                height: 22
                anchors.top: parent.top
                anchors.topMargin: 4
                anchors.left: voice.right
                anchors.leftMargin: 12
                checkable: true

                visible: true
                tooltip: qsTr("发送抖屏")
                hoveredIcon:"qrc:/resource/images/im/shakehover.png"
                normalIcon: "qrc:/resource/images/im/shake.png"
                checkedIcon:"qrc:/resource/images/im/shake.png"
                onClicked:
                {
                    //！发送抖屏
                    console.log("聊天窗口点击抖屏按钮，发送openfire参数为:",4, "抖屏",  strOid + "pq"+jid + "@gsubo","",false,mainwindow.oneselfName)
                    singleChat.sendMsg(4, "抖屏",  strOid + "pq"+jid + "@gsubo","",false,mainwindow.oneselfName);

                    shake_window.start()
                }
            }

            //发送邮件
            CheckedIconButton {
                id: sendEmail
                width: 22
                height: 22
                anchors.left: shaking.right
                anchors.leftMargin: 12
                anchors.top: parent.top
                anchors.topMargin: 3
                checkable: true
                visible: true
                tooltip: qsTr("发送邮件")
                normalIcon: "qrc:/resource/images/im/mail.png"
                hoveredIcon: "qrc:/resource/images/im/mailhover.png"
                checkedIcon: "qrc:/resource/images/im/mail.png"
                onClicked: {
                    //var  paramurl = strip + "/email/index?lang=zh_CN";
                    //Qt.openUrlExternally(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid)
                    //webRun._vNewWindows(strip + "/email/addbox?uid="+jid+"&uname="+chatusername,jsessionid)
                    // Qt.openUrlExternally(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid)
                    //console.log("聊天窗口点击右键按钮详细地址为:",(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid))
                    //iewebrun._vNewWindows_IE(strip + "/email/addbox?uid="+jid+"&uname="+"&JSESSIONID1=" +jsessionid,"邮件");//+decodeURIComponent(chatusername)
                    iewebrun._vNewWindows_XOAbrowser(strip + "/email/addbox?uid="+jid+"&uname="+"&JSESSIONID1=" +jsessionid,"邮件",false);

                    console.log(strip + "/email/addbox?uid="+jid+"&uname="+decodeURI(chatusername)+"&JSESSIONID1=" +jsessionid)
                    //iewebrun._vNewWindows(decodeURIComponent(strip + "/email/addbox?uid="+jid+"&uname="+chatusername+"&JSESSIONID1=" + jsessionid).toString(),"发邮件",true,strip);

                }
            }


            /*  CheckedIconButton {
                id: msgcallback
                width: 22
                height: 22
                anchors.top: parent.top
                anchors.topMargin: 4
                anchors.left: filebtn1.right
                anchors.leftMargin: 10
                checkable: true

                visible: true
                hoveredIcon:"qrc:/resource/images/im/readmsg.png"
                normalIcon: "qrc:/resource/images/im/noreadmsg.png"
                checkedIcon:"qrc:/resource/images/im/readmsg.png"
                onClicked: {

                    if(!callbackmsg)
                    {
                        callbackmsg = true;
                    }
                    else
                    {
                        callbackmsg = false;
                    }
                }
            }*/


            //消息内容录入区
            Text {
                id: messagelogingtext
                height: 22
                anchors.right: parent.right
                anchors.rightMargin: 10
                anchors.top: parent.top
                anchors.topMargin: 3
                font.pixelSize: 12
                font.family: "微软雅黑"
                visible: true
                text: qsTr("消息记录")

                MouseArea {

                    anchors.fill: parent
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onEntered: {
                        messagelogingtext.color = "#16b0e9"
                    }

                    onExited: {
                        messagelogingtext.color = "black"
                    }

                    onClicked: {
                        if(messagelogingrect.visible)
                        {
                            messagelogingrect.visible = false
                            chatwindow.width = 598
                            viewRect.anchors.right = chatwindow.right
                        }
                        else
                        {

                            var MessageKey =strOid + "pq";
                            getuserinfos()
                            messagelogingrect.visible = true
                            chatwindow.width = 898
                            viewRect.anchors.right = messagelogingrect.left
                            messageWeb.url = strip + "/spirit/chatRecord?of_from="+MessageKey+ userjid+"@gsubo&of_to="+MessageKey+ jid +"@gsubo&last_time=" + getTime()*1000

                            console.log("点击了消息记录，详细地址为:", strip + "/spirit/chatRecord?of_from="+ MessageKey+userjid+"@gsubo&of_to="+MessageKey+ jid +"@gsubo&last_time=" + getTime()*1000)
                        }
                    }
                }
            }
        }

        //文字输入区域
        Rectangle {
            id: inputRect
            height: 108

            anchors.bottom: parent.bottom
            anchors.bottomMargin: 1
            anchors.left: parent.left
            anchors.leftMargin: 1
            anchors.right: {
                if(messagelogingrect.visible)
                {
                    return messagelogingrect.left
                }
                else
                {
                    return parent.right
                }

            }

            anchors.rightMargin: 1
            /*   DropArea{
                   anchors.fill:  parent
                 onDropped: {
                       console.log("拖放了文件: " + drop.urls.length);
                       if (drop.hasUrls){
                           console.log("拖放了文件: " + drop.urls.length);
                           for(var i = 0; i < drop.urls.length; i++){
                               console.log("文件: " + drop.urls[i]);
                               edit.insert(edit.text.length,"文件: " + drop.urls[i])
                               var str = fileio.findfilepathUseRegExp(edit.text)
                                                     console.log("粘贴文件",str);
                                                     if(str!== "")
                                                     {
                                                         var strfilepath;
                                                         var strlist = str.toString().split("---");
                                                         for(var i = 0;i<strlist.length-1;i++)
                                                         {
                                                              strfilepath = strlist[i]
                                                         var tempFile = strfilepath.toString().split("/");
                                                         console.log("strfile", strfilepath)
                                                         var MessageKey =strOid + "pq";
                                                         var strUrl;
                                                         var _sUuid =Query.uuid();
                                                         var  s1 =strfilepath;
                                                         var  s2 =downLoadManager.strGetFilePath("2");
                                                         var  s3 =s2+tempFile[tempFile.length - 1];
                                                         fileio.copyFile(s1,s3,s2)
                                                         if(findimg(strfilepath) == 1)
                                                         {
                                                             appendConverList("", getTime(), jid, "img",strStaus)
                                                             var strMessage = "{\"type\":\"img\",\"data\":";
                                                             strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                                             strMessage += ",\"send_time\":\"";
                                                             strMessage += getTime() ;
                                                             strMessage += "\",\"uuid\":\"";
                                                             strMessage +=_sUuid;
                                                             strMessage += "\",\"callback\":\"";
                                                             strMessage +="1" ;
                                                             strMessage += "\"}";
                                                             strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                                     + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                                     + "&msg_type=0&charset=utf-8"
                                                             if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                                             {
                                                                 appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                                             }
                                                             console.log("fileDialog img___",  strUrl)
                                                         }
                                                         else
                                                         {
                                                             appendConverList("", getTime(), jid, "file",strStaus)
                                                             var strMessage1 = "{\"type\":\"file\",\"data\":";
                                                             strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                                             strMessage1 += ",\"send_time\":\"";
                                                             strMessage1 += getTime() ;
                                                             strMessage1 += "\",\"uuid\":\"";
                                                             strMessage1 +=_sUuid;
                                                             strMessage1 += "\",\"callback\":\"";
                                                             strMessage1 +="1" ;
                                                             strMessage1 += "\"}";
                                                             strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                                     + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                                     + "&msg_type=0&charset=utf-8";
                                                             if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                                             {
                                                                 appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")

                                                             }
                                                             console.log("fileDialog file___",strUrl)
                                                         }
                                                        }
                                                         edit.text = "";
                                                     }
                           }
                       }
                       else if (drop.hasText){
                           console.log("拖放了本文: " + drop.text.length);
                           console.log("文本: " + drop.text);
                           edit.insert(edit.text.length,"文本: " + drop.text)
                       }
                       var str = fileio.findfilepathUseRegExp(edit.text)
                       console.log("粘贴文件",str);
                       if(str!== "")
                       {
                           var strfilepath;
                           var strlist = str.toString().split("---");
                           for(var i = 0;i<strlist.length-1;i++)
                           {
                                strfilepath = strlist[i]
                           var tempFile = strfilepath.toString().split("/");
                           console.log("strfile", strfilepath)
                           var MessageKey =strOid + "pq";
                           var strUrl;
                           var _sUuid =Query.uuid();
                           var  s1 =strfilepath;
                           var  s2 =downLoadManager.strGetFilePath("2");
                           var  s3 =s2+tempFile[tempFile.length - 1];
                           fileio.copyFile(s1,s3,s2)
                           if(findimg(strfilepath) == 1)
                           {
                               appendConverList("", getTime(), jid, "img",strStaus)
                               var strMessage = "{\"type\":\"img\",\"data\":";
                               strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                               strMessage += ",\"send_time\":\"";
                               strMessage += getTime() ;
                               strMessage += "\",\"uuid\":\"";
                               strMessage +=_sUuid;
                               strMessage += "\",\"callback\":\"";
                               strMessage +="1" ;
                               strMessage += "\"}";
                               strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                       + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                       + "&msg_type=0&charset=utf-8"
                               if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                               {
                                   appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                               }
                               console.log("fileDialog img___",  strUrl)
                           }
                           else
                           {
                               appendConverList("", getTime(), jid, "file",strStaus)
                               var strMessage1 = "{\"type\":\"file\",\"data\":";
                               strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                               strMessage1 += ",\"send_time\":\"";
                               strMessage1 += getTime() ;
                               strMessage1 += "\",\"uuid\":\"";
                               strMessage1 +=_sUuid;
                               strMessage1 += "\",\"callback\":\"";
                               strMessage1 +="1" ;
                               strMessage1 += "\"}";
                               strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                       + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                       + "&msg_type=0&charset=utf-8";
                               if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                               {
                                   appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")

                               }
                               console.log("fileDialog file___",strUrl)
                           }
                          }
                           edit.text = "";
                       }
                   }
                   onEntered: console.log("onDropped entered")
                         //  onDropped: console.log("dropped")
            }*/
            color: "#EBF3F8"
            MouseArea{
                id:rightmouse;
                anchors.fill: parent;
                acceptedButtons: Qt.RightButton|Qt.LeftButton;

                hoverEnabled: true;
                onClicked: {
                    if (mouse.button == Qt.RightButton) {
                        //if(chatFilePath.length<=0)contents.selectAll();
                        editrightbuttonmenu.open();
                    }

                }
                Menu{
                    id:editrightbuttonmenu


                    MenuItem
                    {
                        // visible:(chatFilePath.length>0)
                        text: qsTr( "复制")
                        onTriggered:
                        {
                            // edit.paste();
                            edit.copy();
                        }
                    }
                    MenuItem
                    {
                        // visible:(chatFilePath.length>0)
                        id:pasteitem
                        text: qsTr( "粘贴")
                        onTriggered:
                        {

                            edit.paste();

                            var str = fileio.findfilepathUseRegExp(edit.text)

                            if(str!= "")
                            {
                                console.log("粘贴文件",str);
                                var strfilepath;
                                var strlist = str.toString().split("---");
                                for(var i = 0;i<strlist.length-1;i++)
                                {
                                    strfilepath = strlist[i]
                                    var tempFile = strfilepath.toString().split("/");
                                    console.log("本次上传文件目录为:", strfilepath)
                                    var MessageKey =strOid + "pq";
                                    var strUrl;
                                    var _sUuid =Query.uuid();
                                    fileUploadUuid=_sUuid; //记录此次上传的uuid

                                    var  s1 =strfilepath;
                                    var  s2 =downLoadManager.strGetFilePath("2");
                                    var  s3 =s2+tempFile[tempFile.length - 1];
                                    fileio.copyFile(s1,s3,s2)
                                    if(findimg(strfilepath) == 1)
                                    {
                                        if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                        {
                                            appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                            var strMessage1 = "{\"type\":\"file\",\"data\":";
                                            strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                            strMessage1 += ",\"send_time\":\"";
                                            strMessage1 += getTime() ;
                                            strMessage1 += "\",\"uuid\":\"";
                                            strMessage1 +=_sUuid;
                                            strMessage1 += "\",\"callback\":\"";
                                            strMessage1 +="1" ;
                                            strMessage1 += "\"}";
                                            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                    + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                    + "&msg_type=0&charset=utf-8";
                                            if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                            {
                                                //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                                var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                                appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                            }
                                            console.log("长传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                                            edit.text = "";
                                            return;
                                        }
                                        appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
                                        var strMessage = "{\"type\":\"img\",\"data\":";
                                        strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                        strMessage += ",\"send_time\":\"";
                                        strMessage += getTime() ;
                                        strMessage += "\",\"uuid\":\"";
                                        strMessage +=_sUuid;
                                        strMessage += "\",\"callback\":\"";
                                        strMessage +="1" ;
                                        strMessage += "\"}";
                                        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                + "&msg_type=0&charset=utf-8"
                                        if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                        {
                                            // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                        }
                                        console.log("本次上传文件地址为:",  strUrl,strfilepath,jessonid,jid)
                                    }
                                    else
                                    {
                                        appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                        var strMessage1 = "{\"type\":\"file\",\"data\":";
                                        strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                        strMessage1 += ",\"send_time\":\"";
                                        strMessage1 += getTime() ;
                                        strMessage1 += "\",\"uuid\":\"";
                                        strMessage1 +=_sUuid;
                                        strMessage1 += "\",\"callback\":\"";
                                        strMessage1 +="1" ;
                                        strMessage1 += "\"}";
                                        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                + "&msg_type=0&charset=utf-8";
                                        if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                        {
                                            // appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                            var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                            appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                        }
                                        console.log("本次上传文件地址为:",strUrl,strfilepath,jessonid,jid)
                                    }
                                }
                                edit.text = "";
                            }



                            // if(edit.text.)
                        }
                    }



                }
            }

            //            LinearGradient {
            //                anchors.left: parent.left
            //                anchors.right: parent.right
            //                height: 108;
            //                gradient: Gradient {
            //                    GradientStop{ position: 0.0; color: "#EBF3F8";}
            //                    GradientStop{ position: 1.0; color: "#EBF3F8";}
            //                }
            //                start: Qt.point(0, 0);
            //                end: Qt.point(0, 108);
            //            }

            Flickable {
                id: flick
                width: parent.width-20
                height: parent.height-30
                anchors.top: parent.top
                anchors.left: parent.left
                anchors.leftMargin: 10

                contentWidth: edit.paintedWidth
                contentHeight: edit.paintedHeight
                clip: true

                function ensureVisible(r)
                {
                    if (contentX >= r.x)
                        contentX = r.x;
                    else if (contentX+width <= r.x+r.width)
                        contentX = r.x+r.width-width;
                    if (contentY >= r.y)
                        contentY = r.y;
                    else if (contentY+height <= r.y+r.height)
                        contentY = r.y+r.height-height;
                }

                TextEdit {
                    id: edit
                    width: flick.width
                    height:flick.height+font.pixelSize*edit.lineCount*2// flick.height -30
                    focus: true
                    wrapMode: TextEdit.Wrap
                    selectByMouse: true
                    onCursorRectangleChanged: flick.ensureVisible(cursorRectangle)
                    mouseSelectionMode: TextEdit.SelectCharacters
                    selectionColor: "#9BCAEF"
                    cursorVisible: true
                    Keys.enabled: true;
                    font.wordSpacing: 1.0
                    font.family: "微软雅黑"
                    font.pixelSize: 14
                    font.weight: Font.Normal
                    renderType: Text.NativeRendering
                    activeFocusOnPress:true
                    smooth: true



                    onFocusChanged: {
                        if(edit.focus)
                        {
                            inputRect.color = "#f5faff"
                            toolbar.color = "#f5faff"
                        }
                        else
                        {
                            inputRect.color = "#EBF3F8"
                            toolbar.color = "#EBF3F8"
                        }
                    }
                    /* Keys.enterPressed:
                   {
                       console.log("1111111111444");
                   }*/


                    Keys.onPressed:
                    {
                        var keyboard  = fileio.readIniFile("SendMsg","keyboard");
                        // console.log("event.key----++",event.key);

                        /*if(86===event.key)
{
    //edit.paste();


}*/

                        if(keyboard === "Enter")
                        {


                            if (Qt.Key_Return===event.key )  //未找到ctrl控制键。先用事件ID代替
                            {
                                if(event.modifiers & Qt.ControlModifier)
                                {
                                    //console.log("");
                                    edit.insert(edit.text.length,"\n");
                                }
                                else
                                {
                                    // console.log("111111111144444444444444");
                                    if(edit.text.length == 0)
                                    {
                                        return;
                                    }

                                    akeyflag = false;
                                    _btnSendmsg();
                                    //released(Qt.Key_Return);
                                }
                            }

                        }
                        else
                        {
                            if (Qt.Key_Return===event.key )  //未找到ctrl控制键。先用事件ID代替
                            {
                                if(event.modifiers & Qt.ControlModifier)
                                {
                                    //console.log("11111111114444");
                                    if(edit.text.length == 0)
                                    {
                                        return;
                                    }

                                    akeyflag = false;
                                    _btnSendmsg();
                                }
                                else
                                {

                                }
                            }

                        }
                        // if (event.key === Qt.Key_Enter)
                        /*if(event.key===Qt.key_)
                        {
                            skeyflag=true
                            console.log("skeyflag==",skeyflag)
                        }*/
                        if(event.key === Qt.Key_V )
                        {
                            if(event.modifiers && Qt.ControlModifier)
                            {

                                edit.paste();
                                // console.log("进入86")


                                console.log(edit.text)
                                var str = fileio.findfilepathUseRegExp(edit.text)
                                edit.undo();

                                // edit.text = "";
                                console.log("粘贴文件本地地址为:",str);
                                if(str!= "")
                                {
                                    // edit.text = "";
                                    var strfilepath;
                                    var strlist = str.toString().split("---");
                                    for(var i = 0;i<strlist.length-1;i++)
                                    {
                                        strfilepath = strlist[i]



                                        var tempFile = strfilepath.toString().split("/");
                                        console.log("本次上传文件本地路径为:", strfilepath)
                                        var MessageKey =strOid + "pq";
                                        var strUrl;
                                        var _sUuid =Query.uuid();
                                        fileUploadUuid=_sUuid; //记录此次上传的uuid

                                        //  if(strFileType == "1") file
                                        //   if(strFileType == "2") img
                                        //   if(strFileType == "3")voice

                                        var  s1 =strfilepath;
                                        var  s2 =downLoadManager.strGetFilePath("2");
                                        var  s3 =s2+tempFile[tempFile.length - 1];

                                        fileio.copyFile(s1,s3,s2)

                                        if(findimg(strfilepath) == 1)
                                        {
                                            if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                            {
                                                appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                                var strMessage1 = "{\"type\":\"file\",\"data\":";
                                                strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                                strMessage1 += ",\"send_time\":\"";
                                                strMessage1 += getTime() ;
                                                strMessage1 += "\",\"uuid\":\"";
                                                strMessage1 +=_sUuid;
                                                strMessage1 += "\",\"callback\":\"";
                                                strMessage1 +="1" ;
                                                strMessage1 += "\"}";
                                                strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                        + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                        + "&msg_type=0&charset=utf-8";
                                                if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                                {
                                                    //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                                    var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                                    appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                                }
                                                console.log("长传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                                                edit.text = "";
                                                return;
                                            }
                                            appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
                                            var strMessage = "{\"type\":\"img\",\"data\":";
                                            strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                            strMessage += ",\"send_time\":\"";
                                            strMessage += getTime() ;
                                            strMessage += "\",\"uuid\":\"";
                                            strMessage +=_sUuid;
                                            strMessage += "\",\"callback\":\"";
                                            strMessage +="1" ;
                                            strMessage += "\"}";

                                            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                    + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                    + "&msg_type=0&charset=utf-8"

                                            //chatTransferFile.setStrJessionId(jessonid)
                                            //chatTransferFile.setServerAddr(strUrl);
                                            //chatTransferFile.setPostFilePath(strfile[1]);
                                            if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                            {
                                                //appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")


                                            }


                                            console.log("本次上传文件地址为:",  strUrl)

                                        }
                                        else
                                        {
                                            appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                            var strMessage1 = "{\"type\":\"file\",\"data\":";
                                            strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                            strMessage1 += ",\"send_time\":\"";
                                            strMessage1 += getTime() ;
                                            strMessage1 += "\",\"uuid\":\"";
                                            strMessage1 +=_sUuid;
                                            strMessage1 += "\",\"callback\":\"";
                                            strMessage1 +="1" ;
                                            strMessage1 += "\"}";


                                            strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                    + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                    + "&msg_type=0&charset=utf-8";

                                            /* chatTransferFile.setStrJessionId(jessonid)
                                    chatTransferFile.setServerAddr(strUrl);
                                    chatTransferFile.setPostFilePath(strfile[1]);*/
                                            if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                            {
                                                //appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                                var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                                appendSendData(sendtext, 0, "0", "", "",jid,"0");


                                            }


                                            console.log("本次上传文件地址为:",strUrl)

                                        }

                                    }
                                    var stredittext = edit.text;
                                    edit.text = "";
                                }
                                //edit.text = "";
                                ckeyflag=true
                            }
                        }
                        if (event.key === Qt.Key_Alt) { //alt键
                            akeyflag=true;
                            //event.accepted = true;
                            // console.log("sendbtn 组合键 Key_Alt",akeyflag);
                            //console.log("sendbtn 组合键 Key_Alt11111",akeyflag);
                        }

                        if (event.key === Qt.Key_C && akeyflag)  //alt + c 键
                        {
                            //  console.log("sendbtn 组合键 alt + c ",akeyflag);
                            chatwindow.deleteitem(jid);
                            chatwindow.distroy();
                            return
                            // edit.text=""
                        }
                        if (event.key === Qt.Key_S && akeyflag)  //alt + S 键
                        {
                            ckeyflag = true;
                            //  console.log("sendbtn 组合键 alt + S ",akeyflag);
                            //  chatwindow.close();
                            if(edit.text.length == 0)
                            {
                                return;
                            }

                            akeyflag = false;
                            _btnSendmsg();
                            edit.text="";

                        }

                        if(event.key === Qt.Key_Escape)//esc键
                        {
                            // console.log("sendbtn 组合键 esc键",akeyflag);
                            chatwindow.close()
                            chatwindow.destroy()
                        }
                    }



                    Keys.onReleased: {
                        if(ckeyflag==true){
                            if(fileio.findfilepathUseRegExp(edit.text)!=="")
                            {
                                edit.clear()}
                        }
                        akeyflag=false
                        ckeyflag=false
                        skeyflag=false
                        //console.log("sendbtn 组合键 esc键 ***1**2**BS");
                    }
                    /*  onTextChanged:
                    {
                        _Command = edit.text.substring(edit.text.length-1,edit.text.length);

                       // console.log("onTextChanged C:",akeyflag)
                       // console.log("onTextChanged C:",_Command)
                       if(!akeyflag)return

                        if(akeyflag && (_Command == "c" || _Command == "C") )
                        {
                            edit.text ="";
                            chatwindow.close();
                         //   console.log("_Command C",_Command)
                            deleteitem(jid)
                        }

                        if(akeyflag && (_Command == "s" || _Command == "S") )
                        {
                            akeyflag = false;
                            edit.text = edit.text.substring(0,edit.text.length-1)
                            console.log("_Command S",_Command)
                            _btnSendmsg();
                        }*/
                    /*  Keys.onPressed : {
                        console.log(event.key);

                        if (event.key === Qt.Key_Enter) { //alt键
                            //akeyflag=true;
                            //event.accepted = true;
                            console.log("sendbtn 组合键 Key_Alt",akeyflag);
                             _btnSendmsg();
                        }
                      }
                    }*/
                }
            }

            Rectangle {
                id: closebtn
                anchors.bottom: parent.bottom
                anchors.right: button_sendmsg.left
                anchors.rightMargin: 10
                anchors.bottomMargin: 5
                width: 80
                height: 25
                border.width: 1
                border.color: "#069DD5"
                radius: 5
                color: "#069DD5"
                Text{
                    id:closeText
                    text: qsTr("关闭 (C)")
                    font.pixelSize: 15
                    anchors.centerIn: parent
                    font.family: "微软雅黑"
                    color: "#FFFFFF"
                }

                MouseArea{
                    id: closeMouse
                    anchors.fill: parent
                    hoverEnabled: true

                    onEntered: {
                        closebtn.color = "#16b0e9"
                    }

                    onExited: {
                        closebtn.color = "#069DD5"
                    }

                    onClicked: {
                        voiceRect.visible = false
                        voicetimer.stop();
                        voice.checked = 0
                        voiceicon_timer.stop();
                        voiceprogressbar.value = 0;
                        chatVoiceMessage.stopRecorder(false);
                        elapseTime = 0
                        deleteitem(jid)
                        chatwindow.close()
                        chatwindow.destroy()
                    }
                }
            }

            /*Rectangle {
                id: sendbtn
                anchors.bottom: parent.bottom
                anchors.right: parent.right
                anchors.rightMargin: 10
                anchors.bottomMargin: 5
                width: 80
                height: 25
                border.width: 1
                border.color: "#069DD5"
                radius: 5
                color: "#069DD5"


                Text{
                    id:sendText
                    text: qsTr("发送 (S)")
                    font.pixelSize: 14
                    anchors.centerIn: parent
                    font.family: "微软雅黑"
                    color: "#FFFFFF"
                }*/

            /*Text{
                   id:tooltip
                  text: qsTr("按Enter键换行，按Ctrl+S键发送")
                  font.pixelSize: 15
                  anchors.centerIn: parent
                  font.family: "微软雅黑"
                  color: "#FFFFFF"
                 }*/

            /*   MouseArea{
                    id:sendMouse
                    anchors.fill: parent
                    //enabled: edit.text.length?true:false
                    hoverEnabled: true
                    cursorShape: Qt.PointingHandCursor

                    onEntered: {
                        sendbtn.color = "#16b0e9"
                    }

                    onExited: {
                        sendbtn.color = "#069DD5"
                    }

                    onClicked: {
                        if(edit.text.length == 0)
                        {
                            return;
                        }

                        akeyflag = false;
                        _btnSendmsg();
                    }
                }
            }*/



            CheckedIconButton {
                id: button_sendmsg
                anchors.bottom: parent.bottom
                anchors.right: button_sendmsgmodechang.left
                anchors.rightMargin: 0
                anchors.bottomMargin: 5
                width: 80
                height: 25

                Text{
                    text: qsTr("发送(S)")
                    font.pixelSize: 15
                    font.family: "微软雅黑"
                    color: "#FFFFFF"
                    anchors.centerIn: parent
                }
                hoveredIcon :"qrc:/resource/images/im/send_hovered.png"
                normalIcon: "qrc:/resource/images/im/send_normal.png"
                checkedIcon:"qrc:/resource/images/im/send_checked.png"
                onClicked: {
                    // groupUserwindow.deleteitem()
                    if(edit.text.length == 0)
                    {
                        return;
                    }

                    if(edit.text.indexOf("高速波软件")>-1)
                        messageDialogGsubo.open();

                    akeyflag = false;
                    _btnSendmsg();
                }
            }
            CheckedIconButton {
                id: button_sendmsgmodechang
                anchors.bottom: parent.bottom
                anchors.right: parent.right
                anchors.rightMargin: 10
                anchors.bottomMargin: 5
                width: 25
                height: 25
                // text: qsTr("")
                hoveredIcon :"qrc:/resource/images/im/sendmsgmode_hovered.png"
                normalIcon: "qrc:/resource/images/im/sendmsgmode_normal.png"
                checkedIcon:"qrc:/resource/images/im/sendmsgmode_checked.png"
                onClicked: {
                    sendmsgmodechangMenu.open();

                }


                Menu {
                    id: sendmsgmodechangMenu
                    MenuItem {
                        id:sendmsgmodechangMenu1
                        text:
                            if(fileio.readIniFile("SendMsg", "keyboard")=="Ctrl+Enter")
                               return "√按Ctrl+Enter键发送"
                            else
                               return "按Ctrl+Enter键发送"

                        onTriggered: {
                            fileio.writeIniFile("SendMsg","keyboard","Ctrl+Enter");
                            this.text= "√按Ctrl+Enter键发送"
                            sendmsgmodechangMenu2.text="按Enter键发送"
                        }
                    }
                    MenuItem {
                        id:sendmsgmodechangMenu2
                        text:
                        if(fileio.readIniFile("SendMsg", "keyboard")=="Enter")
                           return "√按Enter键发送"
                        else
                           return "按Enter键发送"
                        onTriggered: {
                            fileio.writeIniFile("SendMsg","keyboard","Enter");
                            this.text= "√按Enter键发送"
                            sendmsgmodechangMenu1.text="按Ctrl+Enter键发送"
                        }
                    }
                }
            }

            /* Keys.onPressed: {


                console.log("sendbtn 组合键 alt + : ",event.key);
                 var keyboard  = fileio.readIniFile("SendMsg","keyboard");
               /* if(keyboard === "Ctrl+Enter")
                {
                                if (16777220===event.key )  //未找到ctrl控制键。先用事件ID代替
                                {
                                   if(edit.text.length == 0)
                                    {
                                        return;
                                    }

                                    akeyflag = false;
                                    _btnSendmsg();

                                }
                }
                else
                {
                    if (16777248===event.key )  //未找到ctrl控制键。先用事件ID代替
                    {

                       if(edit.text.length == 0)
                        {
                            return;
                        }

                        akeyflag = false;
                        _btnSendmsg();

                    }
                    else if(16777220===event.key)
                    {
                      //  edit.nextItemInFocusChain() ;
                        //edit.insert();
                    }

                }


                //console.log("sendbtn 组合键 alt + : ",event.key);
                // var keyboard  = fileio.readIniFile("SendMsg","keyboard");


                if (event.key === Qt.Key_Alt) { //alt键
                    akeyflag=true;
                    //event.accepted = true;
                    console.log("sendbtn 组合键 Key_Alt+++++++++",akeyflag);
                    console.log("sendbtn 组合键 Key_Alt11111",akeyflag);
                }

                if (event.key === Qt.Key_c && akeyflag)  //alt + c 键
                {
                    console.log("sendbtn 组合键 alt + c ",akeyflag);
                    chatwindow.close();
                }
                if (event.key === Qt.Key_S && akeyflag)  //alt + S 键
                                {
                                  //  console.log("sendbtn 组合键 alt + S ",akeyflag);
                                  //  chatwindow.close();
                                    if(edit.text.length == 0)
                                    {
                                        return;
                                    }

                                    akeyflag = false;
                                    }

                if(event.key === Qt.Key_Escape)//esc键
                {
                    console.log("sendbtn 组合键 esc键",akeyflag);
                    chatwindow.close()
                }
            }

            Keys.onReleased: {
                akeyflag=false
                ckeyflag=false
                skeyflag=false
                console.log("sendbtn 组合键 esc键 ***1**2**BS");
            }
*/

        }

        //文件拖拽区域
        DropArea{
            anchors.fill:  parent
            onDropped: {
                console.log("拖放了文件个数为:" + drop.urls.length);
                if (drop.hasUrls){
                    for(var i = 0; i < drop.urls.length; i++){
                        edit.insert(edit.text.length,"文件: " + drop.urls[i])

                        console.log("本次上传本地文件 edit.text:", edit.text)
                        var str1 = fileio.findfilepathUseRegExp(edit.text)
                        var str= fileio.percentEncoding2ByteArray(str1);

                        if(str!== "")
                        {
                            var strfilepath;
                            var strlist = str.toString().split("---");
                            for(var j = 0;j<strlist.length-1;j++)
                            {
                                strfilepath = strlist[j]
                                var tempFile = strfilepath.toString().split("/");
                                console.log("本次上传本地文件路径为:", strfilepath)
                                var MessageKey =strOid + "pq";
                                var strUrl;
                                var _sUuid =Query.uuid();
                                fileUploadUuid=_sUuid; //记录此次上传的uuid

                                var  s1 =strfilepath;
                                var  s2 =downLoadManager.strGetFilePath("2");
                                var  s3 =s2+tempFile[tempFile.length - 1];
                                fileio.copyFile(s1,s3,s2)
                                if(findimg(strfilepath) == 1)
                                {
                                    if(fileio.getfilesize(strfilepath)>1024*1024*2)
                                    {
                                        appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                        var strMessage1 = "{\"type\":\"file\",\"data\":";
                                        strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                        strMessage1 += ",\"send_time\":\"";
                                        strMessage1 += getTime() ;
                                        strMessage1 += "\",\"uuid\":\"";
                                        strMessage1 +=_sUuid;
                                        strMessage1 += "\",\"callback\":\"";
                                        strMessage1 +="1" ;
                                        strMessage1 += "\"}";
                                        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                                + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                                + "&msg_type=0&charset=utf-8";
                                        if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                        {
                                            //  appendSendData(strMessage1, 0, "1", s2, "",_sUuid,"1")
                                            var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                            appendSendData(sendtext, 0, "0", "", "",jid,"0");

                                        }
                                        edit.text = "";
                                        console.log("长传文件地址为:",strUrl,strfilepath,jessonid,jid)  //http://192.168.0.18/im/putMessage?
                                        return
                                    }
                                    appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
                                    var strMessage = "{\"type\":\"img\",\"data\":";
                                    strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                    strMessage += ",\"send_time\":\"";
                                    strMessage += getTime() ;
                                    strMessage += "\",\"uuid\":\"";
                                    strMessage +=_sUuid;
                                    strMessage += "\",\"callback\":\"";
                                    strMessage +="1" ;
                                    strMessage += "\"}";
                                    strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                            + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                            + "&msg_type=0&charset=utf-8"
                                    if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                    {
                                        // appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
                                    }
                                    console.log("本次上传本地文件地址为:",  strUrl,strfilepath,jessonid,jid)
                                }
                                else
                                {
                                    appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "file",strStaus)
                                    var strMessage1 = "{\"type\":\"file\",\"data\":";
                                    strMessage1 += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
                                    strMessage1 += ",\"send_time\":\"";
                                    strMessage1 += getTime() ;
                                    strMessage1 += "\",\"uuid\":\"";
                                    strMessage1 +=_sUuid;
                                    strMessage1 += "\",\"callback\":\"";
                                    strMessage1 +="1" ;
                                    strMessage1 += "\"}";
                                    strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                                            + "&type=file" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                                            + "&msg_type=0&charset=utf-8";
                                    if( chatTransferFile.start(strUrl,strfilepath,jessonid,jid))
                                    {
                                        //appendSendData(strMessage1, 0, "1", s2, "",_s,"1")
                                        var sendtext = "文件："+tempFile[tempFile.length - 1] +" 正在上传，请不要关闭窗口。";
                                        appendSendData(sendtext, 0, "0", "", "",jid,"0");


                                    }
                                    console.log("本次上传本地文件地址为:",strUrl,strfilepath,jessonid,jid)
                                }
                            }
                            edit.text = "";
                        }
                    }
                }
            }
            onEntered: console.log("onDropped entered")
            //  onDropped: console.log("dropped")
        }
    }

    property Component windowComponent: Window {
        id: webwindow
        property string strTitle: ""
        property WebEngineView webView: webView_
        property int webWidth: 0
        property int webHeight: 0
        x: (Screen.desktopAvailableWidth - webWidth)/2
        y: (Screen.desktopAvailableHeight - webHeight)/2

        width: webWidth
        height: webHeight

        visible: true

        title: strTitle
        //falg:Qt.window|Qt.WA_AcceptDrops
        WebEngineView {
            id: webView_
            anchors.top: parent.top
            anchors.topMargin: 1
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom

            onNewViewRequested: function(request) {
                var newWindow = windowComponent.createObject(window.parent
                                                             , {"webWidth":(Screen.desktopAvailableWidth)*0.8
                                                                 , "webHeight": (Screen.desktopAvailableHeight)*0.8
                                                                 , "strTitle": ""});
                request.openIn(newWindow.webView);
                newWindow.strTitle = newWindow.webView.title
            }

            onWindowCloseRequested: {
                webwindow.close();
            }

        }
        Component.onCompleted: {

        }
    }

    function creatMessageObj(contexText, parm) {
        var component = Qt.createComponent("qrc:/qml/main/MessageDailog");

        //!取消消息记录无消息提示框
        // if (component.status === Component.Ready)
        // {
        //     if(mesageObj === null)
        //     {
        //         mesageObj = component.createObject(window.parent, { "visible": true
        //                                                , "messageText":contexText
        //                                                , "pageId": parm
        //                                                , "isSure": true});
        //     }
        // }
        if(mesageObj === null)
        {

        }
        else
        {
            mesageObj.deleteitem.connect(deleteMessageObj)
            mesageObj.sigSure.connect(deleteMessageObj)
            mesageObj.sigCancel.connect(deleteMessageObj)
        }
    }

    function deleteMessageObj()
    {
        mesageObj.deleteitem.disconnect(chatwindow.deleteMessageObj)
        mesageObj.sigSure.disconnect(chatwindow.deleteMessageObj)
        mesageObj.sigCancel.disconnect(chatwindow.deleteMessageObj)

        mesageObj.destroy()
        mesageObj = null

        console.log("关闭窗口", jid,chatusername)
    }

    function getMsg(strMsg, chatuserjid)
    {

        console.log("这是看是否接收到了消息");
        if(chatuserjid == jid)
        {
            appendReceiveData(strMsg, 1, "");
        }

    }

    function findAtSome(str)
    {
        for(var i=0;i<chatModel.count;i++)
        {
            var tmp = "@";
            tmp += chatModel.get(i).chatname1;

            if(str.indexOf(tmp) >= 0 )
            {
                return true;
            }
            else
            {
                continue;
            }
        }
        return false;
    }

    function appendSendData(str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback)
    {
        //console.log("窗口增加自己发出的消息:",str, iflag, strmsgtype, chatfilepath, voicetime,uuid,callback)
        console.log("窗口增加自己发出的消息:chatfilepath",chatfilepath, "voicetime",voicetime)
        chatisopenfirereverfile1 = "0"
        var tmp = str;
        tmp = tmp.replace(/</g,"&lt;");
        var curTime=new Date().getTime();//结果：1280977330748

        var tmpTime = Number(curTime);
        var strsource = chatgifsource;
        var strHeadIcoUrl;

        if(iflag === 0)
        {
            strHeadIcoUrl = selfvavtar;
            console.log(" 消息为自己发出-头像:"+ strHeadIcoUrl)
        }
        else if(iflag === 1)
        {
            console.log(" 消息为对方发出-别人头像:"+ strHeadIcoUrl)
        }
        else if(chatsex === "0")
        {
            strHeadIcoUrl = "qrc:/resource/images/im/chatman (2).png"
        }
        else
        {
            strHeadIcoUrl = "qrc:/resource/images/im/chatwoman (2).png"
        }


        if(iflag === 0)
        {
            //if(typeof tmpTime == "Number")
            tmpTime = tmpTime.toString();

            console.log("增加自己发的消息 tmpTime=",tmpTime);
            chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime , "chatgifsource1": strsource
                                 , "chatmsgtype": strmsgtype, "chatfiledata":"0.0", "bisreceived": false, "chatfilepath": chatfilepath
                                 ,"chatvoicetime":voicetime,"uuid":uuid,"callback":callback});

            appendDataUuid+=uuid+","
        }
        else
        {
            //console.log(" ERROR_appendSendData_这不是发送数据"+ str ,typeof str )
            console.log(" ERROR_appendSendData_这不是发送数据"+ iflag ,typeof iflag )
        }

        chatView.positionViewAtEnd();
    }


    //接收Openfire 消息
    function appendReceiveData(str, iflag, chatfilepath)
    {
        var tmp;
        var isopenfirereverfile2str;
        chatisopenfirereverfile1 = "1"
        // console.log("appendReceiveData(str, iflag, chatfilepath)")
        // console.log("appendReceiveData(",str, iflag, chatfilepath)
        console.log("窗口内增加一条接收Openfire消息",str);
        var obj = JSON.parse(str);

        var strMsgType;

        if(obj.type === "text"||obj.type === "groupgeneral")
        {
            tmp = obj.data.replace(/\\n/g,"\n");
            tmp = tmp.replace(/</g,"&lt;");
            strMsgType = "0";
        }
        else if(obj.type === "file")
        {
            tmp = str;
            strMsgType = "1";
        }
        else if(obj.type === "img")
        {
            tmp = str;
            strMsgType = "2";
        }
        else if(obj.type === "voice")
        {
            tmp = str;
            strMsgType = "3";
        }
        else if(obj.type === "shaking")
        {
            tmp = str;
            strMsgType = "4";
        }

        // var curTime=new Date().getTime();//结果：1280977330748
        //var obj1 =
        //if("file" in obj )

        var curTime=obj.send_time;//obj.send_time
        console.log("窗口接收Openfie消息,获取时间--------",obj.send_time);

        var tmpTime = curTime;
        var strsource = chatgifsource;
        var strHeadIcoUrl;

        if(avatar != "0" && avatar != "1" && avatar != "" && avatar != null)
        {
            strHeadIcoUrl=avatar;
            // console.log(" appendReceiveData:"+ strHeadIcoUrl)
        }
        else if(chatsex === "0")
        {
            //  console.log(" appendReceiveData0:")
            strHeadIcoUrl = "qrc:/resource/images/im/chatman (2).png"
        }
        else
        {
            //  console.log(" appendReceiveData1:")
            strHeadIcoUrl = "qrc:/resource/images/im/chatwoman (2).png"
        }

        String.prototype.endsWith=function(endStr){
            var d=this.length-endStr.length;
            return (d>=0&&this.lastIndexOf(endStr)==d)
        }

        if(iflag === 1)
        {
            if(obj.type === "file")
            {
                var strFileSize = obj.data.file_size;
                if(strFileSize.endsWith("MB"))
                {
                    console.log("文件大小为 MB____",strFileSize.substr(0,strFileSize.length-2));
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    console.log("文件大小为 KB____",strFileSize.substr(0,strFileSize.length-2));
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    console.log("文件大小按 KB 处理",strFileSize);
                    //iReceived = Number(strFileSize.substr(0,strFileSize.length));
                    chatwindow.iReceived = Number(strFileSize) * 1024;
                }

                //if(typeof tmpTime != "Number")
                tmpTime = tmpTime.toString();


                console.log("窗口开着接收openfire文件-时间戳为------",tmpTime)
                // console.log("append1",obj.callback)

                //chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":Number(tmpTime), "chatgifsource1": strsource
                chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                     , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived" : false , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime" : "" , "uuid":obj.uuid,"callback":obj.callback
                                 });

                //chatModel.setProperty(chatModel.count,"isopenfirereverfile",true);


                //获取登录的地址
                var loginAddressFile = fileio.getLoginAddress();

                //openfire直接收到的文件,小于2M的文件自动下载
                if(chatwindow.iReceived<2*1024*1024)
                {
                    //var sendtext = "文件："+obj.data.file_name +" 正在下载中，请稍候。";
                    //appendSendData(sendtext, 0, "0", "", "",jid,"0");

                    receiverFileName=obj.data.file_name;
                    downLoadManager.downloadFile(loginAddressFile+"/xs?"+obj.data.file_url, obj.data.file_name, "1",obj.send_time,jid,obj.uuid);
                    console.log("openfire直接收到的文件,小于2M的文件自动下载",tmpTime)
                }

            }
            else if(obj.type === "img")
            {
                var strFileSize1 = obj.data.file_size;
                if(strFileSize1.endsWith("MB"))
                {
                    chatwindow.iReceived = Number(strFileSize1.substr(0,strFileSize1.length-2)) * 1024 *1024;
                }
                else if(strFileSize1.endsWith("KB"))
                {
                    chatwindow.iReceived = Number(strFileSize1.substr(0,strFileSize1.length-2)) * 1024;
                }
                else
                {
                    chatwindow.iReceived = Number(strFileSize1) * 1024;
                }

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

                // console.log("append2-------",tmpTime)
                chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                     , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":obj.uuid,"callback":obj.callback});

                //获取登录的地址
                var loginAddressImg= fileio.getLoginAddress();

                //openfire直接收到的图片,自动下载
                receiverFileName=obj.data.file_name;
                downLoadManager.downloadFile(loginAddressImg+"/xs?"+obj.data.file_url, obj.data.file_name, "2",obj.send_time,jid,obj.uuid);
            }
            else if(obj.type === "voice")
            {
                //处理语音消息接收

                var strUrl = obj.data.file_url.split("=");
                //  console.log("url",strUrl[strUrl.length - 1])

                var strVoiceTime = obj.data.voice_time
                // console.log(strTime)

                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();

                console.log("appendReceiveData 收到语音消息")
                chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                     , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": (downLoadManager.strGetFilePath("3") + strUrl[strUrl.length - 1]),
                                     "chatvoicetime": strVoiceTime,"uuid":obj.uuid,"callback":obj.callback});

            }
            else if(obj.type === "text")
            {
                //if(typeof tmpTime == "Number")
                tmpTime = tmpTime.toString();
                //console.log("tmpTime.toString-----------------",tmpTime)

                // console.log("append4")
                chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                     , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": "", "chatvoicetime":"","uuid":obj.uuid,"callback":obj.callback});
            }
            else if(obj.type === "shaking") //解析抖屏数据
            {
                console.log("处理抖屏",tmp)
                tmpTime = tmpTime.toString();
                chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":"发来一个抖屏!", "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                  , "chatmsgtype": "0", "chatfiledata": "0.0", "bisreceived": false  , "chatfilepath": "", "chatvoicetime":"","uuid":obj.uuid,"callback":obj.callback});
                shake_window.start()
            }


            //    for(var i=0;i<chatModel.count;i++)
            //    {
            //        console.log(chatModel.get(i).uuid ,obj.uuid);
            //
            //        if(chatModel.get(i).uuid ==obj.uuid)
            //        {
            //            console.log("chatModel.get(i).callback:",obj.callback);
            //            console.log("chatModel.get(i).callback:", chatModel.get(i).callback);
            //            chatModel.setProperty(i, "callback", "1");
            //            chatModel.setProperty(i-1, "callback", "1");
            //            console.log("chatModel.get(i).callback:", chatModel.get(i).callback);
            //            console.log("chatModel.get(i).callback:", chatModel.get(i-1).callback);
            //        }
            //    }


            chatwindow.isReceivedAll = false;
        }
        else
        {
            //  console.log(" ERROR_appendReceiveData_ 这是接收数据"+ str ,typeof str )
            //  console.log(" ERROR_appendReceiveData_这是接收数据"+ iflag ,typeof iflag )
        }

        appendDataUuid+=obj.uuid+","

        chatView.positionViewAtEnd();
    }

    //找相同时间的
    function findSameTime(str)
    {
        for(var i=0;i<chatModel.count;i++)
        {
            if(chatModel.count == 0)
            {
                return false;
            }

            if(isSameTime(chatModel.get(i).chattime1,str))
            {
                return true;
            }
            else
            {
                continue;
            }
        }
        return false;
    }

    function getFormatData(msecond,iType)
    {
        var dates = new Date((msecond - 0)+ 8*3600);
        if(iType == 0)
        {
            return dates.getFullYear().toString();
        }
        else if(iType == 1)
        {
            return dates.getMonth().toString();
        }
        else if(iType == 2)
        {
            return dates.getDate().toString();
        }
        else if(iType == 3)
        {
            return dates.getHours().toString();
        }
        else if(iType == 4)
        {
            return dates.getMinutes().toString();
        }
    }

    function isSameTime(strModel,str)
    {
        var tmpTime = strModel;

        if(getFormatData(tmpTime,0) === getFormatData(str,0))
        {
            if(getFormatData(tmpTime,1) === getFormatData(str,1))
            {
                if(getFormatData(tmpTime,2) === getFormatData(str,2))
                {
                    if(getFormatData(tmpTime,3) === getFormatData(str,3))
                    {
                        if(getFormatData(tmpTime,4) === getFormatData(str,4))
                        {
                            return true;
                        }
                        else
                        {
                            return false;
                        }
                    }
                }
            }
            return false;
        }
        else
        {
            return false;
        }
    }

    function filterImg(str){
        for(var i=0;i<tmpModel.count;i++)
        {
            var curTitle=tmpModel.get(i).title2;
            var curPath = "<img src="+tmpModel.get(i).path+"/>";
            var reg = new RegExp(curTitle, "ig");
            str = str.replace(reg, curPath);
        }
        var orgStr =str.replace(/<<(.+?)>>/gi,"&lt;&lt;$1&gt;&gt;");
        orgStr.replace(/'/gi,"&#39;")
        return orgStr;
    }

    //获取用户登录IP信息
    function getuserinfos()
    {
        oaoutnet = fileio.readIniFile("login", "useroutnetlogin")
        if(oaoutnet === "0") //内网登录
        {
            strip = fileio.readIniFile("login", "oainnet")
        }
        else if(oaoutnet === "1")//外网登录
        {
            strip = fileio.readIniFile("login", "oaoutnet")
        }
        else if(oaoutnet === "2")//测试地址
        {
            strip = fileio.readIniFile("login", "oatestnet")
        }

        //   strOid = fileio.readIniFile("login", "companyoid")
        strOid = window.companyoid
    }

    function findimg(strfile)
    {
        var ret = -1;

        for(var i = 0; i < imgformat1.length; ++i )
        {
            ret = strfile.indexOf(imgformat1[i])
            if(ret != -1)
            {
                console.log(imgformat1[i],strfile)
                return 1;
            }
        }

        for(var j = 0; j < imgformat2.length; ++j)
        {
            ret = strfile.indexOf(imgformat2[j])
            if(ret != -1)
            {
                console.log(imgformat2[i],strfile)
                return 1;
            }
        }

        return ret;
    }

    //上传文件成功后发送给对方消息
    function getfileurl(msgType, iRet, strReceivedMsg,struid,strfilepath)
    {
        if(struid!=jid)return;
        console.log("上传文件接口返回", strReceivedMsg, msgType,strfilepath);

        var _sUuid =  fileUploadUuid; //获得此次上传的uuid;
        //console.log("上传文件成功后发送给对方消息",_sUuid);
        if(msgType === 1)      //文件
        {
            var strMessage = "{\"type\":\"file\",\"data\":";
            strMessage += strReceivedMsg;
            strMessage += ",\"send_time\":\"";
            strMessage += getTime() ;
            strMessage += "\",\"uuid\":\"";
            strMessage +=_sUuid;
            strMessage += "\",\"callback\":\"";
            strMessage +="1" ;
            strMessage += "\"}";
            console.log("上传文件成功后发送给对方消息，openfire参数:",1, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);
            var obj = eval('(' + strReceivedMsg + ')');//eval
            fileio.writeiniSendfilenotes(strfilepath,obj.file_name,obj.sendTime)
            singleChat.sendMsg(1, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName)



            chatModel.remove(chatModel.count-1,1)//删除提示文字:正在上传，请不要关闭窗口。
            appendSendData(strMessage, 0, "1", s2, "",_sUuid,"1")

            //if(callbackmsg)
            //{
            //    singleChat.sendMsg(1, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,true)
            //    msgcallback.checked = false;
            //    callbackmsg = false;
            //}
            //else
            //{
            //}

            strMsg = strMessage;

            if(chatwindow.isSendAll)
            {
                chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
                // chatModel.setProperty(chatModel.count - 1, "chatcontents1", strMsg)
            }
        }
        else if(msgType === 2) //图片
        {
            var strMessage1 = "{\"type\":\"img\",\"data\":";
            strMessage1 += strReceivedMsg;
            strMessage1 += ",\"send_time\":\"";
            strMessage1 += getTime() ;
            strMessage1 += "\",\"uuid\":\"";
            strMessage1 +=_sUuid;
            strMessage1 += "\",\"callback\":\"";
            strMessage1 +="1" ;
            strMessage1 += "\"}";
            var  s2 =downLoadManager.strGetFilePath("2");
            console.log("上传文件成功后发送给对方消息，openfire参数:",2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);

            //chatModel.remove(chatModel.count-1,1)//删除上传提示文字
            appendSendData(strMessage1, 0, "2", s2, "",_sUuid,"1")
            singleChat.sendMsg(2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName)

            // if(callbackmsg)
            // {
            //     singleChat.sendMsg(2, strReceivedMsg, strOid + "pq"+jid + "@gsubo",uuid,true)
            //     msgcallback.checked = false;
            //     callbackmsg = false;
            // }
            // else
            // {
            // }

            strMsg = strMessage1;

            if(chatwindow.isSendAll)
            {
                chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
                //  chatModel.setProperty(chatModel.count - 1, "chatcontents1", strMsg)
            }
        }
        else if(msgType === 3) //上传声音文件
        {

            console.log("上传语音文件成功后发送给对方消息，openfire参数:",3, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);
            singleChat.sendMsg(3, strReceivedMsg, strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName)

            var elapseTime1 = getTime() - elapseTime;
            if(elapseTime1>60)
               elapseTime1=60

            var strMessage = "{\"type\":\"voice\",\"data\":";
            strMessage += strReceivedMsg;
            strMessage += ",\"send_time\":\"";
            strMessage += getTime() ;
            strMessage += "\",\"uuid\":\"";
            strMessage +=_sUuid;
            strMessage += "\",\"callback\":\"";
            strMessage +="1" ;
            strMessage += "\"}";

            appendSendData(strMessage, 0, "3", "", elapseTime1.toString(),_sUuid,"0")

            //chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
            //chatModel.setProperty(chatModel.count - 1, "chatcontents1", strMessage)
        }
    }

    function getTime()
    {
        var timestamp = Date.parse(new Date());
        timestamp = timestamp/1000.0
        timestamp = timestamp.toString()
        //  console.log("timestamp:____"+timestamp);
        return timestamp + "";
    }

    function appendSendFile(iSend, strMsg)
    {
        if(!chatwindow.isSendAll)
        {
            //    console.log("appendSendFile1")
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",iSend)
        }
        else
        {
            //  console.log("appendSendFile2",iSend)
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",iSend)
        }
    }

    function appendReceivedFile(isReceivedAll)
    {
        //  console.log("appendReceivedFile_iReceived:", iReceived ," isReceivedAll:",isReceivedAll)

        if(isReceivedAll !== 1)
        {
            //      console.log("appendSendFile3")
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",isReceivedAll)
        }
        else
        {
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",isReceivedAll)

            for(var len = 0; len< chatModel.count;len++)
            {
                if(chatModel.get(len).chatfiledata ==  isReceivedAll.toString())
                {
                    chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
                }
            }
            // console.log("appendSendFile4")
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",true)
            chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
        }
        console.log("接受文件数据:", chatwindow.iReceived)

        if(!isReceivedAll)
        {
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",chatwindow.iReceived.toString())
        }
        else
        {
            chatModel.setProperty(chatModel.count - 1,"chatfiledata",chatwindow.iReceived.toString())
            chatModel.setProperty(chatModel.count - 1,"bisreceived",true)

            for(var len = 0; len < chatModel.count;len++)
            {
                chatModel.setProperty(len,"bisreceived",true)
            }
        }

        //console.log("appendReceivedFile_iReceived:", iReceived ," isReceivedAll:",isReceivedAll)
        //
        //if(!isReceivedAll && ( iReceived != null))
        //{
        //    chatModel.setProperty(chatModel.count - 1,"chatfiledata",iReceived.toString())
        //}
        //else
        //{
        //    chatModel.setProperty(chatModel.count - 1,"chatfiledata",iReceived.toString())
        //
        //    for(var len = 0; len< chatModel.count;len++)
        //        if(chatModel.get(len).chatfiledata ==  iReceived.toString())
        //            chatModel.setProperty(chatModel.count - 1,"bisreceived",iReceived.toString())
        //
        //    chatModel.setProperty(chatModel.count - 1,"bisreceived",true)
        //}
    }

    //文件发送
    function sender(parm1, parm2,struid,strfilepath)
    {
        if(struid!=jid)return  // 避免和群聊消息冲突
        console.log("发送文件进度", parm1, parm2,struid,strfilepath)

        if(parm1==0||parm2==0)return;
        if(parm1 != parm2)
        {
            var senderFile = parm1 / parm2 + "";
            var senderCount = Number(senderFile.substr(0,5));

            appendSendFile(senderCount.toString(), strMsg);
        }
        else
        {
            chatwindow.isSendAll = true;
            appendSendFile("1.0", strMsg)
        }
    }

    //文件下载
    function receiver(parm1, parm2)
    {
        //console.log("下载文件 receiver,parm1:",parm1, parm2)

        //chatwindow.receiverFile = Number(parm1);  //收到的字节数

        chatwindow.receiverFile = Number(parm1);  //收到的字节数
        if(parm1 != parm2)
        {
            isReceivedAll = false;
            //chatView.ChatItem.receiverFile1=receiverFile;
            //chatView.ChatItem.isReceivedAll1=isReceivedAll;

            console.log("收到的字节数 receiverFile:",receiverFile)

            //appendReceivedFile(receiverFile.toString().substring(0,3));
        }
        else
        {
            isReceivedAll = true;
            console.log("接收文件:已完成,receiverFile:",receiverFile," isReceivedAll:",isReceivedAll);

            // appendReceivedFile("1.0")
        }

    }

    //文件下载完毕
    function receivefileFinished( code,filename,struid)
    {
        if(struid!=jid)return  // 避免和群聊消息冲突

        console.log("单聊文件下载完毕:",code,filename,struid)
        //code=300 表示文件小于2M，则不显示下载完毕的提示

        if(chatwindow.receiverFileName=="消息记录下载文件")
        //if(receiverFileName=="消息记录下载文件")
        {
            var sendtext = "文件："+filename +"已下载完毕，再次双击文件或图片可以打开";
            appendSendData(sendtext, 0, "0", "", "",jid,"0");
        }

        if(code == "666")
        {
            fileio.playmusic(downLoadManager.strGetFilePath("3")+filename);
            console.log("播放音乐",downLoadManager.strGetFilePath("3")+filename)
        }
    }

    function formatDateTime(inputTime) {
        var date = new Date(inputTime);
        var y = date.getFullYear();
        var m = date.getMonth() + 1;
        m = m < 10 ? ('0' + m) : m;
        var d = date.getDate();
        d = d < 10 ? ('0' + d) : d;
        var h = date.getHours();
        h = h < 10 ? ('0' + h) : h;
        var minute = date.getMinutes();
        var second = date.getSeconds();
        minute = minute < 10 ? ('0' + minute) : minute;
        second = second < 10 ? ('0' + second) : second;
        return y + '-' + m + '-' + d+' '+h+':'+minute+':'+second;
    }

    //显示历史消息
    function appendMsgData(str, iflag, chatfilepath,firsrun)
    {
        var loginAddressFile = fileio.getLoginAddress()
        chatisopenfirereverfile1 = "0"

        var tmp;
        //console.log("增加一条消息",str,iflag,chatfilepath)  //gaobo wait
        var obj = eval('(' + str + ')');//eval

        var strMsgType;

        if(obj.type === "text")
        {
            tmp = obj.content.replace(/\\n/g,"\n");
            tmp = tmp.replace(/</g,"&lt;");

            strMsgType = "0";
        }
        else if(obj.type === "file")
        {
            tmp = str;
            strMsgType = "1";
        }
        else if(obj.type === "img")
        {
            tmp = str;
            strMsgType = "2";
        }
        else if(obj.type === "voice")
        {
            tmp = str;
            strMsgType = "3";
        }

        else if(obj.type === "local")
        {
            //console.log("nukonw type local")
        }

        var tmpTime = obj.time;
        var uuidStr = obj.uuid;
        var strsource = chatgifsource
        var strHeadIcoUrl


        if(iflag === 1 )
            strHeadIcoUrl = avatar ;
        else
            strHeadIcoUrl = selfvavtar;


        // console.log("strHeadIcoUrl---",avatar);
        String.prototype.endsWith=function(endStr){
            var d = this.length-endStr.length;
            return (d >= 0 && this.lastIndexOf(endStr) == d)
        }

        //tmpTime = tmpTime.toString();
        //console.log("这条消息的时间----------------",getFormatData(tmpTime,0),"-",getFormatData(tmpTime,1),"-",getFormatData(tmpTime,2),getFormatData(tmpTime,3),":",getFormatData(tmpTime,4));

        var strFileSize = obj.file.file_size;

        if(iflag === 1) //别人发来的
        {
            if(obj.type === "file")
            {
                if(strFileSize.endsWith("MB"))
                {
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    chatwindow.iReceived = Number(strFileSize) * 1024;
                }

                if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();

                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","uuid":uuidStr});
                }
                else
                {    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","uuid":uuidStr});
                }

                if(chatwindow.iReceived<2*1024*1024)
                {
                    //console.log("历史消息,别人发的文件：小于2M,暂不自动下载",loginAddressFile+"/xs?"+obj.file.file_url, obj.file.file_name)

                }
                else
                {
                    //console.log("历史消息,别人发的文件：大于2M", obj.file.file_name)
                }

            }
            else if(obj.type === "text")
            {
                //console.log("历史消息：文本")

                if(typeof tmpTime == "Number" || typeof tmpTime == "number" )
                {

                    tmpTime = tmpTime.toString();
                    // console.log("路径31" ,typeof tmpTime , tmpTime )
                }



                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": "", "chatvoicetime":"","uuid":uuidStr});
                }
                else
                {
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": "", "chatvoicetime":"","uuid":uuidStr});
                }


            }
            else if(obj.type === "img")
            {
                //console.log("历史消息：图片")
                var strImgSize1 = obj.file.file_size;
                if(strImgSize1.endsWith("MB"))
                {
                    chatwindow.iReceived = Number(strImgSize1.substr(0,strImgSize1.length-2)) * 1024 *1024;
                }
                else if(strImgSize1.endsWith("KB"))
                {
                    chatwindow.iReceived = Number(strImgSize1.substr(0,strImgSize1.length-2)) * 1024;
                }
                else
                {
                    chatwindow.iReceived = Number(strImgSize1) * 1024;
                }

                if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();



                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":uuidStr});

                }
                else
                {
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":uuidStr});
                }

                if(chatwindow.iReceived<2*1024*1024)
                {
                }
            }
            else if(obj.type === "voice")
            {
                console.log("历史消息：语音:",obj.type,tmp);
                chatvoicetime=obj.file.voice_time


                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("3"), "chatvoicetime":chatvoicetime,"uuid":uuidStr});
                }
                else
                {
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":1,"chattime1":tmpTime, "chatgifsource1": strsource
                                          , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                          , "chatfilepath": downLoadManager.strGetFilePath("3"), "chatvoicetime":chatvoicetime,"uuid":uuidStr});
                }

            }

            //  isReceivedAll = false;
            chatView.positionViewAtEnd();
        }
        else //!自己发的
        {
            if(obj.type === "file")
            {
                //console.log("content", tmp)
                //console.log("strFileSize___", strFileSize)


                if(strFileSize.endsWith("MB"))
                {
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024 *1024;
                }
                else if(strFileSize.endsWith("KB"))
                {
                    chatwindow.iReceived = Number(strFileSize.substr(0,strFileSize.length-2)) * 1024;
                }
                else
                {
                    chatwindow.iReceived = Number(strFileSize) * 1024;
                }

                //console.log("路径6" )

                if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();

                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","uuid":uuidStr});
                }
                else
                {
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("1"), "chatvoicetime":"","uuid":uuidStr});

                }

                if(chatwindow.iReceived<2*1024*1024)
                {
                    console.log("历史消息,自己发的文件：小于2M,暂不自动下载")

                }
                else
                {
                    console.log("历史消息,自己发的文件：大于2M")
                }
            }
            else  if(obj.type === "text")
            {
                //console.log("路径4" )

                if(typeof tmpTime == "Number" || typeof tmpTime == "number")
                    tmpTime = tmpTime.toString();


                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": "", "chatvoicetime":"","uuid":uuidStr});
                }
                else
                {
                    //console.log("自己发的文字",tmp)
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": "", "chatvoicetime":"","uuid":uuidStr});

                }
            }
            else if(obj.type === "img")
            {
                var strImgSize = obj.file.file_size;

                if(strImgSize.toString().endsWith("MB"))
                {
                    chatwindow.iReceived = Number(strImgSize.substr(0,strImgSize.length-2)) * 1024 *1024;
                }
                else if(strImgSize.endsWith("KB"))
                {
                    chatwindow.iReceived = Number(strImgSize.substr(0,strImgSize.length-2)) * 1024;
                }
                else
                {
                    chatwindow.iReceived = Number(strImgSize) * 1024;
                }


                if(typeof tmpTime == "Number")
                    tmpTime = tmpTime.toString();


                //console.log("历史消息:自己发的图片" )

                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":uuidStr});
                }
                else
                {
                    chatModel.append({"chatname1": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":"","uuid":uuidStr});
                }

                if(chatwindow.iReceived<20*1024*1024)
                {
                }
            }
            else
            {
                console.log("语音文件");
                chatvoicetime=obj.file.voice_time             

                if(firsrun==1)
                {
                    chatModel.insert(0,{"chatname1:": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":chatvoicetime,"uuid":uuidStr});
                }
                else
                {
                    chatModel.append({"chatname1:": "", "chathead1":strHeadIcoUrl, "chatcontents1":tmp, "chatflag1":0,"chattime1":tmpTime, "chatgifsource1": strsource
                                         , "chatmsgtype": strMsgType, "chatfiledata": "0.0", "bisreceived": false
                                         , "chatfilepath": downLoadManager.strGetFilePath("2"), "chatvoicetime":chatvoicetime,"uuid":uuidStr});

                }
            }

            chatView.positionViewAtEnd();
        }
    }

/*
    function sendmsgresult(str)
    {
        //console.log("发消息请求结果  :return",str)
    }
*/

    //打开窗口第一次获取聊天历史记录的回调
    function appendMessageLoginingDatacallback(str)
    {

        //console.log("历史消息接口返回 :",str) //gaobo wait
        console.log("历史消息接口返回数据"+str);

        if(str === ""||str === null)
        {
            console.log("获取用户聊天记录接口返回空  :return")
            return;
        }

        var strMsg =  eval('(' + str + ')');//eval

        for(var i =  0; i < strMsg.length; ++i)
        {
            var obj = strMsg[i];

            //console.log("第"+i+"条",obj)  //gaobo wait
            //console.log("userjid :",userjid)

            var _sstr = JSON.stringify(obj)

            //console.log("userjid :",_sstr)
            if(obj.from_uid === userjid)//自己发的
            {
                //   console.log("appendMsgData自己发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                if(obj.content.indexOf("对方已经通过PC端在")<=-1)
                   chatwindow.appendMsgData(_sstr, 0, "",1);
                //console.log("自己发给别人,from_uid: to_uid:",obj.from_uid,obj.to_uid,_sstr); //gaobo wait

            }
            else if(obj.to_uid === userjid)//别人发的
            {
                // console.log("appendMsgData别人发给自己:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                chatwindow.appendMsgData(_sstr, 1, "",1);

                // console.log("别人发给自己,from_uid: to_uid",obj.from_uid,obj.to_uid); //gaobo wait
            }

            else//其他聊天框的信息
            {
                console.log("其他聊天框的信息，本窗口忽略",obj.from_uid,obj.to_uid);
                //console.log("appendMsgData别人发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
            }

        }
        edit.focus = true;
        edit.forceActiveFocus()
    }


    //定时获取历史记录的回调
    function appendMessageNewDatacallback(str)
    {

        //console.log("定时历史消息接口返回数据"+str);

        if(str === ""||str === null)
        {
            console.log("获取用户聊天记录接口返回空  :return")
            return;
        }

        var strMsg =  eval('(' + str + ')');//eval

        for(var i =  strMsg.length-1; i >=0 ; i--)
        {
            var obj = strMsg[i];

            //console.log("第"+i+"条",obj)  //gaobo wait
            //console.log("userjid :",userjid)

            var _sstr = JSON.stringify(obj)


            if(parseInt(obj.time)<parseInt(lastMsgTime))  //只显示上次拉取时间之后的消息
            {
                //console.log("时间比较1",parseInt(obj.time),parseInt(lastMsgTime))
                continue;
            }
            //console.log("时间比较2",parseInt(obj.time),parseInt(lastMsgTime))

            if(appendDataUuid.indexOf(obj.uuid)>-1)  //不显示自己发送的已上屏的消息
                continue;

            //console.log("userjid :",_sstr)
            if(obj.from_uid === userjid)//自己发的
            {
                //   console.log("appendMsgData自己发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                if(obj.content.indexOf("对方已经通过PC端在")<=-1)
                   chatwindow.appendMsgData(_sstr, 0, "",0);
                console.log("自己发给别人,from_uid: to_uid:",obj.from_uid,obj.to_uid,_sstr); //gaobo wait

            }
            else if(obj.to_uid === userjid)//别人发的
            {
                // console.log("appendMsgData别人发给自己:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                chatwindow.appendMsgData(_sstr, 1, "",0);
                // console.log("别人发给自己,from_uid: to_uid",obj.from_uid,obj.to_uid); //gaobo wait
            }

            else//其他聊天框的信息
            {
                console.log("其他聊天框的信息，本窗口忽略",obj.from_uid,obj.to_uid);
                //console.log("appendMsgData别人发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
            }

        }
        edit.focus = true
        edit.forceActiveFocus()
        lastMsgTime=getTime()
    }

    function creatImagePreviewObj(imageSource, iWidth, iHeight) {


        // console.log("desktopAvailableWidth_s"+Screen.desktopAvailableWidth);
        // console.log("desktopAvailableHeigth_"+Screen.desktopAvailableHeight);

        if( iWidth >Screen.desktopAvailableWidth)
        {
            iWidth = Screen.desktopAvailableWidth-100;
        }

        if( iWidth >Screen.desktopAvailableHeight)
        {
            iHeight = Screen.desktopAvailableHeight-100;
        }

        //console.log("imageSource:" + imageSource);
        var component = Qt.createComponent("ImagePreview.qml");

        if (component.status === Component.Ready)
        {
            if(imagePreviewObj === null)
            {
                // console.log("imagesadd:"+imageSource)
                imagePreviewObj = component.createObject(window.parent, {"imgSource": imageSource
                                                             , "windowWidth": iWidth
                                                             , "windowHeight": iHeight})
            }
        }
        if(imagePreviewObj === null)
        {

        }
        else
        {
            imagePreviewObj.deleteitem.connect(chatwindow.deleteImagePreObj)
        }
    }

    function deleteImagePreObj()
    {


        if(imagePreviewObj == null)
        {
            return;
        }

        imagePreviewObj.deleteitem.disconnect(chatwindow.deleteImagePreObj)

        imagePreviewObj.destroy()
        imagePreviewObj = null
        //console.log("关闭图像", "imview")
    }

    function  _btnSendmsg()
    {

        //console.log("_____btnSendmsg_______1______");
        akeyflag = false;
        if(edit.text.length<=0||edit.text=="")
        {
            // console.log("_____btnSendmsg_______2______");
            // edit.text="请输入内容"
            return;
        }


        getuserinfos()
        //edit.text="请输入内容"+edit.text
        // console.log("_____btnSendmsg_______3______");
        var _sUuid =  Query.uuid();
        appendConverList(edit.text.replace(/</g,"&lt;"), getTime(), jid, "text",strStaus)  //增加到会话列表

        console.log("发送消息:",edit.text);
        if(callbackmsg)
        {
            singleChat.sendMsg(0, edit.text,  strOid + "pq"+jid + "@gsubo",_sUuid,true,mainwindow.oneselfName);
            msgcallback.checked = false;
            callbackmsg = false;
        }
        else
        {
            //singleChat.sendMsg(0, edit.text,  strOid + "pq"+jid + "@gsubo",_sUuid,false,mainwindow.oneselfName);
        }

        var MessageKey =strOid + "pq";

        //appendSendData(edit.text, 0, "0", "", "",_sUuid,"0");      //增加到界面显示

        // console.log("_____btnSendmsg_______5_____");
        //chatView.positionViewAtEnd();
        // console.log("edit.text",edit.text)
        var parm = [];
        parm[0] = 1;
        parm[1] = userjid;
        parm[2] = jid;
        parm[3] = edit.text;

        parm[3]=parm[3].replace(/#/g,"%23");
        parm[3]=parm[3].replace(/\[/g,"%5B");
        parm[3]=parm[3].replace(/\]/g,"%5D");


        parm[4] = "text";
        parm[5] = userjid + "@gsubo"
        parm[6] = jid + "@gsubo"
        parm[7] = getTime();
        parm[8] = _sUuid;
        parm[9] = 0;

        var parm1 = [];
        parm1[0] = 5;
        parm1[1] = userjid + "@gsubo"
        parm1[2] = jid + "@gsubo"
        parm1[3] = getTime();
        parm1[4] = 0;

        var strServer = strip + "/im/putMessage?flag=" + parm[0] +"&from_uid=" +
                parm[1] +"&to_uid=" + parm[2] + "&content=" + parm[3] + "&type=" + parm[4] +
                "&of_from=" +MessageKey+ parm[5] + "&of_to=" +MessageKey+ parm[6] + "&stime=" + parm[7]  + "&atime=" + parm[7]*1000+ "&uuid=" +
                parm[8] + "&msg_type=" + parm[9] + "&charset=utf-8"



        console.log("发送消息到OA服务器接口地址:"+strServer);
        Query.sendMessage(strServer,parm,edit.text,strOid + "pq",sendMsgResult,sendMsgerror);
        // chatMessageToServer.sendMsgServer(jessonid, strServer.toString())



        edit.text = "";

        alert(5000);
        // console.log("onCompleted:",strStaus)
        // console.log("onCompleted:",avatar  )
        // console.log("onCompleted:",signature )
        // console.log("onCompleted:",signatureIMG)

    }
    function sendMsgResult(userJSON,sendtext,uuid)
    {
        console.log("发送消息到OA服务器接口返回数据:",userJSON, sendtext)
        if(userJSON.indexOf("IMok")>-1||userJSON.indexOf("ok")>-1)
        {
            appendSendData(sendtext, 0, "0", "", "",uuid,"0");
            console.log("发送消息到OA服务器接口返回数据:有ok或IMok，发送open fire参数为:",0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName)
            singleChat.sendMsg(0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName);
            edit.text = "";
        }
        else
        {
            appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0");
            console.log("发送消息到OA服务器接口返回数据:没有ok或IMok,不发送openfire消息")
        }

    }

    function sendMsgerror(sendtext,uuid)
    {
        appendSendData(sendtext+"----发送失败", 0, "0", "", "",uuid,"0");
        console.log("发送消息到OA服务器接口返回数据:网络原因,不发送openfire消息")
    }


    function sendMsgResult2(userJSON,sendtext,uuid) //回执消息
    {
        console.log("发送回执消息到OA服务器接口返回数据:",userJSON, sendtext)
        if(userJSON.indexOf("IMok")>-1||userJSON.indexOf("ok")>-1)
        {
            //appendSendData(sendtext, 0, "0", "", "",uuid,"0");
            console.log("发送回执消息到OA服务器接口返回数据:有ok或IMok，发送open fire参数为:",0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName)
            singleChat.sendMsg(0, sendtext,  strOid + "pq"+jid + "@gsubo",uuid,false,mainwindow.oneselfName);
        }
        else
        {
            //appendSendData(sendtext+"----"+"发送失败", 0, "0", "", "",uuid,"0");
            console.log("发送回执消息到OA服务器接口返回数据:没有ok或IMok,不发送openfire消息")
        }

    }

    function sendMsgerror2(sendtext,uuid)
    {
        //appendSendData(sendtext+"----回执发送失败", 0, "0", "", "",uuid,"0");
        console.log("发送回执消息到OA服务器接口返回数据:网络原因,不发送openfire消息")
    }

    function setChatViewIco(jid,ico)
    {
        for(var i=0;i<chatModel.count;i++)
        {
            if(chatModel.get(i).jid == jid && chatModel.get(i).chathead1 =="")
            {
                //console.log("setChatViewIco__",chatModel.get(i).jid,":",jid,ico);
                chatModel.setProperty(i,"chathead1",ico);
            }
        }
    }

    function insetCallbcklist(v)
    {
        // console.log("insetCallbcklist:",v)

        var head = v.split("**!**!**")[0];
        var msg = v.split("**!**!**")[1];
        var _sUuid = v.split("**!**!**")[2];

        // console.log("insetCallbcklist:",head)
        // console.log("insetCallbcklist:",msg)
        // console.log("insetCallbcklist:",_sUuid)

        for(var i=0;i<chatModel.count;i++)
        {
            //    console.log("uuid__",chatModel.get(i).uuid,":",_sUuid);

            // if(chatModel.get(i).uuid == uuid)
            // {
            //   console.log("chatModel.get(i).uuid:",chatModel.get(i)._sUuid);
            //   chatModel.setProperty(i,"uuid",v);
            //   chatModel.setProperty(i,"showCallBackMsg",true);
            // }
        }

        callbackmsgList.push(v);
    }

    function __callBack(userjson, flags) {}
    function endshotsreen(shotfilepath,uSerjidshot)
    {
        show();
        if(shotfilepath=="")return; //截图未保存就退出

        if(jid!=uSerjidshot)return;
        getuserinfos()
        var strfile = shotfilepath;
        var tempFile = shotfilepath.toString().split("/");
        console.log("截图完成，生成图片路径为", shotfilepath)
        var MessageKey =strOid + "pq";
        var strUrl;
        var _sUuid =Query.uuid();
        //  if(strFileType == "1") file
        //   if(strFileType == "2") img
        //   if(strFileType == "3")voice

        var  s1 =shotfilepath;
        var  s2 =downLoadManager.strGetFilePath("2");
        var  s3 =s2+tempFile[tempFile.length - 1];

        fileio.copyFile(s1,s3,s2)


        appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "img",strStaus)
        var strMessage = "{\"type\":\"img\",\"data\":";
        strMessage += "{\"file_name\":\"" + tempFile[tempFile.length - 1]+ "\",\"file_size\":\"\",\"file_type\":\"\",\"file_url\":\"\",\"status\":\"ok\"}";
        strMessage += ",\"send_time\":\"";
        strMessage += getTime() ;
        strMessage += "\",\"uuid\":\"";
        strMessage +=_sUuid;
        strMessage += "\",\"callback\":\"";
        strMessage +="1" ;
        strMessage += "\"}";

        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                + "&type=img" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                + "&msg_type=0&charset=utf-8"

        //chatTransferFile.setStrJessionId(jessonid)
        //chatTransferFile.setServerAddr(strUrl);
        //chatTransferFile.setPostFilePath(strfile[1]);
        if( chatTransferFile.start(strUrl,shotfilepath,jessonid,jid))
        {
            //appendSendData(strMessage, 0, "2", s2, "",_sUuid,"1")
            // console.log("截图完成，上传地址为:", strUrl)

        }


        console.log("截图完成，上传地址为:",  strUrl)


    }

    //窗口抖屏效果
    Timer {
        id: shake_window;
        interval: 50;//设置定时器时间
        repeat: true //是否重复定时,默认为false
        running: false //是否开启定时，默认是false
        triggeredOnStart: true // 是否开启定时就触发onTriggered

        onTriggered:
        {
            ddcount++;
            reb = !reb;
            if(reb)
            {
                chatwindow.x =chatwindow.x+5;
                chatwindow.y =chatwindow.y+5;
            }
            else
            {
                chatwindow.x =chatwindow.x-5;
                chatwindow.y =chatwindow.y-5;
            }
            if(ddcount>=10)
            {
                ddcount=0;
                shake_window.stop();
            }
        }
    }

    //历史记录同步定时器
    Timer {
        id: history_timer;
        interval: 30000;//设置同步定时器时间30秒
        repeat: true //是否重复定时,默认为false
        running: false //是否开启定时，默认是false
        triggeredOnStart: true // 是否开启定时就触发onTriggered
        onTriggered:
        {
          if(lastMsgTime!="")
          {
            Query.requestusermessage2(strip,userjid,jid,appendMessageNewDatacallback)
          }
          else
          {
             lastMsgTime=getTime()
          }
        }
    }



    Component.onCompleted: {


        var MessageKey =strOid + "pq";
        getuserinfos()

        Query.requestuserinfofromsever(strip,jid,jessonid,requestuserinfofromsevercallBack);

        console.log("获取用户消息 requestuserinfofromsevercallBack");

        // console.log("这里进入1",jid)
        // singleChat.getSingleMsg.connect(getMsg)
        chatTransferFile.sigReplyMessage.connect(getfileurl)
        chatTransferFile.sigSendFileData.connect(sender)
        downLoadManager.signalDownloadProcess.connect(receiver)  // 下载进度接口
        downLoadManager.signalReplyFinished.connect(receivefileFinished);// 下载完成接口

        // chatMessageFromServer.getMsgServer(jessonid, strip + "/im/showMessageList?of_from="+MessageKey+userjid+"@gsubo&of_to="+MessageKey+ jid +"@gsubo&last_time=" + getTime() + "&pagenum=1"+"&msg_type=0");
        //chatMessageFromServer.sigReplyMessage.connect(appendMessageLoginingData)

        //首次获取历史记录
        Query.requestusermessage(strip,userjid,jid,appendMessageLoginingDatacallback)

        //获取新的历史记录
        history_timer.start()

        // chatMessageToServer.sigReplyMessage.connect(sendmsgresult)

        screenshot.finishPixmap.connect(endshotsreen)
        edit.focus = true
        edit.forceActiveFocus()
        // console.log("群初始化:",jessonid)

        // Qt.application.active(this);
    }




    function requestuserinfofromsevercallBack(a)//userjson)
    {

        //console.log("这里进入2")
        //console.log("获取用户信息接口返回数据为:",a)//)userjson)


        var obj1 =  eval('('+ a + ')');   //userjson );//eval

        var obj2 = eval(obj1.object);//eval


        console.log("用户头像:",avatar);
        if("userName" in obj2)
        {
            username.text =  obj2.userName
        }
        else
        {
            username.text =  "该用户不存在"
            console.log("该用户不存在");
        }

        if(obj2.avatar !== "0" && obj2.avatar !== "1" && obj2.avatar !== "" && obj2.avatar !== null)
        {
            userimage1.source= strip+"/img/user/"+ obj2.avatar;
            avatar = strip+"/img/user/"+ obj2.avatar;
            console.log(strip+"/img/user/"+ obj2.avatar)

        }
        else{
            if(obj2.sex === "0")
            {
                chatsex ="0";
                userimage1.source= "qrc:/resource/images/im/chatman (2).png"
                //console.log("个人聊天界面查询个人消息:",userimage1.source)
                avatar = "qrc:/resource/images/im/chatman (2).png"
            }
            else
            {
                chatsex ="1";
                userimage1.source= "qrc:/resource/images/im/chatwoman (2).png"
                avatar = "qrc:/resource/images/im/chatwoman (2).png"
                // console.log("个人聊天界面查询个人消息:",userimage1.source)
            }
        }
        groupbumenname=obj2.deptName
        chatuserprivname = obj2.userPrivName
        if(chatuserprivname!=="")
        {
            if(obj2.deptName!=="")
            {
                linetwo.anchors.topMargin = 29
                positionicontwo.anchors.topMargin = 29
                chatuserprivname = obj2.userPrivName;// obj2.deptName+"-"+
                position.text = chatuserprivname
                department.anchors.topMargin = 29

            }
            else
            {
                chatuserprivname = obj2.userPrivName;
                position.text = chatuserprivname
            }
        }
        strStaus = obj2.myStatus
        if(strStaus!="")
        {
            username.anchors.topMargin = 25
            phoneicon.anchors.topMargin =29
            phone.anchors.topMargin = 29
            moblieNo = obj2.mobilNo

            phone.visible = true
            line.anchors.topMargin = 29
            positionicon.anchors.topMargin = 29
            position.anchors.topMargin = 29
            statusIcon.visible = true
            var strTem = strStaus.split("/");
            statusIcon.source= "qrc:/resource/images/main/common/" + strTem[1];
        }
        edit.focus = true;
        edit.forceActiveFocus()


        /* , "moblieNo": usermobileno
       , "loginusername": oneselfName
       , "inputFocus": true
       , "strStaus" :strStaus
       , "avatar" : ImgSoure*/


    }

    function appendMessageLoginingData(str)
    {
        console.log("获取消息历史记录接口数据返回",str)
        //console.log("strxxxxxx :",str)
        if(str === "")
        {
            console.log("获取用户聊天记录为空",str)
            return;
        }

        //  var strMsg =  eval('(' + str + ')');
        //var strMsg2 =evel('('+strMsg+')')
        var strMsg=eval(str);//eval

        for(var i =  0; i < strMsg.length; ++i)
        {
            var obj = strMsg[i];

            //console.log("obj :",obj)
            //console.log("userjid :",userjid)

            var _sstr = JSON.stringify(obj)

            //console.log("userjid :",_sstr)
            if(obj.from_uid === userjid)//自己
            {
                //   console.log("appendMsgData自己发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                chatwindow.appendMsgData(_sstr, 0, "");
            }
            else if(obj.to_uid === userjid)//自己
            {
                // console.log("appendMsgData别人发给自己:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
                chatwindow.appendMsgData(_sstr, 1, "");
            }

            else//其他聊天框的信息
            {
                console.log("appendMsgData别人发给别人:",chatusername, obj.formUserName +" ---> "+ obj.toUserName," 本地:",userjid+":"+jid," 远程:",obj.from_uid ,":",obj.to_uid)
            }

        }
    }

    //发送语音
    function sendvoice()
    {
        voiceRect.visible = false
        voicetimer.stop()
        voice.checked = 0
        voiceprogressbar.value = 0;
        voiceTimePast=0
        voiceicon_timer.stop();

        var elapseTime1 = getTime() - elapseTime;
        var strFile = chatVoiceMessage.stopRecorder(true);
        var _sUuid=   Query.uuid();
        fileUploadUuid=_sUuid; //记录此次上传的uuid

        //界面追加语音消息
        var MessageKey =strOid + "pq";
        getuserinfos();

        var tempFile = strFile.toString().split("/");
        console.log("发送音频文件",tempFile[tempFile.length-1])

        var strUrl;
        strUrl = strip + "/im/putMessage?flag=3&from_uid=" + userjid + "&to_uid=" + jid
                + "&type=voice" + "&of_from=" +MessageKey+ userjid + "@gsubo&of_to=" +MessageKey+ jid + "@gsubo&stime=" + getTime() + "&uuid=" + _sUuid
                + "&msg_type=0&voice_time="+ elapseTime1 +"&charset=utf-8";

        console.log("音频接口地址", strUrl)

        chatTransferFile.start(strUrl,strFile,jessonid,jid)
        appendConverList(tempFile[tempFile.length - 1], getTime(), jid, "voice",strStaus)
    }

    //停止语音录制
    function cancelvoice()
    {
        voiceRect.visible = false
        voicetimer.stop();
        voice.checked = 0
        voiceicon_timer.stop();
        voiceprogressbar.value = 0;
        voiceTimePast=0
        elapseTime = 0;
        chatVoiceMessage.stopRecorder(false);
    }

}
