﻿import QtQuick 2.6
import QtQuick.Window 2.2
import QtQuick.XmlListModel 2.0

Window {
    id:face_window
    visible: true
    width: 250
    height: 210
    signal deleteitem()
    flags: Qt.Window | Qt.FramelessWindowHint|Qt.NoDropShadowWindowHint|Qt.Tool
    property XmlListModel tmpModel;
    Rectangle{
        id:rec_facefirst
      //  border.color: "blue"
      //  border.width: 2
        anchors.fill: parent

    MouseArea { //为窗口添加鼠标事件
        id:mouse
        anchors.fill:parent
        acceptedButtons: Qt.LeftButton//只处理鼠标左键
        hoverEnabled:true
       // drag.active : true
        property point clickPos: "0,0"
        onCanceled: {
          console.log("onCanceled")
          }
        onEntered:
        {
           console.log("进入")
        }

        onExited:
         { // face_window.visible=false
            //deleteitem()
            console.log("移出")
        }
    }


    XmlListModel {
        id: xmlModel
        source:"ybemxml_new.xml"
        query: "/ybdb/img//item"  ///ybdb/img
        XmlRole { name: "title";  query: "title/string()" }
        XmlRole { name: "path";   query: "path/string()" }
        XmlRole { name: "title2"; query: "title2/string()" }
        Component.onCompleted: {
         //   tmpModel = xmlModel;

        }
    }

     /*  ListModel {
            id: listModel
        }*/

        Component{
            id: baseListDelegate

            Item {
                id: delegateItem
                height: gridView.cellHeight
                width: gridView.cellWidth

                Rectangle{
                    id: delegateItemBack
                    anchors.fill: parent
                    color : "#AAAAAA"

                    MouseArea {
                        anchors.fill: parent
                        hoverEnabled: true
                        acceptedButtons: Qt.LeftButton//只处理鼠标左键

                        onEntered: {

                            delegateItem.GridView.view.currentIndex = model.index;
                        }



                    }

                    Image {
                        id: image
                        anchors.centerIn: parent
                        source:path
                        width: 32
                        height: 32
                        MouseArea{
                            anchors.fill: parent
                            onClicked: {
                             //   console.debug(qsTr("选择的名称: ") + face)
                                console.log("发送表情的编码",title)
                                console.log("选择的表情为==",path)
                             //   console.log("curpath11111 +++++++++++++++++++++",tmpModel.count)
                                  edit.append(title)
                                console.log("xuanzebiaoqing xia ",xmlModel.count)
                               // edit.append("<"+"src="+path+">")
                             //  imagechat_input.source=path
                            //  edit.append("<img src=qrc:/resource/images/im/face/qq/new_6.gif>")
                                face_window.visible=false
                            }
                        }
                    }
                }

                states: [
                    State {
                        name: "isCurrentItem"
                        when: delegateItem.GridView.isCurrentItem
                        PropertyChanges {
                            target: delegateItemBack; color : "#AAAAAA";
                        }
                    },
                    State {
                        name: "isNotCurrentItem"
                        when: !delegateItem.GridView.isCurrentItem
                        PropertyChanges {
                            target: delegateItemBack; color : "transparent";
                        }
                    }
                ]
            }
        }

        GridView {
            id: gridView
            anchors.margins: 4
            anchors.fill: parent
            clip: true
            cellWidth: 40
            cellHeight: 40
            model:  xmlModel   //.createObject(gridView)
            delegate: baseListDelegate
            boundsBehavior: Flickable.StopAtBounds

            Component.onCompleted: {
               /* listModel.append({"face" : "qrc:/resource/images/im/face/sina/sina_emo_6.png"})
                listModel.append({"face" : "qrc:/resource/images/im/face/sina/sina_emo_1.png"})*/
               // console.log("11111111111111111111111111111111111",tmpModel.count)
             /*   for(var i=0;i<tmpModel.count;i++)
                {
                    var curTitle=tmpModel.get(i).title2;
                    var curPath = "<img src="+tmpModel.get(i).path+"/>";
                    console.log("curpath +++++++++++++++++++++",curPath)
                    var reg = new RegExp(curTitle, "ig");
                    str = str.replace(reg, curPath);
                }*/


            }

        }

   }

}
