﻿import QtQuick 2.7
import QtQuick.Layouts 1.1
import QtQuick.Controls 2.2

import "../common"
import WebRunPlatform 1.0
import WebIEPlatform 1.0


Image {
    id:mainbottomOperating
    property var setobj: null
    property var mainControlObj: null
    property var aboutObj: null
    property var imObj: null
    property var mesageObj: null
    property var noteObj: null
    
    property string jid: ""         //聊天对象jid
    
    property string status:""
    property string loginTime: ""
    property string lastTime: ""
    property string strHeartCoount: ""
    property string strLoseHeartCoount: ""

    property string strReconnectionNum: "0"
    property string strUserId: ""
    property string strUserName:""

    source: "qrc:/resource/images/main/common/skin.png"

    
    WebRunPlatform{
        id:webRun
    }

    WebIEPlatform
    {
        id:iewebrun
    }

    Menu {
        id: menu
        x: 10
        z: 1
        y: mainbottomOperating.height - 212
        closePolicy: Popup.CloseOnReleaseOutsideParent | Popup.CloseOnPressOutside
        font.family: "微软雅黑"
        font.pixelSize: 12

        onVisibleChanged: {
            if(!visible)
            {
                mainmenu.checked = false
            }
        }

        background: BorderImage {

            id: name
            width: menu.width + 16
            height: menu.height
            x: -7
            y: -6

            source: "qrc:/resource/images/main/common/shadow.png"
        }

        MenuItem {
            height: 35

            Rectangle{
                id: bkg
                anchors.fill: parent
                color: "#FcFeFF"

                Image {
                    id: img
                    anchors.left: parent.left
                    anchors.leftMargin: 15
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    source: "qrc:/resource/images/main/common/mainpanel.png"
                }

                Text {
                    id: textid
                    anchors.top: parent.top
                    anchors.topMargin: 8
                    anchors.left: img.right
                    anchors.leftMargin: 10
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#555555"
                    text: qsTr("精灵导航")
                }

                MouseArea{
                    anchors.fill: parent
                    cursorShape: Qt.PointingHandCursor
                    hoverEnabled: true

                    onEntered: {
                        bkg.color = "#ABD9FE"
                    }

                    onExited: {
                        bkg.color = "#FcFeFF"
                    }

                    onClicked: {
                        //   var firstWindow = windowComponent.createObject(window.parent
                        //                                                  ,{"webWidth":window.webWidth
                        //                                                  , "webHeight": window.height
                        //                                                  , "strTitle": qsTr("精灵导航")});
                        //   firstWindow.webView.url = strip + "/main?lang=zh_CN";
                        
                        //精灵导航
                          console.log("精灵导航parent:",strip + "/sys/userDetails?uid=" + jid + "&lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                         //webRun._vNewWindows(strip + "/main?lang=zh_CN","精灵导航",true,strip)
                      //  webRunie._vNewWindows(strip + "/main?lang=zh_CN","精灵导航",true,strip)
 console.log("精灵导航JSESSIONID1:",jsessionid)
                      //  console.log("----------------:",strip + "/main?lang=zh_CN"+"&JSESSIONID1=" +obj.msg)
                      //  Qt.openUrlExternally(strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)

                        //iewebrun._vNewWindows_IE(strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"精灵导航");
                        iewebrun._vNewWindows_XOAbrowser(strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"精灵导航",true);

                        //iewebrun._vNewWindows((strip + "/main?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),"精灵导航",true,strip);
                    }
                }
            }
        }


        MenuItem {
            height: 35

            Rectangle{
                id: bkg2
                anchors.fill: parent
                color: "#FcFeFF"
                Image {
                    id: img2
                    anchors.left: parent.left
                    anchors.leftMargin: 15
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    source: "qrc:/resource/images/main/common/about.png"
                }

                Text {
                    id: text2
                    anchors.top: parent.top
                    anchors.topMargin: 8
                    anchors.left: img2.right
                    anchors.leftMargin: 10
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#555555"
                    text: qsTr("关于OA办公精灵")
                }
            }

            MouseArea{
                anchors.fill: parent
                cursorShape: Qt.PointingHandCursor

                hoverEnabled: true

                onEntered: {
                    bkg2.color = "#ABD9FE"
                }

                onExited: {
                    bkg2.color = "#FcFeFF"
                }

                onClicked: {
                    creatAboutObj();
                    menu.close()
                }
            }
        }

        MenuItem {
            height: 35

            Rectangle{
                id: bkg1
                anchors.fill: parent
                color: "#FcFeFF"
                Image {
                    id: img1
                    anchors.left: parent.left
                    anchors.leftMargin: 15
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    source: "qrc:/resource/images/main/common/switch.png"
                }

                Text {
                    id: text1
                    anchors.top: parent.top
                    anchors.topMargin: 8
                    anchors.left: img1.right
                    anchors.leftMargin: 10
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#555555"
                    text: qsTr("切换用户")
                }
            }

            MouseArea{
                anchors.fill: parent
                cursorShape: Qt.PointingHandCursor
                hoverEnabled: true

                onEntered: {
                    bkg1.color = "#ABD9FE"
                }

                onExited: {
                    bkg1.color = "#FcFeFF"
                }

                onClicked: {
                    creatMessageObj("确定要切换用户吗?", "switchUser")
                    menu.close()
                    consloe.log("切换用户")
                }
            }
        }

        MenuItem {
            height: 35

            Rectangle{
                id: bkg3
                anchors.fill: parent
                color: "#FcFeFF"
                Image {
                    id: img3
                    anchors.left: parent.left
                    anchors.leftMargin: 15
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    source: "qrc:/resource/images/main/common/relogin.png"
                }

                Text {
                    id: text3
                    anchors.top: parent.top
                    anchors.topMargin: 8
                    anchors.left: img3.right
                    anchors.leftMargin: 10
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#555555"
                    text: qsTr("重新登录")
                }
            }


            MouseArea{
                anchors.fill: parent
                cursorShape: Qt.PointingHandCursor

                hoverEnabled: true

                onEntered: {
                    bkg3.color = "#ABD9FE"
                }

                onExited: {
                    bkg3.color = "#FcFeFF"
                }

                onClicked: {
                    creatMessageObj("确定要重新登录吗?", "relogin")
                    menu.close()
                    console.log("重新登陆")
                }
            }
        }

        MenuItem {
            height: 35

            Rectangle{
                id: bkg4
                anchors.fill: parent
                color: "#FcFeFF"
                Image {
                    id: img4
                    anchors.left: parent.left
                    anchors.leftMargin: 15
                    anchors.top: parent.top
                    anchors.topMargin: 10
                    source: "qrc:/resource/images/main/common/quit.png"
                }

                Text {
                    id: text4
                    anchors.top: parent.top
                    anchors.topMargin: 8
                    anchors.left: img4.right
                    anchors.leftMargin: 10
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#555555"
                    text: qsTr("退出")
                }
            }


            MouseArea{
                anchors.fill: parent
                cursorShape: Qt.PointingHandCursor

                hoverEnabled: true

                onEntered: {
                    bkg4.color = "#ABD9FE"
                    tooltip.text = qsTr("退出")
                    tooltip.visible = true
                }

                onExited: {
                    bkg4.color = "#FcFeFF"
                    //tooltip.text = qsTr("")
                    //tooltip.visible = false
                }

                onClicked: {
                    creatMessageObj("确定要退出吗?", "main_quit")
                    menu.close()
                    //menu.show()

                }
            }
        }

    }


    RowLayout {
        anchors.fill: parent

        CheckedIconButton {
            id:mainmenu
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 12
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            checkable: true
            normalIcon: "qrc:/resource/images/main/mainbottom/MenuNormal.png"
            checkedIcon: "qrc:/resource/images/main/mainbottom/menuChecked.png"
            hoveredIcon: "qrc:/resource/images/main/mainbottom/menuChecked.png"
            tooltip: qsTr("主菜单")

            onClicked: {
                if(isWindowedge&&isWindowedge){
                                   isWindowsHide =false
                                   window.y = 10
                                   window.height=_mainwindowh;
                               }
                menu.open()
            }
        }
        ControlButton {
            id:setting
            visible: true
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 4
            leftMargin: 3
            textContent: qsTr("OA办公精灵设置")
            normalImage: "qrc:/resource/images/main/mainbottom/setup.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"

            onClicked: {
                if(isWindowedge&&isWindowedge){
                                   isWindowsHide =false
                                   window.y = 10
                                   window.height=_mainwindowh;
                               }
                creatSetObj()
            }
        }


        //消息历史记录
        ControlButton {
            id:historyRecord
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 4
            leftMargin: 3
            textContent: qsTr("消息历史记录")
            normalImage: "qrc:/resource/images/main/mainbottom/historyRecord.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"
            onClicked: {

                console.log("消息历史记录:"+ strip + "/spirit/webChatRecord")
                //Qt.openUrlExternally(strip + "/spirit/webChatRecord?"+"&JSESSIONID1=" + jsessionid)
                //webRun._vNewWindows(strip + "/spirit/webChatRecord","消息历史记录",false,strip)
                //iewebrun._vNewWindows_IE(strip + "/spirit/webChatRecord?"+"&JSESSIONID1=" + jsessionid,"消息历史记录");
                iewebrun._vNewWindows_XOAbrowser(strip + "/spirit/webChatRecord?"+"&JSESSIONID1=" + jsessionid,"消息历史记录",false);   //XOA 浏览器
            }
        }



        ControlButton {
            id:msgmanager
            visible: false
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 4
            leftMargin: 3

            normalImage: "qrc:/resource/images/main/mainbottom/sms.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"
        }

        ControlButton {
            id:note
            visible: true
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 4
            leftMargin: 3
            textContent: if(hrmenu!=""){qsTr("中煜插件")}else{qsTr("便签")}
            normalImage: if(hrmenu!=""){"qrc:/resource/images/main/mainbottom/fusion.png"} else{"qrc:/resource/images/main/mainbottom/note.png"}
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"
            onClicked: {

                //便签
                console.log("便签:"+ strip + "/Notes/index?lang=zh_CN")
                //webRun._vNewWindows(strip + "/Notes/index?lang=zh_CN","便签",true,strip)
                // Qt.openUrlExternally(strip + "/Notes/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid)
                //iewebrun._vNewWindows((strip + "/Notes/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid).toString(),"便签",true,strip);
                //iewebrun._vNewWindows_IE(strip + "/Notes/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"便签");

                if(hrmenu!="")
                   fileio.hrmenu();
                else
                   iewebrun._vNewWindows_XOAbrowser(strip + "/Notes/index?lang=zh_CN"+"&JSESSIONID1=" + jsessionid,"便签",false);   //XOA 浏览器
            }
        }

/*
        ControlButton {
            id:flyfile
            visible: true
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 5
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 3
            leftMargin: 3
            textContent: qsTr("飞秒快传")
            normalImage: "qrc:/resource/images/main/mainbottom/flyfile.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"

            onClicked: {
                fileio.flyfile(window.strusername2)
            }
        }

        ControlButton {
            id:xoamind
            visible: true
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 3
            leftMargin: 3
            textContent: qsTr("灵通快图")
            normalImage: "qrc:/resource/images/main/mainbottom/xoamind.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"

            onClicked: {
                fileio.xoamind()
            }
        }
*/
        ControlButton {
            id:iminfor
            Layout.alignment: Qt.AlignCenter
            Layout.leftMargin: 6
            Layout.preferredWidth: 28
            Layout.preferredHeight: 28
            iconWidth: 22
            iconHeight: 22
            topMargin: 5
            leftMargin: 3
            textContent: qsTr("即时通讯状态")
            normalImage: "qrc:/resource/images/main/mainbottom/IM-green.png"
            hoverImage: "qrc:/resource/images/main/mainbottom/hovered.png"
            onClicked: {
                if(isWindowedge&&isWindowedge){
                                   isWindowsHide =false
                                   window.y = 10
                                   window.height=_mainwindowh;
                               }
                creatImObj();
            }
        }

        Item {

            Layout.fillWidth: true
        }

    }

    ToolTip{
        id: tooltip
    }


    function creatSetObj() {
        var component = Qt.createComponent("../setting/Setting.qml");

        if (component.status === Component.Ready)
        {
            if(setobj === null)
            {
                setobj = component.createObject(window.parent, { "visible": true});
            }
        }
        if(setobj === null)
        {

        }
        else
        {
            setobj.setValue();
            setobj.deleteitem.connect(mainbottomOperating.deleteSetObj)
        }
    }

    function deleteSetObj()
    {
        if(setobj == null)
        {
            return;
        }

        setobj.deleteitem.disconnect(mainbottomOperating.deleteSetObj)

        setobj.destroy()
        setobj = null
        console.log("destroy2341234", "setview")
    }

    function creatMainControlObj(text, mainUrl, pageId) {
        var component = Qt.createComponent("../common/CustomWebView.qml");

        console.log("mainUrl___1____",mainUrl)
        if (component.status === Component.Ready)
        {
            if(mainControlObj == null)
            {
                mainControlObj = component.createObject(window.parent, {"nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                                            , "titletext": text
                                                            , "visible": true
                                                            , "pageid": pageId
                                                            , "weburl": mainUrl});
            }
        }

        if(mainControlObj === null)
        {

        }
        else
        {
            mainControlObj.deleteitem.connect(mainbottomOperating.deleteMainControlObj)
        }
    }

    function deleteMainControlObj(pageid)
    {
        console.log("pageid",pageid)
        if(mainControlObj == null)
        {
            return;
        }

        mainControlObj.deleteitem.disconnect(mainbottomOperating.deleteMainControlObj)
        mainControlObj.destroy()
        mainControlObj = null;
    }

    function creatNoteObj(text, mainUrl, pageId) {

        console.log("mainUrl_______",text)
            console.log("mainUrl_______",mainUrl)

        var component = Qt.createComponent("../common/CustomWebView.qml");

        if (component.status === Component.Ready)
        {
            if(noteObj == null)
            {
                noteObj = component.createObject(window.parent, {"nabkgImageme": "qrc:/resource/images/main/common/skin.png"
                                                     , "titletext": text
                                                     , "visible": true
                                                     , "pageid": pageId
                                                     , "weburl": mainUrl});
            }
        }

        if(noteObj === null)
        {

        }
        else
        {
            noteObj.deleteitem.connect(mainbottomOperating.deleteNotesObj)
        }
    }

    function deleteNotesObj(pageid)
    {
        console.log("pageid",pageid)
        if(noteObj == null)
        {
            return;
        }

        noteObj.deleteitem.disconnect(mainbottomOperating.deleteNotesObj)
        noteObj.destroy()
        noteObj = null;
    }

    function creatAboutObj() {
        var component = Qt.createComponent("AboutPage.qml");

        if (component.status === Component.Ready)
        {
            if(aboutObj === null)
            {
                aboutObj = component.createObject(window.parent, { "visible": true});
            }
        }
        if(aboutObj === null)
        {

        }
        else
        {
            aboutObj.deleteitem.connect(mainbottomOperating.deleteAboutObj)
        }
    }

    function deleteAboutObj()
    {
        if(aboutObj == null)
        {
            return;
        }

        aboutObj.deleteitem.disconnect(mainbottomOperating.deleteAboutObj)

        aboutObj.destroy()
        aboutObj = null
        console.log("destroyREW23", "setview")
    }

    function creatImObj() {
        var component = Qt.createComponent("ImInformation.qml");

        if (component.status === Component.Ready)
        {
            if(imObj === null)
            {
                imObj = component.createObject(window.parent, { "visible": true
                                                   , "loginStatusText": status
                                                   , "loginTimeText": loginTime
                                                   , "heartBeatCount": strHeartCoount
                                                   , "loseHeartBeatCount":strLoseHeartCoount
                                                   , "reconnectionNum":strReconnectionNum
                                                   , "userId": strUserId
                                                   , "lastTimeText": lastTime
                                                   ,"userName":window.strusername
                                                   , "openfireIp": mainwindow.strImIp});
                console.log("打开即时通讯状态窗口，用户UID：",strUserId)
            }
            else
            {
                imObj.visible=true
                //imObj.userId=strUserId
                //imObj.loginTimeText=loginTime
                //imObj.lastTime=lastTime

            }
        }
        if(imObj === null)
        {

        }
        else
        {
            imObj.deleteitem.connect(mainbottomOperating.deleteImObj)
        }
    }

    function deleteImObj()
    {
        if(imObj == null)
        {
            return;
        }

        imObj.deleteitem.disconnect(mainbottomOperating.deleteImObj)

        imObj.destroy()
        imObj = null
        console.log("关闭IM信息窗")
    }

    function setHeartBeat(iHeartBeatCount, iLoseCount)
    {
        strHeartCoount = iHeartBeatCount
        strLoseHeartCoount = iLoseCount

    }
    function addReconnectionNum()
    {
        //heartBeatCount = iHeartBeatCount
       // loseHeartBeatCount = iLoseCount
         //console.log("进入重新连接计数")
        strReconnectionNum = String(Number(strReconnectionNum)+1);
        if(imObj!=null)
        {
            imObj.addReconnectionNum()
        }


    }
    function setLoginSatus(strStatus)
    {
        if(strStatus === "即时通讯服务连接失败")
        {
            status = "即时通讯服务连接失败"
            iminfor.textContent = ("即时通讯服务连接失败");
            iminfor.normalImage = "qrc:/resource/images/main/mainbottom/IM-green_error.png"
        }     
        else if(strStatus === "即时通讯服务连接成功")
        {
            status = "即时通讯服务连接成功";
            iminfor.textContent = ("即时通讯服务连接成功");
            iminfor.normalImage = "qrc:/resource/images/main/mainbottom/IM-green.png"

        }
        else
        {
            status =  strStatus
        }
    }

    function setLoginTime(strTime, id)
    {
        strUserId = id + ""

        if(loginTime=="")
           loginTime = strTime

        lastTime= strTime
    }

    function creatMessageObj(contexText, parm) {
        var component = Qt.createComponent("MessageDailog.qml");

        if (component.status === Component.Ready)
        {
            if(mesageObj === null)
            {
                mesageObj = component.createObject(window.parent, { "visible": true
                                                       , "messageText":contexText
                                                       , "pageId": parm});
            }
        }
        if(mesageObj === null)
        {

        }
        else
        {
            mesageObj.deleteitem.connect(mainbottomOperating.deleteMessageObj)
            mesageObj.sigSure.connect(mainbottomOperating.messageOperate)
            mesageObj.sigCancel.connect(mainbottomOperating.deleteMessageObj)
        }
    }

    function deleteMessageObj()
    {
        mesageObj.deleteitem.disconnect(deleteMessageObj)
        mesageObj.sigSure.disconnect(messageOperate)
        mesageObj.sigCancel.disconnect(deleteMessageObj)

        mesageObj.destroy()
        mesageObj = null
        console.log("destroyR342", "setview")
    }

    function messageOperate(parm) //对话框选择后根据返回值进行处理
    {

        console.log("响应菜单操作");
        if(parm === "main_quit")
        {

            // loginServer.logoutServer();
            // logoutWebServer.logoutServer(strip + "/logOut?name=liuyu&userAgent=pc", jsessionid,"0");
            deleteImObj()
            deleteAboutObj()
            deleteSetObj()
            deleteMainControlObj(10)
            deleteNotesObj("note")
            deleteWebObj()
            destroyallobject()
            maintopoperating.deleteAllObj()


            fileio.exequitsharememory(window.strusername)
            console.log("登录过1，退出于 MainBottomOperating.messageOperate()，删除共享内存账号:",window.strusername);

            app_quit()

        }
        else if(parm === "switchUser")
        {
            //loginServer.logoutSever();
            console.log("点击了切换用户");  //这几个汉字不能修改，会根据这个判断是否含有用户ID
            deleteImObj()
            deleteAboutObj()
            deleteSetObj()
            deleteMainControlObj(10)
            deleteNotesObj("note")
            deleteWebObj()
            destroyallobject()
            maintopoperating.deleteAllObj()
            fileio.exequitsharememory(window.strusername)

            loginServer.startExe("./ispirit_xoa","switchUser")
            app_quit()

           /*
            logoutWebServer.logoutServer(strip + "/logOut?name=liuyu&userAgent=pc", jsessionid, "1");
            deleteImObj()
            deleteAboutObj()
            deleteSetObj()
            deleteMainControlObj(10)
            deleteNotesObj("note")
            deleteWebObj()
            destroyallobject()
            maintopoperating.deleteAllObj()*/

            //fileio.writeIniFile("login", "switchlogin", "1")

        }
        else if(parm === "relogin")  //重新登陆
        {
            //loginServer.logoutServer();
            logoutWebServer.logoutServer(strip + "/logOut?name="+ username +"&userAgent=pc", jsessionid,"2");
            deleteImObj()
            deleteAboutObj()
            deleteSetObj()
            deleteMainControlObj(10)
            deleteNotesObj("note")
            deleteWebObj()
            destroyallobject()
            maintopoperating.deleteAllObj()
            fileio.exequitsharememory(window.strusername)

            console.log("点击了重新登录");  //这几个汉字不能修改，会根据这个判断是否含有用户ID

        }
        deleteMessageObj()
    }

    Component.onCompleted: {
        loginServer.sigGetLoginTime.connect(setLoginTime)
        loginServer.sigGetHeartBeatCount.connect(setHeartBeat);
        loginServer.sigGetConReason.connect(setLoginSatus)

        loginServer.sigAddReconnectionNum.connect(addReconnectionNum);

    }
}
