﻿import QtQuick 2.2
import QtQuick.Controls 1.2
import QtQuick.Controls.Styles 1.4
import FileIo 1.0
import "../js/query.js" as Query
import "../common"

Item {
    id:loginsettingitem
    property var usercompanyinfojson: []
    property string _autorun: "" //!自动登录

    property var    mesageObj: null

    signal saveLoginClicked(string passwd);
    signal closeLoginClicked()


    function setValue(){

      //  userzzinput.currentIndex = fileio.readIniFile("login", "companyoid")


        usernametextinput.text = fileio.readIniFile("login", "username")
        //passwdtextinput.text = fileio.readIniFile("login", "passwd")

        var xoabang= fileio.readIniFile("login", "xoabang")
        passwdtextinput.text=fileio.textDecode(xoabang,"X");


        autologin.checkedState = fileio.readIniFile("login", "autologin")
        innetinput.text = fileio.readIniFile("login", "oainnet")
        outnetinput.text = fileio.readIniFile("login", "oaoutnet")
        testnetinput.text = fileio.readIniFile("login", "oatestnet")
        rememb.checkedState = fileio.readIniFile("login", "remembPasswd") 
        idautorun.checkedState  = fileio.readIniFile("login", "autorun")
 
        
        var usernet = fileio.readIniFile("login", "useroutnetlogin");
        if(usernet === "0")
        {
            innetcheckbox.checked = true;
        }
        else if(usernet === "1")
        {
            outnetcheckbox.checked = true;
        }
        else if(usernet === "2")
        {
            testnetcheckbox.checked = true;
        }

        var usercompanynet = ""
        if(innetcheckbox.checked)
        {
            usercompanynet = innetinput.text;
        }
        else if(outnetcheckbox.checked)
        {
            usercompanynet = outnetinput.text;
        }
        else if(testnetcheckbox.checked)
        {
            usercompanynet = testnetinput.text;
        }
       // Query.queryusercompanyinfo(usercompanynet, callback)

        //companyBox.reMoveAllData();

      //  companyBox.appendData( fileio.readIniFile("login", "companyoname") ,fileio.readIniFile("login", "companyoid"));
        //companyBox.setCurrentIndex(1);
        if(fileio.readIniFile("login", "companyname")==="")
        {
            companyBox.setComboxdisplayItemText("默认组织");
        }
        else
        {
            companyBox.setComboxdisplayItemText(fileio.readIniFile("login", "companyname"));
        }
        console.log("网络设置按钮请求服务器位置");

    }

    function callback(usercompanyinfo){

        console.log("usercompanyinfo",usercompanyinfo)
        companyBox.reMoveAllData();

        var obj = eval('(' + usercompanyinfo + ')');
        usercompanyinfojson = obj.obj
        for(var i =0; i < obj.obj.length; ++i)
        {
            companyBox.appendData( obj.obj[i].name, obj.obj[i].oid)
        }

        var oid = fileio.readIniFile("login", "companyoid")
      /*  for(var j = 0; j < companyBox.modelCount(); ++j)
        {
            if(oid === companyBox.modelIndexValue(j))
            {
                companyBox.setCurrentIndex(j)

                companyBox.comboClicked.disconnect(companyBoxClicked);
                companyBox.comboClicked.connect(companyBoxClicked);
                return;
            }
            else
            {
                companyBox.setCurrentIndex(j);
                companyBox.comboClicked.disconnect(companyBoxClicked);
                companyBox.comboClicked.connect(companyBoxClicked);
                return;
            }
        }
        companyBox.setCurrentIndex(0);*/
        companyBox.comboClicked.disconnect(companyBoxClicked);
        companyBox.comboClicked.connect(companyBoxClicked);
    }
    function creatMessageObj(contexText, parm) {
        var component = Qt.createComponent("../main/MessageDailog.qml");

        if (component.status === Component.Ready)
        {
            if(mesageObj === null)
            {
                mesageObj = component.createObject(window.parent, { "visible": true
                                                       , "messageText":contexText
                                                       , "pageId": parm});
            }
        }
        if(mesageObj === null)
        {

        }
        else
        {
            //mesageObj.deleteitem.connect(mainbottomOperating.deleteMessageObj)
            mesageObj.sigSure.connect(deleteMessageObj)
            mesageObj.sigCancel.connect(deleteMessageObj)
        }
    }
    function deleteMessageObj()
    {
       // mesageObj.deleteitem.disconnect(deleteMessageObj)
       // mesageObj.sigSure.disconnect(messageOperate)
        mesageObj.sigCancel.disconnect(deleteMessageObj)
         mesageObj.sigSure.disconnect(deleteMessageObj)

        mesageObj.destroy()
        mesageObj = null
        console.log("destroyR342", "没有输入zu'zh组织--提醒框")
    }
    function companyBoxClicked(){
        console.log("com组件被点击")
        if(innetcheckbox.checked)
        {
            Query.queryusercompanyinfo(fileio.readIniFile("login", "oainnet"), callback);
             console.log("com组件被点击1")
        }
        if(outnetcheckbox.checked)
        {
            Query.queryusercompanyinfo(fileio.readIniFile("login", "oaoutnet"), callback);
             console.log("com组件被点击2")
        }
        if(testnetcheckbox.checked)
        {
            Query.queryusercompanyinfo(fileio.readIniFile("login", "oatestnet"), callback);
             console.log("com组件被点击3")
        }
    }
    Text {
        id: loginsettext
        width: 48
        height: 26
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 210
        anchors.left: parent.left
        anchors.leftMargin: 44

        font.pixelSize: 14
        font.family: "微软雅黑"
        //font.bold: true
        color: "#1874CD"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("登录设置")
    }


    Text {
        id: userzz
        width: 48
        height: 26
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 170
        anchors.left: parent.left
        anchors.leftMargin: 55

        font.pixelSize: 14
        font.family: "微软雅黑"
        font.bold: false
        color: "#666666"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("组织")


    }

    ListModel {
        id: companymodel
    }
//选择组织com控件
    CustomCombobox{
        id: companyBox
        width: 200
        height: 26
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 170
        anchors.left: userzz.right
        anchors.leftMargin: 0
        z: 1


    }



    Text {
        id: usernametext
        width: 48
        height: 25
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 130
        anchors.left: parent.left
        anchors.leftMargin: 55

        font.pixelSize: 14
        font.family: "微软雅黑"
        font.bold: false
        color: "#666666"
        verticalAlignment: Qt.AlignVCenter
        text: qsTr("用户")
    }

    TextField {
        id: usernametextinput
        width: 200
        height: 25
        anchors.bottom:parent.bottom
        anchors.bottomMargin: 130
        anchors.left: usernametext.right
        anchors.leftMargin: 0

        font.pixelSize: 14
        verticalAlignment: Qt.AlignVCenter
        font.family: "微软雅黑"
        style: TextFieldStyle {

            textColor: "#666666"
            background: Rectangle {
                border.color: "#dbdbdb"
                border.width: 1
                radius: 3
            }
        }
    }

    Text {
        id: passwdtext
        width: 48
        height: 25
        anchors.top: usernametext.bottom
        anchors.topMargin: 15
        anchors.left: parent.left
        anchors.leftMargin: 55

        font.family: "微软雅黑"
        font.pixelSize: 14
        color: "#666666"

        verticalAlignment: Qt.AlignVCenter
        text: qsTr("密码")
    }

    TextField {
        id: passwdtextinput
        width: 200
        height: 25
        anchors.top:usernametextinput.bottom
        anchors.topMargin: 15
        anchors.left: passwdtext.right
        anchors.leftMargin: 0

        font.pixelSize: 14
        echoMode: TextInput.Password
        inputMethodHints: Qt.ImhHiddenText
        verticalAlignment: Qt.AlignVCenter
        font.family: "微软雅黑"
        style: TextFieldStyle {

            textColor: "#666666"
            background: Rectangle {
                border.color: "#dbdbdb"
                border.width: 1
                radius: 3
            }
        }

    }

    CheckBox {
            id: rememb
            width: 80
            height: 23
            anchors.top:passwdtextinput.bottom
            anchors.topMargin: 5
            anchors.left: passwdtextinput.left
            anchors.leftMargin: 5
            visible: true
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: normal
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png"
                    }

                    Image {
                        id: checked
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png"
                    }
                }
                label: Text{
                    id: text_label
                    text: qsTr(" 记住密码")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#666666"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                }
            }
        }


    CheckBox {
            id: autologin
            width: 80
            height: 23
            anchors.top:passwdtextinput.bottom
            anchors.topMargin: 5
            anchors.left: rememb.right
            anchors.leftMargin: 0
            visible: true
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: normal1
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png";
                    }

                    Image {
                        id: checked1
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png";
                    }
                }
                label: Text{
                    id: text_label1
                    text: qsTr(" 自动登录")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#666666"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                }
            }
        }


    CheckBox {
            id: idautorun
            width: 80
            height: 23
            anchors.top:passwdtextinput.bottom
            anchors.topMargin: 5
            anchors.left: autologin.right
            anchors.leftMargin: 0
            visible: true
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: normal2
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png"
                    }

                    Image {
                        id: checked2
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png"
                    }
                }
                label: Text{
                    id: text_label2
                    text: qsTr(" 开机启动")
                    font.pixelSize: 12
                    font.family: "微软雅黑"
                    color: "#666666"
                    horizontalAlignment: Qt.AlignLeft
                    verticalAlignment: Qt.AlignVCenter
                }
            }
        }

    ExclusiveGroup {
        id: exclusive
    }

   /* Rectangle {
        id:line4
        anchors.top: parent.top
        anchors.topMargin: 20+15
        anchors.left: parent.left
        anchors.leftMargin: 40
        anchors.right: parent.right
        anchors.rightMargin: 20
        height: 1
        color: "#eee"
    }*/

    Item {
        id: innetitem
        height: 60
        anchors.top: parent.top
        anchors.topMargin: 37
        anchors.left: parent.left
        anchors.right: parent.right

        CheckBox {
            id: innetcheckbox
            width: 23
            height: 23
            anchors.left: parent.left
            anchors.leftMargin: 60
            anchors.top: parent.top
            anchors.topMargin: 25.5
            exclusiveGroup: exclusive
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: autonormal
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png"
                    }

                    Image {
                        id: autochecked
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png"
                    }
                }
            }

            onClicked: {
            //    fileio.writeIniFile("login", "useroutnetlogin", 0)
                companyBox.reMoveAllData();
               // Query.queryusercompanyinfo(fileio.readIniFile("login", "oainnet"), callback)
          // companyBox.setCurrentIndex(0);
            }
        }

        Rectangle {
            width: 340
            height: 60
            anchors.left: innetcheckbox.right
            anchors.leftMargin: 20
            anchors.top:parent.top
            radius: 5

            border.color: "#dbdbdb"
            border.width: 1
            Text {
                id: websettext
                width: 48
                height: 26
                anchors.bottom:innetnamebkg.top
                anchors.bottomMargin: 5
                anchors.left: parent.left
                anchors.leftMargin: -60

                font.pixelSize: 14
                font.family: "微软雅黑"
                //font.bold: true
                color: "#1874CD"
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("网络设置")
            }
            Image {
                id: websettexticon
                width: 22
                height: 22
                source: "qrc:/resource/images/login/loginicon.png"
                anchors.bottom:websettext.bottom
                anchors.bottomMargin: 1
                anchors.right:  websettext.left
                anchors.leftMargin: 5
                visible: true

            }

            Rectangle{
                id: innetnamebkg
                width: 85
                height: 29
                color: "#edf3f7"
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.left: parent.left
                anchors.leftMargin: 1
                Text {
                    id: innetname
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    color: "#333333"
                    font.family: "微软雅黑"

                    text:qsTr(" 网址1:")
                }
            }

            Text {
                anchors.top: parent.top
                anchors.bottom: line.top
                anchors.left: innetnamebkg.right
                anchors.leftMargin: 20
                anchors.right: parent.right

                font.pixelSize: 14
                color: "#666666"
                font.family: "微软雅黑"
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("内网地址")
            }

            Rectangle{
                id:line
                height: 1
                anchors.top: innetnamebkg.bottom
                anchors.left: parent.left
                anchors.right: parent.right
                color: "#dbdbdb"
            }

            Rectangle{
                id: innetipbkg
                width: 85
                height: 28
                anchors.top: line.bottom
                anchors.topMargin: 0
                anchors.left: parent.left
                anchors.leftMargin: 1
                color: "#edf3f7"

                Text {
                    id: innetip
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    color: "#333333"
                    font.family: "微软雅黑"
                    text: qsTr("域名或IP:")
                }
            }

            TextField {
                id: innetinput
                anchors.left: innetipbkg.right
                anchors.leftMargin:14
                anchors.right: parent.right
                anchors.rightMargin: 5
                anchors.top: line.bottom
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                font.pixelSize: 14
                font.family: "微软雅黑"
                style: TextFieldStyle {

                    textColor: "#666666"
                    background: Rectangle {
                        border.color: "#333"
                        border.width: 0
                    }
                }

                onEditingFinished: {
                    innetinput.text = fileio.removeSubstr(innetinput.text);
                    //Query.queryusercompanyinfo(outnetinput.text, callback)

                    var strinaddress = innetinput.text.split(":");
                    if(strinaddress[0] === "http"||strinaddress[0] === "https")
                    {
                        fileio.writeIniFile("login", "oainnet", innetinput.text)
                    }
                    else
                    {
                        fileio.writeIniFile("login", "oainnet", "http://" + innetinput.text)
                    }

                    companyBox.reMoveAllData();
                  //  Query.queryusercompanyinfo(fileio.readIniFile("login", "oainnet"), callback)
                }
            }
        }
    }

    Item {
        id: outnetitem
        height: 60
        anchors.top: innetitem.bottom
        anchors.topMargin: 15
        anchors.left: parent.left
        anchors.right: parent.right

        CheckBox {
            id: outnetcheckbox
            width: 23
            height: 23
            anchors.left: parent.left
            anchors.leftMargin: 60
            anchors.top: parent.top
            anchors.topMargin: 18.5
            exclusiveGroup: exclusive
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: autonormal1
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png"
                    }

                    Image {
                        id: autochecked1
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png"
                    }
                }
            }
            onClicked: {
              //  fileio.writeIniFile("login", "useroutnetlogin", 1)
                companyBox.reMoveAllData();
              //  Query.queryusercompanyinfo(fileio.readIniFile("login", "oaoutnet"), callback)
            }
        }

        Rectangle {
            width: 340
            height: 60
            anchors.left: outnetcheckbox.right
            anchors.leftMargin: 20
            anchors.top:parent.top
            radius: 5

            border.color: "#dbdbdb"
            border.width: 1

            Rectangle{
                id: outnetnamebkg
                width: 85
                height: 29
                color: "#edf3f7"
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.left: parent.left
                anchors.leftMargin: 1
                Text {
                    id: outnetname
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    color: "#333333"
                    font.family: "微软雅黑"

                    text:qsTr(" 网址2:")
                }
            }

            Text {
                anchors.top: parent.top
                anchors.bottom: line1.top
                anchors.left: outnetnamebkg.right
                anchors.leftMargin: 20
                anchors.right: parent.right

                font.pixelSize: 14
                font.family: "微软雅黑"
                color: "#666666"
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("外网地址")
            }

            Rectangle{
                id:line1
                height: 1
                anchors.top: outnetnamebkg.bottom
                anchors.left: parent.left
                anchors.right: parent.right
                color: "#dbdbdb"
            }

            Rectangle{
                id: outnetipbkg
                width: 85
                height: 28
                anchors.top: line1.bottom
                anchors.topMargin: 0
                anchors.left: parent.left
                anchors.leftMargin: 1
                color: "#edf3f7"

                Text {
                    id: outnetip
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    color: "#333333"
                    text: qsTr("域名或IP:")
                }
            }


            TextField {
                id: outnetinput
                anchors.left: outnetipbkg.right
                anchors.leftMargin: 14
                anchors.right: parent.right
                anchors.rightMargin: 5
                anchors.top: line1.bottom
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                font.pixelSize: 14
                font.family: "微软雅黑"
                style: TextFieldStyle {

                    textColor: "#666666"
                    background: Rectangle {
                        border.color: "#333"
                        border.width: 0
                    }
                }
                onEditingFinished: {
                    outnetinput.text = fileio.removeSubstr(outnetinput.text);
                    //Query.queryusercompanyinfo(outnetinput.text, callback)

                    var stroutaddress = outnetinput.text.split(":")
                    if(stroutaddress[0] === "http"||stroutaddress[0] === "https")
                    {
                        fileio.writeIniFile("login", "oaoutnet", outnetinput.text)
                    }
                    else
                    {
                        fileio.writeIniFile("login", "oaoutnet", "http://" + outnetinput.text)
                    }
                    companyBox.reMoveAllData();
                 //   Query.queryusercompanyinfo(fileio.readIniFile("login", "oaoutnet"), callback)
                }
            }
        }
    }

    Item {
        id: testnetitem
        height: 60
        anchors.top: outnetitem.bottom
        anchors.topMargin: 15
        anchors.left: parent.left
        anchors.right: parent.right

        CheckBox {
            id: testnetcheckbox
            width: 23
            height: 23
            anchors.left: parent.left
            anchors.leftMargin: 60
            anchors.top: parent.top
            anchors.topMargin: 18.5
            exclusiveGroup: exclusive
            style: CheckBoxStyle {
                indicator: Item {
                    implicitWidth: 16
                    implicitHeight: 16
                    Image {
                        id: autonormal2
                        anchors.fill: parent
                        source: "qrc:/resource/images/login/checkbox.png"
                    }

                    Image {
                        id: autochecked2
                        anchors.fill: parent
                        visible: control.checked
                        source: "qrc:/resource/images/login/checkbox_hover.png"
                    }
                }
            }

            onClicked: {
               // fileio.writeIniFile("login", "useroutnetlogin", 2)
                companyBox.reMoveAllData();
               // Query.queryusercompanyinfo(fileio.readIniFile("login", "oatestnet"), callback)

            }
        }

        Rectangle {
            width: 340
            height: 60
            anchors.left: testnetcheckbox.right
            anchors.leftMargin: 20
            anchors.top:parent.top
            radius: 3

            border.color: "#dbdbdb"
            border.width: 1

            Rectangle{
                id: testnetnamebkg
                width: 85
                height: 29
                color: "#edf3f7"
                anchors.top: parent.top
                anchors.topMargin: 1
                anchors.left: parent.left
                anchors.leftMargin: 1
                Text {
                    id: testnetname
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    color: "#333333"
                    font.family: "微软雅黑"

                    text:qsTr(" 网址3:")
                }
            }

            Text {
                anchors.top: parent.top
                anchors.bottom: line2.top
                anchors.left: testnetnamebkg.right
                anchors.leftMargin: 20
                anchors.right: parent.right

                font.pixelSize: 14
                font.family: "微软雅黑"
                color: "#666666"
                horizontalAlignment: Qt.AlignLeft
                verticalAlignment: Qt.AlignVCenter
                text: qsTr("备用地址")
            }

            Rectangle{
                id:line2
                height: 1
                anchors.top: testnetnamebkg.bottom
                anchors.left: parent.left
                anchors.right: parent.right
                color: "#dbdbdb"
            }

            Rectangle{
                id: testnetipbkg
                width: 85
                height: 28
                anchors.top: line2.bottom
                anchors.topMargin: 0
                anchors.left: parent.left
                anchors.leftMargin: 1
                color: "#edf3f7"

                Text {
                    id: testnetip
                    anchors.centerIn: parent
                    font.pixelSize: 14
                    font.family: "微软雅黑"
                    color: "#333333"
                    text: qsTr("域名或IP:")
                }
            }


            TextField {
                id: testnetinput
                anchors.left: testnetipbkg.right
                anchors.leftMargin: 14
                anchors.right: parent.right
                anchors.rightMargin: 6
                anchors.top: line2.bottom
                anchors.bottom: parent.bottom
                anchors.bottomMargin: 1
                font.pixelSize: 14
                font.family: "微软雅黑"
                style: TextFieldStyle {

                    textColor: "#666666"
                    background: Rectangle {
                        border.color: "#333"
                        border.width: 0
                    }
                }
                onEditingFinished: {
                    testnetinput.text = fileio.removeSubstr(testnetinput.text);
                    //Query.queryusercompanyinfo(testnetinput.text, callback)
                    var strtestaddress = testnetinput.text.split(":");
                    if(strtestaddress[0] === "http"||strtestaddress[0] === "https")
                    {
                        fileio.writeIniFile("login", "oatestnet", testnetinput.text)
                    }
                    else
                    {
                        fileio.writeIniFile("login", "oatestnet", "http://" + testnetinput.text)
                    }
                    companyBox.reMoveAllData();
                  //  Query.queryusercompanyinfo(fileio.readIniFile("login", "oatestnet"), callback)
                }
            }
        }
    }
//Ini文件
    FileIo {
        id: fileio
    }


//保存按钮
    Button {
        id: loginsavebtn
        width: 64
        height: 28
        anchors.right: logincancelbtn.left
        anchors.rightMargin: 15
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 10
        style:ButtonStyle {
            background: Rectangle {
                border.color: control.hovered ? "#0075c4" : "#ccc"
                border.width: 1
                radius: 3
                color: control.hovered ? "#278ADD" : "#EEEEEE"
            }

            label: Text{
                text:qsTr("保存")
                font.pixelSize: 12
                font.family: "微软雅黑"
                color: control.hovered ?"#FFFFFF" :"#333333"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }

        onClicked: {
            //if(comboBox.focus === false){
            //creatMessageObj("请选择组织!", "displayItem")
            //creatSetObj()
            //}
            console.log(companyBox.getCurrentCompanyOid());
          /*  if(companyBox.getCurrentCompanyOid() == "")
                {

                creatMessageObj("请选择组织!", "displayItem");
                return;
                 }*/

            innetinput.text = fileio.removeSubstr(innetinput.text);
            var strinaddress = innetinput.text.split(":");
            console.log(strinaddress);
            if(strinaddress[0] === "http"||strinaddress[0] === "https")
            {
                fileio.writeIniFile("login", "oainnet", innetinput.text)
                console.log(innetinput.text);

            }
            else
            {
                fileio.writeIniFile("login", "oainnet", "http://" + innetinput.text)
            }
             outnetinput.text = fileio.removeSubstr(outnetinput.text);
             console.log(outnetinput.text);

            var stroutaddress1 = outnetinput.text.split(":")
            if(stroutaddress1[0] === "http"||stroutaddress1[0] === "https")
            {
                fileio.writeIniFile("login", "oaoutnet", outnetinput.text)
            }
            else
            {
                fileio.writeIniFile("login", "oaoutnet", "http://" + outnetinput.text)
            }
            testnetinput.text = fileio.removeSubstr(testnetinput.text);
             console.log(testnetinput.text);

            var strtestaddress2 = testnetinput.text.split(":");
            if(strtestaddress2[0] === "http"||strtestaddress2[0] === "https")
            {
                console.log("1",testnetinput.text)
                fileio.writeIniFile("login", "oatestnet", testnetinput.text)
            }
            else
            {
                fileio.writeIniFile("login", "oatestnet", "http://" + testnetinput.text)
            }

            if(rememb.checkedState)
            {
                //fileio.writeIniFile("login", "passwd", passwdtextinput.text)
                fileio.writeIniFile("login", "xoabang", fileio.textEncode(passwdtextinput.text,"X"))
            }

            fileio.writeIniFile("login", "username", usernametextinput.text)
            fileio.writeIniFile("login", "remembPasswd", rememb.checkedState)
            fileio.writeIniFile("login", "autologin", autologin.checkedState)
            if(companyBox.getComboxdisplayItemText() ===fileio.readIniFile("login", "companyname"))
            {}
            else if(companyBox.getComboxdisplayItemText() === "默认组织")
            {
                fileio.writeIniFile("login", "companyname","")
                fileio.writeIniFile("login", "companyoid", "")
            }
            else
            {
                fileio.writeIniFile("login", "companyname", companyBox.getCurrentCompanyName())
                fileio.writeIniFile("login", "companyoid", companyBox.getCurrentCompanyOid())
            }


            fileio.writeIniFile("login", "autorun", idautorun.checkedState)

            console.log("autoRun___",idautorun.checkedState)
            fileio.autoRun(idautorun.checkedState);


            loginsettingitem.saveLoginClicked(passwdtextinput.text)
            loginsettingitem.closeLoginClicked()

            //settingwindow.close();
            if(innetcheckbox.checked)
            {
                fileio.writeIniFile("login", "dnsip",fileio.readIniFile("login","oainnet")) //innetinput.text
                fileio.writeIniFile("login", "useroutnetlogin","0")

               // fileio.setstrDns(fileio.readIniFile("login","oainnet"));
            }
            else if(outnetcheckbox.checked)
            {
                fileio.writeIniFile("login", "dnsip", fileio.readIniFile("login","oaoutnet"))//outnetinput.text
                fileio.writeIniFile("login", "useroutnetlogin","1")

               //  fileio.setstrDns(fileio.readIniFile("login","oaoutnet"));
            }
            else
            {
                fileio.writeIniFile("login", "dnsip", fileio.readIniFile("login","oatestnet"))//testnetinput.text
                fileio.writeIniFile("login", "useroutnetlogin","2")

               // fileio.setstrDns(fileio.readIniFile("login","oatestnet"));
            }

            if(passwdtextinput.text.length!==0)
            {

            }

            login.setLoginLogo()
        }
    }
//取消按钮
    Button {        
        id: logincancelbtn
        width: 64
        height: 28
        anchors.right: parent.right
        anchors.rightMargin: 35
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 10
        style:ButtonStyle {
            background: Rectangle {
                border.color: control.hovered ? "#0075c4" : "#ccc"
                border.width: 1
                radius: 3
                color: control.hovered ? "#278ADD" : "#EEEEEE"
            }

            label: Text{
                text:qsTr("取消")
                font.pixelSize: 12
                font.family: "微软雅黑"
                color: control.hovered ?"#FFFFFF" :"#333333"
                font.bold: false
                horizontalAlignment: Qt.AlignHCenter
                verticalAlignment: Qt.AlignVCenter
            }
        }
        onClicked: {
            loginsettingitem.closeLoginClicked()
        }


        Component.onCompleted: {
            console.log("ttttt",fileio.readIniFile("login", "useroutnetlogin"))
            console.log("完成界面控制连接com组件接口")
            companyBox.comboClicked.connect(companyBoxClicked);            


        }
    }



}
